package de.hftstuttgart.energycomponents.app.parts;

import java.io.IOException;

import javax.annotation.PostConstruct;

import org.eclipse.e4.ui.di.Persist;
import org.eclipse.e4.ui.model.application.MApplication;
import org.eclipse.emf.common.command.BasicCommandStack;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecp.ui.view.ECPRendererException;
import org.eclipse.emf.ecp.ui.view.swt.ECPSWTViewRenderer;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.jface.layout.GridLayoutFactory;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;

import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.EnergyComponentsCatalog;

/**
 * Part for displaying a Forms Editor for an EnergyComponentsCatalog.
 * See https://www.vogella.com/tutorials/Eclipse4Services/article.html#implementing-editor-like-behavior
 * Reuse ECPModelView? https://www.eclipse.org/forums/index.php/t/1070750/
 */
//TODO: Selection context/adapter for MPart to enable/disable Save command
//TODO: Update Dirty state of MPart
//TODO: resourceSet.getResourceFactoryRegistry().getExtensionToFactoryMap().put("encomp", new  XMIResourceFactoryImpl());
//TODO: Resource energyCatalogResource = resourceSet.getResource(URI.createURI("file://" + pathToCatalog), true);

public class CatalogPart {
	private Resource energyCatalogResource;
	
	@PostConstruct
	public void createComposite(MApplication application, Composite parent) {
		energyCatalogResource = application.getContext().get(Resource.class);
		EObject energyCatalog = energyCatalogResource.getContents().get(0);
		try {
			final Composite content = new Composite(parent, SWT.NONE);
			content.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_WHITE));
			content.setLayout(GridLayoutFactory.fillDefaults().margins(10, 10).create());
			ECPSWTViewRenderer.INSTANCE.render(content, energyCatalog);
			content.layout();
		} catch (final ECPRendererException e) {
			e.printStackTrace();
		}
		parent.layout();
	}
	
	@Persist
	public void save() {
		System.out.println("Saved " + energyCatalogResource);
		try {
			energyCatalogResource.save(null);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}