/**
 */
package de.hftstuttgart.energycomponents.provider;

import de.hftstuttgart.energycomponents.CombinedHeatPower;
import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link de.hftstuttgart.energycomponents.CombinedHeatPower} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class CombinedHeatPowerItemProvider extends ThermalEnergyDeviceItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CombinedHeatPowerItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addThermalEfficiencyPropertyDescriptor(object);
			addElectricalEfficiencyPropertyDescriptor(object);
			addInstalledElectricalPowerPropertyDescriptor(object);
			addElectricalEfficiencyPartLoadPropertyDescriptor(object);
			addThermalEfficiencyPartLoadPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Thermal Efficiency feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addThermalEfficiencyPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_CombinedHeatPower_thermalEfficiency_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_CombinedHeatPower_thermalEfficiency_feature",
						"_UI_CombinedHeatPower_type"),
				EnCompPackage.Literals.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY, true, false, false,
				ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Electrical Efficiency feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addElectricalEfficiencyPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_CombinedHeatPower_electricalEfficiency_feature"),
						getString("_UI_PropertyDescriptor_description",
								"_UI_CombinedHeatPower_electricalEfficiency_feature", "_UI_CombinedHeatPower_type"),
						EnCompPackage.Literals.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY, true, false, false,
						ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Installed Electrical Power feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addInstalledElectricalPowerPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_CombinedHeatPower_installedElectricalPower_feature"),
						getString("_UI_PropertyDescriptor_description",
								"_UI_CombinedHeatPower_installedElectricalPower_feature", "_UI_CombinedHeatPower_type"),
						EnCompPackage.Literals.COMBINED_HEAT_POWER__INSTALLED_ELECTRICAL_POWER, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Electrical Efficiency Part Load feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addElectricalEfficiencyPartLoadPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_CombinedHeatPower_electricalEfficiencyPartLoad_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_CombinedHeatPower_electricalEfficiencyPartLoad_feature", "_UI_CombinedHeatPower_type"),
				EnCompPackage.Literals.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD, true, false, false, null,
				null, null));
	}

	/**
	 * This adds a property descriptor for the Thermal Efficiency Part Load feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addThermalEfficiencyPartLoadPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_CombinedHeatPower_thermalEfficiencyPartLoad_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_CombinedHeatPower_thermalEfficiencyPartLoad_feature", "_UI_CombinedHeatPower_type"),
				EnCompPackage.Literals.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD, true, false, false, null,
				null, null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(EnCompPackage.Literals.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD);
			childrenFeatures.add(EnCompPackage.Literals.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns CombinedHeatPower.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/CombinedHeatPower"));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean shouldComposeCreationImage() {
		return true;
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((CombinedHeatPower) object).getModelName();
		return label == null || label.length() == 0 ? getString("_UI_CombinedHeatPower_type")
				: getString("_UI_CombinedHeatPower_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(CombinedHeatPower.class)) {
		case EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY:
		case EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY:
		case EnCompPackage.COMBINED_HEAT_POWER__INSTALLED_ELECTRICAL_POWER:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
			return;
		case EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD:
		case EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD,
						EnCompFactory.eINSTANCE.createTableCharacteristic()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD,
						EnCompFactory.eINSTANCE.createLinearCharacteristic()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD,
						EnCompFactory.eINSTANCE.createExponentionalCharacteristic()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD,
						EnCompFactory.eINSTANCE.createPolynomialCharacteristic()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD,
						EnCompFactory.eINSTANCE.createPowerCharacteristic()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD,
						EnCompFactory.eINSTANCE.createTableCharacteristic()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD,
						EnCompFactory.eINSTANCE.createLinearCharacteristic()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD,
						EnCompFactory.eINSTANCE.createExponentionalCharacteristic()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD,
						EnCompFactory.eINSTANCE.createPolynomialCharacteristic()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD,
						EnCompFactory.eINSTANCE.createPowerCharacteristic()));
	}

	/**
	 * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify = childFeature == EnCompPackage.Literals.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD
				|| childFeature == EnCompPackage.Literals.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD;

		if (qualify) {
			return getString("_UI_CreateChild_text2",
					new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

}
