/**
 */
package de.hftstuttgart.energycomponents.provider;

import de.hftstuttgart.energycomponents.Cost;
import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link de.hftstuttgart.energycomponents.Cost} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class CostItemProvider extends ItemProviderAdapter implements IEditingDomainItemProvider,
		IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CostItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addComponentNamePropertyDescriptor(object);
			addDescriptionPropertyDescriptor(object);
			addHeatSourcePropertyDescriptor(object);
			addDatasourcePropertyDescriptor(object);
			addInvestmentCostPropertyDescriptor(object);
			addOtherInvestmentCostPropertyDescriptor(object);
			addPersonnelHoursPropertyDescriptor(object);
			addPersonnelCostSharePropertyDescriptor(object);
			addAdministrationAndOtherCostSharePropertyDescriptor(object);
			addMaintenanceCostSharePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Personnel Hours feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addPersonnelHoursPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Cost_personnelHours_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Cost_personnelHours_feature",
								"_UI_Cost_type"),
						EnCompPackage.Literals.COST__PERSONNEL_HOURS, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Personnel Cost Share feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addPersonnelCostSharePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Cost_personnelCostShare_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Cost_personnelCostShare_feature",
								"_UI_Cost_type"),
						EnCompPackage.Literals.COST__PERSONNEL_COST_SHARE, true, false, false,
						ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Administration And Other Cost Share feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addAdministrationAndOtherCostSharePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_Cost_administrationAndOtherCostShare_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_Cost_administrationAndOtherCostShare_feature",
						"_UI_Cost_type"),
				EnCompPackage.Literals.COST__ADMINISTRATION_AND_OTHER_COST_SHARE, true, false, false,
				ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Maintenance Cost Share feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addMaintenanceCostSharePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Cost_maintenanceCostShare_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Cost_maintenanceCostShare_feature",
								"_UI_Cost_type"),
						EnCompPackage.Literals.COST__MAINTENANCE_COST_SHARE, true, false, false,
						ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(EnCompPackage.Literals.COST__INVESTMENT_COST);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This adds a property descriptor for the Datasource feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addDatasourcePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Cost_datasource_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Cost_datasource_feature", "_UI_Cost_type"),
						EnCompPackage.Literals.COST__DATASOURCE, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Investment Cost feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addInvestmentCostPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Cost_investmentCost_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Cost_investmentCost_feature",
								"_UI_Cost_type"),
						EnCompPackage.Literals.COST__INVESTMENT_COST, true, false, false, null, null, null));
	}

	/**
	 * This adds a property descriptor for the Other Investment Cost feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addOtherInvestmentCostPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Cost_otherInvestmentCost_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Cost_otherInvestmentCost_feature",
								"_UI_Cost_type"),
						EnCompPackage.Literals.COST__OTHER_INVESTMENT_COST, true, false, false,
						ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Component Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addComponentNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Cost_componentName_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Cost_componentName_feature",
								"_UI_Cost_type"),
						EnCompPackage.Literals.COST__COMPONENT_NAME, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Description feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addDescriptionPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Cost_description_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Cost_description_feature",
								"_UI_Cost_type"),
						EnCompPackage.Literals.COST__DESCRIPTION, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Heat Source feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addHeatSourcePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Cost_heatSource_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Cost_heatSource_feature", "_UI_Cost_type"),
						EnCompPackage.Literals.COST__HEAT_SOURCE, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This returns Cost.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Cost"));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean shouldComposeCreationImage() {
		return true;
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((Cost) object).getComponentName();
		return label == null || label.length() == 0 ? getString("_UI_Cost_type")
				: getString("_UI_Cost_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Cost.class)) {
		case EnCompPackage.COST__COMPONENT_NAME:
		case EnCompPackage.COST__DESCRIPTION:
		case EnCompPackage.COST__HEAT_SOURCE:
		case EnCompPackage.COST__DATASOURCE:
		case EnCompPackage.COST__OTHER_INVESTMENT_COST:
		case EnCompPackage.COST__PERSONNEL_HOURS:
		case EnCompPackage.COST__PERSONNEL_COST_SHARE:
		case EnCompPackage.COST__ADMINISTRATION_AND_OTHER_COST_SHARE:
		case EnCompPackage.COST__MAINTENANCE_COST_SHARE:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
			return;
		case EnCompPackage.COST__INVESTMENT_COST:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.COST__INVESTMENT_COST,
				EnCompFactory.eINSTANCE.createTableCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.COST__INVESTMENT_COST,
				EnCompFactory.eINSTANCE.createLinearCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.COST__INVESTMENT_COST,
				EnCompFactory.eINSTANCE.createExponentionalCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.COST__INVESTMENT_COST,
				EnCompFactory.eINSTANCE.createPolynomialCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.COST__INVESTMENT_COST,
				EnCompFactory.eINSTANCE.createPowerCharacteristic()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return EnergyComponentsEditPlugin.INSTANCE;
	}

}
