/**
 */
package de.hftstuttgart.energycomponents.provider;

import de.hftstuttgart.energycomponents.ElectricalStorage;
import de.hftstuttgart.energycomponents.EnCompPackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link de.hftstuttgart.energycomponents.ElectricalStorage} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ElectricalStorageItemProvider extends EnergyComponentItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ElectricalStorageItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addElectricalStorageTypePropertyDescriptor(object);
			addBatteryCapacityPropertyDescriptor(object);
			addBatteryVoltagePropertyDescriptor(object);
			addBatteryLifeCyclePropertyDescriptor(object);
			addSelfDischargePropertyDescriptor(object);
			addInverterIncludedPropertyDescriptor(object);
			addBatteryEffiencyPropertyDescriptor(object);
			addEnergyContentPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Electrical Storage Type feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addElectricalStorageTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_ElectricalStorage_electricalStorageType_feature"),
						getString("_UI_PropertyDescriptor_description",
								"_UI_ElectricalStorage_electricalStorageType_feature", "_UI_ElectricalStorage_type"),
						EnCompPackage.Literals.ELECTRICAL_STORAGE__ELECTRICAL_STORAGE_TYPE, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Battery Capacity feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addBatteryCapacityPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_ElectricalStorage_batteryCapacity_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_ElectricalStorage_batteryCapacity_feature",
						"_UI_ElectricalStorage_type"),
				EnCompPackage.Literals.ELECTRICAL_STORAGE__BATTERY_CAPACITY, true, false, false,
				ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Battery Voltage feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addBatteryVoltagePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_ElectricalStorage_batteryVoltage_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_ElectricalStorage_batteryVoltage_feature",
						"_UI_ElectricalStorage_type"),
				EnCompPackage.Literals.ELECTRICAL_STORAGE__BATTERY_VOLTAGE, true, false, false,
				ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Battery Life Cycle feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addBatteryLifeCyclePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_ElectricalStorage_batteryLifeCycle_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_ElectricalStorage_batteryLifeCycle_feature",
						"_UI_ElectricalStorage_type"),
				EnCompPackage.Literals.ELECTRICAL_STORAGE__BATTERY_LIFE_CYCLE, true, false, false,
				ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Self Discharge feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addSelfDischargePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_ElectricalStorage_selfDischarge_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_ElectricalStorage_selfDischarge_feature",
						"_UI_ElectricalStorage_type"),
				EnCompPackage.Literals.ELECTRICAL_STORAGE__SELF_DISCHARGE, true, false, false,
				ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Inverter Included feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addInverterIncludedPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_ElectricalStorage_inverterIncluded_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_ElectricalStorage_inverterIncluded_feature",
						"_UI_ElectricalStorage_type"),
				EnCompPackage.Literals.ELECTRICAL_STORAGE__INVERTER_INCLUDED, true, false, false,
				ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Battery Effiency feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addBatteryEffiencyPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_ElectricalStorage_batteryEffiency_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_ElectricalStorage_batteryEffiency_feature",
						"_UI_ElectricalStorage_type"),
				EnCompPackage.Literals.ELECTRICAL_STORAGE__BATTERY_EFFIENCY, true, false, false,
				ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Energy Content feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addEnergyContentPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_ElectricalStorage_energyContent_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_ElectricalStorage_energyContent_feature",
						"_UI_ElectricalStorage_type"),
				EnCompPackage.Literals.ELECTRICAL_STORAGE__ENERGY_CONTENT, true, false, false,
				ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This returns ElectricalStorage.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ElectricalStorage"));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean shouldComposeCreationImage() {
		return true;
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((ElectricalStorage) object).getModelName();
		return label == null || label.length() == 0 ? getString("_UI_ElectricalStorage_type")
				: getString("_UI_ElectricalStorage_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ElectricalStorage.class)) {
		case EnCompPackage.ELECTRICAL_STORAGE__ELECTRICAL_STORAGE_TYPE:
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_CAPACITY:
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_VOLTAGE:
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_LIFE_CYCLE:
		case EnCompPackage.ELECTRICAL_STORAGE__SELF_DISCHARGE:
		case EnCompPackage.ELECTRICAL_STORAGE__INVERTER_INCLUDED:
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_EFFIENCY:
		case EnCompPackage.ELECTRICAL_STORAGE__ENERGY_CONTENT:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
