/**
 */
package de.hftstuttgart.energycomponents.provider;

import de.hftstuttgart.energycomponents.Electrolyzer;
import de.hftstuttgart.energycomponents.EnCompPackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link de.hftstuttgart.energycomponents.Electrolyzer} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ElectrolyzerItemProvider extends EnergyComponentItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ElectrolyzerItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addCellTypePropertyDescriptor(object);
			addCellAreaPropertyDescriptor(object);
			addNumberOfCellsPropertyDescriptor(object);
			addMaxOperatingCurrentDensityPropertyDescriptor(object);
			addMinOperatingCurrentDensityPropertyDescriptor(object);
			addOverloadCapacityPropertyDescriptor(object);
			addNominalCellVoltagePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Cell Type feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addCellTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Electrolyzer_cellType_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Electrolyzer_cellType_feature",
								"_UI_Electrolyzer_type"),
						EnCompPackage.Literals.ELECTROLYZER__CELL_TYPE, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Cell Area feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addCellAreaPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Electrolyzer_cellArea_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Electrolyzer_cellArea_feature",
								"_UI_Electrolyzer_type"),
						EnCompPackage.Literals.ELECTROLYZER__CELL_AREA, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Number Of Cells feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNumberOfCellsPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Electrolyzer_numberOfCells_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Electrolyzer_numberOfCells_feature",
								"_UI_Electrolyzer_type"),
						EnCompPackage.Literals.ELECTROLYZER__NUMBER_OF_CELLS, true, false, false,
						ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Max Operating Current Density feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addMaxOperatingCurrentDensityPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_Electrolyzer_maxOperatingCurrentDensity_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_Electrolyzer_maxOperatingCurrentDensity_feature",
						"_UI_Electrolyzer_type"),
				EnCompPackage.Literals.ELECTROLYZER__MAX_OPERATING_CURRENT_DENSITY, true, false, false,
				ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Min Operating Current Density feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addMinOperatingCurrentDensityPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_Electrolyzer_minOperatingCurrentDensity_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_Electrolyzer_minOperatingCurrentDensity_feature",
						"_UI_Electrolyzer_type"),
				EnCompPackage.Literals.ELECTROLYZER__MIN_OPERATING_CURRENT_DENSITY, true, false, false,
				ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Overload Capacity feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addOverloadCapacityPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Electrolyzer_overloadCapacity_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Electrolyzer_overloadCapacity_feature",
								"_UI_Electrolyzer_type"),
						EnCompPackage.Literals.ELECTROLYZER__OVERLOAD_CAPACITY, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Nominal Cell Voltage feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNominalCellVoltagePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_Electrolyzer_nominalCellVoltage_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_Electrolyzer_nominalCellVoltage_feature",
								"_UI_Electrolyzer_type"),
						EnCompPackage.Literals.ELECTROLYZER__NOMINAL_CELL_VOLTAGE, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This returns Electrolyzer.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Electrolyzer"));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean shouldComposeCreationImage() {
		return true;
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((Electrolyzer) object).getModelName();
		return label == null || label.length() == 0 ? getString("_UI_Electrolyzer_type")
				: getString("_UI_Electrolyzer_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Electrolyzer.class)) {
		case EnCompPackage.ELECTROLYZER__CELL_TYPE:
		case EnCompPackage.ELECTROLYZER__CELL_AREA:
		case EnCompPackage.ELECTROLYZER__NUMBER_OF_CELLS:
		case EnCompPackage.ELECTROLYZER__MAX_OPERATING_CURRENT_DENSITY:
		case EnCompPackage.ELECTROLYZER__MIN_OPERATING_CURRENT_DENSITY:
		case EnCompPackage.ELECTROLYZER__OVERLOAD_CAPACITY:
		case EnCompPackage.ELECTROLYZER__NOMINAL_CELL_VOLTAGE:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
