/**
 */
package de.hftstuttgart.energycomponents.provider;

import de.hftstuttgart.energycomponents.util.EnCompAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class EnCompItemProviderAdapterFactory extends EnCompAdapterFactory
		implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EnCompItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.ThermalStorage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ThermalStorageItemProvider thermalStorageItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.ThermalStorage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createThermalStorageAdapter() {
		if (thermalStorageItemProvider == null) {
			thermalStorageItemProvider = new ThermalStorageItemProvider(this);
		}

		return thermalStorageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.ElectricalStorage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ElectricalStorageItemProvider electricalStorageItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.ElectricalStorage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createElectricalStorageAdapter() {
		if (electricalStorageItemProvider == null) {
			electricalStorageItemProvider = new ElectricalStorageItemProvider(this);
		}

		return electricalStorageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.CombinedHeatPower} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CombinedHeatPowerItemProvider combinedHeatPowerItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.CombinedHeatPower}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCombinedHeatPowerAdapter() {
		if (combinedHeatPowerItemProvider == null) {
			combinedHeatPowerItemProvider = new CombinedHeatPowerItemProvider(this);
		}

		return combinedHeatPowerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.HeatPump} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HeatPumpItemProvider heatPumpItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.HeatPump}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createHeatPumpAdapter() {
		if (heatPumpItemProvider == null) {
			heatPumpItemProvider = new HeatPumpItemProvider(this);
		}

		return heatPumpItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.Boiler} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BoilerItemProvider boilerItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.Boiler}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBoilerAdapter() {
		if (boilerItemProvider == null) {
			boilerItemProvider = new BoilerItemProvider(this);
		}

		return boilerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.SolarThermalCollector} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SolarThermalCollectorItemProvider solarThermalCollectorItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.SolarThermalCollector}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSolarThermalCollectorAdapter() {
		if (solarThermalCollectorItemProvider == null) {
			solarThermalCollectorItemProvider = new SolarThermalCollectorItemProvider(this);
		}

		return solarThermalCollectorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnergyComponentsCatalogItemProvider energyComponentsCatalogItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEnergyComponentsCatalogAdapter() {
		if (energyComponentsCatalogItemProvider == null) {
			energyComponentsCatalogItemProvider = new EnergyComponentsCatalogItemProvider(this);
		}

		return energyComponentsCatalogItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.Electrolyzer} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ElectrolyzerItemProvider electrolyzerItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.Electrolyzer}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createElectrolyzerAdapter() {
		if (electrolyzerItemProvider == null) {
			electrolyzerItemProvider = new ElectrolyzerItemProvider(this);
		}

		return electrolyzerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.LinearFunction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LinearFunctionItemProvider linearFunctionItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.LinearFunction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLinearFunctionAdapter() {
		if (linearFunctionItemProvider == null) {
			linearFunctionItemProvider = new LinearFunctionItemProvider(this);
		}

		return linearFunctionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.HydrogenCompressor} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HydrogenCompressorItemProvider hydrogenCompressorItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.HydrogenCompressor}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createHydrogenCompressorAdapter() {
		if (hydrogenCompressorItemProvider == null) {
			hydrogenCompressorItemProvider = new HydrogenCompressorItemProvider(this);
		}

		return hydrogenCompressorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.HydrogenStorage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HydrogenStorageItemProvider hydrogenStorageItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.HydrogenStorage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createHydrogenStorageAdapter() {
		if (hydrogenStorageItemProvider == null) {
			hydrogenStorageItemProvider = new HydrogenStorageItemProvider(this);
		}

		return hydrogenStorageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.FuelCell} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FuelCellItemProvider fuelCellItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.FuelCell}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFuelCellAdapter() {
		if (fuelCellItemProvider == null) {
			fuelCellItemProvider = new FuelCellItemProvider(this);
		}

		return fuelCellItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.ExponentialFunction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExponentialFunctionItemProvider exponentialFunctionItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.ExponentialFunction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createExponentialFunctionAdapter() {
		if (exponentialFunctionItemProvider == null) {
			exponentialFunctionItemProvider = new ExponentialFunctionItemProvider(this);
		}

		return exponentialFunctionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.TableCharacteristic} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TableCharacteristicItemProvider tableCharacteristicItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.TableCharacteristic}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTableCharacteristicAdapter() {
		if (tableCharacteristicItemProvider == null) {
			tableCharacteristicItemProvider = new TableCharacteristicItemProvider(this);
		}

		return tableCharacteristicItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.LinearCharacteristic} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LinearCharacteristicItemProvider linearCharacteristicItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.LinearCharacteristic}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLinearCharacteristicAdapter() {
		if (linearCharacteristicItemProvider == null) {
			linearCharacteristicItemProvider = new LinearCharacteristicItemProvider(this);
		}

		return linearCharacteristicItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.ExponentionalCharacteristic} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExponentionalCharacteristicItemProvider exponentionalCharacteristicItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.ExponentionalCharacteristic}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createExponentionalCharacteristicAdapter() {
		if (exponentionalCharacteristicItemProvider == null) {
			exponentionalCharacteristicItemProvider = new ExponentionalCharacteristicItemProvider(this);
		}

		return exponentionalCharacteristicItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.Manufacturer} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ManufacturerItemProvider manufacturerItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.Manufacturer}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createManufacturerAdapter() {
		if (manufacturerItemProvider == null) {
			manufacturerItemProvider = new ManufacturerItemProvider(this);
		}

		return manufacturerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.PolynomialCharacteristic} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PolynomialCharacteristicItemProvider polynomialCharacteristicItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.PolynomialCharacteristic}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPolynomialCharacteristicAdapter() {
		if (polynomialCharacteristicItemProvider == null) {
			polynomialCharacteristicItemProvider = new PolynomialCharacteristicItemProvider(this);
		}

		return polynomialCharacteristicItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.PolynomialFunction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PolynomialFunctionItemProvider polynomialFunctionItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.PolynomialFunction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPolynomialFunctionAdapter() {
		if (polynomialFunctionItemProvider == null) {
			polynomialFunctionItemProvider = new PolynomialFunctionItemProvider(this);
		}

		return polynomialFunctionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.Material} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MaterialItemProvider materialItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.Material}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMaterialAdapter() {
		if (materialItemProvider == null) {
			materialItemProvider = new MaterialItemProvider(this);
		}

		return materialItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnergyComponentsCostCatalogItemProvider energyComponentsCostCatalogItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEnergyComponentsCostCatalogAdapter() {
		if (energyComponentsCostCatalogItemProvider == null) {
			energyComponentsCostCatalogItemProvider = new EnergyComponentsCostCatalogItemProvider(this);
		}

		return energyComponentsCostCatalogItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.Cost} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CostItemProvider costItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.Cost}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCostAdapter() {
		if (costItemProvider == null) {
			costItemProvider = new CostItemProvider(this);
		}

		return costItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.PowerCharacteristic} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PowerCharacteristicItemProvider powerCharacteristicItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.PowerCharacteristic}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPowerCharacteristicAdapter() {
		if (powerCharacteristicItemProvider == null) {
			powerCharacteristicItemProvider = new PowerCharacteristicItemProvider(this);
		}

		return powerCharacteristicItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.PowerFunction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PowerFunctionItemProvider powerFunctionItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.PowerFunction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPowerFunctionAdapter() {
		if (powerFunctionItemProvider == null) {
			powerFunctionItemProvider = new PowerFunctionItemProvider(this);
		}

		return powerFunctionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.FossilFuel} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FossilFuelItemProvider fossilFuelItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.FossilFuel}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFossilFuelAdapter() {
		if (fossilFuelItemProvider == null) {
			fossilFuelItemProvider = new FossilFuelItemProvider(this);
		}

		return fossilFuelItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.Hydrogen} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HydrogenItemProvider hydrogenItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.Hydrogen}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createHydrogenAdapter() {
		if (hydrogenItemProvider == null) {
			hydrogenItemProvider = new HydrogenItemProvider(this);
		}

		return hydrogenItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.BioFuel} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BioFuelItemProvider bioFuelItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.BioFuel}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBioFuelAdapter() {
		if (bioFuelItemProvider == null) {
			bioFuelItemProvider = new BioFuelItemProvider(this);
		}

		return bioFuelItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.WindTurbine} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected WindTurbineItemProvider windTurbineItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.WindTurbine}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createWindTurbineAdapter() {
		if (windTurbineItemProvider == null) {
			windTurbineItemProvider = new WindTurbineItemProvider(this);
		}

		return windTurbineItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.PhotovoltaicModule} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PhotovoltaicModuleItemProvider photovoltaicModuleItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.PhotovoltaicModule}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPhotovoltaicModuleAdapter() {
		if (photovoltaicModuleItemProvider == null) {
			photovoltaicModuleItemProvider = new PhotovoltaicModuleItemProvider(this);
		}

		return photovoltaicModuleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.Inverter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InverterItemProvider inverterItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.Inverter}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInverterAdapter() {
		if (inverterItemProvider == null) {
			inverterItemProvider = new InverterItemProvider(this);
		}

		return inverterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.HeatExchanger} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HeatExchangerItemProvider heatExchangerItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.HeatExchanger}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createHeatExchangerAdapter() {
		if (heatExchangerItemProvider == null) {
			heatExchangerItemProvider = new HeatExchangerItemProvider(this);
		}

		return heatExchangerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.GeothermalHeatExchanger} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GeothermalHeatExchangerItemProvider geothermalHeatExchangerItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.GeothermalHeatExchanger}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createGeothermalHeatExchangerAdapter() {
		if (geothermalHeatExchangerItemProvider == null) {
			geothermalHeatExchangerItemProvider = new GeothermalHeatExchangerItemProvider(this);
		}

		return geothermalHeatExchangerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.Medium} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MediumItemProvider mediumItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.Medium}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMediumAdapter() {
		if (mediumItemProvider == null) {
			mediumItemProvider = new MediumItemProvider(this);
		}

		return mediumItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.TableFunction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TableFunctionItemProvider tableFunctionItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.TableFunction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTableFunctionAdapter() {
		if (tableFunctionItemProvider == null) {
			tableFunctionItemProvider = new TableFunctionItemProvider(this);
		}

		return tableFunctionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.hftstuttgart.energycomponents.DataPoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataPointItemProvider dataPointItemProvider;

	/**
	 * This creates an adapter for a {@link de.hftstuttgart.energycomponents.DataPoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDataPointAdapter() {
		if (dataPointItemProvider == null) {
			dataPointItemProvider = new DataPointItemProvider(this);
		}

		return dataPointItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>) type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void dispose() {
		if (energyComponentsCatalogItemProvider != null)
			energyComponentsCatalogItemProvider.dispose();
		if (thermalStorageItemProvider != null)
			thermalStorageItemProvider.dispose();
		if (electricalStorageItemProvider != null)
			electricalStorageItemProvider.dispose();
		if (combinedHeatPowerItemProvider != null)
			combinedHeatPowerItemProvider.dispose();
		if (heatPumpItemProvider != null)
			heatPumpItemProvider.dispose();
		if (boilerItemProvider != null)
			boilerItemProvider.dispose();
		if (solarThermalCollectorItemProvider != null)
			solarThermalCollectorItemProvider.dispose();
		if (electrolyzerItemProvider != null)
			electrolyzerItemProvider.dispose();
		if (hydrogenCompressorItemProvider != null)
			hydrogenCompressorItemProvider.dispose();
		if (hydrogenStorageItemProvider != null)
			hydrogenStorageItemProvider.dispose();
		if (fuelCellItemProvider != null)
			fuelCellItemProvider.dispose();
		if (fossilFuelItemProvider != null)
			fossilFuelItemProvider.dispose();
		if (hydrogenItemProvider != null)
			hydrogenItemProvider.dispose();
		if (bioFuelItemProvider != null)
			bioFuelItemProvider.dispose();
		if (windTurbineItemProvider != null)
			windTurbineItemProvider.dispose();
		if (photovoltaicModuleItemProvider != null)
			photovoltaicModuleItemProvider.dispose();
		if (inverterItemProvider != null)
			inverterItemProvider.dispose();
		if (heatExchangerItemProvider != null)
			heatExchangerItemProvider.dispose();
		if (geothermalHeatExchangerItemProvider != null)
			geothermalHeatExchangerItemProvider.dispose();
		if (mediumItemProvider != null)
			mediumItemProvider.dispose();
		if (linearFunctionItemProvider != null)
			linearFunctionItemProvider.dispose();
		if (dataPointItemProvider != null)
			dataPointItemProvider.dispose();
		if (tableFunctionItemProvider != null)
			tableFunctionItemProvider.dispose();
		if (exponentialFunctionItemProvider != null)
			exponentialFunctionItemProvider.dispose();
		if (tableCharacteristicItemProvider != null)
			tableCharacteristicItemProvider.dispose();
		if (linearCharacteristicItemProvider != null)
			linearCharacteristicItemProvider.dispose();
		if (exponentionalCharacteristicItemProvider != null)
			exponentionalCharacteristicItemProvider.dispose();
		if (manufacturerItemProvider != null)
			manufacturerItemProvider.dispose();
		if (polynomialCharacteristicItemProvider != null)
			polynomialCharacteristicItemProvider.dispose();
		if (polynomialFunctionItemProvider != null)
			polynomialFunctionItemProvider.dispose();
		if (materialItemProvider != null)
			materialItemProvider.dispose();
		if (energyComponentsCostCatalogItemProvider != null)
			energyComponentsCostCatalogItemProvider.dispose();
		if (costItemProvider != null)
			costItemProvider.dispose();
		if (powerCharacteristicItemProvider != null)
			powerCharacteristicItemProvider.dispose();
		if (powerFunctionItemProvider != null)
			powerFunctionItemProvider.dispose();
	}

}
