/**
 */
package de.hftstuttgart.energycomponents.provider;

import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.EnergyComponentsCatalog;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class EnergyComponentsCatalogItemProvider extends ItemProviderAdapter implements IEditingDomainItemProvider,
		IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EnergyComponentsCatalogItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addAuthorPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Author feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addAuthorPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_EnergyComponentsCatalog_author_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_EnergyComponentsCatalog_author_feature",
						"_UI_EnergyComponentsCatalog_type"),
				EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__AUTHOR, true, false, false,
				ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__BIO_FUELS);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__MEDIA);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__COMBINED_HEAT_POWER_UTILITIES);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__BOILERS);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__PHOTOVOLTAIC_MODULES);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__SOLAR_THERMAL_COLLECTORS);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__WIND_TURBINES);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__GEOTHERMAL_HEAT_EXCHANGERS);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__HEAT_PUMPS);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__INVERTERS);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__HEAT_EXCHANGERS);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__ELECTROLYZERS);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__HYDROGEN_COMPRESSORS);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__FUEL_CELLS);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__THERMAL_STORAGES);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__POWER_STORAGES);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__HYDROGEN_STORAGES);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__FOSSIL_FUELS);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__MANUFACTURERS);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__MATERIALS);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG);
			childrenFeatures.add(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns EnergyComponentsCatalog.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/EnergyComponentsCatalog"));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean shouldComposeCreationImage() {
		return true;
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((EnergyComponentsCatalog) object).getAuthor();
		return label == null || label.length() == 0 ? getString("_UI_EnergyComponentsCatalog_type")
				: getString("_UI_EnergyComponentsCatalog_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(EnergyComponentsCatalog.class)) {
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__AUTHOR:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__BIO_FUELS:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MEDIA:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__COMBINED_HEAT_POWER_UTILITIES:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__BOILERS:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__PHOTOVOLTAIC_MODULES:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__SOLAR_THERMAL_COLLECTORS:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__WIND_TURBINES:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__GEOTHERMAL_HEAT_EXCHANGERS:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_PUMPS:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__INVERTERS:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_EXCHANGERS:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ELECTROLYZERS:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_COMPRESSORS:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__FUEL_CELLS:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__THERMAL_STORAGES:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__POWER_STORAGES:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_STORAGES:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__FOSSIL_FUELS:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MANUFACTURERS:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MATERIALS:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG:
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__BIO_FUELS,
				EnCompFactory.eINSTANCE.createBioFuel()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__MEDIA,
				EnCompFactory.eINSTANCE.createMedium()));

		newChildDescriptors.add(
				createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__COMBINED_HEAT_POWER_UTILITIES,
						EnCompFactory.eINSTANCE.createCombinedHeatPower()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__BOILERS,
				EnCompFactory.eINSTANCE.createBoiler()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__PHOTOVOLTAIC_MODULES,
						EnCompFactory.eINSTANCE.createPhotovoltaicModule()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__SOLAR_THERMAL_COLLECTORS,
						EnCompFactory.eINSTANCE.createSolarThermalCollector()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__WIND_TURBINES,
				EnCompFactory.eINSTANCE.createWindTurbine()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__GEOTHERMAL_HEAT_EXCHANGERS,
						EnCompFactory.eINSTANCE.createGeothermalHeatExchanger()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__HEAT_PUMPS,
				EnCompFactory.eINSTANCE.createHeatPump()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__INVERTERS,
				EnCompFactory.eINSTANCE.createInverter()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__HEAT_EXCHANGERS,
				EnCompFactory.eINSTANCE.createHeatExchanger()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__ELECTROLYZERS,
				EnCompFactory.eINSTANCE.createElectrolyzer()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__HYDROGEN_COMPRESSORS,
						EnCompFactory.eINSTANCE.createHydrogenCompressor()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__FUEL_CELLS,
				EnCompFactory.eINSTANCE.createFuelCell()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__THERMAL_STORAGES,
				EnCompFactory.eINSTANCE.createThermalStorage()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__POWER_STORAGES,
				EnCompFactory.eINSTANCE.createElectricalStorage()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__HYDROGEN_STORAGES,
						EnCompFactory.eINSTANCE.createHydrogenStorage()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__FOSSIL_FUELS,
				EnCompFactory.eINSTANCE.createFossilFuel()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__MANUFACTURERS,
				EnCompFactory.eINSTANCE.createManufacturer()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__MATERIALS,
				EnCompFactory.eINSTANCE.createMaterial()));

		newChildDescriptors
				.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG,
						EnCompFactory.eINSTANCE.createEnergyComponentsCostCatalog()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS,
				EnCompFactory.eINSTANCE.createFossilFuel()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS,
				EnCompFactory.eINSTANCE.createHydrogen()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS,
				EnCompFactory.eINSTANCE.createBioFuel()));
	}

	/**
	 * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify = childFeature == EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__BIO_FUELS
				|| childFeature == EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS
				|| childFeature == EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG__FOSSIL_FUELS;

		if (qualify) {
			return getString("_UI_CreateChild_text2",
					new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return EnergyComponentsEditPlugin.INSTANCE;
	}

}
