/**
 */
package de.hftstuttgart.energycomponents.provider;

import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.HeatPump;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link de.hftstuttgart.energycomponents.HeatPump} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class HeatPumpItemProvider extends ThermalEnergyDeviceItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HeatPumpItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addHeatSourcePropertyDescriptor(object);
			addCoefficientOfPerformancePropertyDescriptor(object);
			addPowerInputPropertyDescriptor(object);
			addHeatOutputPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Heat Source feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addHeatSourcePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_HeatPump_heatSource_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_HeatPump_heatSource_feature",
								"_UI_HeatPump_type"),
						EnCompPackage.Literals.HEAT_PUMP__HEAT_SOURCE, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Coefficient Of Performance feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addCoefficientOfPerformancePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_HeatPump_coefficientOfPerformance_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_HeatPump_coefficientOfPerformance_feature",
								"_UI_HeatPump_type"),
						EnCompPackage.Literals.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE, true, false, false, null, null,
						null));
	}

	/**
	 * This adds a property descriptor for the Power Input feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addPowerInputPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_HeatPump_powerInput_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_HeatPump_powerInput_feature",
								"_UI_HeatPump_type"),
						EnCompPackage.Literals.HEAT_PUMP__POWER_INPUT, true, false, false, null, null, null));
	}

	/**
	 * This adds a property descriptor for the Heat Output feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addHeatOutputPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_HeatPump_heatOutput_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_HeatPump_heatOutput_feature",
								"_UI_HeatPump_type"),
						EnCompPackage.Literals.HEAT_PUMP__HEAT_OUTPUT, true, false, false, null, null, null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(EnCompPackage.Literals.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE);
			childrenFeatures.add(EnCompPackage.Literals.HEAT_PUMP__POWER_INPUT);
			childrenFeatures.add(EnCompPackage.Literals.HEAT_PUMP__HEAT_OUTPUT);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns HeatPump.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/HeatPump"));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean shouldComposeCreationImage() {
		return true;
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((HeatPump) object).getModelName();
		return label == null || label.length() == 0 ? getString("_UI_HeatPump_type")
				: getString("_UI_HeatPump_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(HeatPump.class)) {
		case EnCompPackage.HEAT_PUMP__HEAT_SOURCE:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
			return;
		case EnCompPackage.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE:
		case EnCompPackage.HEAT_PUMP__POWER_INPUT:
		case EnCompPackage.HEAT_PUMP__HEAT_OUTPUT:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE,
				EnCompFactory.eINSTANCE.createTableCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE,
				EnCompFactory.eINSTANCE.createLinearCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE,
				EnCompFactory.eINSTANCE.createExponentionalCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE,
				EnCompFactory.eINSTANCE.createPolynomialCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE,
				EnCompFactory.eINSTANCE.createPowerCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__POWER_INPUT,
				EnCompFactory.eINSTANCE.createTableCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__POWER_INPUT,
				EnCompFactory.eINSTANCE.createLinearCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__POWER_INPUT,
				EnCompFactory.eINSTANCE.createExponentionalCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__POWER_INPUT,
				EnCompFactory.eINSTANCE.createPolynomialCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__POWER_INPUT,
				EnCompFactory.eINSTANCE.createPowerCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__HEAT_OUTPUT,
				EnCompFactory.eINSTANCE.createTableCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__HEAT_OUTPUT,
				EnCompFactory.eINSTANCE.createLinearCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__HEAT_OUTPUT,
				EnCompFactory.eINSTANCE.createExponentionalCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__HEAT_OUTPUT,
				EnCompFactory.eINSTANCE.createPolynomialCharacteristic()));

		newChildDescriptors.add(createChildParameter(EnCompPackage.Literals.HEAT_PUMP__HEAT_OUTPUT,
				EnCompFactory.eINSTANCE.createPowerCharacteristic()));
	}

	/**
	 * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify = childFeature == EnCompPackage.Literals.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE
				|| childFeature == EnCompPackage.Literals.HEAT_PUMP__POWER_INPUT
				|| childFeature == EnCompPackage.Literals.HEAT_PUMP__HEAT_OUTPUT;

		if (qualify) {
			return getString("_UI_CreateChild_text2",
					new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

}
