/**
 */
package de.hftstuttgart.energycomponents.provider;

import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.PhotovoltaicModule;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link de.hftstuttgart.energycomponents.PhotovoltaicModule} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class PhotovoltaicModuleItemProvider extends EnergyComponentItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PhotovoltaicModuleItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addCellTypePropertyDescriptor(object);
			addNominalPowerPropertyDescriptor(object);
			addMppVoltagePropertyDescriptor(object);
			addMppCurrentPropertyDescriptor(object);
			addNominalEfficiencyPropertyDescriptor(object);
			addModuleAreaPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Cell Type feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addCellTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_PhotovoltaicModule_cellType_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_PhotovoltaicModule_cellType_feature",
								"_UI_PhotovoltaicModule_type"),
						EnCompPackage.Literals.PHOTOVOLTAIC_MODULE__CELL_TYPE, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Nominal Power feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNominalPowerPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_PhotovoltaicModule_nominalPower_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_PhotovoltaicModule_nominalPower_feature",
						"_UI_PhotovoltaicModule_type"),
				EnCompPackage.Literals.PHOTOVOLTAIC_MODULE__NOMINAL_POWER, true, false, false,
				ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Mpp Voltage feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addMppVoltagePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_PhotovoltaicModule_mppVoltage_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_PhotovoltaicModule_mppVoltage_feature",
								"_UI_PhotovoltaicModule_type"),
						EnCompPackage.Literals.PHOTOVOLTAIC_MODULE__MPP_VOLTAGE, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Mpp Current feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addMppCurrentPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_PhotovoltaicModule_mppCurrent_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_PhotovoltaicModule_mppCurrent_feature",
								"_UI_PhotovoltaicModule_type"),
						EnCompPackage.Literals.PHOTOVOLTAIC_MODULE__MPP_CURRENT, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Nominal Efficiency feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNominalEfficiencyPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_PhotovoltaicModule_nominalEfficiency_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_PhotovoltaicModule_nominalEfficiency_feature",
						"_UI_PhotovoltaicModule_type"),
				EnCompPackage.Literals.PHOTOVOLTAIC_MODULE__NOMINAL_EFFICIENCY, true, false, false,
				ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Module Area feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addModuleAreaPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_PhotovoltaicModule_moduleArea_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_PhotovoltaicModule_moduleArea_feature",
								"_UI_PhotovoltaicModule_type"),
						EnCompPackage.Literals.PHOTOVOLTAIC_MODULE__MODULE_AREA, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This returns PhotovoltaicModule.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/PhotovoltaicModule"));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean shouldComposeCreationImage() {
		return true;
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((PhotovoltaicModule) object).getModelName();
		return label == null || label.length() == 0 ? getString("_UI_PhotovoltaicModule_type")
				: getString("_UI_PhotovoltaicModule_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(PhotovoltaicModule.class)) {
		case EnCompPackage.PHOTOVOLTAIC_MODULE__CELL_TYPE:
		case EnCompPackage.PHOTOVOLTAIC_MODULE__NOMINAL_POWER:
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MPP_VOLTAGE:
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MPP_CURRENT:
		case EnCompPackage.PHOTOVOLTAIC_MODULE__NOMINAL_EFFICIENCY:
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MODULE_AREA:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
