/**
 */
package de.hftstuttgart.energycomponents.provider;

import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.SolarThermalCollector;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link de.hftstuttgart.energycomponents.SolarThermalCollector} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class SolarThermalCollectorItemProvider extends EnergyComponentItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SolarThermalCollectorItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addCollectorTypePropertyDescriptor(object);
			addApertureAreaPropertyDescriptor(object);
			addOpticalEfficiencyPropertyDescriptor(object);
			addLinearHeatLossCoefficientPropertyDescriptor(object);
			addQuadraticalHeatLossCoefficientPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Collector Type feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addCollectorTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_SolarThermalCollector_collectorType_feature"),
						getString("_UI_PropertyDescriptor_description",
								"_UI_SolarThermalCollector_collectorType_feature", "_UI_SolarThermalCollector_type"),
						EnCompPackage.Literals.SOLAR_THERMAL_COLLECTOR__COLLECTOR_TYPE, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Aperture Area feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addApertureAreaPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_SolarThermalCollector_apertureArea_feature"),
						getString("_UI_PropertyDescriptor_description",
								"_UI_SolarThermalCollector_apertureArea_feature", "_UI_SolarThermalCollector_type"),
						EnCompPackage.Literals.SOLAR_THERMAL_COLLECTOR__APERTURE_AREA, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Optical Efficiency feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addOpticalEfficiencyPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_SolarThermalCollector_opticalEfficiency_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_SolarThermalCollector_opticalEfficiency_feature",
						"_UI_SolarThermalCollector_type"),
				EnCompPackage.Literals.SOLAR_THERMAL_COLLECTOR__OPTICAL_EFFICIENCY, true, false, false,
				ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Linear Heat Loss Coefficient feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addLinearHeatLossCoefficientPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_SolarThermalCollector_linearHeatLossCoefficient_feature"),
						getString("_UI_PropertyDescriptor_description",
								"_UI_SolarThermalCollector_linearHeatLossCoefficient_feature",
								"_UI_SolarThermalCollector_type"),
						EnCompPackage.Literals.SOLAR_THERMAL_COLLECTOR__LINEAR_HEAT_LOSS_COEFFICIENT, true, false,
						false, ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Quadratical Heat Loss Coefficient feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addQuadraticalHeatLossCoefficientPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_SolarThermalCollector_quadraticalHeatLossCoefficient_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_SolarThermalCollector_quadraticalHeatLossCoefficient_feature",
						"_UI_SolarThermalCollector_type"),
				EnCompPackage.Literals.SOLAR_THERMAL_COLLECTOR__QUADRATICAL_HEAT_LOSS_COEFFICIENT, true, false, false,
				ItemPropertyDescriptor.REAL_VALUE_IMAGE, null, null));
	}

	/**
	 * This returns SolarThermalCollector.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/SolarThermalCollector"));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean shouldComposeCreationImage() {
		return true;
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((SolarThermalCollector) object).getModelName();
		return label == null || label.length() == 0 ? getString("_UI_SolarThermalCollector_type")
				: getString("_UI_SolarThermalCollector_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(SolarThermalCollector.class)) {
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__COLLECTOR_TYPE:
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__APERTURE_AREA:
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__OPTICAL_EFFICIENCY:
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__LINEAR_HEAT_LOSS_COEFFICIENT:
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__QUADRATICAL_HEAT_LOSS_COEFFICIENT:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
