/**
 */
package de.hftstuttgart.energycomponents.provider;

import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.ThermalStorage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link de.hftstuttgart.energycomponents.ThermalStorage} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ThermalStorageItemProvider extends EnergyComponentItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ThermalStorageItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addVolumePropertyDescriptor(object);
			addThermalStorageTypePropertyDescriptor(object);
			addMaxTempPropertyDescriptor(object);
			addTankThicknessPropertyDescriptor(object);
			addInsulationThicknessPropertyDescriptor(object);
			addUsesMediumPropertyDescriptor(object);
			addInsulationMaterialPropertyDescriptor(object);
			addHeightPropertyDescriptor(object);
			addTankMaterialPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Volume feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addVolumePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_ThermalStorage_volume_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_ThermalStorage_volume_feature",
								"_UI_ThermalStorage_type"),
						EnCompPackage.Literals.THERMAL_STORAGE__VOLUME, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Thermal Storage Type feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addThermalStorageTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_ThermalStorage_thermalStorageType_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_ThermalStorage_thermalStorageType_feature",
						"_UI_ThermalStorage_type"),
				EnCompPackage.Literals.THERMAL_STORAGE__THERMAL_STORAGE_TYPE, true, false, false,
				ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Max Temp feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addMaxTempPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_ThermalStorage_maxTemp_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_ThermalStorage_maxTemp_feature",
								"_UI_ThermalStorage_type"),
						EnCompPackage.Literals.THERMAL_STORAGE__MAX_TEMP, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Tank Thickness feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addTankThicknessPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_ThermalStorage_tankThickness_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_ThermalStorage_tankThickness_feature",
								"_UI_ThermalStorage_type"),
						EnCompPackage.Literals.THERMAL_STORAGE__TANK_THICKNESS, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Insulation Thickness feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addInsulationThicknessPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_ThermalStorage_insulationThickness_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_ThermalStorage_insulationThickness_feature",
						"_UI_ThermalStorage_type"),
				EnCompPackage.Literals.THERMAL_STORAGE__INSULATION_THICKNESS, true, false, false,
				ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Uses Medium feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addUsesMediumPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_ThermalStorage_usesMedium_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_ThermalStorage_usesMedium_feature",
								"_UI_ThermalStorage_type"),
						EnCompPackage.Literals.THERMAL_STORAGE__USES_MEDIUM, true, false, true, null, null, null));
	}

	/**
	 * This adds a property descriptor for the Insulation Material feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addInsulationMaterialPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_ThermalStorage_insulationMaterial_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_ThermalStorage_insulationMaterial_feature",
								"_UI_ThermalStorage_type"),
						EnCompPackage.Literals.THERMAL_STORAGE__INSULATION_MATERIAL, true, false, true, null, null,
						null));
	}

	/**
	 * This adds a property descriptor for the Height feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addHeightPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_ThermalStorage_height_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_ThermalStorage_height_feature",
								"_UI_ThermalStorage_type"),
						EnCompPackage.Literals.THERMAL_STORAGE__HEIGHT, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Tank Material feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addTankMaterialPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_ThermalStorage_tankMaterial_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_ThermalStorage_tankMaterial_feature",
								"_UI_ThermalStorage_type"),
						EnCompPackage.Literals.THERMAL_STORAGE__TANK_MATERIAL, true, false, true, null, null, null));
	}

	/**
	 * This returns ThermalStorage.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ThermalStorage"));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean shouldComposeCreationImage() {
		return true;
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((ThermalStorage) object).getModelName();
		return label == null || label.length() == 0 ? getString("_UI_ThermalStorage_type")
				: getString("_UI_ThermalStorage_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ThermalStorage.class)) {
		case EnCompPackage.THERMAL_STORAGE__VOLUME:
		case EnCompPackage.THERMAL_STORAGE__THERMAL_STORAGE_TYPE:
		case EnCompPackage.THERMAL_STORAGE__MAX_TEMP:
		case EnCompPackage.THERMAL_STORAGE__TANK_THICKNESS:
		case EnCompPackage.THERMAL_STORAGE__INSULATION_THICKNESS:
		case EnCompPackage.THERMAL_STORAGE__HEIGHT:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
