/**
 */
package de.hftstuttgart.energycomponents;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Bio Fuel Types</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getBioFuelTypes()
 * @model
 * @generated
 */
public enum BioFuelTypes implements Enumerator {
	/**
	 * The '<em><b>Bio Gas</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BIO_GAS_VALUE
	 * @generated
	 * @ordered
	 */
	BIO_GAS(0, "bioGas", "bioGas"),

	/**
	 * The '<em><b>Synthetic Gas</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SYNTHETIC_GAS_VALUE
	 * @generated
	 * @ordered
	 */
	SYNTHETIC_GAS(1, "syntheticGas", "syntheticGas"),

	/**
	 * The '<em><b>Wood Pellets</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #WOOD_PELLETS_VALUE
	 * @generated
	 * @ordered
	 */
	WOOD_PELLETS(2, "woodPellets", "woodPellets"),

	/**
	 * The '<em><b>Wood Chips</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #WOOD_CHIPS_VALUE
	 * @generated
	 * @ordered
	 */
	WOOD_CHIPS(3, "woodChips", "woodChips"),

	/**
	 * The '<em><b>Sewage Gas</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SEWAGE_GAS_VALUE
	 * @generated
	 * @ordered
	 */
	SEWAGE_GAS(4, "sewageGas", "sewageGas");

	/**
	 * The '<em><b>Bio Gas</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BIO_GAS
	 * @model name="bioGas"
	 * @generated
	 * @ordered
	 */
	public static final int BIO_GAS_VALUE = 0;

	/**
	 * The '<em><b>Synthetic Gas</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SYNTHETIC_GAS
	 * @model name="syntheticGas"
	 * @generated
	 * @ordered
	 */
	public static final int SYNTHETIC_GAS_VALUE = 1;

	/**
	 * The '<em><b>Wood Pellets</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #WOOD_PELLETS
	 * @model name="woodPellets"
	 * @generated
	 * @ordered
	 */
	public static final int WOOD_PELLETS_VALUE = 2;

	/**
	 * The '<em><b>Wood Chips</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #WOOD_CHIPS
	 * @model name="woodChips"
	 * @generated
	 * @ordered
	 */
	public static final int WOOD_CHIPS_VALUE = 3;

	/**
	 * The '<em><b>Sewage Gas</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SEWAGE_GAS
	 * @model name="sewageGas"
	 * @generated
	 * @ordered
	 */
	public static final int SEWAGE_GAS_VALUE = 4;

	/**
	 * An array of all the '<em><b>Bio Fuel Types</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final BioFuelTypes[] VALUES_ARRAY = new BioFuelTypes[] { BIO_GAS, SYNTHETIC_GAS, WOOD_PELLETS,
			WOOD_CHIPS, SEWAGE_GAS, };

	/**
	 * A public read-only list of all the '<em><b>Bio Fuel Types</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<BioFuelTypes> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Bio Fuel Types</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static BioFuelTypes get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			BioFuelTypes result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Bio Fuel Types</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static BioFuelTypes getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			BioFuelTypes result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Bio Fuel Types</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static BioFuelTypes get(int value) {
		switch (value) {
		case BIO_GAS_VALUE:
			return BIO_GAS;
		case SYNTHETIC_GAS_VALUE:
			return SYNTHETIC_GAS;
		case WOOD_PELLETS_VALUE:
			return WOOD_PELLETS;
		case WOOD_CHIPS_VALUE:
			return WOOD_CHIPS;
		case SEWAGE_GAS_VALUE:
			return SEWAGE_GAS;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private BioFuelTypes(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int getValue() {
		return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getLiteral() {
		return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}

} //BioFuelTypes
