/**
 */
package de.hftstuttgart.energycomponents;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Boiler Types</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getBoilerTypes()
 * @model
 * @generated
 */
public enum BoilerTypes implements Enumerator {
	/**
	 * The '<em><b>Condensing Boiler</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CONDENSING_BOILER_VALUE
	 * @generated
	 * @ordered
	 */
	CONDENSING_BOILER(0, "condensingBoiler", "condensingBoiler"),
	/**
	 * The '<em><b>Lowtemperature Boiler</b></em>' literal object.
	 * <!-- begin-user-doc -->
	* <!-- end-user-doc -->
	 * @see #LOWTEMPERATURE_BOILER_VALUE
	 * @generated
	 * @ordered
	 */
	LOWTEMPERATURE_BOILER(1, "lowtemperatureBoiler", "lowtemperatureBoiler");

	/**
	 * The '<em><b>Condensing Boiler</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CONDENSING_BOILER
	 * @model name="condensingBoiler"
	 * @generated
	 * @ordered
	 */
	public static final int CONDENSING_BOILER_VALUE = 0;

	/**
	 * The '<em><b>Lowtemperature Boiler</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LOWTEMPERATURE_BOILER
	 * @model name="lowtemperatureBoiler"
	 * @generated
	 * @ordered
	 */
	public static final int LOWTEMPERATURE_BOILER_VALUE = 1;

	/**
	 * An array of all the '<em><b>Boiler Types</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final BoilerTypes[] VALUES_ARRAY = new BoilerTypes[] { CONDENSING_BOILER, LOWTEMPERATURE_BOILER, };

	/**
	 * A public read-only list of all the '<em><b>Boiler Types</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<BoilerTypes> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Boiler Types</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static BoilerTypes get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			BoilerTypes result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Boiler Types</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static BoilerTypes getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			BoilerTypes result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Boiler Types</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static BoilerTypes get(int value) {
		switch (value) {
		case CONDENSING_BOILER_VALUE:
			return CONDENSING_BOILER;
		case LOWTEMPERATURE_BOILER_VALUE:
			return LOWTEMPERATURE_BOILER;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private BoilerTypes(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int getValue() {
		return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getLiteral() {
		return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}

} //BoilerTypes
