/**
 */
package de.hftstuttgart.energycomponents;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Collector Types</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getCollectorTypes()
 * @model
 * @generated
 */
public enum CollectorTypes implements Enumerator {
	/**
	 * The '<em><b>Flat Plane Collector</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FLAT_PLANE_COLLECTOR_VALUE
	 * @generated
	 * @ordered
	 */
	FLAT_PLANE_COLLECTOR(0, "flatPlaneCollector", "flatPlaneCollector"),

	/**
	 * The '<em><b>Evacuated Tube Collector</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EVACUATED_TUBE_COLLECTOR_VALUE
	 * @generated
	 * @ordered
	 */
	EVACUATED_TUBE_COLLECTOR(1, "evacuatedTubeCollector", "evacuatedTubeCollector");

	/**
	 * The '<em><b>Flat Plane Collector</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FLAT_PLANE_COLLECTOR
	 * @model name="flatPlaneCollector"
	 * @generated
	 * @ordered
	 */
	public static final int FLAT_PLANE_COLLECTOR_VALUE = 0;

	/**
	 * The '<em><b>Evacuated Tube Collector</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EVACUATED_TUBE_COLLECTOR
	 * @model name="evacuatedTubeCollector"
	 * @generated
	 * @ordered
	 */
	public static final int EVACUATED_TUBE_COLLECTOR_VALUE = 1;

	/**
	 * An array of all the '<em><b>Collector Types</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final CollectorTypes[] VALUES_ARRAY = new CollectorTypes[] { FLAT_PLANE_COLLECTOR,
			EVACUATED_TUBE_COLLECTOR, };

	/**
	 * A public read-only list of all the '<em><b>Collector Types</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<CollectorTypes> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Collector Types</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static CollectorTypes get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			CollectorTypes result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Collector Types</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static CollectorTypes getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			CollectorTypes result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Collector Types</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static CollectorTypes get(int value) {
		switch (value) {
		case FLAT_PLANE_COLLECTOR_VALUE:
			return FLAT_PLANE_COLLECTOR;
		case EVACUATED_TUBE_COLLECTOR_VALUE:
			return EVACUATED_TUBE_COLLECTOR;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private CollectorTypes(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int getValue() {
		return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getLiteral() {
		return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}

} //CollectorTypes
