/**
 */
package de.hftstuttgart.energycomponents;

import de.hftstuttgart.units.NullableQuantity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Combined Heat Power</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getThermalEfficiency <em>Thermal Efficiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getElectricalEfficiency <em>Electrical Efficiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getInstalledElectricalPower <em>Installed Electrical Power</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getElectricalEfficiencyPartLoad <em>Electrical Efficiency Part Load</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getThermalEfficiencyPartLoad <em>Thermal Efficiency Part Load</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getCombinedHeatPower()
 * @model
 * @generated
 */
public interface CombinedHeatPower extends ThermalEnergyDevice {
	/**
	 * Returns the value of the '<em><b>Thermal Efficiency</b></em>' attribute.
	 * The default value is <code>"0.4"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * share
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Thermal Efficiency</em>' attribute.
	 * @see #setThermalEfficiency(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getCombinedHeatPower_ThermalEfficiency()
	 * @model default="0.4" required="true"
	 * @generated
	 */
	double getThermalEfficiency();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getThermalEfficiency <em>Thermal Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Thermal Efficiency</em>' attribute.
	 * @see #getThermalEfficiency()
	 * @generated
	 */
	void setThermalEfficiency(double value);

	/**
	 * Returns the value of the '<em><b>Electrical Efficiency</b></em>' attribute.
	 * The default value is <code>"0.4"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * share
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Electrical Efficiency</em>' attribute.
	 * @see #setElectricalEfficiency(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getCombinedHeatPower_ElectricalEfficiency()
	 * @model default="0.4" required="true"
	 * @generated
	 */
	double getElectricalEfficiency();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getElectricalEfficiency <em>Electrical Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Electrical Efficiency</em>' attribute.
	 * @see #getElectricalEfficiency()
	 * @generated
	 */
	void setElectricalEfficiency(double value);

	/**
	 * Returns the value of the '<em><b>Installed Electrical Power</b></em>' attribute.
	 * The default value is <code>"kW"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * kW
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Installed Electrical Power</em>' attribute.
	 * @see #setInstalledElectricalPower(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getCombinedHeatPower_InstalledElectricalPower()
	 * @model default="kW" dataType="de.hftstuttgart.energycomponents.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getInstalledElectricalPower();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getInstalledElectricalPower <em>Installed Electrical Power</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Installed Electrical Power</em>' attribute.
	 * @see #getInstalledElectricalPower()
	 * @generated
	 */
	void setInstalledElectricalPower(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Electrical Efficiency Part Load</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Electrical Efficiency Part Load</em>' containment reference.
	 * @see #setElectricalEfficiencyPartLoad(Characteristic)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getCombinedHeatPower_ElectricalEfficiencyPartLoad()
	 * @model containment="true"
	 * @generated
	 */
	Characteristic getElectricalEfficiencyPartLoad();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getElectricalEfficiencyPartLoad <em>Electrical Efficiency Part Load</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Electrical Efficiency Part Load</em>' containment reference.
	 * @see #getElectricalEfficiencyPartLoad()
	 * @generated
	 */
	void setElectricalEfficiencyPartLoad(Characteristic value);

	/**
	 * Returns the value of the '<em><b>Thermal Efficiency Part Load</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Thermal Efficiency Part Load</em>' containment reference.
	 * @see #setThermalEfficiencyPartLoad(Characteristic)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getCombinedHeatPower_ThermalEfficiencyPartLoad()
	 * @model containment="true"
	 * @generated
	 */
	Characteristic getThermalEfficiencyPartLoad();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getThermalEfficiencyPartLoad <em>Thermal Efficiency Part Load</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Thermal Efficiency Part Load</em>' containment reference.
	 * @see #getThermalEfficiencyPartLoad()
	 * @generated
	 */
	void setThermalEfficiencyPartLoad(Characteristic value);

} // CombinedHeatPower
