/**
 */
package de.hftstuttgart.energycomponents;

import de.hftstuttgart.units.NullableQuantity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Electrical Storage</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.ElectricalStorage#getElectricalStorageType <em>Electrical Storage Type</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryCapacity <em>Battery Capacity</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryVoltage <em>Battery Voltage</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryLifeCycle <em>Battery Life Cycle</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ElectricalStorage#getSelfDischarge <em>Self Discharge</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ElectricalStorage#getInverterIncluded <em>Inverter Included</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryEffiency <em>Battery Effiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ElectricalStorage#getEnergyContent <em>Energy Content</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectricalStorage()
 * @model
 * @generated
 */
public interface ElectricalStorage extends EnergyComponent {
	/**
	 * Returns the value of the '<em><b>Electrical Storage Type</b></em>' attribute.
	 * The literals are from the enumeration {@link de.hftstuttgart.energycomponents.ElectricalStorageTypes}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Electrical Storage Type</em>' attribute.
	 * @see de.hftstuttgart.energycomponents.ElectricalStorageTypes
	 * @see #setElectricalStorageType(ElectricalStorageTypes)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectricalStorage_ElectricalStorageType()
	 * @model required="true"
	 * @generated
	 */
	ElectricalStorageTypes getElectricalStorageType();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getElectricalStorageType <em>Electrical Storage Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Electrical Storage Type</em>' attribute.
	 * @see de.hftstuttgart.energycomponents.ElectricalStorageTypes
	 * @see #getElectricalStorageType()
	 * @generated
	 */
	void setElectricalStorageType(ElectricalStorageTypes value);

	/**
	 * Returns the value of the '<em><b>Battery Capacity</b></em>' attribute.
	 * The default value is <code>"A*h"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Ah
	 * 
	 * The storage capacity of the battery is  represented in Ampere 
	 * hour or Ah. If V is the battery voltage then the energy storage 
	 * capacity of the  battery can  be Ah  x V  = Watt-hour.  Usually 
	 * battery capacity will be specified for a given discharge/charge 
	 * rating or C  rating. The  actual capacity depends  on operating 
	 * conditions such as load, temperature, etc. 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Battery Capacity</em>' attribute.
	 * @see #setBatteryCapacity(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectricalStorage_BatteryCapacity()
	 * @model default="A*h" dataType="de.hftstuttgart.energycomponents.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getBatteryCapacity();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryCapacity <em>Battery Capacity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Battery Capacity</em>' attribute.
	 * @see #getBatteryCapacity()
	 * @generated
	 */
	void setBatteryCapacity(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Battery Voltage</b></em>' attribute.
	 * The default value is <code>"V"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * V
	 * 
	 * The terminal voltage during operating condition  is known as 
	 * nominal  voltage  or  working  voltage.  This  voltage  will  be 
	 * specified by manufactures. It may be 3V, 6V, 12V, 24Vetc 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Battery Voltage</em>' attribute.
	 * @see #setBatteryVoltage(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectricalStorage_BatteryVoltage()
	 * @model default="V" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getBatteryVoltage();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryVoltage <em>Battery Voltage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Battery Voltage</em>' attribute.
	 * @see #getBatteryVoltage()
	 * @generated
	 */
	void setBatteryVoltage(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Battery Life Cycle</b></em>' attribute.
	 * The default value is <code>"7000"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * It  is  the  number  of  complete  charge  –  discharge  cycles  a 
	 * battery can  work before the  nominal capacity  decreases less 
	 * than 80% of its rated  initial capacity. After the  specified life 
	 * cycle, the battery will  work with reduced  capacity. It can be 
	 * used but the capacity will be lower. 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Battery Life Cycle</em>' attribute.
	 * @see #setBatteryLifeCycle(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectricalStorage_BatteryLifeCycle()
	 * @model default="7000"
	 * @generated
	 */
	double getBatteryLifeCycle();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryLifeCycle <em>Battery Life Cycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Battery Life Cycle</em>' attribute.
	 * @see #getBatteryLifeCycle()
	 * @generated
	 */
	void setBatteryLifeCycle(double value);

	/**
	 * Returns the value of the '<em><b>Self Discharge</b></em>' attribute.
	 * The default value is <code>"0.2"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * rate
	 * 
	 * It is  the electrical  capacity lost  when a  battery is  not being 
	 * used due to internal electrochemical process with the battery. 
	 * The self discharge increases with increase of temperature. The 
	 * batteries  can  be stored  at lower  temperatures to  reduce  self 
	 * discharge. 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Self Discharge</em>' attribute.
	 * @see #setSelfDischarge(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectricalStorage_SelfDischarge()
	 * @model default="0.2"
	 * @generated
	 */
	double getSelfDischarge();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getSelfDischarge <em>Self Discharge</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Self Discharge</em>' attribute.
	 * @see #getSelfDischarge()
	 * @generated
	 */
	void setSelfDischarge(double value);

	/**
	 * Returns the value of the '<em><b>Inverter Included</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Inverter Included</em>' attribute.
	 * @see #setInverterIncluded(Boolean)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectricalStorage_InverterIncluded()
	 * @model default="false"
	 * @generated
	 */
	Boolean getInverterIncluded();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getInverterIncluded <em>Inverter Included</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Inverter Included</em>' attribute.
	 * @see #getInverterIncluded()
	 * @generated
	 */
	void setInverterIncluded(Boolean value);

	/**
	 * Returns the value of the '<em><b>Battery Effiency</b></em>' attribute.
	 * The default value is <code>"0.8"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Battery Effiency</em>' attribute.
	 * @see #setBatteryEffiency(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectricalStorage_BatteryEffiency()
	 * @model default="0.8"
	 * @generated
	 */
	double getBatteryEffiency();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryEffiency <em>Battery Effiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Battery Effiency</em>' attribute.
	 * @see #getBatteryEffiency()
	 * @generated
	 */
	void setBatteryEffiency(double value);

	/**
	 * Returns the value of the '<em><b>Energy Content</b></em>' attribute.
	 * The default value is <code>"5 kW*h"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Energy Content</em>' attribute.
	 * @see #setEnergyContent(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectricalStorage_EnergyContent()
	 * @model default="5 kW*h" dataType="de.hftstuttgart.energycomponents.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getEnergyContent();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getEnergyContent <em>Energy Content</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Energy Content</em>' attribute.
	 * @see #getEnergyContent()
	 * @generated
	 */
	void setEnergyContent(NullableQuantity value);

} // ElectricalStorage
