/**
 */
package de.hftstuttgart.energycomponents;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Electrical Storage Types</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectricalStorageTypes()
 * @model
 * @generated
 */
public enum ElectricalStorageTypes implements Enumerator {
	/**
	 * The '<em><b>Lithium Ion</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Lithium ion
	 * <!-- end-model-doc -->
	 * @see #LITHIUM_ION_VALUE
	 * @generated
	 * @ordered
	 */
	LITHIUM_ION(0, "lithiumIon", "lithiumIon"),

	/**
	 * The '<em><b>Lead Acid</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LEAD_ACID_VALUE
	 * @generated
	 * @ordered
	 */
	LEAD_ACID(1, "leadAcid", "leadAcid"),

	/**
	 * The '<em><b>Ni MH</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Nickel – Metal hydride
	 * <!-- end-model-doc -->
	 * @see #NI_MH_VALUE
	 * @generated
	 * @ordered
	 */
	NI_MH(2, "niMH", "niMH"),

	/**
	 * The '<em><b>Lithium Polymer</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * <!-- end-model-doc -->
	 * @see #LITHIUM_POLYMER_VALUE
	 * @generated
	 * @ordered
	 */
	LITHIUM_POLYMER(3, "lithiumPolymer", "lithiumPolymer");

	/**
	 * The '<em><b>Lithium Ion</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Lithium ion
	 * <!-- end-model-doc -->
	 * @see #LITHIUM_ION
	 * @model name="lithiumIon"
	 * @generated
	 * @ordered
	 */
	public static final int LITHIUM_ION_VALUE = 0;

	/**
	 * The '<em><b>Lead Acid</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LEAD_ACID
	 * @model name="leadAcid"
	 * @generated
	 * @ordered
	 */
	public static final int LEAD_ACID_VALUE = 1;

	/**
	 * The '<em><b>Ni MH</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Nickel – Metal hydride
	 * <!-- end-model-doc -->
	 * @see #NI_MH
	 * @model name="niMH"
	 * @generated
	 * @ordered
	 */
	public static final int NI_MH_VALUE = 2;

	/**
	 * The '<em><b>Lithium Polymer</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * <!-- end-model-doc -->
	 * @see #LITHIUM_POLYMER
	 * @model name="lithiumPolymer"
	 * @generated
	 * @ordered
	 */
	public static final int LITHIUM_POLYMER_VALUE = 3;

	/**
	 * An array of all the '<em><b>Electrical Storage Types</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final ElectricalStorageTypes[] VALUES_ARRAY = new ElectricalStorageTypes[] { LITHIUM_ION, LEAD_ACID,
			NI_MH, LITHIUM_POLYMER, };

	/**
	 * A public read-only list of all the '<em><b>Electrical Storage Types</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<ElectricalStorageTypes> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Electrical Storage Types</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static ElectricalStorageTypes get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ElectricalStorageTypes result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Electrical Storage Types</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static ElectricalStorageTypes getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ElectricalStorageTypes result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Electrical Storage Types</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static ElectricalStorageTypes get(int value) {
		switch (value) {
		case LITHIUM_ION_VALUE:
			return LITHIUM_ION;
		case LEAD_ACID_VALUE:
			return LEAD_ACID;
		case NI_MH_VALUE:
			return NI_MH;
		case LITHIUM_POLYMER_VALUE:
			return LITHIUM_POLYMER;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private ElectricalStorageTypes(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int getValue() {
		return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getLiteral() {
		return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}

} //ElectricalStorageTypes
