/**
 */
package de.hftstuttgart.energycomponents;

import de.hftstuttgart.units.NullableQuantity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Electrolyzer</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.Electrolyzer#getCellType <em>Cell Type</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.Electrolyzer#getCellArea <em>Cell Area</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.Electrolyzer#getNumberOfCells <em>Number Of Cells</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.Electrolyzer#getMaxOperatingCurrentDensity <em>Max Operating Current Density</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.Electrolyzer#getMinOperatingCurrentDensity <em>Min Operating Current Density</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.Electrolyzer#getOverloadCapacity <em>Overload Capacity</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.Electrolyzer#getNominalCellVoltage <em>Nominal Cell Voltage</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectrolyzer()
 * @model
 * @generated
 */
public interface Electrolyzer extends EnergyComponent {
	/**
	 * Returns the value of the '<em><b>Cell Type</b></em>' attribute.
	 * The literals are from the enumeration {@link de.hftstuttgart.energycomponents.cellTypesElectrolyzer}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cell Type</em>' attribute.
	 * @see de.hftstuttgart.energycomponents.cellTypesElectrolyzer
	 * @see #setCellType(cellTypesElectrolyzer)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectrolyzer_CellType()
	 * @model
	 * @generated
	 */
	cellTypesElectrolyzer getCellType();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.Electrolyzer#getCellType <em>Cell Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cell Type</em>' attribute.
	 * @see de.hftstuttgart.energycomponents.cellTypesElectrolyzer
	 * @see #getCellType()
	 * @generated
	 */
	void setCellType(cellTypesElectrolyzer value);

	/**
	 * Returns the value of the '<em><b>Cell Area</b></em>' attribute.
	 * The default value is <code>"50 cm\u00b2"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * cm²
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Cell Area</em>' attribute.
	 * @see #setCellArea(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectrolyzer_CellArea()
	 * @model default="50 cm\u00b2" dataType="de.hftstuttgart.energycomponents.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getCellArea();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.Electrolyzer#getCellArea <em>Cell Area</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cell Area</em>' attribute.
	 * @see #getCellArea()
	 * @generated
	 */
	void setCellArea(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Number Of Cells</b></em>' attribute.
	 * The default value is <code>"5"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Number Of Cells</em>' attribute.
	 * @see #setNumberOfCells(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectrolyzer_NumberOfCells()
	 * @model default="5" required="true"
	 * @generated
	 */
	double getNumberOfCells();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.Electrolyzer#getNumberOfCells <em>Number Of Cells</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Number Of Cells</em>' attribute.
	 * @see #getNumberOfCells()
	 * @generated
	 */
	void setNumberOfCells(double value);

	/**
	 * Returns the value of the '<em><b>Max Operating Current Density</b></em>' attribute.
	 * The default value is <code>"3 A/cm\u00b2"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * A/cm²
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Max Operating Current Density</em>' attribute.
	 * @see #setMaxOperatingCurrentDensity(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectrolyzer_MaxOperatingCurrentDensity()
	 * @model default="3 A/cm\u00b2" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getMaxOperatingCurrentDensity();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.Electrolyzer#getMaxOperatingCurrentDensity <em>Max Operating Current Density</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Operating Current Density</em>' attribute.
	 * @see #getMaxOperatingCurrentDensity()
	 * @generated
	 */
	void setMaxOperatingCurrentDensity(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Min Operating Current Density</b></em>' attribute.
	 * The default value is <code>"0.3 A/cm\u00b2"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * A/cm²
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Min Operating Current Density</em>' attribute.
	 * @see #setMinOperatingCurrentDensity(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectrolyzer_MinOperatingCurrentDensity()
	 * @model default="0.3 A/cm\u00b2" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getMinOperatingCurrentDensity();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.Electrolyzer#getMinOperatingCurrentDensity <em>Min Operating Current Density</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Min Operating Current Density</em>' attribute.
	 * @see #getMinOperatingCurrentDensity()
	 * @generated
	 */
	void setMinOperatingCurrentDensity(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Overload Capacity</b></em>' attribute.
	 * The default value is <code>"120 %"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * percent
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Overload Capacity</em>' attribute.
	 * @see #setOverloadCapacity(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectrolyzer_OverloadCapacity()
	 * @model default="120 %" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getOverloadCapacity();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.Electrolyzer#getOverloadCapacity <em>Overload Capacity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Overload Capacity</em>' attribute.
	 * @see #getOverloadCapacity()
	 * @generated
	 */
	void setOverloadCapacity(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Nominal Cell Voltage</b></em>' attribute.
	 * The default value is <code>"1.94 V"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * V
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Nominal Cell Voltage</em>' attribute.
	 * @see #setNominalCellVoltage(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getElectrolyzer_NominalCellVoltage()
	 * @model default="1.94 V" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getNominalCellVoltage();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.Electrolyzer#getNominalCellVoltage <em>Nominal Cell Voltage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Nominal Cell Voltage</em>' attribute.
	 * @see #getNominalCellVoltage()
	 * @generated
	 */
	void setNominalCellVoltage(NullableQuantity value);

} // Electrolyzer
