/**
 */
package de.hftstuttgart.energycomponents;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see de.hftstuttgart.energycomponents.EnCompPackage
 * @generated
 */
public interface EnCompFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	EnCompFactory eINSTANCE = de.hftstuttgart.energycomponents.impl.EnCompFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Energy Components Catalog</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Energy Components Catalog</em>'.
	 * @generated
	 */
	EnergyComponentsCatalog createEnergyComponentsCatalog();

	/**
	 * Returns a new object of class '<em>Thermal Storage</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Thermal Storage</em>'.
	 * @generated
	 */
	ThermalStorage createThermalStorage();

	/**
	 * Returns a new object of class '<em>Electrical Storage</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Electrical Storage</em>'.
	 * @generated
	 */
	ElectricalStorage createElectricalStorage();

	/**
	 * Returns a new object of class '<em>Combined Heat Power</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Combined Heat Power</em>'.
	 * @generated
	 */
	CombinedHeatPower createCombinedHeatPower();

	/**
	 * Returns a new object of class '<em>Heat Pump</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Heat Pump</em>'.
	 * @generated
	 */
	HeatPump createHeatPump();

	/**
	 * Returns a new object of class '<em>Boiler</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Boiler</em>'.
	 * @generated
	 */
	Boiler createBoiler();

	/**
	 * Returns a new object of class '<em>Solar Thermal Collector</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Solar Thermal Collector</em>'.
	 * @generated
	 */
	SolarThermalCollector createSolarThermalCollector();

	/**
	 * Returns a new object of class '<em>Electrolyzer</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Electrolyzer</em>'.
	 * @generated
	 */
	Electrolyzer createElectrolyzer();

	/**
	 * Returns a new object of class '<em>Hydrogen Compressor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hydrogen Compressor</em>'.
	 * @generated
	 */
	HydrogenCompressor createHydrogenCompressor();

	/**
	 * Returns a new object of class '<em>Hydrogen Storage</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hydrogen Storage</em>'.
	 * @generated
	 */
	HydrogenStorage createHydrogenStorage();

	/**
	 * Returns a new object of class '<em>Fuel Cell</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Fuel Cell</em>'.
	 * @generated
	 */
	FuelCell createFuelCell();

	/**
	 * Returns a new object of class '<em>Fossil Fuel</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Fossil Fuel</em>'.
	 * @generated
	 */
	FossilFuel createFossilFuel();

	/**
	 * Returns a new object of class '<em>Hydrogen</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hydrogen</em>'.
	 * @generated
	 */
	Hydrogen createHydrogen();

	/**
	 * Returns a new object of class '<em>Bio Fuel</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Bio Fuel</em>'.
	 * @generated
	 */
	BioFuel createBioFuel();

	/**
	 * Returns a new object of class '<em>Wind Turbine</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Wind Turbine</em>'.
	 * @generated
	 */
	WindTurbine createWindTurbine();

	/**
	 * Returns a new object of class '<em>Photovoltaic Module</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Photovoltaic Module</em>'.
	 * @generated
	 */
	PhotovoltaicModule createPhotovoltaicModule();

	/**
	 * Returns a new object of class '<em>Inverter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Inverter</em>'.
	 * @generated
	 */
	Inverter createInverter();

	/**
	 * Returns a new object of class '<em>Heat Exchanger</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Heat Exchanger</em>'.
	 * @generated
	 */
	HeatExchanger createHeatExchanger();

	/**
	 * Returns a new object of class '<em>Geothermal Heat Exchanger</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Geothermal Heat Exchanger</em>'.
	 * @generated
	 */
	GeothermalHeatExchanger createGeothermalHeatExchanger();

	/**
	 * Returns a new object of class '<em>Medium</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Medium</em>'.
	 * @generated
	 */
	Medium createMedium();

	/**
	 * Returns a new object of class '<em>Linear Function</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Linear Function</em>'.
	 * @generated
	 */
	LinearFunction createLinearFunction();

	/**
	 * Returns a new object of class '<em>Data Point</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Data Point</em>'.
	 * @generated
	 */
	DataPoint createDataPoint();

	/**
	 * Returns a new object of class '<em>Table Function</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Table Function</em>'.
	 * @generated
	 */
	TableFunction createTableFunction();

	/**
	 * Returns a new object of class '<em>Exponential Function</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Exponential Function</em>'.
	 * @generated
	 */
	ExponentialFunction createExponentialFunction();

	/**
	 * Returns a new object of class '<em>Table Characteristic</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Table Characteristic</em>'.
	 * @generated
	 */
	TableCharacteristic createTableCharacteristic();

	/**
	 * Returns a new object of class '<em>Linear Characteristic</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Linear Characteristic</em>'.
	 * @generated
	 */
	LinearCharacteristic createLinearCharacteristic();

	/**
	 * Returns a new object of class '<em>Exponentional Characteristic</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Exponentional Characteristic</em>'.
	 * @generated
	 */
	ExponentionalCharacteristic createExponentionalCharacteristic();

	/**
	 * Returns a new object of class '<em>Manufacturer</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Manufacturer</em>'.
	 * @generated
	 */
	Manufacturer createManufacturer();

	/**
	 * Returns a new object of class '<em>Polynomial Characteristic</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Polynomial Characteristic</em>'.
	 * @generated
	 */
	PolynomialCharacteristic createPolynomialCharacteristic();

	/**
	 * Returns a new object of class '<em>Polynomial Function</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Polynomial Function</em>'.
	 * @generated
	 */
	PolynomialFunction createPolynomialFunction();

	/**
	 * Returns a new object of class '<em>Material</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Material</em>'.
	 * @generated
	 */
	Material createMaterial();

	/**
	 * Returns a new object of class '<em>Energy Components Cost Catalog</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Energy Components Cost Catalog</em>'.
	 * @generated
	 */
	EnergyComponentsCostCatalog createEnergyComponentsCostCatalog();

	/**
	 * Returns a new object of class '<em>Cost</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Cost</em>'.
	 * @generated
	 */
	Cost createCost();

	/**
	 * Returns a new object of class '<em>Power Characteristic</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Power Characteristic</em>'.
	 * @generated
	 */
	PowerCharacteristic createPowerCharacteristic();

	/**
	 * Returns a new object of class '<em>Power Function</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Power Function</em>'.
	 * @generated
	 */
	PowerFunction createPowerFunction();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	EnCompPackage getEnCompPackage();

} //EnCompFactory
