/**
 */
package de.hftstuttgart.energycomponents;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Energy Carrier</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.EnergyCarrier#getCo2EmissionsFactor <em>Co2 Emissions Factor</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.EnergyCarrier#getPrimaryEnergyFactor <em>Primary Energy Factor</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.EnergyCarrier#getName <em>Name</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.EnergyCarrier#getCost <em>Cost</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getEnergyCarrier()
 * @model abstract="true"
 * @generated
 */
public interface EnergyCarrier extends EObject {
	/**
	 * Returns the value of the '<em><b>Co2 Emissions Factor</b></em>' attribute.
	 * The default value is <code>"t/MW*h"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Co2 Emissions Factor</em>' attribute.
	 * @see #setCo2EmissionsFactor(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getEnergyCarrier_Co2EmissionsFactor()
	 * @model default="t/MW*h" dataType="de.hftstuttgart.energycomponents.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getCo2EmissionsFactor();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.EnergyCarrier#getCo2EmissionsFactor <em>Co2 Emissions Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Co2 Emissions Factor</em>' attribute.
	 * @see #getCo2EmissionsFactor()
	 * @generated
	 */
	void setCo2EmissionsFactor(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Primary Energy Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Primary Energy Factor</em>' attribute.
	 * @see #setPrimaryEnergyFactor(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getEnergyCarrier_PrimaryEnergyFactor()
	 * @model required="true"
	 * @generated
	 */
	double getPrimaryEnergyFactor();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.EnergyCarrier#getPrimaryEnergyFactor <em>Primary Energy Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Primary Energy Factor</em>' attribute.
	 * @see #getPrimaryEnergyFactor()
	 * @generated
	 */
	void setPrimaryEnergyFactor(double value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getEnergyCarrier_Name()
	 * @model required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.EnergyCarrier#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Cost</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cost</em>' attribute.
	 * @see #setCost(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getEnergyCarrier_Cost()
	 * @model
	 * @generated
	 */
	double getCost();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.EnergyCarrier#getCost <em>Cost</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cost</em>' attribute.
	 * @see #getCost()
	 * @generated
	 */
	void setCost(double value);

} // EnergyCarrier
