/**
 */
package de.hftstuttgart.energycomponents;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Fossil Fuel Types</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getFossilFuelTypes()
 * @model
 * @generated
 */
public enum FossilFuelTypes implements Enumerator {
	/**
	 * The '<em><b>Natural Gas</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NATURAL_GAS_VALUE
	 * @generated
	 * @ordered
	 */
	NATURAL_GAS(0, "naturalGas", "naturalGas"),

	/**
	 * The '<em><b>Oil</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #OIL_VALUE
	 * @generated
	 * @ordered
	 */
	OIL(1, "oil", "oil"),

	/**
	 * The '<em><b>Diesel</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DIESEL_VALUE
	 * @generated
	 * @ordered
	 */
	DIESEL(2, "diesel", "diesel"),
	/**
	 * The '<em><b>LNG</b></em>' literal object.
	 * <!-- begin-user-doc -->
	* <!-- end-user-doc -->
	 * @see #LNG_VALUE
	 * @generated
	 * @ordered
	 */
	LNG(3, "LNG", "LNG"),
	/**
	 * The '<em><b>CNG</b></em>' literal object.
	 * <!-- begin-user-doc -->
	* <!-- end-user-doc -->
	 * @see #CNG_VALUE
	 * @generated
	 * @ordered
	 */
	CNG(4, "CNG", "CNG");

	/**
	 * The '<em><b>Natural Gas</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NATURAL_GAS
	 * @model name="naturalGas"
	 * @generated
	 * @ordered
	 */
	public static final int NATURAL_GAS_VALUE = 0;

	/**
	 * The '<em><b>Oil</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #OIL
	 * @model name="oil"
	 * @generated
	 * @ordered
	 */
	public static final int OIL_VALUE = 1;

	/**
	 * The '<em><b>Diesel</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DIESEL
	 * @model name="diesel"
	 * @generated
	 * @ordered
	 */
	public static final int DIESEL_VALUE = 2;

	/**
	 * The '<em><b>LNG</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LNG
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int LNG_VALUE = 3;

	/**
	 * The '<em><b>CNG</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CNG
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int CNG_VALUE = 4;

	/**
	 * An array of all the '<em><b>Fossil Fuel Types</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final FossilFuelTypes[] VALUES_ARRAY = new FossilFuelTypes[] { NATURAL_GAS, OIL, DIESEL, LNG, CNG, };

	/**
	 * A public read-only list of all the '<em><b>Fossil Fuel Types</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<FossilFuelTypes> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Fossil Fuel Types</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static FossilFuelTypes get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			FossilFuelTypes result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Fossil Fuel Types</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static FossilFuelTypes getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			FossilFuelTypes result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Fossil Fuel Types</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static FossilFuelTypes get(int value) {
		switch (value) {
		case NATURAL_GAS_VALUE:
			return NATURAL_GAS;
		case OIL_VALUE:
			return OIL;
		case DIESEL_VALUE:
			return DIESEL;
		case LNG_VALUE:
			return LNG;
		case CNG_VALUE:
			return CNG;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private FossilFuelTypes(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int getValue() {
		return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getLiteral() {
		return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}

} //FossilFuelTypes
