/**
 */
package de.hftstuttgart.energycomponents;

import de.hftstuttgart.units.NullableQuantity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Heat Exchanger</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.HeatExchanger#getHeatRecoveryEfficiency <em>Heat Recovery Efficiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.HeatExchanger#getNominalElectricityConsumption <em>Nominal Electricity Consumption</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getHeatExchanger()
 * @model
 * @generated
 */
public interface HeatExchanger extends EnergyComponent {
	/**
	 * Returns the value of the '<em><b>Heat Recovery Efficiency</b></em>' attribute.
	 * The default value is <code>"0.8"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Heat Recovery Efficiency</em>' attribute.
	 * @see #setHeatRecoveryEfficiency(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getHeatExchanger_HeatRecoveryEfficiency()
	 * @model default="0.8"
	 * @generated
	 */
	double getHeatRecoveryEfficiency();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.HeatExchanger#getHeatRecoveryEfficiency <em>Heat Recovery Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Heat Recovery Efficiency</em>' attribute.
	 * @see #getHeatRecoveryEfficiency()
	 * @generated
	 */
	void setHeatRecoveryEfficiency(double value);

	/**
	 * Returns the value of the '<em><b>Nominal Electricity Consumption</b></em>' attribute.
	 * The default value is <code>"W"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Watt
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Nominal Electricity Consumption</em>' attribute.
	 * @see #setNominalElectricityConsumption(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getHeatExchanger_NominalElectricityConsumption()
	 * @model default="W" dataType="de.hftstuttgart.energycomponents.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getNominalElectricityConsumption();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.HeatExchanger#getNominalElectricityConsumption <em>Nominal Electricity Consumption</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Nominal Electricity Consumption</em>' attribute.
	 * @see #getNominalElectricityConsumption()
	 * @generated
	 */
	void setNominalElectricityConsumption(NullableQuantity value);

} // HeatExchanger
