/**
 */
package de.hftstuttgart.energycomponents;

import de.hftstuttgart.units.NullableQuantity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Hydrogen Compressor</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.HydrogenCompressor#getEfficiency <em>Efficiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.HydrogenCompressor#getThermodynamicMode <em>Thermodynamic Mode</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.HydrogenCompressor#getMaxPressure <em>Max Pressure</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.HydrogenCompressor#getMaxDeliveryRate <em>Max Delivery Rate</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getHydrogenCompressor()
 * @model
 * @generated
 */
public interface HydrogenCompressor extends EnergyComponent {
	/**
	 * Returns the value of the '<em><b>Efficiency</b></em>' attribute.
	 * The default value is <code>"0.68"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * share
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Efficiency</em>' attribute.
	 * @see #setEfficiency(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getHydrogenCompressor_Efficiency()
	 * @model default="0.68"
	 * @generated
	 */
	double getEfficiency();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.HydrogenCompressor#getEfficiency <em>Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Efficiency</em>' attribute.
	 * @see #getEfficiency()
	 * @generated
	 */
	void setEfficiency(double value);

	/**
	 * Returns the value of the '<em><b>Thermodynamic Mode</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Thermodynamic Mode</em>' attribute.
	 * @see #setThermodynamicMode(int)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getHydrogenCompressor_ThermodynamicMode()
	 * @model default="0"
	 * @generated
	 */
	int getThermodynamicMode();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.HydrogenCompressor#getThermodynamicMode <em>Thermodynamic Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Thermodynamic Mode</em>' attribute.
	 * @see #getThermodynamicMode()
	 * @generated
	 */
	void setThermodynamicMode(int value);

	/**
	 * Returns the value of the '<em><b>Max Pressure</b></em>' attribute.
	 * The default value is <code>"50 MPa"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * MPa
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Max Pressure</em>' attribute.
	 * @see #setMaxPressure(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getHydrogenCompressor_MaxPressure()
	 * @model default="50 MPa" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getMaxPressure();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.HydrogenCompressor#getMaxPressure <em>Max Pressure</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Pressure</em>' attribute.
	 * @see #getMaxPressure()
	 * @generated
	 */
	void setMaxPressure(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Max Delivery Rate</b></em>' attribute.
	 * The default value is <code>"9 kg/h"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * kg/h
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Max Delivery Rate</em>' attribute.
	 * @see #setMaxDeliveryRate(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getHydrogenCompressor_MaxDeliveryRate()
	 * @model default="9 kg/h" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getMaxDeliveryRate();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.HydrogenCompressor#getMaxDeliveryRate <em>Max Delivery Rate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Delivery Rate</em>' attribute.
	 * @see #getMaxDeliveryRate()
	 * @generated
	 */
	void setMaxDeliveryRate(NullableQuantity value);

} // HydrogenCompressor
