/**
 */
package de.hftstuttgart.energycomponents;

import de.hftstuttgart.units.NullableQuantity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Hydrogen Storage</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.HydrogenStorage#getNumberOfCylinders <em>Number Of Cylinders</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.HydrogenStorage#getCylinderVolume <em>Cylinder Volume</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.HydrogenStorage#getNominalPressure <em>Nominal Pressure</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getHydrogenStorage()
 * @model
 * @generated
 */
public interface HydrogenStorage extends EnergyComponent {
	/**
	 * Returns the value of the '<em><b>Number Of Cylinders</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Number Of Cylinders</em>' attribute.
	 * @see #setNumberOfCylinders(int)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getHydrogenStorage_NumberOfCylinders()
	 * @model default="1" required="true"
	 * @generated
	 */
	int getNumberOfCylinders();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.HydrogenStorage#getNumberOfCylinders <em>Number Of Cylinders</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Number Of Cylinders</em>' attribute.
	 * @see #getNumberOfCylinders()
	 * @generated
	 */
	void setNumberOfCylinders(int value);

	/**
	 * Returns the value of the '<em><b>Cylinder Volume</b></em>' attribute.
	 * The default value is <code>"1.5 m\u00b3"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * m³
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Cylinder Volume</em>' attribute.
	 * @see #setCylinderVolume(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getHydrogenStorage_CylinderVolume()
	 * @model default="1.5 m\u00b3" dataType="de.hftstuttgart.energycomponents.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getCylinderVolume();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.HydrogenStorage#getCylinderVolume <em>Cylinder Volume</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cylinder Volume</em>' attribute.
	 * @see #getCylinderVolume()
	 * @generated
	 */
	void setCylinderVolume(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Nominal Pressure</b></em>' attribute.
	 * The default value is <code>"25 MPa"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Nominal Pressure</em>' attribute.
	 * @see #setNominalPressure(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getHydrogenStorage_NominalPressure()
	 * @model default="25 MPa" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getNominalPressure();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.HydrogenStorage#getNominalPressure <em>Nominal Pressure</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Nominal Pressure</em>' attribute.
	 * @see #getNominalPressure()
	 * @generated
	 */
	void setNominalPressure(NullableQuantity value);

} // HydrogenStorage
