/**
 */
package de.hftstuttgart.energycomponents;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Medium</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.Medium#getDensity <em>Density</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.Medium#getHeatCapacity <em>Heat Capacity</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.Medium#getEvaporationTemperature <em>Evaporation Temperature</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.Medium#getMeltingTemperature <em>Melting Temperature</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.Medium#getName <em>Name</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getMedium()
 * @model
 * @generated
 */
public interface Medium extends EObject {
	/**
	 * Returns the value of the '<em><b>Density</b></em>' attribute.
	 * The default value is <code>"g/cm\u00b3"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * kg/m³
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Density</em>' attribute.
	 * @see #setDensity(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getMedium_Density()
	 * @model default="g/cm\u00b3" dataType="de.hftstuttgart.energycomponents.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getDensity();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.Medium#getDensity <em>Density</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Density</em>' attribute.
	 * @see #getDensity()
	 * @generated
	 */
	void setDensity(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Heat Capacity</b></em>' attribute.
	 * The default value is <code>"kJ/(kg*K)"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * kJ/kg*K
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Heat Capacity</em>' attribute.
	 * @see #setHeatCapacity(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getMedium_HeatCapacity()
	 * @model default="kJ/(kg*K)" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getHeatCapacity();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.Medium#getHeatCapacity <em>Heat Capacity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Heat Capacity</em>' attribute.
	 * @see #getHeatCapacity()
	 * @generated
	 */
	void setHeatCapacity(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Evaporation Temperature</b></em>' attribute.
	 * The default value is <code>"\u00b0C"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * degree Celsius
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Evaporation Temperature</em>' attribute.
	 * @see #setEvaporationTemperature(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getMedium_EvaporationTemperature()
	 * @model default="\u00b0C" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getEvaporationTemperature();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.Medium#getEvaporationTemperature <em>Evaporation Temperature</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Evaporation Temperature</em>' attribute.
	 * @see #getEvaporationTemperature()
	 * @generated
	 */
	void setEvaporationTemperature(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Melting Temperature</b></em>' attribute.
	 * The default value is <code>"\u00b0C"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * degree Celsius
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Melting Temperature</em>' attribute.
	 * @see #setMeltingTemperature(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getMedium_MeltingTemperature()
	 * @model default="\u00b0C" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getMeltingTemperature();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.Medium#getMeltingTemperature <em>Melting Temperature</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Melting Temperature</em>' attribute.
	 * @see #getMeltingTemperature()
	 * @generated
	 */
	void setMeltingTemperature(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getMedium_Name()
	 * @model required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.Medium#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

} // Medium
