/**
 */
package de.hftstuttgart.energycomponents;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Photovoltaic Module</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getCellType <em>Cell Type</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getNominalPower <em>Nominal Power</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getMppVoltage <em>Mpp Voltage</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getMppCurrent <em>Mpp Current</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getNominalEfficiency <em>Nominal Efficiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getModuleArea <em>Module Area</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getPhotovoltaicModule()
 * @model
 * @generated
 */
public interface PhotovoltaicModule extends EnergyComponent {
	/**
	 * Returns the value of the '<em><b>Cell Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cell Type</em>' attribute.
	 * @see #setCellType(Enumerator)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getPhotovoltaicModule_CellType()
	 * @model required="true" transient="true"
	 * @generated
	 */
	Enumerator getCellType();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getCellType <em>Cell Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cell Type</em>' attribute.
	 * @see #getCellType()
	 * @generated
	 */
	void setCellType(Enumerator value);

	/**
	 * Returns the value of the '<em><b>Nominal Power</b></em>' attribute.
	 * The default value is <code>"W"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * W
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Nominal Power</em>' attribute.
	 * @see #setNominalPower(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getPhotovoltaicModule_NominalPower()
	 * @model default="W" dataType="de.hftstuttgart.energycomponents.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getNominalPower();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getNominalPower <em>Nominal Power</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Nominal Power</em>' attribute.
	 * @see #getNominalPower()
	 * @generated
	 */
	void setNominalPower(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Mpp Voltage</b></em>' attribute.
	 * The default value is <code>"V"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * V
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Mpp Voltage</em>' attribute.
	 * @see #setMppVoltage(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getPhotovoltaicModule_MppVoltage()
	 * @model default="V" dataType="de.hftstuttgart.energycomponents.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getMppVoltage();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getMppVoltage <em>Mpp Voltage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mpp Voltage</em>' attribute.
	 * @see #getMppVoltage()
	 * @generated
	 */
	void setMppVoltage(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Mpp Current</b></em>' attribute.
	 * The default value is <code>"A"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * A
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Mpp Current</em>' attribute.
	 * @see #setMppCurrent(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getPhotovoltaicModule_MppCurrent()
	 * @model default="A" dataType="de.hftstuttgart.energycomponents.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getMppCurrent();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getMppCurrent <em>Mpp Current</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mpp Current</em>' attribute.
	 * @see #getMppCurrent()
	 * @generated
	 */
	void setMppCurrent(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Nominal Efficiency</b></em>' attribute.
	 * The default value is <code>"0.18"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Nominal Efficiency</em>' attribute.
	 * @see #setNominalEfficiency(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getPhotovoltaicModule_NominalEfficiency()
	 * @model default="0.18" required="true"
	 * @generated
	 */
	double getNominalEfficiency();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getNominalEfficiency <em>Nominal Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Nominal Efficiency</em>' attribute.
	 * @see #getNominalEfficiency()
	 * @generated
	 */
	void setNominalEfficiency(double value);

	/**
	 * Returns the value of the '<em><b>Module Area</b></em>' attribute.
	 * The default value is <code>"m\u00b2"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * m²
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Module Area</em>' attribute.
	 * @see #setModuleArea(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getPhotovoltaicModule_ModuleArea()
	 * @model default="m\u00b2" dataType="de.hftstuttgart.energycomponents.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getModuleArea();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getModuleArea <em>Module Area</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Module Area</em>' attribute.
	 * @see #getModuleArea()
	 * @generated
	 */
	void setModuleArea(NullableQuantity value);

} // PhotovoltaicModule
