/**
 */
package de.hftstuttgart.energycomponents;

import de.hftstuttgart.units.NullableQuantity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Solar Thermal Collector</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getCollectorType <em>Collector Type</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getApertureArea <em>Aperture Area</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getOpticalEfficiency <em>Optical Efficiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getLinearHeatLossCoefficient <em>Linear Heat Loss Coefficient</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getQuadraticalHeatLossCoefficient <em>Quadratical Heat Loss Coefficient</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getSolarThermalCollector()
 * @model
 * @generated
 */
public interface SolarThermalCollector extends EnergyComponent {
	/**
	 * Returns the value of the '<em><b>Collector Type</b></em>' attribute.
	 * The literals are from the enumeration {@link de.hftstuttgart.energycomponents.CollectorTypes}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Collector Type</em>' attribute.
	 * @see de.hftstuttgart.energycomponents.CollectorTypes
	 * @see #setCollectorType(CollectorTypes)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getSolarThermalCollector_CollectorType()
	 * @model required="true"
	 * @generated
	 */
	CollectorTypes getCollectorType();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getCollectorType <em>Collector Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Collector Type</em>' attribute.
	 * @see de.hftstuttgart.energycomponents.CollectorTypes
	 * @see #getCollectorType()
	 * @generated
	 */
	void setCollectorType(CollectorTypes value);

	/**
	 * Returns the value of the '<em><b>Aperture Area</b></em>' attribute.
	 * The default value is <code>"m\u00b2"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * m²
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Aperture Area</em>' attribute.
	 * @see #setApertureArea(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getSolarThermalCollector_ApertureArea()
	 * @model default="m\u00b2" dataType="de.hftstuttgart.energycomponents.QuantityDouble" required="true"
	 * @generated
	 */
	NullableQuantity getApertureArea();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getApertureArea <em>Aperture Area</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Aperture Area</em>' attribute.
	 * @see #getApertureArea()
	 * @generated
	 */
	void setApertureArea(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Optical Efficiency</b></em>' attribute.
	 * The default value is <code>"0.77"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * share
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Optical Efficiency</em>' attribute.
	 * @see #setOpticalEfficiency(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getSolarThermalCollector_OpticalEfficiency()
	 * @model default="0.77"
	 * @generated
	 */
	double getOpticalEfficiency();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getOpticalEfficiency <em>Optical Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Optical Efficiency</em>' attribute.
	 * @see #getOpticalEfficiency()
	 * @generated
	 */
	void setOpticalEfficiency(double value);

	/**
	 * Returns the value of the '<em><b>Linear Heat Loss Coefficient</b></em>' attribute.
	 * The default value is <code>"3.2"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Linear Heat Loss Coefficient</em>' attribute.
	 * @see #setLinearHeatLossCoefficient(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getSolarThermalCollector_LinearHeatLossCoefficient()
	 * @model default="3.2"
	 * @generated
	 */
	double getLinearHeatLossCoefficient();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getLinearHeatLossCoefficient <em>Linear Heat Loss Coefficient</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Linear Heat Loss Coefficient</em>' attribute.
	 * @see #getLinearHeatLossCoefficient()
	 * @generated
	 */
	void setLinearHeatLossCoefficient(double value);

	/**
	 * Returns the value of the '<em><b>Quadratical Heat Loss Coefficient</b></em>' attribute.
	 * The default value is <code>"0.01"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Quadratical Heat Loss Coefficient</em>' attribute.
	 * @see #setQuadraticalHeatLossCoefficient(double)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getSolarThermalCollector_QuadraticalHeatLossCoefficient()
	 * @model default="0.01"
	 * @generated
	 */
	double getQuadraticalHeatLossCoefficient();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getQuadraticalHeatLossCoefficient <em>Quadratical Heat Loss Coefficient</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Quadratical Heat Loss Coefficient</em>' attribute.
	 * @see #getQuadraticalHeatLossCoefficient()
	 * @generated
	 */
	void setQuadraticalHeatLossCoefficient(double value);

} // SolarThermalCollector
