/**
 */
package de.hftstuttgart.energycomponents;

import de.hftstuttgart.units.NullableQuantity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Thermal Storage</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.ThermalStorage#getVolume <em>Volume</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ThermalStorage#getThermalStorageType <em>Thermal Storage Type</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ThermalStorage#getMaxTemp <em>Max Temp</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ThermalStorage#getTankThickness <em>Tank Thickness</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ThermalStorage#getInsulationThickness <em>Insulation Thickness</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ThermalStorage#getUsesMedium <em>Uses Medium</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ThermalStorage#getInsulationMaterial <em>Insulation Material</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ThermalStorage#getHeight <em>Height</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.ThermalStorage#getTankMaterial <em>Tank Material</em>}</li>
 * </ul>
 *
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getThermalStorage()
 * @model
 * @generated
 */
public interface ThermalStorage extends EnergyComponent {
	/**
	 * Returns the value of the '<em><b>Volume</b></em>' attribute.
	 * The default value is <code>"5 m\u00b3"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * m³
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Volume</em>' attribute.
	 * @see #setVolume(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getThermalStorage_Volume()
	 * @model default="5 m\u00b3" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getVolume();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ThermalStorage#getVolume <em>Volume</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Volume</em>' attribute.
	 * @see #getVolume()
	 * @generated
	 */
	void setVolume(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Thermal Storage Type</b></em>' attribute.
	 * The literals are from the enumeration {@link de.hftstuttgart.energycomponents.ThermalStorageTypes}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Thermal Storage Type</em>' attribute.
	 * @see de.hftstuttgart.energycomponents.ThermalStorageTypes
	 * @see #setThermalStorageType(ThermalStorageTypes)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getThermalStorage_ThermalStorageType()
	 * @model unique="false" transient="true"
	 * @generated
	 */
	ThermalStorageTypes getThermalStorageType();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ThermalStorage#getThermalStorageType <em>Thermal Storage Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Thermal Storage Type</em>' attribute.
	 * @see de.hftstuttgart.energycomponents.ThermalStorageTypes
	 * @see #getThermalStorageType()
	 * @generated
	 */
	void setThermalStorageType(ThermalStorageTypes value);

	/**
	 * Returns the value of the '<em><b>Max Temp</b></em>' attribute.
	 * The default value is <code>"80 \u00b0C"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * degree Celsius
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Max Temp</em>' attribute.
	 * @see #setMaxTemp(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getThermalStorage_MaxTemp()
	 * @model default="80 \u00b0C" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getMaxTemp();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ThermalStorage#getMaxTemp <em>Max Temp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Temp</em>' attribute.
	 * @see #getMaxTemp()
	 * @generated
	 */
	void setMaxTemp(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Tank Thickness</b></em>' attribute.
	 * The default value is <code>"10 mm "</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tank Thickness</em>' attribute.
	 * @see #setTankThickness(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getThermalStorage_TankThickness()
	 * @model default="10 mm " dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getTankThickness();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ThermalStorage#getTankThickness <em>Tank Thickness</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Tank Thickness</em>' attribute.
	 * @see #getTankThickness()
	 * @generated
	 */
	void setTankThickness(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Insulation Thickness</b></em>' attribute.
	 * The default value is <code>"100 mm"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Insulation Thickness</em>' attribute.
	 * @see #setInsulationThickness(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getThermalStorage_InsulationThickness()
	 * @model default="100 mm" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getInsulationThickness();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ThermalStorage#getInsulationThickness <em>Insulation Thickness</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Insulation Thickness</em>' attribute.
	 * @see #getInsulationThickness()
	 * @generated
	 */
	void setInsulationThickness(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Uses Medium</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Uses Medium</em>' reference.
	 * @see #setUsesMedium(Medium)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getThermalStorage_UsesMedium()
	 * @model required="true"
	 * @generated
	 */
	Medium getUsesMedium();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ThermalStorage#getUsesMedium <em>Uses Medium</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Uses Medium</em>' reference.
	 * @see #getUsesMedium()
	 * @generated
	 */
	void setUsesMedium(Medium value);

	/**
	 * Returns the value of the '<em><b>Insulation Material</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Insulation Material</em>' reference.
	 * @see #setInsulationMaterial(Material)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getThermalStorage_InsulationMaterial()
	 * @model
	 * @generated
	 */
	Material getInsulationMaterial();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ThermalStorage#getInsulationMaterial <em>Insulation Material</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Insulation Material</em>' reference.
	 * @see #getInsulationMaterial()
	 * @generated
	 */
	void setInsulationMaterial(Material value);

	/**
	 * Returns the value of the '<em><b>Height</b></em>' attribute.
	 * The default value is <code>"2 m"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Height</em>' attribute.
	 * @see #setHeight(NullableQuantity)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getThermalStorage_Height()
	 * @model default="2 m" dataType="de.hftstuttgart.energycomponents.QuantityDouble"
	 * @generated
	 */
	NullableQuantity getHeight();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ThermalStorage#getHeight <em>Height</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Height</em>' attribute.
	 * @see #getHeight()
	 * @generated
	 */
	void setHeight(NullableQuantity value);

	/**
	 * Returns the value of the '<em><b>Tank Material</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tank Material</em>' reference.
	 * @see #setTankMaterial(Material)
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#getThermalStorage_TankMaterial()
	 * @model
	 * @generated
	 */
	Material getTankMaterial();

	/**
	 * Sets the value of the '{@link de.hftstuttgart.energycomponents.ThermalStorage#getTankMaterial <em>Tank Material</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Tank Material</em>' reference.
	 * @see #getTankMaterial()
	 * @generated
	 */
	void setTankMaterial(Material value);

} // ThermalStorage
