/**
 */
package de.hftstuttgart.energycomponents;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Thermal Storage Types</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see de.hftstuttgart.energycomponents.EnCompPackage#getThermalStorageTypes()
 * @model
 * @generated
 */
public enum ThermalStorageTypes implements Enumerator {
	/**
	 * The '<em><b>Sensible</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SENSIBLE_VALUE
	 * @generated
	 * @ordered
	 */
	SENSIBLE(0, "sensible", "sensible"),

	/**
	 * The '<em><b>Latent</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LATENT_VALUE
	 * @generated
	 * @ordered
	 */
	LATENT(1, "latent", "LITERAL1");

	/**
	 * The '<em><b>Sensible</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SENSIBLE
	 * @model name="sensible"
	 * @generated
	 * @ordered
	 */
	public static final int SENSIBLE_VALUE = 0;

	/**
	 * The '<em><b>Latent</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LATENT
	 * @model name="latent" literal="LITERAL1"
	 * @generated
	 * @ordered
	 */
	public static final int LATENT_VALUE = 1;

	/**
	 * An array of all the '<em><b>Thermal Storage Types</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final ThermalStorageTypes[] VALUES_ARRAY = new ThermalStorageTypes[] { SENSIBLE, LATENT, };

	/**
	 * A public read-only list of all the '<em><b>Thermal Storage Types</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<ThermalStorageTypes> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Thermal Storage Types</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static ThermalStorageTypes get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ThermalStorageTypes result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Thermal Storage Types</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static ThermalStorageTypes getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ThermalStorageTypes result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Thermal Storage Types</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static ThermalStorageTypes get(int value) {
		switch (value) {
		case SENSIBLE_VALUE:
			return SENSIBLE;
		case LATENT_VALUE:
			return LATENT;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private ThermalStorageTypes(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int getValue() {
		return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getLiteral() {
		return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}

} //ThermalStorageTypes
