/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.Characteristic;
import de.hftstuttgart.energycomponents.CombinedHeatPower;
import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Combined Heat Power</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CombinedHeatPowerImpl#getThermalEfficiency <em>Thermal Efficiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CombinedHeatPowerImpl#getElectricalEfficiency <em>Electrical Efficiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CombinedHeatPowerImpl#getInstalledElectricalPower <em>Installed Electrical Power</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CombinedHeatPowerImpl#getElectricalEfficiencyPartLoad <em>Electrical Efficiency Part Load</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CombinedHeatPowerImpl#getThermalEfficiencyPartLoad <em>Thermal Efficiency Part Load</em>}</li>
 * </ul>
 *
 * @generated
 */
public class CombinedHeatPowerImpl extends ThermalEnergyDeviceImpl implements CombinedHeatPower {
	/**
	 * The default value of the '{@link #getThermalEfficiency() <em>Thermal Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getThermalEfficiency()
	 * @generated
	 * @ordered
	 */
	protected static final double THERMAL_EFFICIENCY_EDEFAULT = 0.4;

	/**
	 * The cached value of the '{@link #getThermalEfficiency() <em>Thermal Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getThermalEfficiency()
	 * @generated
	 * @ordered
	 */
	protected double thermalEfficiency = THERMAL_EFFICIENCY_EDEFAULT;

	/**
	 * The default value of the '{@link #getElectricalEfficiency() <em>Electrical Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getElectricalEfficiency()
	 * @generated
	 * @ordered
	 */
	protected static final double ELECTRICAL_EFFICIENCY_EDEFAULT = 0.4;

	/**
	 * The cached value of the '{@link #getElectricalEfficiency() <em>Electrical Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getElectricalEfficiency()
	 * @generated
	 * @ordered
	 */
	protected double electricalEfficiency = ELECTRICAL_EFFICIENCY_EDEFAULT;

	/**
	 * The default value of the '{@link #getInstalledElectricalPower() <em>Installed Electrical Power</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInstalledElectricalPower()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity INSTALLED_ELECTRICAL_POWER_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "kW");

	/**
	 * The cached value of the '{@link #getInstalledElectricalPower() <em>Installed Electrical Power</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInstalledElectricalPower()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity installedElectricalPower = INSTALLED_ELECTRICAL_POWER_EDEFAULT;

	/**
	 * The cached value of the '{@link #getElectricalEfficiencyPartLoad() <em>Electrical Efficiency Part Load</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getElectricalEfficiencyPartLoad()
	 * @generated
	 * @ordered
	 */
	protected Characteristic electricalEfficiencyPartLoad;

	/**
	 * The cached value of the '{@link #getThermalEfficiencyPartLoad() <em>Thermal Efficiency Part Load</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getThermalEfficiencyPartLoad()
	 * @generated
	 * @ordered
	 */
	protected Characteristic thermalEfficiencyPartLoad;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CombinedHeatPowerImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.COMBINED_HEAT_POWER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getThermalEfficiency() {
		return thermalEfficiency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setThermalEfficiency(double newThermalEfficiency) {
		double oldThermalEfficiency = thermalEfficiency;
		thermalEfficiency = newThermalEfficiency;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY,
					oldThermalEfficiency, thermalEfficiency));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getElectricalEfficiency() {
		return electricalEfficiency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setElectricalEfficiency(double newElectricalEfficiency) {
		double oldElectricalEfficiency = electricalEfficiency;
		electricalEfficiency = newElectricalEfficiency;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY, oldElectricalEfficiency,
					electricalEfficiency));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getInstalledElectricalPower() {
		return installedElectricalPower;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setInstalledElectricalPower(NullableQuantity newInstalledElectricalPower) {
		NullableQuantity oldInstalledElectricalPower = installedElectricalPower;
		installedElectricalPower = newInstalledElectricalPower;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.COMBINED_HEAT_POWER__INSTALLED_ELECTRICAL_POWER, oldInstalledElectricalPower,
					installedElectricalPower));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Characteristic getElectricalEfficiencyPartLoad() {
		return electricalEfficiencyPartLoad;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetElectricalEfficiencyPartLoad(Characteristic newElectricalEfficiencyPartLoad,
			NotificationChain msgs) {
		Characteristic oldElectricalEfficiencyPartLoad = electricalEfficiencyPartLoad;
		electricalEfficiencyPartLoad = newElectricalEfficiencyPartLoad;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD, oldElectricalEfficiencyPartLoad,
					newElectricalEfficiencyPartLoad);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setElectricalEfficiencyPartLoad(Characteristic newElectricalEfficiencyPartLoad) {
		if (newElectricalEfficiencyPartLoad != electricalEfficiencyPartLoad) {
			NotificationChain msgs = null;
			if (electricalEfficiencyPartLoad != null)
				msgs = ((InternalEObject) electricalEfficiencyPartLoad).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD,
						null, msgs);
			if (newElectricalEfficiencyPartLoad != null)
				msgs = ((InternalEObject) newElectricalEfficiencyPartLoad).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD,
						null, msgs);
			msgs = basicSetElectricalEfficiencyPartLoad(newElectricalEfficiencyPartLoad, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD, newElectricalEfficiencyPartLoad,
					newElectricalEfficiencyPartLoad));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Characteristic getThermalEfficiencyPartLoad() {
		return thermalEfficiencyPartLoad;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetThermalEfficiencyPartLoad(Characteristic newThermalEfficiencyPartLoad,
			NotificationChain msgs) {
		Characteristic oldThermalEfficiencyPartLoad = thermalEfficiencyPartLoad;
		thermalEfficiencyPartLoad = newThermalEfficiencyPartLoad;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD, oldThermalEfficiencyPartLoad,
					newThermalEfficiencyPartLoad);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setThermalEfficiencyPartLoad(Characteristic newThermalEfficiencyPartLoad) {
		if (newThermalEfficiencyPartLoad != thermalEfficiencyPartLoad) {
			NotificationChain msgs = null;
			if (thermalEfficiencyPartLoad != null)
				msgs = ((InternalEObject) thermalEfficiencyPartLoad).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD, null,
						msgs);
			if (newThermalEfficiencyPartLoad != null)
				msgs = ((InternalEObject) newThermalEfficiencyPartLoad).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD, null,
						msgs);
			msgs = basicSetThermalEfficiencyPartLoad(newThermalEfficiencyPartLoad, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD, newThermalEfficiencyPartLoad,
					newThermalEfficiencyPartLoad));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD:
			return basicSetElectricalEfficiencyPartLoad(null, msgs);
		case EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD:
			return basicSetThermalEfficiencyPartLoad(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY:
			return getThermalEfficiency();
		case EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY:
			return getElectricalEfficiency();
		case EnCompPackage.COMBINED_HEAT_POWER__INSTALLED_ELECTRICAL_POWER:
			return getInstalledElectricalPower();
		case EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD:
			return getElectricalEfficiencyPartLoad();
		case EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD:
			return getThermalEfficiencyPartLoad();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY:
			setThermalEfficiency((Double) newValue);
			return;
		case EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY:
			setElectricalEfficiency((Double) newValue);
			return;
		case EnCompPackage.COMBINED_HEAT_POWER__INSTALLED_ELECTRICAL_POWER:
			setInstalledElectricalPower((NullableQuantity) newValue);
			return;
		case EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD:
			setElectricalEfficiencyPartLoad((Characteristic) newValue);
			return;
		case EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD:
			setThermalEfficiencyPartLoad((Characteristic) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY:
			setThermalEfficiency(THERMAL_EFFICIENCY_EDEFAULT);
			return;
		case EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY:
			setElectricalEfficiency(ELECTRICAL_EFFICIENCY_EDEFAULT);
			return;
		case EnCompPackage.COMBINED_HEAT_POWER__INSTALLED_ELECTRICAL_POWER:
			setInstalledElectricalPower(INSTALLED_ELECTRICAL_POWER_EDEFAULT);
			return;
		case EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD:
			setElectricalEfficiencyPartLoad((Characteristic) null);
			return;
		case EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD:
			setThermalEfficiencyPartLoad((Characteristic) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY:
			return thermalEfficiency != THERMAL_EFFICIENCY_EDEFAULT;
		case EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY:
			return electricalEfficiency != ELECTRICAL_EFFICIENCY_EDEFAULT;
		case EnCompPackage.COMBINED_HEAT_POWER__INSTALLED_ELECTRICAL_POWER:
			return INSTALLED_ELECTRICAL_POWER_EDEFAULT == null ? installedElectricalPower != null
					: !INSTALLED_ELECTRICAL_POWER_EDEFAULT.equals(installedElectricalPower);
		case EnCompPackage.COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD:
			return electricalEfficiencyPartLoad != null;
		case EnCompPackage.COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD:
			return thermalEfficiencyPartLoad != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (thermalEfficiency: ");
		result.append(thermalEfficiency);
		result.append(", electricalEfficiency: ");
		result.append(electricalEfficiency);
		result.append(", installedElectricalPower: ");
		result.append(installedElectricalPower);
		result.append(')');
		return result.toString();
	}

} //CombinedHeatPowerImpl
