/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.Characteristic;
import de.hftstuttgart.energycomponents.Cost;
import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.TypeOfHeatSource;
import de.hftstuttgart.units.NullableQuantity;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Cost</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CostImpl#getComponentName <em>Component Name</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CostImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CostImpl#getHeatSource <em>Heat Source</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CostImpl#getDatasource <em>Datasource</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CostImpl#getInvestmentCost <em>Investment Cost</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CostImpl#getOtherInvestmentCost <em>Other Investment Cost</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CostImpl#getPersonnelHours <em>Personnel Hours</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CostImpl#getPersonnelCostShare <em>Personnel Cost Share</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CostImpl#getAdministrationAndOtherCostShare <em>Administration And Other Cost Share</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.CostImpl#getMaintenanceCostShare <em>Maintenance Cost Share</em>}</li>
 * </ul>
 *
 * @generated
 */
public class CostImpl extends MinimalEObjectImpl.Container implements Cost {
	/**
	 * The default value of the '{@link #getComponentName() <em>Component Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComponentName()
	 * @generated
	 * @ordered
	 */
	protected static final String COMPONENT_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getComponentName() <em>Component Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComponentName()
	 * @generated
	 * @ordered
	 */
	protected String componentName = COMPONENT_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getHeatSource() <em>Heat Source</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeatSource()
	 * @generated
	 * @ordered
	 */
	protected static final TypeOfHeatSource HEAT_SOURCE_EDEFAULT = TypeOfHeatSource.NATURAL_GAS;

	/**
	 * The cached value of the '{@link #getHeatSource() <em>Heat Source</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeatSource()
	 * @generated
	 * @ordered
	 */
	protected TypeOfHeatSource heatSource = HEAT_SOURCE_EDEFAULT;

	/**
	 * The default value of the '{@link #getDatasource() <em>Datasource</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDatasource()
	 * @generated
	 * @ordered
	 */
	protected static final String DATASOURCE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDatasource() <em>Datasource</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDatasource()
	 * @generated
	 * @ordered
	 */
	protected String datasource = DATASOURCE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getInvestmentCost() <em>Investment Cost</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInvestmentCost()
	 * @generated
	 * @ordered
	 */
	protected Characteristic investmentCost;

	/**
	 * The default value of the '{@link #getOtherInvestmentCost() <em>Other Investment Cost</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOtherInvestmentCost()
	 * @generated
	 * @ordered
	 */
	protected static final double OTHER_INVESTMENT_COST_EDEFAULT = 0.0;

	/**
	 * The cached value of the '{@link #getOtherInvestmentCost() <em>Other Investment Cost</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOtherInvestmentCost()
	 * @generated
	 * @ordered
	 */
	protected double otherInvestmentCost = OTHER_INVESTMENT_COST_EDEFAULT;

	/**
	 * The default value of the '{@link #getPersonnelHours() <em>Personnel Hours</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPersonnelHours()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity PERSONNEL_HOURS_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "10 h");

	/**
	 * The cached value of the '{@link #getPersonnelHours() <em>Personnel Hours</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPersonnelHours()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity personnelHours = PERSONNEL_HOURS_EDEFAULT;

	/**
	 * The default value of the '{@link #getPersonnelCostShare() <em>Personnel Cost Share</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPersonnelCostShare()
	 * @generated
	 * @ordered
	 */
	protected static final double PERSONNEL_COST_SHARE_EDEFAULT = 0.0;

	/**
	 * The cached value of the '{@link #getPersonnelCostShare() <em>Personnel Cost Share</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPersonnelCostShare()
	 * @generated
	 * @ordered
	 */
	protected double personnelCostShare = PERSONNEL_COST_SHARE_EDEFAULT;

	/**
	 * The default value of the '{@link #getAdministrationAndOtherCostShare() <em>Administration And Other Cost Share</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAdministrationAndOtherCostShare()
	 * @generated
	 * @ordered
	 */
	protected static final double ADMINISTRATION_AND_OTHER_COST_SHARE_EDEFAULT = 0.015;

	/**
	 * The cached value of the '{@link #getAdministrationAndOtherCostShare() <em>Administration And Other Cost Share</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAdministrationAndOtherCostShare()
	 * @generated
	 * @ordered
	 */
	protected double administrationAndOtherCostShare = ADMINISTRATION_AND_OTHER_COST_SHARE_EDEFAULT;

	/**
	 * The default value of the '{@link #getMaintenanceCostShare() <em>Maintenance Cost Share</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaintenanceCostShare()
	 * @generated
	 * @ordered
	 */
	protected static final double MAINTENANCE_COST_SHARE_EDEFAULT = 0.015;

	/**
	 * The cached value of the '{@link #getMaintenanceCostShare() <em>Maintenance Cost Share</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaintenanceCostShare()
	 * @generated
	 * @ordered
	 */
	protected double maintenanceCostShare = MAINTENANCE_COST_SHARE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CostImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.COST;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getPersonnelHours() {
		return personnelHours;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setPersonnelHours(NullableQuantity newPersonnelHours) {
		NullableQuantity oldPersonnelHours = personnelHours;
		personnelHours = newPersonnelHours;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.COST__PERSONNEL_HOURS,
					oldPersonnelHours, personnelHours));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getPersonnelCostShare() {
		return personnelCostShare;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setPersonnelCostShare(double newPersonnelCostShare) {
		double oldPersonnelCostShare = personnelCostShare;
		personnelCostShare = newPersonnelCostShare;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.COST__PERSONNEL_COST_SHARE,
					oldPersonnelCostShare, personnelCostShare));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getAdministrationAndOtherCostShare() {
		return administrationAndOtherCostShare;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setAdministrationAndOtherCostShare(double newAdministrationAndOtherCostShare) {
		double oldAdministrationAndOtherCostShare = administrationAndOtherCostShare;
		administrationAndOtherCostShare = newAdministrationAndOtherCostShare;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.COST__ADMINISTRATION_AND_OTHER_COST_SHARE, oldAdministrationAndOtherCostShare,
					administrationAndOtherCostShare));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getMaintenanceCostShare() {
		return maintenanceCostShare;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMaintenanceCostShare(double newMaintenanceCostShare) {
		double oldMaintenanceCostShare = maintenanceCostShare;
		maintenanceCostShare = newMaintenanceCostShare;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.COST__MAINTENANCE_COST_SHARE,
					oldMaintenanceCostShare, maintenanceCostShare));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case EnCompPackage.COST__INVESTMENT_COST:
			return basicSetInvestmentCost(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getDatasource() {
		return datasource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDatasource(String newDatasource) {
		String oldDatasource = datasource;
		datasource = newDatasource;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.COST__DATASOURCE, oldDatasource,
					datasource));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Characteristic getInvestmentCost() {
		return investmentCost;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInvestmentCost(Characteristic newInvestmentCost, NotificationChain msgs) {
		Characteristic oldInvestmentCost = investmentCost;
		investmentCost = newInvestmentCost;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					EnCompPackage.COST__INVESTMENT_COST, oldInvestmentCost, newInvestmentCost);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setInvestmentCost(Characteristic newInvestmentCost) {
		if (newInvestmentCost != investmentCost) {
			NotificationChain msgs = null;
			if (investmentCost != null)
				msgs = ((InternalEObject) investmentCost).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.COST__INVESTMENT_COST, null, msgs);
			if (newInvestmentCost != null)
				msgs = ((InternalEObject) newInvestmentCost).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.COST__INVESTMENT_COST, null, msgs);
			msgs = basicSetInvestmentCost(newInvestmentCost, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.COST__INVESTMENT_COST,
					newInvestmentCost, newInvestmentCost));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getOtherInvestmentCost() {
		return otherInvestmentCost;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setOtherInvestmentCost(double newOtherInvestmentCost) {
		double oldOtherInvestmentCost = otherInvestmentCost;
		otherInvestmentCost = newOtherInvestmentCost;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.COST__OTHER_INVESTMENT_COST,
					oldOtherInvestmentCost, otherInvestmentCost));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getComponentName() {
		return componentName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setComponentName(String newComponentName) {
		String oldComponentName = componentName;
		componentName = newComponentName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.COST__COMPONENT_NAME, oldComponentName,
					componentName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.COST__DESCRIPTION, oldDescription,
					description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TypeOfHeatSource getHeatSource() {
		return heatSource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setHeatSource(TypeOfHeatSource newHeatSource) {
		TypeOfHeatSource oldHeatSource = heatSource;
		heatSource = newHeatSource == null ? HEAT_SOURCE_EDEFAULT : newHeatSource;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.COST__HEAT_SOURCE, oldHeatSource,
					heatSource));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.COST__COMPONENT_NAME:
			return getComponentName();
		case EnCompPackage.COST__DESCRIPTION:
			return getDescription();
		case EnCompPackage.COST__HEAT_SOURCE:
			return getHeatSource();
		case EnCompPackage.COST__DATASOURCE:
			return getDatasource();
		case EnCompPackage.COST__INVESTMENT_COST:
			return getInvestmentCost();
		case EnCompPackage.COST__OTHER_INVESTMENT_COST:
			return getOtherInvestmentCost();
		case EnCompPackage.COST__PERSONNEL_HOURS:
			return getPersonnelHours();
		case EnCompPackage.COST__PERSONNEL_COST_SHARE:
			return getPersonnelCostShare();
		case EnCompPackage.COST__ADMINISTRATION_AND_OTHER_COST_SHARE:
			return getAdministrationAndOtherCostShare();
		case EnCompPackage.COST__MAINTENANCE_COST_SHARE:
			return getMaintenanceCostShare();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.COST__COMPONENT_NAME:
			setComponentName((String) newValue);
			return;
		case EnCompPackage.COST__DESCRIPTION:
			setDescription((String) newValue);
			return;
		case EnCompPackage.COST__HEAT_SOURCE:
			setHeatSource((TypeOfHeatSource) newValue);
			return;
		case EnCompPackage.COST__DATASOURCE:
			setDatasource((String) newValue);
			return;
		case EnCompPackage.COST__INVESTMENT_COST:
			setInvestmentCost((Characteristic) newValue);
			return;
		case EnCompPackage.COST__OTHER_INVESTMENT_COST:
			setOtherInvestmentCost((Double) newValue);
			return;
		case EnCompPackage.COST__PERSONNEL_HOURS:
			setPersonnelHours((NullableQuantity) newValue);
			return;
		case EnCompPackage.COST__PERSONNEL_COST_SHARE:
			setPersonnelCostShare((Double) newValue);
			return;
		case EnCompPackage.COST__ADMINISTRATION_AND_OTHER_COST_SHARE:
			setAdministrationAndOtherCostShare((Double) newValue);
			return;
		case EnCompPackage.COST__MAINTENANCE_COST_SHARE:
			setMaintenanceCostShare((Double) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.COST__COMPONENT_NAME:
			setComponentName(COMPONENT_NAME_EDEFAULT);
			return;
		case EnCompPackage.COST__DESCRIPTION:
			setDescription(DESCRIPTION_EDEFAULT);
			return;
		case EnCompPackage.COST__HEAT_SOURCE:
			setHeatSource(HEAT_SOURCE_EDEFAULT);
			return;
		case EnCompPackage.COST__DATASOURCE:
			setDatasource(DATASOURCE_EDEFAULT);
			return;
		case EnCompPackage.COST__INVESTMENT_COST:
			setInvestmentCost((Characteristic) null);
			return;
		case EnCompPackage.COST__OTHER_INVESTMENT_COST:
			setOtherInvestmentCost(OTHER_INVESTMENT_COST_EDEFAULT);
			return;
		case EnCompPackage.COST__PERSONNEL_HOURS:
			setPersonnelHours(PERSONNEL_HOURS_EDEFAULT);
			return;
		case EnCompPackage.COST__PERSONNEL_COST_SHARE:
			setPersonnelCostShare(PERSONNEL_COST_SHARE_EDEFAULT);
			return;
		case EnCompPackage.COST__ADMINISTRATION_AND_OTHER_COST_SHARE:
			setAdministrationAndOtherCostShare(ADMINISTRATION_AND_OTHER_COST_SHARE_EDEFAULT);
			return;
		case EnCompPackage.COST__MAINTENANCE_COST_SHARE:
			setMaintenanceCostShare(MAINTENANCE_COST_SHARE_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.COST__COMPONENT_NAME:
			return COMPONENT_NAME_EDEFAULT == null ? componentName != null
					: !COMPONENT_NAME_EDEFAULT.equals(componentName);
		case EnCompPackage.COST__DESCRIPTION:
			return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
		case EnCompPackage.COST__HEAT_SOURCE:
			return heatSource != HEAT_SOURCE_EDEFAULT;
		case EnCompPackage.COST__DATASOURCE:
			return DATASOURCE_EDEFAULT == null ? datasource != null : !DATASOURCE_EDEFAULT.equals(datasource);
		case EnCompPackage.COST__INVESTMENT_COST:
			return investmentCost != null;
		case EnCompPackage.COST__OTHER_INVESTMENT_COST:
			return otherInvestmentCost != OTHER_INVESTMENT_COST_EDEFAULT;
		case EnCompPackage.COST__PERSONNEL_HOURS:
			return PERSONNEL_HOURS_EDEFAULT == null ? personnelHours != null
					: !PERSONNEL_HOURS_EDEFAULT.equals(personnelHours);
		case EnCompPackage.COST__PERSONNEL_COST_SHARE:
			return personnelCostShare != PERSONNEL_COST_SHARE_EDEFAULT;
		case EnCompPackage.COST__ADMINISTRATION_AND_OTHER_COST_SHARE:
			return administrationAndOtherCostShare != ADMINISTRATION_AND_OTHER_COST_SHARE_EDEFAULT;
		case EnCompPackage.COST__MAINTENANCE_COST_SHARE:
			return maintenanceCostShare != MAINTENANCE_COST_SHARE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (componentName: ");
		result.append(componentName);
		result.append(", description: ");
		result.append(description);
		result.append(", heatSource: ");
		result.append(heatSource);
		result.append(", datasource: ");
		result.append(datasource);
		result.append(", otherInvestmentCost: ");
		result.append(otherInvestmentCost);
		result.append(", personnelHours: ");
		result.append(personnelHours);
		result.append(", personnelCostShare: ");
		result.append(personnelCostShare);
		result.append(", administrationAndOtherCostShare: ");
		result.append(administrationAndOtherCostShare);
		result.append(", maintenanceCostShare: ");
		result.append(maintenanceCostShare);
		result.append(')');
		return result.toString();
	}

} //CostImpl
