/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.ElectricalStorage;
import de.hftstuttgart.energycomponents.ElectricalStorageTypes;
import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Electrical Storage</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectricalStorageImpl#getElectricalStorageType <em>Electrical Storage Type</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectricalStorageImpl#getBatteryCapacity <em>Battery Capacity</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectricalStorageImpl#getBatteryVoltage <em>Battery Voltage</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectricalStorageImpl#getBatteryLifeCycle <em>Battery Life Cycle</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectricalStorageImpl#getSelfDischarge <em>Self Discharge</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectricalStorageImpl#getInverterIncluded <em>Inverter Included</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectricalStorageImpl#getBatteryEffiency <em>Battery Effiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectricalStorageImpl#getEnergyContent <em>Energy Content</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ElectricalStorageImpl extends EnergyComponentImpl implements ElectricalStorage {
	/**
	 * The default value of the '{@link #getElectricalStorageType() <em>Electrical Storage Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getElectricalStorageType()
	 * @generated
	 * @ordered
	 */
	protected static final ElectricalStorageTypes ELECTRICAL_STORAGE_TYPE_EDEFAULT = ElectricalStorageTypes.LITHIUM_ION;

	/**
	 * The cached value of the '{@link #getElectricalStorageType() <em>Electrical Storage Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getElectricalStorageType()
	 * @generated
	 * @ordered
	 */
	protected ElectricalStorageTypes electricalStorageType = ELECTRICAL_STORAGE_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getBatteryCapacity() <em>Battery Capacity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBatteryCapacity()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity BATTERY_CAPACITY_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "A*h");

	/**
	 * The cached value of the '{@link #getBatteryCapacity() <em>Battery Capacity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBatteryCapacity()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity batteryCapacity = BATTERY_CAPACITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getBatteryVoltage() <em>Battery Voltage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBatteryVoltage()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity BATTERY_VOLTAGE_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "V");

	/**
	 * The cached value of the '{@link #getBatteryVoltage() <em>Battery Voltage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBatteryVoltage()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity batteryVoltage = BATTERY_VOLTAGE_EDEFAULT;

	/**
	 * The default value of the '{@link #getBatteryLifeCycle() <em>Battery Life Cycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBatteryLifeCycle()
	 * @generated
	 * @ordered
	 */
	protected static final double BATTERY_LIFE_CYCLE_EDEFAULT = 7000.0;

	/**
	 * The cached value of the '{@link #getBatteryLifeCycle() <em>Battery Life Cycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBatteryLifeCycle()
	 * @generated
	 * @ordered
	 */
	protected double batteryLifeCycle = BATTERY_LIFE_CYCLE_EDEFAULT;

	/**
	 * The default value of the '{@link #getSelfDischarge() <em>Self Discharge</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSelfDischarge()
	 * @generated
	 * @ordered
	 */
	protected static final double SELF_DISCHARGE_EDEFAULT = 0.2;

	/**
	 * The cached value of the '{@link #getSelfDischarge() <em>Self Discharge</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSelfDischarge()
	 * @generated
	 * @ordered
	 */
	protected double selfDischarge = SELF_DISCHARGE_EDEFAULT;

	/**
	 * The default value of the '{@link #getInverterIncluded() <em>Inverter Included</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInverterIncluded()
	 * @generated
	 * @ordered
	 */
	protected static final Boolean INVERTER_INCLUDED_EDEFAULT = Boolean.FALSE;

	/**
	 * The cached value of the '{@link #getInverterIncluded() <em>Inverter Included</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInverterIncluded()
	 * @generated
	 * @ordered
	 */
	protected Boolean inverterIncluded = INVERTER_INCLUDED_EDEFAULT;

	/**
	 * The default value of the '{@link #getBatteryEffiency() <em>Battery Effiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBatteryEffiency()
	 * @generated
	 * @ordered
	 */
	protected static final double BATTERY_EFFIENCY_EDEFAULT = 0.8;

	/**
	 * The cached value of the '{@link #getBatteryEffiency() <em>Battery Effiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBatteryEffiency()
	 * @generated
	 * @ordered
	 */
	protected double batteryEffiency = BATTERY_EFFIENCY_EDEFAULT;

	/**
	 * The default value of the '{@link #getEnergyContent() <em>Energy Content</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEnergyContent()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity ENERGY_CONTENT_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "5 kW*h");

	/**
	 * The cached value of the '{@link #getEnergyContent() <em>Energy Content</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEnergyContent()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity energyContent = ENERGY_CONTENT_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ElectricalStorageImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.ELECTRICAL_STORAGE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ElectricalStorageTypes getElectricalStorageType() {
		return electricalStorageType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setElectricalStorageType(ElectricalStorageTypes newElectricalStorageType) {
		ElectricalStorageTypes oldElectricalStorageType = electricalStorageType;
		electricalStorageType = newElectricalStorageType == null ? ELECTRICAL_STORAGE_TYPE_EDEFAULT
				: newElectricalStorageType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.ELECTRICAL_STORAGE__ELECTRICAL_STORAGE_TYPE, oldElectricalStorageType,
					electricalStorageType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getBatteryCapacity() {
		return batteryCapacity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setBatteryCapacity(NullableQuantity newBatteryCapacity) {
		NullableQuantity oldBatteryCapacity = batteryCapacity;
		batteryCapacity = newBatteryCapacity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ELECTRICAL_STORAGE__BATTERY_CAPACITY,
					oldBatteryCapacity, batteryCapacity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getBatteryVoltage() {
		return batteryVoltage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setBatteryVoltage(NullableQuantity newBatteryVoltage) {
		NullableQuantity oldBatteryVoltage = batteryVoltage;
		batteryVoltage = newBatteryVoltage;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ELECTRICAL_STORAGE__BATTERY_VOLTAGE,
					oldBatteryVoltage, batteryVoltage));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getBatteryLifeCycle() {
		return batteryLifeCycle;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setBatteryLifeCycle(double newBatteryLifeCycle) {
		double oldBatteryLifeCycle = batteryLifeCycle;
		batteryLifeCycle = newBatteryLifeCycle;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ELECTRICAL_STORAGE__BATTERY_LIFE_CYCLE,
					oldBatteryLifeCycle, batteryLifeCycle));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getSelfDischarge() {
		return selfDischarge;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setSelfDischarge(double newSelfDischarge) {
		double oldSelfDischarge = selfDischarge;
		selfDischarge = newSelfDischarge;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ELECTRICAL_STORAGE__SELF_DISCHARGE,
					oldSelfDischarge, selfDischarge));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Boolean getInverterIncluded() {
		return inverterIncluded;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setInverterIncluded(Boolean newInverterIncluded) {
		Boolean oldInverterIncluded = inverterIncluded;
		inverterIncluded = newInverterIncluded;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ELECTRICAL_STORAGE__INVERTER_INCLUDED,
					oldInverterIncluded, inverterIncluded));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getBatteryEffiency() {
		return batteryEffiency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setBatteryEffiency(double newBatteryEffiency) {
		double oldBatteryEffiency = batteryEffiency;
		batteryEffiency = newBatteryEffiency;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ELECTRICAL_STORAGE__BATTERY_EFFIENCY,
					oldBatteryEffiency, batteryEffiency));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getEnergyContent() {
		return energyContent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setEnergyContent(NullableQuantity newEnergyContent) {
		NullableQuantity oldEnergyContent = energyContent;
		energyContent = newEnergyContent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ELECTRICAL_STORAGE__ENERGY_CONTENT,
					oldEnergyContent, energyContent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.ELECTRICAL_STORAGE__ELECTRICAL_STORAGE_TYPE:
			return getElectricalStorageType();
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_CAPACITY:
			return getBatteryCapacity();
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_VOLTAGE:
			return getBatteryVoltage();
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_LIFE_CYCLE:
			return getBatteryLifeCycle();
		case EnCompPackage.ELECTRICAL_STORAGE__SELF_DISCHARGE:
			return getSelfDischarge();
		case EnCompPackage.ELECTRICAL_STORAGE__INVERTER_INCLUDED:
			return getInverterIncluded();
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_EFFIENCY:
			return getBatteryEffiency();
		case EnCompPackage.ELECTRICAL_STORAGE__ENERGY_CONTENT:
			return getEnergyContent();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.ELECTRICAL_STORAGE__ELECTRICAL_STORAGE_TYPE:
			setElectricalStorageType((ElectricalStorageTypes) newValue);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_CAPACITY:
			setBatteryCapacity((NullableQuantity) newValue);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_VOLTAGE:
			setBatteryVoltage((NullableQuantity) newValue);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_LIFE_CYCLE:
			setBatteryLifeCycle((Double) newValue);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__SELF_DISCHARGE:
			setSelfDischarge((Double) newValue);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__INVERTER_INCLUDED:
			setInverterIncluded((Boolean) newValue);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_EFFIENCY:
			setBatteryEffiency((Double) newValue);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__ENERGY_CONTENT:
			setEnergyContent((NullableQuantity) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.ELECTRICAL_STORAGE__ELECTRICAL_STORAGE_TYPE:
			setElectricalStorageType(ELECTRICAL_STORAGE_TYPE_EDEFAULT);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_CAPACITY:
			setBatteryCapacity(BATTERY_CAPACITY_EDEFAULT);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_VOLTAGE:
			setBatteryVoltage(BATTERY_VOLTAGE_EDEFAULT);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_LIFE_CYCLE:
			setBatteryLifeCycle(BATTERY_LIFE_CYCLE_EDEFAULT);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__SELF_DISCHARGE:
			setSelfDischarge(SELF_DISCHARGE_EDEFAULT);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__INVERTER_INCLUDED:
			setInverterIncluded(INVERTER_INCLUDED_EDEFAULT);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_EFFIENCY:
			setBatteryEffiency(BATTERY_EFFIENCY_EDEFAULT);
			return;
		case EnCompPackage.ELECTRICAL_STORAGE__ENERGY_CONTENT:
			setEnergyContent(ENERGY_CONTENT_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.ELECTRICAL_STORAGE__ELECTRICAL_STORAGE_TYPE:
			return electricalStorageType != ELECTRICAL_STORAGE_TYPE_EDEFAULT;
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_CAPACITY:
			return BATTERY_CAPACITY_EDEFAULT == null ? batteryCapacity != null
					: !BATTERY_CAPACITY_EDEFAULT.equals(batteryCapacity);
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_VOLTAGE:
			return BATTERY_VOLTAGE_EDEFAULT == null ? batteryVoltage != null
					: !BATTERY_VOLTAGE_EDEFAULT.equals(batteryVoltage);
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_LIFE_CYCLE:
			return batteryLifeCycle != BATTERY_LIFE_CYCLE_EDEFAULT;
		case EnCompPackage.ELECTRICAL_STORAGE__SELF_DISCHARGE:
			return selfDischarge != SELF_DISCHARGE_EDEFAULT;
		case EnCompPackage.ELECTRICAL_STORAGE__INVERTER_INCLUDED:
			return INVERTER_INCLUDED_EDEFAULT == null ? inverterIncluded != null
					: !INVERTER_INCLUDED_EDEFAULT.equals(inverterIncluded);
		case EnCompPackage.ELECTRICAL_STORAGE__BATTERY_EFFIENCY:
			return batteryEffiency != BATTERY_EFFIENCY_EDEFAULT;
		case EnCompPackage.ELECTRICAL_STORAGE__ENERGY_CONTENT:
			return ENERGY_CONTENT_EDEFAULT == null ? energyContent != null
					: !ENERGY_CONTENT_EDEFAULT.equals(energyContent);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (electricalStorageType: ");
		result.append(electricalStorageType);
		result.append(", batteryCapacity: ");
		result.append(batteryCapacity);
		result.append(", batteryVoltage: ");
		result.append(batteryVoltage);
		result.append(", batteryLifeCycle: ");
		result.append(batteryLifeCycle);
		result.append(", selfDischarge: ");
		result.append(selfDischarge);
		result.append(", inverterIncluded: ");
		result.append(inverterIncluded);
		result.append(", batteryEffiency: ");
		result.append(batteryEffiency);
		result.append(", energyContent: ");
		result.append(energyContent);
		result.append(')');
		return result.toString();
	}

} //ElectricalStorageImpl
