/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.Electrolyzer;
import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.cellTypesElectrolyzer;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Electrolyzer</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectrolyzerImpl#getCellType <em>Cell Type</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectrolyzerImpl#getCellArea <em>Cell Area</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectrolyzerImpl#getNumberOfCells <em>Number Of Cells</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectrolyzerImpl#getMaxOperatingCurrentDensity <em>Max Operating Current Density</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectrolyzerImpl#getMinOperatingCurrentDensity <em>Min Operating Current Density</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectrolyzerImpl#getOverloadCapacity <em>Overload Capacity</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ElectrolyzerImpl#getNominalCellVoltage <em>Nominal Cell Voltage</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ElectrolyzerImpl extends EnergyComponentImpl implements Electrolyzer {
	/**
	 * The default value of the '{@link #getCellType() <em>Cell Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCellType()
	 * @generated
	 * @ordered
	 */
	protected static final cellTypesElectrolyzer CELL_TYPE_EDEFAULT = cellTypesElectrolyzer.PEM;

	/**
	 * The cached value of the '{@link #getCellType() <em>Cell Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCellType()
	 * @generated
	 * @ordered
	 */
	protected cellTypesElectrolyzer cellType = CELL_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getCellArea() <em>Cell Area</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCellArea()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity CELL_AREA_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "50 cm\u00b2");

	/**
	 * The cached value of the '{@link #getCellArea() <em>Cell Area</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCellArea()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity cellArea = CELL_AREA_EDEFAULT;

	/**
	 * The default value of the '{@link #getNumberOfCells() <em>Number Of Cells</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumberOfCells()
	 * @generated
	 * @ordered
	 */
	protected static final double NUMBER_OF_CELLS_EDEFAULT = 5.0;

	/**
	 * The cached value of the '{@link #getNumberOfCells() <em>Number Of Cells</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumberOfCells()
	 * @generated
	 * @ordered
	 */
	protected double numberOfCells = NUMBER_OF_CELLS_EDEFAULT;

	/**
	 * The default value of the '{@link #getMaxOperatingCurrentDensity() <em>Max Operating Current Density</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxOperatingCurrentDensity()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity MAX_OPERATING_CURRENT_DENSITY_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "3 A/cm\u00b2");

	/**
	 * The cached value of the '{@link #getMaxOperatingCurrentDensity() <em>Max Operating Current Density</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxOperatingCurrentDensity()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity maxOperatingCurrentDensity = MAX_OPERATING_CURRENT_DENSITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getMinOperatingCurrentDensity() <em>Min Operating Current Density</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinOperatingCurrentDensity()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity MIN_OPERATING_CURRENT_DENSITY_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "0.3 A/cm\u00b2");

	/**
	 * The cached value of the '{@link #getMinOperatingCurrentDensity() <em>Min Operating Current Density</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinOperatingCurrentDensity()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity minOperatingCurrentDensity = MIN_OPERATING_CURRENT_DENSITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getOverloadCapacity() <em>Overload Capacity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOverloadCapacity()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity OVERLOAD_CAPACITY_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "120 %");

	/**
	 * The cached value of the '{@link #getOverloadCapacity() <em>Overload Capacity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOverloadCapacity()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity overloadCapacity = OVERLOAD_CAPACITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getNominalCellVoltage() <em>Nominal Cell Voltage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNominalCellVoltage()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity NOMINAL_CELL_VOLTAGE_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "1.94 V");

	/**
	 * The cached value of the '{@link #getNominalCellVoltage() <em>Nominal Cell Voltage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNominalCellVoltage()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity nominalCellVoltage = NOMINAL_CELL_VOLTAGE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ElectrolyzerImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.ELECTROLYZER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public cellTypesElectrolyzer getCellType() {
		return cellType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setCellType(cellTypesElectrolyzer newCellType) {
		cellTypesElectrolyzer oldCellType = cellType;
		cellType = newCellType == null ? CELL_TYPE_EDEFAULT : newCellType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ELECTROLYZER__CELL_TYPE, oldCellType,
					cellType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getCellArea() {
		return cellArea;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setCellArea(NullableQuantity newCellArea) {
		NullableQuantity oldCellArea = cellArea;
		cellArea = newCellArea;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ELECTROLYZER__CELL_AREA, oldCellArea,
					cellArea));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getNumberOfCells() {
		return numberOfCells;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setNumberOfCells(double newNumberOfCells) {
		double oldNumberOfCells = numberOfCells;
		numberOfCells = newNumberOfCells;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ELECTROLYZER__NUMBER_OF_CELLS,
					oldNumberOfCells, numberOfCells));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getMaxOperatingCurrentDensity() {
		return maxOperatingCurrentDensity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMaxOperatingCurrentDensity(NullableQuantity newMaxOperatingCurrentDensity) {
		NullableQuantity oldMaxOperatingCurrentDensity = maxOperatingCurrentDensity;
		maxOperatingCurrentDensity = newMaxOperatingCurrentDensity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.ELECTROLYZER__MAX_OPERATING_CURRENT_DENSITY, oldMaxOperatingCurrentDensity,
					maxOperatingCurrentDensity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getMinOperatingCurrentDensity() {
		return minOperatingCurrentDensity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMinOperatingCurrentDensity(NullableQuantity newMinOperatingCurrentDensity) {
		NullableQuantity oldMinOperatingCurrentDensity = minOperatingCurrentDensity;
		minOperatingCurrentDensity = newMinOperatingCurrentDensity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.ELECTROLYZER__MIN_OPERATING_CURRENT_DENSITY, oldMinOperatingCurrentDensity,
					minOperatingCurrentDensity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getOverloadCapacity() {
		return overloadCapacity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setOverloadCapacity(NullableQuantity newOverloadCapacity) {
		NullableQuantity oldOverloadCapacity = overloadCapacity;
		overloadCapacity = newOverloadCapacity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ELECTROLYZER__OVERLOAD_CAPACITY,
					oldOverloadCapacity, overloadCapacity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getNominalCellVoltage() {
		return nominalCellVoltage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setNominalCellVoltage(NullableQuantity newNominalCellVoltage) {
		NullableQuantity oldNominalCellVoltage = nominalCellVoltage;
		nominalCellVoltage = newNominalCellVoltage;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ELECTROLYZER__NOMINAL_CELL_VOLTAGE,
					oldNominalCellVoltage, nominalCellVoltage));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.ELECTROLYZER__CELL_TYPE:
			return getCellType();
		case EnCompPackage.ELECTROLYZER__CELL_AREA:
			return getCellArea();
		case EnCompPackage.ELECTROLYZER__NUMBER_OF_CELLS:
			return getNumberOfCells();
		case EnCompPackage.ELECTROLYZER__MAX_OPERATING_CURRENT_DENSITY:
			return getMaxOperatingCurrentDensity();
		case EnCompPackage.ELECTROLYZER__MIN_OPERATING_CURRENT_DENSITY:
			return getMinOperatingCurrentDensity();
		case EnCompPackage.ELECTROLYZER__OVERLOAD_CAPACITY:
			return getOverloadCapacity();
		case EnCompPackage.ELECTROLYZER__NOMINAL_CELL_VOLTAGE:
			return getNominalCellVoltage();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.ELECTROLYZER__CELL_TYPE:
			setCellType((cellTypesElectrolyzer) newValue);
			return;
		case EnCompPackage.ELECTROLYZER__CELL_AREA:
			setCellArea((NullableQuantity) newValue);
			return;
		case EnCompPackage.ELECTROLYZER__NUMBER_OF_CELLS:
			setNumberOfCells((Double) newValue);
			return;
		case EnCompPackage.ELECTROLYZER__MAX_OPERATING_CURRENT_DENSITY:
			setMaxOperatingCurrentDensity((NullableQuantity) newValue);
			return;
		case EnCompPackage.ELECTROLYZER__MIN_OPERATING_CURRENT_DENSITY:
			setMinOperatingCurrentDensity((NullableQuantity) newValue);
			return;
		case EnCompPackage.ELECTROLYZER__OVERLOAD_CAPACITY:
			setOverloadCapacity((NullableQuantity) newValue);
			return;
		case EnCompPackage.ELECTROLYZER__NOMINAL_CELL_VOLTAGE:
			setNominalCellVoltage((NullableQuantity) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.ELECTROLYZER__CELL_TYPE:
			setCellType(CELL_TYPE_EDEFAULT);
			return;
		case EnCompPackage.ELECTROLYZER__CELL_AREA:
			setCellArea(CELL_AREA_EDEFAULT);
			return;
		case EnCompPackage.ELECTROLYZER__NUMBER_OF_CELLS:
			setNumberOfCells(NUMBER_OF_CELLS_EDEFAULT);
			return;
		case EnCompPackage.ELECTROLYZER__MAX_OPERATING_CURRENT_DENSITY:
			setMaxOperatingCurrentDensity(MAX_OPERATING_CURRENT_DENSITY_EDEFAULT);
			return;
		case EnCompPackage.ELECTROLYZER__MIN_OPERATING_CURRENT_DENSITY:
			setMinOperatingCurrentDensity(MIN_OPERATING_CURRENT_DENSITY_EDEFAULT);
			return;
		case EnCompPackage.ELECTROLYZER__OVERLOAD_CAPACITY:
			setOverloadCapacity(OVERLOAD_CAPACITY_EDEFAULT);
			return;
		case EnCompPackage.ELECTROLYZER__NOMINAL_CELL_VOLTAGE:
			setNominalCellVoltage(NOMINAL_CELL_VOLTAGE_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.ELECTROLYZER__CELL_TYPE:
			return cellType != CELL_TYPE_EDEFAULT;
		case EnCompPackage.ELECTROLYZER__CELL_AREA:
			return CELL_AREA_EDEFAULT == null ? cellArea != null : !CELL_AREA_EDEFAULT.equals(cellArea);
		case EnCompPackage.ELECTROLYZER__NUMBER_OF_CELLS:
			return numberOfCells != NUMBER_OF_CELLS_EDEFAULT;
		case EnCompPackage.ELECTROLYZER__MAX_OPERATING_CURRENT_DENSITY:
			return MAX_OPERATING_CURRENT_DENSITY_EDEFAULT == null ? maxOperatingCurrentDensity != null
					: !MAX_OPERATING_CURRENT_DENSITY_EDEFAULT.equals(maxOperatingCurrentDensity);
		case EnCompPackage.ELECTROLYZER__MIN_OPERATING_CURRENT_DENSITY:
			return MIN_OPERATING_CURRENT_DENSITY_EDEFAULT == null ? minOperatingCurrentDensity != null
					: !MIN_OPERATING_CURRENT_DENSITY_EDEFAULT.equals(minOperatingCurrentDensity);
		case EnCompPackage.ELECTROLYZER__OVERLOAD_CAPACITY:
			return OVERLOAD_CAPACITY_EDEFAULT == null ? overloadCapacity != null
					: !OVERLOAD_CAPACITY_EDEFAULT.equals(overloadCapacity);
		case EnCompPackage.ELECTROLYZER__NOMINAL_CELL_VOLTAGE:
			return NOMINAL_CELL_VOLTAGE_EDEFAULT == null ? nominalCellVoltage != null
					: !NOMINAL_CELL_VOLTAGE_EDEFAULT.equals(nominalCellVoltage);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (cellType: ");
		result.append(cellType);
		result.append(", cellArea: ");
		result.append(cellArea);
		result.append(", numberOfCells: ");
		result.append(numberOfCells);
		result.append(", maxOperatingCurrentDensity: ");
		result.append(maxOperatingCurrentDensity);
		result.append(", minOperatingCurrentDensity: ");
		result.append(minOperatingCurrentDensity);
		result.append(", overloadCapacity: ");
		result.append(overloadCapacity);
		result.append(", nominalCellVoltage: ");
		result.append(nominalCellVoltage);
		result.append(')');
		return result.toString();
	}

} //ElectrolyzerImpl
