/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.*;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class EnCompFactoryImpl extends EFactoryImpl implements EnCompFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static EnCompFactory init() {
		try {
			EnCompFactory theEnCompFactory = (EnCompFactory) EPackage.Registry.INSTANCE
					.getEFactory(EnCompPackage.eNS_URI);
			if (theEnCompFactory != null) {
				return theEnCompFactory;
			}
		} catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new EnCompFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EnCompFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG:
			return createEnergyComponentsCatalog();
		case EnCompPackage.THERMAL_STORAGE:
			return createThermalStorage();
		case EnCompPackage.ELECTRICAL_STORAGE:
			return createElectricalStorage();
		case EnCompPackage.COMBINED_HEAT_POWER:
			return createCombinedHeatPower();
		case EnCompPackage.HEAT_PUMP:
			return createHeatPump();
		case EnCompPackage.BOILER:
			return createBoiler();
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR:
			return createSolarThermalCollector();
		case EnCompPackage.ELECTROLYZER:
			return createElectrolyzer();
		case EnCompPackage.HYDROGEN_COMPRESSOR:
			return createHydrogenCompressor();
		case EnCompPackage.HYDROGEN_STORAGE:
			return createHydrogenStorage();
		case EnCompPackage.FUEL_CELL:
			return createFuelCell();
		case EnCompPackage.FOSSIL_FUEL:
			return createFossilFuel();
		case EnCompPackage.HYDROGEN:
			return createHydrogen();
		case EnCompPackage.BIO_FUEL:
			return createBioFuel();
		case EnCompPackage.WIND_TURBINE:
			return createWindTurbine();
		case EnCompPackage.PHOTOVOLTAIC_MODULE:
			return createPhotovoltaicModule();
		case EnCompPackage.INVERTER:
			return createInverter();
		case EnCompPackage.HEAT_EXCHANGER:
			return createHeatExchanger();
		case EnCompPackage.GEOTHERMAL_HEAT_EXCHANGER:
			return createGeothermalHeatExchanger();
		case EnCompPackage.MEDIUM:
			return createMedium();
		case EnCompPackage.LINEAR_FUNCTION:
			return createLinearFunction();
		case EnCompPackage.DATA_POINT:
			return createDataPoint();
		case EnCompPackage.TABLE_FUNCTION:
			return createTableFunction();
		case EnCompPackage.EXPONENTIAL_FUNCTION:
			return createExponentialFunction();
		case EnCompPackage.TABLE_CHARACTERISTIC:
			return createTableCharacteristic();
		case EnCompPackage.LINEAR_CHARACTERISTIC:
			return createLinearCharacteristic();
		case EnCompPackage.EXPONENTIONAL_CHARACTERISTIC:
			return createExponentionalCharacteristic();
		case EnCompPackage.MANUFACTURER:
			return createManufacturer();
		case EnCompPackage.POLYNOMIAL_CHARACTERISTIC:
			return createPolynomialCharacteristic();
		case EnCompPackage.POLYNOMIAL_FUNCTION:
			return createPolynomialFunction();
		case EnCompPackage.MATERIAL:
			return createMaterial();
		case EnCompPackage.ENERGY_COMPONENTS_COST_CATALOG:
			return createEnergyComponentsCostCatalog();
		case EnCompPackage.COST:
			return createCost();
		case EnCompPackage.POWER_CHARACTERISTIC:
			return createPowerCharacteristic();
		case EnCompPackage.POWER_FUNCTION:
			return createPowerFunction();
		default:
			throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
		case EnCompPackage.HEAT_SOURCES:
			return createHeatSourcesFromString(eDataType, initialValue);
		case EnCompPackage.COLLECTOR_TYPES:
			return createCollectorTypesFromString(eDataType, initialValue);
		case EnCompPackage.ELECTRICAL_STORAGE_TYPES:
			return createElectricalStorageTypesFromString(eDataType, initialValue);
		case EnCompPackage.BOILER_TYPES:
			return createBoilerTypesFromString(eDataType, initialValue);
		case EnCompPackage.THERMAL_STORAGE_TYPES:
			return createThermalStorageTypesFromString(eDataType, initialValue);
		case EnCompPackage.CELL_TYPES_ELECTROLYZER:
			return createcellTypesElectrolyzerFromString(eDataType, initialValue);
		case EnCompPackage.FUEL_TYPES:
			return createFuelTypesFromString(eDataType, initialValue);
		case EnCompPackage.TYPE_OF_HEAT_SOURCE:
			return createTypeOfHeatSourceFromString(eDataType, initialValue);
		case EnCompPackage.QUANTITY_DOUBLE:
			return createQuantityDoubleFromString(eDataType, initialValue);
		case EnCompPackage.QUANTITY_LONG:
			return createQuantityLongFromString(eDataType, initialValue);
		default:
			throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
		case EnCompPackage.HEAT_SOURCES:
			return convertHeatSourcesToString(eDataType, instanceValue);
		case EnCompPackage.COLLECTOR_TYPES:
			return convertCollectorTypesToString(eDataType, instanceValue);
		case EnCompPackage.ELECTRICAL_STORAGE_TYPES:
			return convertElectricalStorageTypesToString(eDataType, instanceValue);
		case EnCompPackage.BOILER_TYPES:
			return convertBoilerTypesToString(eDataType, instanceValue);
		case EnCompPackage.THERMAL_STORAGE_TYPES:
			return convertThermalStorageTypesToString(eDataType, instanceValue);
		case EnCompPackage.CELL_TYPES_ELECTROLYZER:
			return convertcellTypesElectrolyzerToString(eDataType, instanceValue);
		case EnCompPackage.FUEL_TYPES:
			return convertFuelTypesToString(eDataType, instanceValue);
		case EnCompPackage.TYPE_OF_HEAT_SOURCE:
			return convertTypeOfHeatSourceToString(eDataType, instanceValue);
		case EnCompPackage.QUANTITY_DOUBLE:
			return convertQuantityDoubleToString(eDataType, instanceValue);
		case EnCompPackage.QUANTITY_LONG:
			return convertQuantityLongToString(eDataType, instanceValue);
		default:
			throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EnergyComponentsCatalog createEnergyComponentsCatalog() {
		EnergyComponentsCatalogImpl energyComponentsCatalog = new EnergyComponentsCatalogImpl();
		return energyComponentsCatalog;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ThermalStorage createThermalStorage() {
		ThermalStorageImpl thermalStorage = new ThermalStorageImpl();
		return thermalStorage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ElectricalStorage createElectricalStorage() {
		ElectricalStorageImpl electricalStorage = new ElectricalStorageImpl();
		return electricalStorage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public CombinedHeatPower createCombinedHeatPower() {
		CombinedHeatPowerImpl combinedHeatPower = new CombinedHeatPowerImpl();
		return combinedHeatPower;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public HeatPump createHeatPump() {
		HeatPumpImpl heatPump = new HeatPumpImpl();
		return heatPump;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Boiler createBoiler() {
		BoilerImpl boiler = new BoilerImpl();
		return boiler;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public SolarThermalCollector createSolarThermalCollector() {
		SolarThermalCollectorImpl solarThermalCollector = new SolarThermalCollectorImpl();
		return solarThermalCollector;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Electrolyzer createElectrolyzer() {
		ElectrolyzerImpl electrolyzer = new ElectrolyzerImpl();
		return electrolyzer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public HydrogenCompressor createHydrogenCompressor() {
		HydrogenCompressorImpl hydrogenCompressor = new HydrogenCompressorImpl();
		return hydrogenCompressor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public HydrogenStorage createHydrogenStorage() {
		HydrogenStorageImpl hydrogenStorage = new HydrogenStorageImpl();
		return hydrogenStorage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public FuelCell createFuelCell() {
		FuelCellImpl fuelCell = new FuelCellImpl();
		return fuelCell;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public FossilFuel createFossilFuel() {
		FossilFuelImpl fossilFuel = new FossilFuelImpl();
		return fossilFuel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Hydrogen createHydrogen() {
		HydrogenImpl hydrogen = new HydrogenImpl();
		return hydrogen;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public BioFuel createBioFuel() {
		BioFuelImpl bioFuel = new BioFuelImpl();
		return bioFuel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public WindTurbine createWindTurbine() {
		WindTurbineImpl windTurbine = new WindTurbineImpl();
		return windTurbine;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public PhotovoltaicModule createPhotovoltaicModule() {
		PhotovoltaicModuleImpl photovoltaicModule = new PhotovoltaicModuleImpl();
		return photovoltaicModule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Inverter createInverter() {
		InverterImpl inverter = new InverterImpl();
		return inverter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public HeatExchanger createHeatExchanger() {
		HeatExchangerImpl heatExchanger = new HeatExchangerImpl();
		return heatExchanger;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public GeothermalHeatExchanger createGeothermalHeatExchanger() {
		GeothermalHeatExchangerImpl geothermalHeatExchanger = new GeothermalHeatExchangerImpl();
		return geothermalHeatExchanger;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Medium createMedium() {
		MediumImpl medium = new MediumImpl();
		return medium;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public LinearFunction createLinearFunction() {
		LinearFunctionImpl linearFunction = new LinearFunctionImpl();
		return linearFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public DataPoint createDataPoint() {
		DataPointImpl dataPoint = new DataPointImpl();
		return dataPoint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TableFunction createTableFunction() {
		TableFunctionImpl tableFunction = new TableFunctionImpl();
		return tableFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ExponentialFunction createExponentialFunction() {
		ExponentialFunctionImpl exponentialFunction = new ExponentialFunctionImpl();
		return exponentialFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TableCharacteristic createTableCharacteristic() {
		TableCharacteristicImpl tableCharacteristic = new TableCharacteristicImpl();
		return tableCharacteristic;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public LinearCharacteristic createLinearCharacteristic() {
		LinearCharacteristicImpl linearCharacteristic = new LinearCharacteristicImpl();
		return linearCharacteristic;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ExponentionalCharacteristic createExponentionalCharacteristic() {
		ExponentionalCharacteristicImpl exponentionalCharacteristic = new ExponentionalCharacteristicImpl();
		return exponentionalCharacteristic;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Manufacturer createManufacturer() {
		ManufacturerImpl manufacturer = new ManufacturerImpl();
		return manufacturer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public PolynomialCharacteristic createPolynomialCharacteristic() {
		PolynomialCharacteristicImpl polynomialCharacteristic = new PolynomialCharacteristicImpl();
		return polynomialCharacteristic;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public PolynomialFunction createPolynomialFunction() {
		PolynomialFunctionImpl polynomialFunction = new PolynomialFunctionImpl();
		return polynomialFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Material createMaterial() {
		MaterialImpl material = new MaterialImpl();
		return material;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EnergyComponentsCostCatalog createEnergyComponentsCostCatalog() {
		EnergyComponentsCostCatalogImpl energyComponentsCostCatalog = new EnergyComponentsCostCatalogImpl();
		return energyComponentsCostCatalog;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Cost createCost() {
		CostImpl cost = new CostImpl();
		return cost;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public PowerCharacteristic createPowerCharacteristic() {
		PowerCharacteristicImpl powerCharacteristic = new PowerCharacteristicImpl();
		return powerCharacteristic;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public PowerFunction createPowerFunction() {
		PowerFunctionImpl powerFunction = new PowerFunctionImpl();
		return powerFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HeatSources createHeatSourcesFromString(EDataType eDataType, String initialValue) {
		HeatSources result = HeatSources.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException(
					"The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertHeatSourcesToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CollectorTypes createCollectorTypesFromString(EDataType eDataType, String initialValue) {
		CollectorTypes result = CollectorTypes.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException(
					"The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertCollectorTypesToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ElectricalStorageTypes createElectricalStorageTypesFromString(EDataType eDataType, String initialValue) {
		ElectricalStorageTypes result = ElectricalStorageTypes.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException(
					"The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertElectricalStorageTypesToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BoilerTypes createBoilerTypesFromString(EDataType eDataType, String initialValue) {
		BoilerTypes result = BoilerTypes.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException(
					"The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertBoilerTypesToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ThermalStorageTypes createThermalStorageTypesFromString(EDataType eDataType, String initialValue) {
		ThermalStorageTypes result = ThermalStorageTypes.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException(
					"The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertThermalStorageTypesToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FuelTypes createFuelTypesFromString(EDataType eDataType, String initialValue) {
		FuelTypes result = FuelTypes.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException(
					"The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertFuelTypesToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TypeOfHeatSource createTypeOfHeatSourceFromString(EDataType eDataType, String initialValue) {
		TypeOfHeatSource result = TypeOfHeatSource.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException(
					"The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertTypeOfHeatSourceToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public cellTypesElectrolyzer createcellTypesElectrolyzerFromString(EDataType eDataType, String initialValue) {
		cellTypesElectrolyzer result = cellTypesElectrolyzer.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException(
					"The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertcellTypesElectrolyzerToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NullableQuantity createQuantityDouble(final String it) {
		return de.hftstuttgart.units.NullableQuantity.create(it);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NullableQuantity createQuantityDoubleFromString(EDataType eDataType, String initialValue) {
		return createQuantityDouble(initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertQuantityDouble(final NullableQuantity it) {
		return it == null ? null : it.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertQuantityDoubleToString(EDataType eDataType, Object instanceValue) {
		return convertQuantityDouble((NullableQuantity) instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NullableQuantity createQuantityLong(final String it) {
		return de.hftstuttgart.units.NullableQuantity.create(it);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NullableQuantity createQuantityLongFromString(EDataType eDataType, String initialValue) {
		return createQuantityLong(initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertQuantityLong(final NullableQuantity it) {
		return it == null ? null : it.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertQuantityLongToString(EDataType eDataType, Object instanceValue) {
		return convertQuantityLong((NullableQuantity) instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EnCompPackage getEnCompPackage() {
		return (EnCompPackage) getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static EnCompPackage getPackage() {
		return EnCompPackage.eINSTANCE;
	}

} //EnCompFactoryImpl
