/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.BioFuel;
import de.hftstuttgart.energycomponents.Boiler;
import de.hftstuttgart.energycomponents.BoilerTypes;
import de.hftstuttgart.energycomponents.Characteristic;
import de.hftstuttgart.energycomponents.CollectorTypes;
import de.hftstuttgart.energycomponents.CombinedHeatPower;
import de.hftstuttgart.energycomponents.Cost;
import de.hftstuttgart.energycomponents.DataPoint;
import de.hftstuttgart.energycomponents.ElectricalStorage;
import de.hftstuttgart.energycomponents.ElectricalStorageTypes;
import de.hftstuttgart.energycomponents.Electricity;
import de.hftstuttgart.energycomponents.Electrolyzer;
import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.EnergyCarrier;
import de.hftstuttgart.energycomponents.EnergyComponent;
import de.hftstuttgart.energycomponents.EnergyComponentsCatalog;
import de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog;
import de.hftstuttgart.energycomponents.ExponentialFunction;
import de.hftstuttgart.energycomponents.ExponentionalCharacteristic;
import de.hftstuttgart.energycomponents.FossilFuel;
import de.hftstuttgart.energycomponents.Fuel;
import de.hftstuttgart.energycomponents.FuelCell;
import de.hftstuttgart.energycomponents.FuelTypes;
import de.hftstuttgart.energycomponents.GeothermalHeatExchanger;
import de.hftstuttgart.energycomponents.HeatExchanger;
import de.hftstuttgart.energycomponents.HeatPump;
import de.hftstuttgart.energycomponents.HeatSources;
import de.hftstuttgart.energycomponents.Hydrogen;
import de.hftstuttgart.energycomponents.HydrogenCompressor;
import de.hftstuttgart.energycomponents.HydrogenStorage;
import de.hftstuttgart.energycomponents.Inverter;
import de.hftstuttgart.energycomponents.LinearCharacteristic;
import de.hftstuttgart.energycomponents.LinearFunction;
import de.hftstuttgart.energycomponents.Manufacturer;
import de.hftstuttgart.energycomponents.Material;
import de.hftstuttgart.energycomponents.Medium;
import de.hftstuttgart.energycomponents.PhotovoltaicModule;
import de.hftstuttgart.energycomponents.PolynomialCharacteristic;
import de.hftstuttgart.energycomponents.PolynomialFunction;
import de.hftstuttgart.energycomponents.PowerCharacteristic;
import de.hftstuttgart.energycomponents.PowerFunction;
import de.hftstuttgart.energycomponents.SolarThermalCollector;
import de.hftstuttgart.energycomponents.TableCharacteristic;
import de.hftstuttgart.energycomponents.TableFunction;
import de.hftstuttgart.energycomponents.ThermalEnergyDevice;
import de.hftstuttgart.energycomponents.ThermalStorage;
import de.hftstuttgart.energycomponents.ThermalStorageTypes;
import de.hftstuttgart.energycomponents.TypeOfHeatSource;
import de.hftstuttgart.energycomponents.WindTurbine;
import de.hftstuttgart.energycomponents.cellTypesElectrolyzer;
import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.eclipse.emf.ecore.xml.type.XMLTypePackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class EnCompPackageImpl extends EPackageImpl implements EnCompPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass energyComponentEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass energyComponentsCatalogEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass thermalStorageEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass electricalStorageEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass combinedHeatPowerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass heatPumpEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass boilerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass solarThermalCollectorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass electrolyzerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass thermalEnergyDeviceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass hydrogenCompressorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass hydrogenStorageEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass fuelCellEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass energyCarrierEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass fossilFuelEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass hydrogenEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass electricityEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bioFuelEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass fuelEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass windTurbineEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass photovoltaicModuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass inverterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass heatExchangerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass geothermalHeatExchangerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mediumEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass linearFunctionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataPointEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tableFunctionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass exponentialFunctionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass characteristicEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tableCharacteristicEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass linearCharacteristicEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass exponentionalCharacteristicEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass manufacturerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass polynomialCharacteristicEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass polynomialFunctionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass materialEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass energyComponentsCostCatalogEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass costEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass powerCharacteristicEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass powerFunctionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum heatSourcesEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum collectorTypesEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum electricalStorageTypesEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum boilerTypesEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum thermalStorageTypesEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum fuelTypesEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum typeOfHeatSourceEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum cellTypesElectrolyzerEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType quantityDoubleEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType quantityLongEDataType = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see de.hftstuttgart.energycomponents.EnCompPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private EnCompPackageImpl() {
		super(eNS_URI, EnCompFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 *
	 * <p>This method is used to initialize {@link EnCompPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static EnCompPackage init() {
		if (isInited)
			return (EnCompPackage) EPackage.Registry.INSTANCE.getEPackage(EnCompPackage.eNS_URI);

		// Obtain or create and register package
		Object registeredEnCompPackage = EPackage.Registry.INSTANCE.get(eNS_URI);
		EnCompPackageImpl theEnCompPackage = registeredEnCompPackage instanceof EnCompPackageImpl
				? (EnCompPackageImpl) registeredEnCompPackage
				: new EnCompPackageImpl();

		isInited = true;

		// Initialize simple dependencies
		XMLTypePackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theEnCompPackage.createPackageContents();

		// Initialize created meta-data
		theEnCompPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theEnCompPackage.freeze();

		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(EnCompPackage.eNS_URI, theEnCompPackage);
		return theEnCompPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getEnergyComponent() {
		return energyComponentEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getEnergyComponent_Description() {
		return (EAttribute) energyComponentEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getEnergyComponent_ModelName() {
		return (EAttribute) energyComponentEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getEnergyComponent_RevisionYear() {
		return (EAttribute) energyComponentEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getEnergyComponent_TechnicalLifetime() {
		return (EAttribute) energyComponentEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponent_Manufacturer() {
		return (EReference) energyComponentEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getEnergyComponentsCatalog() {
		return energyComponentsCatalogEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getEnergyComponentsCatalog_Author() {
		return (EAttribute) energyComponentsCatalogEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_BioFuels() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_Media() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_CombinedHeatPowerUtilities() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_Boilers() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_PhotovoltaicModules() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_SolarThermalCollectors() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_WindTurbines() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_GeothermalHeatExchangers() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_HeatPumps() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_Inverters() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_HeatExchangers() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_Electrolyzers() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_HydrogenCompressors() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(13);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_FuelCells() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(14);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_ThermalStorages() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(15);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_PowerStorages() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(16);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_HydrogenStorages() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(17);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_FossilFuels() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(18);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_Manufacturers() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(19);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_Materials() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(20);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_Energycomponentscostcatalog() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(21);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCatalog_Energycarriers() {
		return (EReference) energyComponentsCatalogEClass.getEStructuralFeatures().get(22);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getThermalStorage() {
		return thermalStorageEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getThermalStorage_Volume() {
		return (EAttribute) thermalStorageEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getThermalStorage_ThermalStorageType() {
		return (EAttribute) thermalStorageEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getThermalStorage_MaxTemp() {
		return (EAttribute) thermalStorageEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getThermalStorage_TankThickness() {
		return (EAttribute) thermalStorageEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getThermalStorage_InsulationThickness() {
		return (EAttribute) thermalStorageEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getThermalStorage_UsesMedium() {
		return (EReference) thermalStorageEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getThermalStorage_InsulationMaterial() {
		return (EReference) thermalStorageEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getThermalStorage_Height() {
		return (EAttribute) thermalStorageEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getThermalStorage_TankMaterial() {
		return (EReference) thermalStorageEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getElectricalStorage() {
		return electricalStorageEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectricalStorage_ElectricalStorageType() {
		return (EAttribute) electricalStorageEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectricalStorage_BatteryCapacity() {
		return (EAttribute) electricalStorageEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectricalStorage_BatteryVoltage() {
		return (EAttribute) electricalStorageEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectricalStorage_BatteryLifeCycle() {
		return (EAttribute) electricalStorageEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectricalStorage_SelfDischarge() {
		return (EAttribute) electricalStorageEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectricalStorage_InverterIncluded() {
		return (EAttribute) electricalStorageEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectricalStorage_BatteryEffiency() {
		return (EAttribute) electricalStorageEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectricalStorage_EnergyContent() {
		return (EAttribute) electricalStorageEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getCombinedHeatPower() {
		return combinedHeatPowerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getCombinedHeatPower_ThermalEfficiency() {
		return (EAttribute) combinedHeatPowerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getCombinedHeatPower_ElectricalEfficiency() {
		return (EAttribute) combinedHeatPowerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getCombinedHeatPower_InstalledElectricalPower() {
		return (EAttribute) combinedHeatPowerEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getCombinedHeatPower_ElectricalEfficiencyPartLoad() {
		return (EReference) combinedHeatPowerEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getCombinedHeatPower_ThermalEfficiencyPartLoad() {
		return (EReference) combinedHeatPowerEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getHeatPump() {
		return heatPumpEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getHeatPump_HeatSource() {
		return (EAttribute) heatPumpEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getHeatPump_PowerInput() {
		return (EReference) heatPumpEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getHeatPump_HeatOutput() {
		return (EReference) heatPumpEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getHeatPump_CoefficientOfPerformance() {
		return (EReference) heatPumpEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getBoiler() {
		return boilerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getBoiler_NominalEfficiency() {
		return (EAttribute) boilerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getBoiler_BoilerType() {
		return (EAttribute) boilerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getSolarThermalCollector() {
		return solarThermalCollectorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getSolarThermalCollector_CollectorType() {
		return (EAttribute) solarThermalCollectorEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getSolarThermalCollector_ApertureArea() {
		return (EAttribute) solarThermalCollectorEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getSolarThermalCollector_OpticalEfficiency() {
		return (EAttribute) solarThermalCollectorEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getSolarThermalCollector_LinearHeatLossCoefficient() {
		return (EAttribute) solarThermalCollectorEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getSolarThermalCollector_QuadraticalHeatLossCoefficient() {
		return (EAttribute) solarThermalCollectorEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getElectrolyzer() {
		return electrolyzerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectrolyzer_CellType() {
		return (EAttribute) electrolyzerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectrolyzer_CellArea() {
		return (EAttribute) electrolyzerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectrolyzer_NumberOfCells() {
		return (EAttribute) electrolyzerEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectrolyzer_MaxOperatingCurrentDensity() {
		return (EAttribute) electrolyzerEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectrolyzer_MinOperatingCurrentDensity() {
		return (EAttribute) electrolyzerEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectrolyzer_OverloadCapacity() {
		return (EAttribute) electrolyzerEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectrolyzer_NominalCellVoltage() {
		return (EAttribute) electrolyzerEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getThermalEnergyDevice() {
		return thermalEnergyDeviceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getThermalEnergyDevice_InstalledThermalPower() {
		return (EAttribute) thermalEnergyDeviceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getThermalEnergyDevice_ModulationRange() {
		return (EAttribute) thermalEnergyDeviceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getThermalEnergyDevice_Fuel() {
		return (EAttribute) thermalEnergyDeviceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getHydrogenCompressor() {
		return hydrogenCompressorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getHydrogenCompressor_Efficiency() {
		return (EAttribute) hydrogenCompressorEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getHydrogenCompressor_ThermodynamicMode() {
		return (EAttribute) hydrogenCompressorEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getHydrogenCompressor_MaxPressure() {
		return (EAttribute) hydrogenCompressorEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getHydrogenCompressor_MaxDeliveryRate() {
		return (EAttribute) hydrogenCompressorEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getHydrogenStorage() {
		return hydrogenStorageEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getHydrogenStorage_NumberOfCylinders() {
		return (EAttribute) hydrogenStorageEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getHydrogenStorage_CylinderVolume() {
		return (EAttribute) hydrogenStorageEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getHydrogenStorage_NominalPressure() {
		return (EAttribute) hydrogenStorageEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getFuelCell() {
		return fuelCellEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getEnergyCarrier() {
		return energyCarrierEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getEnergyCarrier_Co2EmissionsFactor() {
		return (EAttribute) energyCarrierEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getEnergyCarrier_PrimaryEnergyFactor() {
		return (EAttribute) energyCarrierEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getEnergyCarrier_Name() {
		return (EAttribute) energyCarrierEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getEnergyCarrier_Cost() {
		return (EAttribute) energyCarrierEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getFossilFuel() {
		return fossilFuelEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getFossilFuel_MethaneContent() {
		return (EAttribute) fossilFuelEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getHydrogen() {
		return hydrogenEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getHydrogen_ChemicalPurity() {
		return (EAttribute) hydrogenEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getHydrogen_HydrogenForHydrogenStorage() {
		return (EReference) hydrogenEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getElectricity() {
		return electricityEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getElectricity_RenewableShare() {
		return (EAttribute) electricityEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getBioFuel() {
		return bioFuelEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getBioFuel_WaterContent() {
		return (EAttribute) bioFuelEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getBioFuel_AshContent() {
		return (EAttribute) bioFuelEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getFuel() {
		return fuelEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getFuel_NetCalorificValue() {
		return (EAttribute) fuelEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getFuel_GrossCalorificValue() {
		return (EAttribute) fuelEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getFuel_Density() {
		return (EAttribute) fuelEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getFuel_FuelType() {
		return (EAttribute) fuelEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getWindTurbine() {
		return windTurbineEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getPhotovoltaicModule() {
		return photovoltaicModuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getPhotovoltaicModule_CellType() {
		return (EAttribute) photovoltaicModuleEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getPhotovoltaicModule_NominalPower() {
		return (EAttribute) photovoltaicModuleEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getPhotovoltaicModule_MppVoltage() {
		return (EAttribute) photovoltaicModuleEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getPhotovoltaicModule_MppCurrent() {
		return (EAttribute) photovoltaicModuleEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getPhotovoltaicModule_NominalEfficiency() {
		return (EAttribute) photovoltaicModuleEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getPhotovoltaicModule_ModuleArea() {
		return (EAttribute) photovoltaicModuleEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getInverter() {
		return inverterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getHeatExchanger() {
		return heatExchangerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getHeatExchanger_HeatRecoveryEfficiency() {
		return (EAttribute) heatExchangerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getHeatExchanger_NominalElectricityConsumption() {
		return (EAttribute) heatExchangerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getGeothermalHeatExchanger() {
		return geothermalHeatExchangerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getGeothermalHeatExchanger_PipeDiameter() {
		return (EAttribute) geothermalHeatExchangerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getMedium() {
		return mediumEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getMedium_Density() {
		return (EAttribute) mediumEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getMedium_HeatCapacity() {
		return (EAttribute) mediumEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getMedium_EvaporationTemperature() {
		return (EAttribute) mediumEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getMedium_MeltingTemperature() {
		return (EAttribute) mediumEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getMedium_Name() {
		return (EAttribute) mediumEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getLinearFunction() {
		return linearFunctionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getLinearFunction_Key() {
		return (EAttribute) linearFunctionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getLinearFunction_ParameterM() {
		return (EAttribute) linearFunctionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getLinearFunction_ParameterC() {
		return (EAttribute) linearFunctionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getLinearFunction__Linearfunction__double() {
		return linearFunctionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getDataPoint() {
		return dataPointEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getDataPoint_X() {
		return (EAttribute) dataPointEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getDataPoint_Y() {
		return (EAttribute) dataPointEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getTableFunction() {
		return tableFunctionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getTableFunction_Key() {
		return (EAttribute) tableFunctionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getTableFunction_Datapoints() {
		return (EReference) tableFunctionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getExponentialFunction() {
		return exponentialFunctionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getExponentialFunction_Key() {
		return (EAttribute) exponentialFunctionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getExponentialFunction_ParameterA() {
		return (EAttribute) exponentialFunctionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getExponentialFunction_ParameterB() {
		return (EAttribute) exponentialFunctionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getExponentialFunction__Exponentialfunction__double() {
		return exponentialFunctionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getCharacteristic() {
		return characteristicEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getTableCharacteristic() {
		return tableCharacteristicEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getTableCharacteristic_Functions() {
		return (EReference) tableCharacteristicEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getLinearCharacteristic() {
		return linearCharacteristicEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getLinearCharacteristic_Functions() {
		return (EReference) linearCharacteristicEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getExponentionalCharacteristic() {
		return exponentionalCharacteristicEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getExponentionalCharacteristic_Functions() {
		return (EReference) exponentionalCharacteristicEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getManufacturer() {
		return manufacturerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getManufacturer_ManufacturerName() {
		return (EAttribute) manufacturerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getManufacturer_Country() {
		return (EAttribute) manufacturerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getManufacturer_OutOfBusinessSince() {
		return (EAttribute) manufacturerEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getPolynomialCharacteristic() {
		return polynomialCharacteristicEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getPolynomialCharacteristic_Functions() {
		return (EReference) polynomialCharacteristicEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getPolynomialFunction() {
		return polynomialFunctionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getPolynomialFunction_Key() {
		return (EAttribute) polynomialFunctionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getPolynomialFunction_ParameterA() {
		return (EAttribute) polynomialFunctionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getPolynomialFunction_ParameterB() {
		return (EAttribute) polynomialFunctionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getPolynomialFunction_ParameterC() {
		return (EAttribute) polynomialFunctionEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getPolynomialFunction__Polynomialfunction__double() {
		return polynomialFunctionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getMaterial() {
		return materialEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getMaterial_ThermalConductivity() {
		return (EAttribute) materialEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getMaterial_Name() {
		return (EAttribute) materialEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getEnergyComponentsCostCatalog() {
		return energyComponentsCostCatalogEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getEnergyComponentsCostCatalog_Author() {
		return (EAttribute) energyComponentsCostCatalogEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getEnergyComponentsCostCatalog_RevisionYear() {
		return (EAttribute) energyComponentsCostCatalogEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEnergyComponentsCostCatalog_CostCategories() {
		return (EReference) energyComponentsCostCatalogEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getEnergyComponentsCostCatalog_PersonnelCost() {
		return (EAttribute) energyComponentsCostCatalogEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getCost() {
		return costEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getCost_Datasource() {
		return (EAttribute) costEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getCost_InvestmentCost() {
		return (EReference) costEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getCost_OtherInvestmentCost() {
		return (EAttribute) costEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getCost_PersonnelHours() {
		return (EAttribute) costEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getCost_PersonnelCostShare() {
		return (EAttribute) costEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getCost_AdministrationAndOtherCostShare() {
		return (EAttribute) costEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getCost_MaintenanceCostShare() {
		return (EAttribute) costEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getPowerCharacteristic() {
		return powerCharacteristicEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getPowerCharacteristic_Functions() {
		return (EReference) powerCharacteristicEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getPowerFunction() {
		return powerFunctionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getPowerFunction_Key() {
		return (EAttribute) powerFunctionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getPowerFunction_ParameterA() {
		return (EAttribute) powerFunctionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getPowerFunction_ParameterB() {
		return (EAttribute) powerFunctionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getPowerFunction__Powerfunction__double() {
		return powerFunctionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getCost_ComponentName() {
		return (EAttribute) costEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getCost_Description() {
		return (EAttribute) costEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getCost_HeatSource() {
		return (EAttribute) costEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getHeatSources() {
		return heatSourcesEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getCollectorTypes() {
		return collectorTypesEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getElectricalStorageTypes() {
		return electricalStorageTypesEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getBoilerTypes() {
		return boilerTypesEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getThermalStorageTypes() {
		return thermalStorageTypesEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getFuelTypes() {
		return fuelTypesEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getTypeOfHeatSource() {
		return typeOfHeatSourceEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getcellTypesElectrolyzer() {
		return cellTypesElectrolyzerEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EDataType getQuantityDouble() {
		return quantityDoubleEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EDataType getQuantityLong() {
		return quantityLongEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EnCompFactory getEnCompFactory() {
		return (EnCompFactory) getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated)
			return;
		isCreated = true;

		// Create classes and their features
		energyComponentEClass = createEClass(ENERGY_COMPONENT);
		createEAttribute(energyComponentEClass, ENERGY_COMPONENT__DESCRIPTION);
		createEAttribute(energyComponentEClass, ENERGY_COMPONENT__MODEL_NAME);
		createEAttribute(energyComponentEClass, ENERGY_COMPONENT__REVISION_YEAR);
		createEAttribute(energyComponentEClass, ENERGY_COMPONENT__TECHNICAL_LIFETIME);
		createEReference(energyComponentEClass, ENERGY_COMPONENT__MANUFACTURER);

		energyComponentsCatalogEClass = createEClass(ENERGY_COMPONENTS_CATALOG);
		createEAttribute(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__AUTHOR);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__BIO_FUELS);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__MEDIA);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__COMBINED_HEAT_POWER_UTILITIES);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__BOILERS);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__PHOTOVOLTAIC_MODULES);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__SOLAR_THERMAL_COLLECTORS);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__WIND_TURBINES);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__GEOTHERMAL_HEAT_EXCHANGERS);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__HEAT_PUMPS);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__INVERTERS);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__HEAT_EXCHANGERS);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__ELECTROLYZERS);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__HYDROGEN_COMPRESSORS);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__FUEL_CELLS);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__THERMAL_STORAGES);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__POWER_STORAGES);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__HYDROGEN_STORAGES);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__FOSSIL_FUELS);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__MANUFACTURERS);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__MATERIALS);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG);
		createEReference(energyComponentsCatalogEClass, ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS);

		thermalStorageEClass = createEClass(THERMAL_STORAGE);
		createEAttribute(thermalStorageEClass, THERMAL_STORAGE__VOLUME);
		createEAttribute(thermalStorageEClass, THERMAL_STORAGE__THERMAL_STORAGE_TYPE);
		createEAttribute(thermalStorageEClass, THERMAL_STORAGE__MAX_TEMP);
		createEAttribute(thermalStorageEClass, THERMAL_STORAGE__TANK_THICKNESS);
		createEAttribute(thermalStorageEClass, THERMAL_STORAGE__INSULATION_THICKNESS);
		createEReference(thermalStorageEClass, THERMAL_STORAGE__USES_MEDIUM);
		createEReference(thermalStorageEClass, THERMAL_STORAGE__INSULATION_MATERIAL);
		createEAttribute(thermalStorageEClass, THERMAL_STORAGE__HEIGHT);
		createEReference(thermalStorageEClass, THERMAL_STORAGE__TANK_MATERIAL);

		electricalStorageEClass = createEClass(ELECTRICAL_STORAGE);
		createEAttribute(electricalStorageEClass, ELECTRICAL_STORAGE__ELECTRICAL_STORAGE_TYPE);
		createEAttribute(electricalStorageEClass, ELECTRICAL_STORAGE__BATTERY_CAPACITY);
		createEAttribute(electricalStorageEClass, ELECTRICAL_STORAGE__BATTERY_VOLTAGE);
		createEAttribute(electricalStorageEClass, ELECTRICAL_STORAGE__BATTERY_LIFE_CYCLE);
		createEAttribute(electricalStorageEClass, ELECTRICAL_STORAGE__SELF_DISCHARGE);
		createEAttribute(electricalStorageEClass, ELECTRICAL_STORAGE__INVERTER_INCLUDED);
		createEAttribute(electricalStorageEClass, ELECTRICAL_STORAGE__BATTERY_EFFIENCY);
		createEAttribute(electricalStorageEClass, ELECTRICAL_STORAGE__ENERGY_CONTENT);

		combinedHeatPowerEClass = createEClass(COMBINED_HEAT_POWER);
		createEAttribute(combinedHeatPowerEClass, COMBINED_HEAT_POWER__THERMAL_EFFICIENCY);
		createEAttribute(combinedHeatPowerEClass, COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY);
		createEAttribute(combinedHeatPowerEClass, COMBINED_HEAT_POWER__INSTALLED_ELECTRICAL_POWER);
		createEReference(combinedHeatPowerEClass, COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD);
		createEReference(combinedHeatPowerEClass, COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD);

		heatPumpEClass = createEClass(HEAT_PUMP);
		createEAttribute(heatPumpEClass, HEAT_PUMP__HEAT_SOURCE);
		createEReference(heatPumpEClass, HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE);
		createEReference(heatPumpEClass, HEAT_PUMP__POWER_INPUT);
		createEReference(heatPumpEClass, HEAT_PUMP__HEAT_OUTPUT);

		boilerEClass = createEClass(BOILER);
		createEAttribute(boilerEClass, BOILER__NOMINAL_EFFICIENCY);
		createEAttribute(boilerEClass, BOILER__BOILER_TYPE);

		solarThermalCollectorEClass = createEClass(SOLAR_THERMAL_COLLECTOR);
		createEAttribute(solarThermalCollectorEClass, SOLAR_THERMAL_COLLECTOR__COLLECTOR_TYPE);
		createEAttribute(solarThermalCollectorEClass, SOLAR_THERMAL_COLLECTOR__APERTURE_AREA);
		createEAttribute(solarThermalCollectorEClass, SOLAR_THERMAL_COLLECTOR__OPTICAL_EFFICIENCY);
		createEAttribute(solarThermalCollectorEClass, SOLAR_THERMAL_COLLECTOR__LINEAR_HEAT_LOSS_COEFFICIENT);
		createEAttribute(solarThermalCollectorEClass, SOLAR_THERMAL_COLLECTOR__QUADRATICAL_HEAT_LOSS_COEFFICIENT);

		electrolyzerEClass = createEClass(ELECTROLYZER);
		createEAttribute(electrolyzerEClass, ELECTROLYZER__CELL_TYPE);
		createEAttribute(electrolyzerEClass, ELECTROLYZER__CELL_AREA);
		createEAttribute(electrolyzerEClass, ELECTROLYZER__NUMBER_OF_CELLS);
		createEAttribute(electrolyzerEClass, ELECTROLYZER__MAX_OPERATING_CURRENT_DENSITY);
		createEAttribute(electrolyzerEClass, ELECTROLYZER__MIN_OPERATING_CURRENT_DENSITY);
		createEAttribute(electrolyzerEClass, ELECTROLYZER__OVERLOAD_CAPACITY);
		createEAttribute(electrolyzerEClass, ELECTROLYZER__NOMINAL_CELL_VOLTAGE);

		thermalEnergyDeviceEClass = createEClass(THERMAL_ENERGY_DEVICE);
		createEAttribute(thermalEnergyDeviceEClass, THERMAL_ENERGY_DEVICE__INSTALLED_THERMAL_POWER);
		createEAttribute(thermalEnergyDeviceEClass, THERMAL_ENERGY_DEVICE__MODULATION_RANGE);
		createEAttribute(thermalEnergyDeviceEClass, THERMAL_ENERGY_DEVICE__FUEL);

		hydrogenCompressorEClass = createEClass(HYDROGEN_COMPRESSOR);
		createEAttribute(hydrogenCompressorEClass, HYDROGEN_COMPRESSOR__EFFICIENCY);
		createEAttribute(hydrogenCompressorEClass, HYDROGEN_COMPRESSOR__THERMODYNAMIC_MODE);
		createEAttribute(hydrogenCompressorEClass, HYDROGEN_COMPRESSOR__MAX_PRESSURE);
		createEAttribute(hydrogenCompressorEClass, HYDROGEN_COMPRESSOR__MAX_DELIVERY_RATE);

		hydrogenStorageEClass = createEClass(HYDROGEN_STORAGE);
		createEAttribute(hydrogenStorageEClass, HYDROGEN_STORAGE__NUMBER_OF_CYLINDERS);
		createEAttribute(hydrogenStorageEClass, HYDROGEN_STORAGE__CYLINDER_VOLUME);
		createEAttribute(hydrogenStorageEClass, HYDROGEN_STORAGE__NOMINAL_PRESSURE);

		fuelCellEClass = createEClass(FUEL_CELL);

		energyCarrierEClass = createEClass(ENERGY_CARRIER);
		createEAttribute(energyCarrierEClass, ENERGY_CARRIER__CO2_EMISSIONS_FACTOR);
		createEAttribute(energyCarrierEClass, ENERGY_CARRIER__PRIMARY_ENERGY_FACTOR);
		createEAttribute(energyCarrierEClass, ENERGY_CARRIER__NAME);
		createEAttribute(energyCarrierEClass, ENERGY_CARRIER__COST);

		fossilFuelEClass = createEClass(FOSSIL_FUEL);
		createEAttribute(fossilFuelEClass, FOSSIL_FUEL__METHANE_CONTENT);

		hydrogenEClass = createEClass(HYDROGEN);
		createEAttribute(hydrogenEClass, HYDROGEN__CHEMICAL_PURITY);
		createEReference(hydrogenEClass, HYDROGEN__HYDROGEN_FOR_HYDROGEN_STORAGE);

		electricityEClass = createEClass(ELECTRICITY);
		createEAttribute(electricityEClass, ELECTRICITY__RENEWABLE_SHARE);

		bioFuelEClass = createEClass(BIO_FUEL);
		createEAttribute(bioFuelEClass, BIO_FUEL__WATER_CONTENT);
		createEAttribute(bioFuelEClass, BIO_FUEL__ASH_CONTENT);

		fuelEClass = createEClass(FUEL);
		createEAttribute(fuelEClass, FUEL__NET_CALORIFIC_VALUE);
		createEAttribute(fuelEClass, FUEL__GROSS_CALORIFIC_VALUE);
		createEAttribute(fuelEClass, FUEL__DENSITY);
		createEAttribute(fuelEClass, FUEL__FUEL_TYPE);

		windTurbineEClass = createEClass(WIND_TURBINE);

		photovoltaicModuleEClass = createEClass(PHOTOVOLTAIC_MODULE);
		createEAttribute(photovoltaicModuleEClass, PHOTOVOLTAIC_MODULE__CELL_TYPE);
		createEAttribute(photovoltaicModuleEClass, PHOTOVOLTAIC_MODULE__NOMINAL_POWER);
		createEAttribute(photovoltaicModuleEClass, PHOTOVOLTAIC_MODULE__MPP_VOLTAGE);
		createEAttribute(photovoltaicModuleEClass, PHOTOVOLTAIC_MODULE__MPP_CURRENT);
		createEAttribute(photovoltaicModuleEClass, PHOTOVOLTAIC_MODULE__NOMINAL_EFFICIENCY);
		createEAttribute(photovoltaicModuleEClass, PHOTOVOLTAIC_MODULE__MODULE_AREA);

		inverterEClass = createEClass(INVERTER);

		heatExchangerEClass = createEClass(HEAT_EXCHANGER);
		createEAttribute(heatExchangerEClass, HEAT_EXCHANGER__HEAT_RECOVERY_EFFICIENCY);
		createEAttribute(heatExchangerEClass, HEAT_EXCHANGER__NOMINAL_ELECTRICITY_CONSUMPTION);

		geothermalHeatExchangerEClass = createEClass(GEOTHERMAL_HEAT_EXCHANGER);
		createEAttribute(geothermalHeatExchangerEClass, GEOTHERMAL_HEAT_EXCHANGER__PIPE_DIAMETER);

		mediumEClass = createEClass(MEDIUM);
		createEAttribute(mediumEClass, MEDIUM__DENSITY);
		createEAttribute(mediumEClass, MEDIUM__HEAT_CAPACITY);
		createEAttribute(mediumEClass, MEDIUM__EVAPORATION_TEMPERATURE);
		createEAttribute(mediumEClass, MEDIUM__MELTING_TEMPERATURE);
		createEAttribute(mediumEClass, MEDIUM__NAME);

		linearFunctionEClass = createEClass(LINEAR_FUNCTION);
		createEAttribute(linearFunctionEClass, LINEAR_FUNCTION__KEY);
		createEAttribute(linearFunctionEClass, LINEAR_FUNCTION__PARAMETER_M);
		createEAttribute(linearFunctionEClass, LINEAR_FUNCTION__PARAMETER_C);
		createEOperation(linearFunctionEClass, LINEAR_FUNCTION___LINEARFUNCTION__DOUBLE);

		dataPointEClass = createEClass(DATA_POINT);
		createEAttribute(dataPointEClass, DATA_POINT__X);
		createEAttribute(dataPointEClass, DATA_POINT__Y);

		tableFunctionEClass = createEClass(TABLE_FUNCTION);
		createEAttribute(tableFunctionEClass, TABLE_FUNCTION__KEY);
		createEReference(tableFunctionEClass, TABLE_FUNCTION__DATAPOINTS);

		exponentialFunctionEClass = createEClass(EXPONENTIAL_FUNCTION);
		createEAttribute(exponentialFunctionEClass, EXPONENTIAL_FUNCTION__KEY);
		createEAttribute(exponentialFunctionEClass, EXPONENTIAL_FUNCTION__PARAMETER_A);
		createEAttribute(exponentialFunctionEClass, EXPONENTIAL_FUNCTION__PARAMETER_B);
		createEOperation(exponentialFunctionEClass, EXPONENTIAL_FUNCTION___EXPONENTIALFUNCTION__DOUBLE);

		characteristicEClass = createEClass(CHARACTERISTIC);

		tableCharacteristicEClass = createEClass(TABLE_CHARACTERISTIC);
		createEReference(tableCharacteristicEClass, TABLE_CHARACTERISTIC__FUNCTIONS);

		linearCharacteristicEClass = createEClass(LINEAR_CHARACTERISTIC);
		createEReference(linearCharacteristicEClass, LINEAR_CHARACTERISTIC__FUNCTIONS);

		exponentionalCharacteristicEClass = createEClass(EXPONENTIONAL_CHARACTERISTIC);
		createEReference(exponentionalCharacteristicEClass, EXPONENTIONAL_CHARACTERISTIC__FUNCTIONS);

		manufacturerEClass = createEClass(MANUFACTURER);
		createEAttribute(manufacturerEClass, MANUFACTURER__MANUFACTURER_NAME);
		createEAttribute(manufacturerEClass, MANUFACTURER__COUNTRY);
		createEAttribute(manufacturerEClass, MANUFACTURER__OUT_OF_BUSINESS_SINCE);

		polynomialCharacteristicEClass = createEClass(POLYNOMIAL_CHARACTERISTIC);
		createEReference(polynomialCharacteristicEClass, POLYNOMIAL_CHARACTERISTIC__FUNCTIONS);

		polynomialFunctionEClass = createEClass(POLYNOMIAL_FUNCTION);
		createEAttribute(polynomialFunctionEClass, POLYNOMIAL_FUNCTION__KEY);
		createEAttribute(polynomialFunctionEClass, POLYNOMIAL_FUNCTION__PARAMETER_A);
		createEAttribute(polynomialFunctionEClass, POLYNOMIAL_FUNCTION__PARAMETER_B);
		createEAttribute(polynomialFunctionEClass, POLYNOMIAL_FUNCTION__PARAMETER_C);
		createEOperation(polynomialFunctionEClass, POLYNOMIAL_FUNCTION___POLYNOMIALFUNCTION__DOUBLE);

		materialEClass = createEClass(MATERIAL);
		createEAttribute(materialEClass, MATERIAL__THERMAL_CONDUCTIVITY);
		createEAttribute(materialEClass, MATERIAL__NAME);

		energyComponentsCostCatalogEClass = createEClass(ENERGY_COMPONENTS_COST_CATALOG);
		createEAttribute(energyComponentsCostCatalogEClass, ENERGY_COMPONENTS_COST_CATALOG__AUTHOR);
		createEAttribute(energyComponentsCostCatalogEClass, ENERGY_COMPONENTS_COST_CATALOG__REVISION_YEAR);
		createEReference(energyComponentsCostCatalogEClass, ENERGY_COMPONENTS_COST_CATALOG__COST_CATEGORIES);
		createEAttribute(energyComponentsCostCatalogEClass, ENERGY_COMPONENTS_COST_CATALOG__PERSONNEL_COST);

		costEClass = createEClass(COST);
		createEAttribute(costEClass, COST__COMPONENT_NAME);
		createEAttribute(costEClass, COST__DESCRIPTION);
		createEAttribute(costEClass, COST__HEAT_SOURCE);
		createEAttribute(costEClass, COST__DATASOURCE);
		createEReference(costEClass, COST__INVESTMENT_COST);
		createEAttribute(costEClass, COST__OTHER_INVESTMENT_COST);
		createEAttribute(costEClass, COST__PERSONNEL_HOURS);
		createEAttribute(costEClass, COST__PERSONNEL_COST_SHARE);
		createEAttribute(costEClass, COST__ADMINISTRATION_AND_OTHER_COST_SHARE);
		createEAttribute(costEClass, COST__MAINTENANCE_COST_SHARE);

		powerCharacteristicEClass = createEClass(POWER_CHARACTERISTIC);
		createEReference(powerCharacteristicEClass, POWER_CHARACTERISTIC__FUNCTIONS);

		powerFunctionEClass = createEClass(POWER_FUNCTION);
		createEAttribute(powerFunctionEClass, POWER_FUNCTION__KEY);
		createEAttribute(powerFunctionEClass, POWER_FUNCTION__PARAMETER_A);
		createEAttribute(powerFunctionEClass, POWER_FUNCTION__PARAMETER_B);
		createEOperation(powerFunctionEClass, POWER_FUNCTION___POWERFUNCTION__DOUBLE);

		// Create enums
		heatSourcesEEnum = createEEnum(HEAT_SOURCES);
		collectorTypesEEnum = createEEnum(COLLECTOR_TYPES);
		electricalStorageTypesEEnum = createEEnum(ELECTRICAL_STORAGE_TYPES);
		boilerTypesEEnum = createEEnum(BOILER_TYPES);
		thermalStorageTypesEEnum = createEEnum(THERMAL_STORAGE_TYPES);
		cellTypesElectrolyzerEEnum = createEEnum(CELL_TYPES_ELECTROLYZER);
		fuelTypesEEnum = createEEnum(FUEL_TYPES);
		typeOfHeatSourceEEnum = createEEnum(TYPE_OF_HEAT_SOURCE);

		// Create data types
		quantityDoubleEDataType = createEDataType(QUANTITY_DOUBLE);
		quantityLongEDataType = createEDataType(QUANTITY_LONG);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized)
			return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		XMLTypePackage theXMLTypePackage = (XMLTypePackage) EPackage.Registry.INSTANCE
				.getEPackage(XMLTypePackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		thermalStorageEClass.getESuperTypes().add(this.getEnergyComponent());
		electricalStorageEClass.getESuperTypes().add(this.getEnergyComponent());
		combinedHeatPowerEClass.getESuperTypes().add(this.getThermalEnergyDevice());
		heatPumpEClass.getESuperTypes().add(this.getThermalEnergyDevice());
		boilerEClass.getESuperTypes().add(this.getThermalEnergyDevice());
		solarThermalCollectorEClass.getESuperTypes().add(this.getEnergyComponent());
		electrolyzerEClass.getESuperTypes().add(this.getEnergyComponent());
		thermalEnergyDeviceEClass.getESuperTypes().add(this.getEnergyComponent());
		hydrogenCompressorEClass.getESuperTypes().add(this.getEnergyComponent());
		hydrogenStorageEClass.getESuperTypes().add(this.getEnergyComponent());
		fuelCellEClass.getESuperTypes().add(this.getEnergyComponent());
		fossilFuelEClass.getESuperTypes().add(this.getFuel());
		hydrogenEClass.getESuperTypes().add(this.getFuel());
		electricityEClass.getESuperTypes().add(this.getEnergyCarrier());
		bioFuelEClass.getESuperTypes().add(this.getFuel());
		fuelEClass.getESuperTypes().add(this.getEnergyCarrier());
		windTurbineEClass.getESuperTypes().add(this.getEnergyComponent());
		photovoltaicModuleEClass.getESuperTypes().add(this.getEnergyComponent());
		inverterEClass.getESuperTypes().add(this.getEnergyComponent());
		heatExchangerEClass.getESuperTypes().add(this.getEnergyComponent());
		geothermalHeatExchangerEClass.getESuperTypes().add(this.getEnergyComponent());
		tableCharacteristicEClass.getESuperTypes().add(this.getCharacteristic());
		linearCharacteristicEClass.getESuperTypes().add(this.getCharacteristic());
		exponentionalCharacteristicEClass.getESuperTypes().add(this.getCharacteristic());
		polynomialCharacteristicEClass.getESuperTypes().add(this.getCharacteristic());
		powerCharacteristicEClass.getESuperTypes().add(this.getCharacteristic());

		// Initialize classes, features, and operations; add parameters
		initEClass(energyComponentEClass, EnergyComponent.class, "EnergyComponent", IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getEnergyComponent_Description(), ecorePackage.getEString(), "description", null, 0, 1,
				EnergyComponent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getEnergyComponent_ModelName(), ecorePackage.getEString(), "modelName", "model xyz", 1, 1,
				EnergyComponent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getEnergyComponent_RevisionYear(), ecorePackage.getEInt(), "revisionYear", null, 0, 1,
				EnergyComponent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getEnergyComponent_TechnicalLifetime(), ecorePackage.getEDouble(), "technicalLifetime", "30", 0,
				1, EnergyComponent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponent_Manufacturer(), this.getManufacturer(), null, "manufacturer", null, 1, 1,
				EnergyComponent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(energyComponentsCatalogEClass, EnergyComponentsCatalog.class, "EnergyComponentsCatalog",
				!IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getEnergyComponentsCatalog_Author(), ecorePackage.getEString(), "author", "HFT_Stuttgart", 0, 1,
				EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_BioFuels(), this.getBioFuel(), null, "bioFuels", null, 0, -1,
				EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_Media(), this.getMedium(), null, "media", null, 0, -1,
				EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_CombinedHeatPowerUtilities(), this.getCombinedHeatPower(), null,
				"combinedHeatPowerUtilities", null, 0, -1, EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_Boilers(), this.getBoiler(), null, "boilers", null, 0, -1,
				EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_PhotovoltaicModules(), this.getPhotovoltaicModule(), null,
				"photovoltaicModules", null, 0, -1, EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_SolarThermalCollectors(), this.getSolarThermalCollector(), null,
				"solarThermalCollectors", null, 0, -1, EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_WindTurbines(), this.getWindTurbine(), null, "windTurbines", null, 0,
				-1, EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_GeothermalHeatExchangers(), this.getGeothermalHeatExchanger(), null,
				"geothermalHeatExchangers", null, 0, -1, EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_HeatPumps(), this.getHeatPump(), null, "heatPumps", null, 0, -1,
				EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_Inverters(), this.getInverter(), null, "inverters", null, 0, -1,
				EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_HeatExchangers(), this.getHeatExchanger(), null, "heatExchangers",
				null, 0, -1, EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_Electrolyzers(), this.getElectrolyzer(), null, "electrolyzers", null,
				0, -1, EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_HydrogenCompressors(), this.getHydrogenCompressor(), null,
				"hydrogenCompressors", null, 0, -1, EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_FuelCells(), this.getFuelCell(), null, "fuelCells", null, 0, -1,
				EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_ThermalStorages(), this.getThermalStorage(), null, "thermalStorages",
				null, 0, -1, EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_PowerStorages(), this.getElectricalStorage(), null, "powerStorages",
				null, 0, -1, EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_HydrogenStorages(), this.getHydrogenStorage(), null,
				"hydrogenStorages", null, 0, -1, EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_FossilFuels(), this.getFossilFuel(), null, "fossilFuels", null, 0, -1,
				EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_Manufacturers(), this.getManufacturer(), null, "manufacturers", null,
				0, -1, EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_Materials(), this.getMaterial(), null, "materials", null, 0, -1,
				EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_Energycomponentscostcatalog(), this.getEnergyComponentsCostCatalog(),
				null, "energycomponentscostcatalog", null, 0, 1, EnergyComponentsCatalog.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
				IS_ORDERED);
		initEReference(getEnergyComponentsCatalog_Energycarriers(), this.getEnergyCarrier(), null, "energycarriers",
				null, 0, -1, EnergyComponentsCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(thermalStorageEClass, ThermalStorage.class, "ThermalStorage", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getThermalStorage_Volume(), this.getQuantityDouble(), "volume", "5 m\u00b3", 0, 1,
				ThermalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getThermalStorage_ThermalStorageType(), this.getThermalStorageTypes(), "thermalStorageType",
				null, 0, 1, ThermalStorage.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				!IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getThermalStorage_MaxTemp(), this.getQuantityDouble(), "maxTemp", "80 \u00b0C", 0, 1,
				ThermalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getThermalStorage_TankThickness(), this.getQuantityDouble(), "tankThickness", "10 mm ", 0, 1,
				ThermalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getThermalStorage_InsulationThickness(), this.getQuantityDouble(), "insulationThickness",
				"100 mm", 0, 1, ThermalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE,
				!IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getThermalStorage_UsesMedium(), this.getMedium(), null, "usesMedium", null, 1, 1,
				ThermalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getThermalStorage_InsulationMaterial(), this.getMaterial(), null, "insulationMaterial", null, 0,
				1, ThermalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getThermalStorage_Height(), this.getQuantityDouble(), "height", "2 m", 0, 1,
				ThermalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEReference(getThermalStorage_TankMaterial(), this.getMaterial(), null, "tankMaterial", null, 0, 1,
				ThermalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(electricalStorageEClass, ElectricalStorage.class, "ElectricalStorage", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getElectricalStorage_ElectricalStorageType(), this.getElectricalStorageTypes(),
				"electricalStorageType", null, 1, 1, ElectricalStorage.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getElectricalStorage_BatteryCapacity(), this.getQuantityDouble(), "batteryCapacity", "A*h", 1, 1,
				ElectricalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getElectricalStorage_BatteryVoltage(), this.getQuantityDouble(), "batteryVoltage", "V", 0, 1,
				ElectricalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getElectricalStorage_BatteryLifeCycle(), ecorePackage.getEDouble(), "batteryLifeCycle", "7000",
				0, 1, ElectricalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getElectricalStorage_SelfDischarge(), ecorePackage.getEDouble(), "selfDischarge", "0.2", 0, 1,
				ElectricalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getElectricalStorage_InverterIncluded(), ecorePackage.getEBooleanObject(), "inverterIncluded",
				"false", 0, 1, ElectricalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE,
				!IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getElectricalStorage_BatteryEffiency(), ecorePackage.getEDouble(), "batteryEffiency", "0.8", 0,
				1, ElectricalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getElectricalStorage_EnergyContent(), this.getQuantityDouble(), "energyContent", "5 kW*h", 1, 1,
				ElectricalStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);

		initEClass(combinedHeatPowerEClass, CombinedHeatPower.class, "CombinedHeatPower", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCombinedHeatPower_ThermalEfficiency(), ecorePackage.getEDouble(), "thermalEfficiency", "0.4",
				1, 1, CombinedHeatPower.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCombinedHeatPower_ElectricalEfficiency(), ecorePackage.getEDouble(), "electricalEfficiency",
				"0.4", 1, 1, CombinedHeatPower.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE,
				!IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCombinedHeatPower_InstalledElectricalPower(), this.getQuantityDouble(),
				"installedElectricalPower", "kW", 1, 1, CombinedHeatPower.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCombinedHeatPower_ElectricalEfficiencyPartLoad(), this.getCharacteristic(), null,
				"electricalEfficiencyPartLoad", null, 0, 1, CombinedHeatPower.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCombinedHeatPower_ThermalEfficiencyPartLoad(), this.getCharacteristic(), null,
				"thermalEfficiencyPartLoad", null, 0, 1, CombinedHeatPower.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(heatPumpEClass, HeatPump.class, "HeatPump", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getHeatPump_HeatSource(), this.getHeatSources(), "heatSource", null, 1, 1, HeatPump.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHeatPump_CoefficientOfPerformance(), this.getCharacteristic(), null,
				"coefficientOfPerformance", null, 1, 1, HeatPump.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHeatPump_PowerInput(), this.getCharacteristic(), null, "powerInput", null, 0, 1,
				HeatPump.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHeatPump_HeatOutput(), this.getCharacteristic(), null, "heatOutput", null, 0, 1,
				HeatPump.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(boilerEClass, Boiler.class, "Boiler", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getBoiler_NominalEfficiency(), ecorePackage.getEDouble(), "nominalEfficiency", "0.98", 0, 1,
				Boiler.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getBoiler_BoilerType(), this.getBoilerTypes(), "boilerType", null, 0, 1, Boiler.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(solarThermalCollectorEClass, SolarThermalCollector.class, "SolarThermalCollector", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSolarThermalCollector_CollectorType(), this.getCollectorTypes(), "collectorType", null, 1, 1,
				SolarThermalCollector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSolarThermalCollector_ApertureArea(), this.getQuantityDouble(), "apertureArea", "m\u00b2", 1,
				1, SolarThermalCollector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSolarThermalCollector_OpticalEfficiency(), ecorePackage.getEDouble(), "opticalEfficiency",
				"0.77", 0, 1, SolarThermalCollector.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE,
				!IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSolarThermalCollector_LinearHeatLossCoefficient(), ecorePackage.getEDouble(),
				"linearHeatLossCoefficient", "3.2", 0, 1, SolarThermalCollector.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSolarThermalCollector_QuadraticalHeatLossCoefficient(), ecorePackage.getEDouble(),
				"quadraticalHeatLossCoefficient", "0.01", 0, 1, SolarThermalCollector.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(electrolyzerEClass, Electrolyzer.class, "Electrolyzer", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getElectrolyzer_CellType(), this.getcellTypesElectrolyzer(), "cellType", null, 0, 1,
				Electrolyzer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getElectrolyzer_CellArea(), this.getQuantityDouble(), "cellArea", "50 cm\u00b2", 1, 1,
				Electrolyzer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getElectrolyzer_NumberOfCells(), ecorePackage.getEDouble(), "numberOfCells", "5", 1, 1,
				Electrolyzer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getElectrolyzer_MaxOperatingCurrentDensity(), this.getQuantityDouble(),
				"maxOperatingCurrentDensity", "3 A/cm\u00b2", 0, 1, Electrolyzer.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getElectrolyzer_MinOperatingCurrentDensity(), this.getQuantityDouble(),
				"minOperatingCurrentDensity", "0.3 A/cm\u00b2", 0, 1, Electrolyzer.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getElectrolyzer_OverloadCapacity(), this.getQuantityDouble(), "overloadCapacity", "120 %", 0, 1,
				Electrolyzer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getElectrolyzer_NominalCellVoltage(), this.getQuantityDouble(), "nominalCellVoltage", "1.94 V",
				0, 1, Electrolyzer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);

		initEClass(thermalEnergyDeviceEClass, ThermalEnergyDevice.class, "ThermalEnergyDevice", IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getThermalEnergyDevice_InstalledThermalPower(), this.getQuantityDouble(),
				"installedThermalPower", "kW", 1, 1, ThermalEnergyDevice.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getThermalEnergyDevice_ModulationRange(), ecorePackage.getEDouble(), "modulationRange", "0.5", 0,
				1, ThermalEnergyDevice.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getThermalEnergyDevice_Fuel(), this.getFuelTypes(), "fuel", null, 1, 1,
				ThermalEnergyDevice.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(hydrogenCompressorEClass, HydrogenCompressor.class, "HydrogenCompressor", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getHydrogenCompressor_Efficiency(), ecorePackage.getEDouble(), "efficiency", "0.68", 0, 1,
				HydrogenCompressor.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getHydrogenCompressor_ThermodynamicMode(), ecorePackage.getEInt(), "thermodynamicMode", "0", 0,
				1, HydrogenCompressor.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHydrogenCompressor_MaxPressure(), this.getQuantityDouble(), "maxPressure", "50 MPa", 0, 1,
				HydrogenCompressor.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getHydrogenCompressor_MaxDeliveryRate(), this.getQuantityDouble(), "maxDeliveryRate", "9 kg/h",
				0, 1, HydrogenCompressor.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(hydrogenStorageEClass, HydrogenStorage.class, "HydrogenStorage", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getHydrogenStorage_NumberOfCylinders(), ecorePackage.getEInt(), "numberOfCylinders", "1", 1, 1,
				HydrogenStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getHydrogenStorage_CylinderVolume(), this.getQuantityDouble(), "cylinderVolume", "1.5 m\u00b3",
				1, 1, HydrogenStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHydrogenStorage_NominalPressure(), this.getQuantityDouble(), "nominalPressure", "25 MPa", 0,
				1, HydrogenStorage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);

		initEClass(fuelCellEClass, FuelCell.class, "FuelCell", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);

		initEClass(energyCarrierEClass, EnergyCarrier.class, "EnergyCarrier", IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getEnergyCarrier_Co2EmissionsFactor(), this.getQuantityDouble(), "co2EmissionsFactor", "t/MW*h",
				1, 1, EnergyCarrier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEnergyCarrier_PrimaryEnergyFactor(), ecorePackage.getEDouble(), "primaryEnergyFactor", null,
				1, 1, EnergyCarrier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEnergyCarrier_Name(), ecorePackage.getEString(), "name", null, 1, 1, EnergyCarrier.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEnergyCarrier_Cost(), ecorePackage.getEDouble(), "cost", null, 0, 1, EnergyCarrier.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(fossilFuelEClass, FossilFuel.class, "FossilFuel", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getFossilFuel_MethaneContent(), ecorePackage.getEDouble(), "methaneContent", null, 0, 1,
				FossilFuel.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);

		initEClass(hydrogenEClass, Hydrogen.class, "Hydrogen", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getHydrogen_ChemicalPurity(), ecorePackage.getEDouble(), "chemicalPurity", "0.99", 1, 1,
				Hydrogen.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEReference(getHydrogen_HydrogenForHydrogenStorage(), this.getHydrogenStorage(), null,
				"hydrogenForHydrogenStorage", null, 0, 1, Hydrogen.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				!IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(electricityEClass, Electricity.class, "Electricity", IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getElectricity_RenewableShare(), ecorePackage.getEDouble(), "renewableShare", null, 0, 1,
				Electricity.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);

		initEClass(bioFuelEClass, BioFuel.class, "BioFuel", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getBioFuel_WaterContent(), ecorePackage.getEDouble(), "waterContent", "0", 0, 1, BioFuel.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getBioFuel_AshContent(), ecorePackage.getEDouble(), "ashContent", "0", 0, 1, BioFuel.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(fuelEClass, Fuel.class, "Fuel", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getFuel_NetCalorificValue(), this.getQuantityDouble(), "netCalorificValue", "(kW*h)/m\u00b3", 1,
				1, Fuel.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getFuel_GrossCalorificValue(), this.getQuantityDouble(), "grossCalorificValue", "(kW*h)/m\u00b3",
				1, 1, Fuel.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getFuel_Density(), this.getQuantityDouble(), "density", "kg/m\u00b3", 1, 1, Fuel.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFuel_FuelType(), this.getFuelTypes(), "fuelType", null, 1, 1, Fuel.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(windTurbineEClass, WindTurbine.class, "WindTurbine", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);

		initEClass(photovoltaicModuleEClass, PhotovoltaicModule.class, "PhotovoltaicModule", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getPhotovoltaicModule_CellType(), ecorePackage.getEEnumerator(), "cellType", null, 1, 1,
				PhotovoltaicModule.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getPhotovoltaicModule_NominalPower(), this.getQuantityDouble(), "nominalPower", "W", 1, 1,
				PhotovoltaicModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getPhotovoltaicModule_MppVoltage(), this.getQuantityDouble(), "mppVoltage", "V", 1, 1,
				PhotovoltaicModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getPhotovoltaicModule_MppCurrent(), this.getQuantityDouble(), "mppCurrent", "A", 1, 1,
				PhotovoltaicModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getPhotovoltaicModule_NominalEfficiency(), ecorePackage.getEDouble(), "nominalEfficiency",
				"0.18", 1, 1, PhotovoltaicModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE,
				!IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPhotovoltaicModule_ModuleArea(), this.getQuantityDouble(), "moduleArea", "m\u00b2", 1, 1,
				PhotovoltaicModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);

		initEClass(inverterEClass, Inverter.class, "Inverter", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);

		initEClass(heatExchangerEClass, HeatExchanger.class, "HeatExchanger", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getHeatExchanger_HeatRecoveryEfficiency(), ecorePackage.getEDouble(), "heatRecoveryEfficiency",
				"0.8", 0, 1, HeatExchanger.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHeatExchanger_NominalElectricityConsumption(), this.getQuantityDouble(),
				"nominalElectricityConsumption", "W", 1, 1, HeatExchanger.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(geothermalHeatExchangerEClass, GeothermalHeatExchanger.class, "GeothermalHeatExchanger",
				!IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getGeothermalHeatExchanger_PipeDiameter(), this.getQuantityDouble(), "pipeDiameter", "1 cm", 0,
				1, GeothermalHeatExchanger.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mediumEClass, Medium.class, "Medium", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMedium_Density(), this.getQuantityDouble(), "density", "g/cm\u00b3", 1, 1, Medium.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMedium_HeatCapacity(), this.getQuantityDouble(), "heatCapacity", "kJ/(kg*K)", 0, 1,
				Medium.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getMedium_EvaporationTemperature(), this.getQuantityDouble(), "evaporationTemperature",
				"\u00b0C", 0, 1, Medium.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMedium_MeltingTemperature(), this.getQuantityDouble(), "meltingTemperature", "\u00b0C", 0, 1,
				Medium.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getMedium_Name(), ecorePackage.getEString(), "name", null, 1, 1, Medium.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(linearFunctionEClass, LinearFunction.class, "LinearFunction", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getLinearFunction_Key(), ecorePackage.getEString(), "key", null, 1, 1, LinearFunction.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getLinearFunction_ParameterM(), ecorePackage.getEDouble(), "parameterM", null, 1, 1,
				LinearFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getLinearFunction_ParameterC(), ecorePackage.getEDouble(), "parameterC", null, 1, 1,
				LinearFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);

		EOperation op = initEOperation(getLinearFunction__Linearfunction__double(), ecorePackage.getEDouble(),
				"linearfunction", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "x", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(dataPointEClass, DataPoint.class, "DataPoint", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDataPoint_X(), theXMLTypePackage.getDouble(), "x", null, 0, 1, DataPoint.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataPoint_Y(), theXMLTypePackage.getDouble(), "y", null, 0, 1, DataPoint.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(tableFunctionEClass, TableFunction.class, "TableFunction", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTableFunction_Key(), ecorePackage.getEString(), "key", null, 1, 1, TableFunction.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTableFunction_Datapoints(), this.getDataPoint(), null, "datapoints", null, 2, -1,
				TableFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(exponentialFunctionEClass, ExponentialFunction.class, "ExponentialFunction", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getExponentialFunction_Key(), ecorePackage.getEString(), "key", null, 1, 1,
				ExponentialFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getExponentialFunction_ParameterA(), ecorePackage.getEDouble(), "parameterA", null, 1, 1,
				ExponentialFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getExponentialFunction_ParameterB(), ecorePackage.getEDouble(), "parameterB", null, 1, 1,
				ExponentialFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getExponentialFunction__Exponentialfunction__double(), ecorePackage.getEDouble(),
				"exponentialfunction", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "x", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(characteristicEClass, Characteristic.class, "Characteristic", IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);

		initEClass(tableCharacteristicEClass, TableCharacteristic.class, "TableCharacteristic", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTableCharacteristic_Functions(), this.getTableFunction(), null, "functions", null, 1, -1,
				TableCharacteristic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(linearCharacteristicEClass, LinearCharacteristic.class, "LinearCharacteristic", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLinearCharacteristic_Functions(), this.getLinearFunction(), null, "functions", null, 1, -1,
				LinearCharacteristic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(exponentionalCharacteristicEClass, ExponentionalCharacteristic.class, "ExponentionalCharacteristic",
				!IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getExponentionalCharacteristic_Functions(), this.getExponentialFunction(), null, "functions",
				null, 1, -1, ExponentionalCharacteristic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(manufacturerEClass, Manufacturer.class, "Manufacturer", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getManufacturer_ManufacturerName(), ecorePackage.getEString(), "manufacturerName", null, 1, 1,
				Manufacturer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getManufacturer_Country(), ecorePackage.getEString(), "country", null, 0, 1, Manufacturer.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getManufacturer_OutOfBusinessSince(), ecorePackage.getEInt(), "outOfBusinessSince", null, 0, 1,
				Manufacturer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);

		initEClass(polynomialCharacteristicEClass, PolynomialCharacteristic.class, "PolynomialCharacteristic",
				!IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getPolynomialCharacteristic_Functions(), this.getPolynomialFunction(), null, "functions", null,
				1, -1, PolynomialCharacteristic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(polynomialFunctionEClass, PolynomialFunction.class, "PolynomialFunction", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getPolynomialFunction_Key(), ecorePackage.getEString(), "key", null, 1, 1,
				PolynomialFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getPolynomialFunction_ParameterA(), ecorePackage.getEDouble(), "parameterA", null, 1, 1,
				PolynomialFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getPolynomialFunction_ParameterB(), ecorePackage.getEDouble(), "parameterB", null, 1, 1,
				PolynomialFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getPolynomialFunction_ParameterC(), ecorePackage.getEDouble(), "parameterC", null, 1, 1,
				PolynomialFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);

		op = initEOperation(getPolynomialFunction__Polynomialfunction__double(), ecorePackage.getEDouble(),
				"polynomialfunction", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "x", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(materialEClass, Material.class, "Material", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMaterial_ThermalConductivity(), this.getQuantityDouble(), "thermalConductivity", " W/(m*K)",
				0, 1, Material.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getMaterial_Name(), ecorePackage.getEString(), "name", null, 1, 1, Material.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(energyComponentsCostCatalogEClass, EnergyComponentsCostCatalog.class, "EnergyComponentsCostCatalog",
				!IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getEnergyComponentsCostCatalog_Author(), ecorePackage.getEString(), "author", null, 0, 1,
				EnergyComponentsCostCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEnergyComponentsCostCatalog_RevisionYear(), ecorePackage.getEInt(), "revisionYear", null, 1,
				1, EnergyComponentsCostCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE,
				!IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnergyComponentsCostCatalog_CostCategories(), this.getCost(), null, "costCategories", null, 0,
				-1, EnergyComponentsCostCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEnergyComponentsCostCatalog_PersonnelCost(), ecorePackage.getEDouble(), "personnelCost",
				"150 ", 0, 1, EnergyComponentsCostCatalog.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				!IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(costEClass, Cost.class, "Cost", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCost_ComponentName(), theXMLTypePackage.getString(), "componentName", null, 1, 1, Cost.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCost_Description(), ecorePackage.getEString(), "description", null, 0, 1, Cost.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCost_HeatSource(), this.getTypeOfHeatSource(), "heatSource", null, 0, 1, Cost.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCost_Datasource(), ecorePackage.getEString(), "datasource", null, 0, 1, Cost.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCost_InvestmentCost(), this.getCharacteristic(), null, "investmentCost", null, 1, 1,
				Cost.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCost_OtherInvestmentCost(), ecorePackage.getEDouble(), "otherInvestmentCost", "0", 0, 1,
				Cost.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
				IS_ORDERED);
		initEAttribute(getCost_PersonnelHours(), this.getQuantityDouble(), "personnelHours", "10 h", 0, 1, Cost.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCost_PersonnelCostShare(), ecorePackage.getEDouble(), "personnelCostShare", null, 0, 1,
				Cost.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
				IS_ORDERED);
		initEAttribute(getCost_AdministrationAndOtherCostShare(), ecorePackage.getEDouble(),
				"administrationAndOtherCostShare", "0.015", 0, 1, Cost.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCost_MaintenanceCostShare(), ecorePackage.getEDouble(), "maintenanceCostShare", "0.015", 0, 1,
				Cost.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
				IS_ORDERED);

		initEClass(powerCharacteristicEClass, PowerCharacteristic.class, "PowerCharacteristic", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getPowerCharacteristic_Functions(), this.getPowerFunction(), null, "functions", null, 1, -1,
				PowerCharacteristic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(powerFunctionEClass, PowerFunction.class, "PowerFunction", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getPowerFunction_Key(), ecorePackage.getEString(), "key", null, 1, 1, PowerFunction.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPowerFunction_ParameterA(), ecorePackage.getEDouble(), "parameterA", null, 1, 1,
				PowerFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getPowerFunction_ParameterB(), ecorePackage.getEDouble(), "parameterB", null, 1, 1,
				PowerFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);

		op = initEOperation(getPowerFunction__Powerfunction__double(), ecorePackage.getEDouble(), "powerfunction", 0, 1,
				IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "x", 0, 1, IS_UNIQUE, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(heatSourcesEEnum, HeatSources.class, "HeatSources");
		addEEnumLiteral(heatSourcesEEnum, HeatSources.AIR);
		addEEnumLiteral(heatSourcesEEnum, HeatSources.GROUND);
		addEEnumLiteral(heatSourcesEEnum, HeatSources.WATER);

		initEEnum(collectorTypesEEnum, CollectorTypes.class, "CollectorTypes");
		addEEnumLiteral(collectorTypesEEnum, CollectorTypes.FLAT_PLANE_COLLECTOR);
		addEEnumLiteral(collectorTypesEEnum, CollectorTypes.EVACUATED_TUBE_COLLECTOR);

		initEEnum(electricalStorageTypesEEnum, ElectricalStorageTypes.class, "ElectricalStorageTypes");
		addEEnumLiteral(electricalStorageTypesEEnum, ElectricalStorageTypes.LITHIUM_ION);
		addEEnumLiteral(electricalStorageTypesEEnum, ElectricalStorageTypes.LEAD_ACID);
		addEEnumLiteral(electricalStorageTypesEEnum, ElectricalStorageTypes.NI_MH);
		addEEnumLiteral(electricalStorageTypesEEnum, ElectricalStorageTypes.LITHIUM_POLYMER);

		initEEnum(boilerTypesEEnum, BoilerTypes.class, "BoilerTypes");
		addEEnumLiteral(boilerTypesEEnum, BoilerTypes.CONDENSING_BOILER);
		addEEnumLiteral(boilerTypesEEnum, BoilerTypes.LOWTEMPERATURE_BOILER);

		initEEnum(thermalStorageTypesEEnum, ThermalStorageTypes.class, "ThermalStorageTypes");
		addEEnumLiteral(thermalStorageTypesEEnum, ThermalStorageTypes.SENSIBLE);
		addEEnumLiteral(thermalStorageTypesEEnum, ThermalStorageTypes.LATENT);

		initEEnum(cellTypesElectrolyzerEEnum, cellTypesElectrolyzer.class, "cellTypesElectrolyzer");
		addEEnumLiteral(cellTypesElectrolyzerEEnum, cellTypesElectrolyzer.PEM);

		initEEnum(fuelTypesEEnum, FuelTypes.class, "FuelTypes");
		addEEnumLiteral(fuelTypesEEnum, FuelTypes.NATURAL_GAS);
		addEEnumLiteral(fuelTypesEEnum, FuelTypes.OIL);
		addEEnumLiteral(fuelTypesEEnum, FuelTypes.DIESEL);
		addEEnumLiteral(fuelTypesEEnum, FuelTypes.BIO_GAS);
		addEEnumLiteral(fuelTypesEEnum, FuelTypes.SYNTHETIC_GAS);
		addEEnumLiteral(fuelTypesEEnum, FuelTypes.WOOD_PELLETS);
		addEEnumLiteral(fuelTypesEEnum, FuelTypes.WOOD_CHIPS);
		addEEnumLiteral(fuelTypesEEnum, FuelTypes.SEWAGE_GAS);
		addEEnumLiteral(fuelTypesEEnum, FuelTypes.ELECTRICITY);

		initEEnum(typeOfHeatSourceEEnum, TypeOfHeatSource.class, "TypeOfHeatSource");
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.NATURAL_GAS);
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.BIOGAS);
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.OIL);
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.DIESEL);
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.SYNTHETIC_GAS);
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.WOOD_PELLETS);
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.WOOD_CHIPS);
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.SEWAGE_GAS);
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.LNG);
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.CNG);
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.WATER);
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.AIR);
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.SOIL);
		addEEnumLiteral(typeOfHeatSourceEEnum, TypeOfHeatSource.NONE);

		// Initialize data types
		initEDataType(quantityDoubleEDataType, NullableQuantity.class, "QuantityDouble", IS_SERIALIZABLE,
				!IS_GENERATED_INSTANCE_CLASS);
		initEDataType(quantityLongEDataType, NullableQuantity.class, "QuantityLong", IS_SERIALIZABLE,
				!IS_GENERATED_INSTANCE_CLASS);

		// Create resource
		createResource(eNS_URI);
	}

} //EnCompPackageImpl
