/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.EnergyCarrier;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Energy Carrier</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyCarrierImpl#getCo2EmissionsFactor <em>Co2 Emissions Factor</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyCarrierImpl#getPrimaryEnergyFactor <em>Primary Energy Factor</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyCarrierImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyCarrierImpl#getCost <em>Cost</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class EnergyCarrierImpl extends MinimalEObjectImpl.Container implements EnergyCarrier {
	/**
	 * The default value of the '{@link #getCo2EmissionsFactor() <em>Co2 Emissions Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCo2EmissionsFactor()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity CO2_EMISSIONS_FACTOR_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "t/MW*h");

	/**
	 * The cached value of the '{@link #getCo2EmissionsFactor() <em>Co2 Emissions Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCo2EmissionsFactor()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity co2EmissionsFactor = CO2_EMISSIONS_FACTOR_EDEFAULT;

	/**
	 * The default value of the '{@link #getPrimaryEnergyFactor() <em>Primary Energy Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrimaryEnergyFactor()
	 * @generated
	 * @ordered
	 */
	protected static final double PRIMARY_ENERGY_FACTOR_EDEFAULT = 0.0;

	/**
	 * The cached value of the '{@link #getPrimaryEnergyFactor() <em>Primary Energy Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrimaryEnergyFactor()
	 * @generated
	 * @ordered
	 */
	protected double primaryEnergyFactor = PRIMARY_ENERGY_FACTOR_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getCost() <em>Cost</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCost()
	 * @generated
	 * @ordered
	 */
	protected static final double COST_EDEFAULT = 0.0;

	/**
	 * The cached value of the '{@link #getCost() <em>Cost</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCost()
	 * @generated
	 * @ordered
	 */
	protected double cost = COST_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnergyCarrierImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.ENERGY_CARRIER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getCo2EmissionsFactor() {
		return co2EmissionsFactor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setCo2EmissionsFactor(NullableQuantity newCo2EmissionsFactor) {
		NullableQuantity oldCo2EmissionsFactor = co2EmissionsFactor;
		co2EmissionsFactor = newCo2EmissionsFactor;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ENERGY_CARRIER__CO2_EMISSIONS_FACTOR,
					oldCo2EmissionsFactor, co2EmissionsFactor));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getPrimaryEnergyFactor() {
		return primaryEnergyFactor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setPrimaryEnergyFactor(double newPrimaryEnergyFactor) {
		double oldPrimaryEnergyFactor = primaryEnergyFactor;
		primaryEnergyFactor = newPrimaryEnergyFactor;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ENERGY_CARRIER__PRIMARY_ENERGY_FACTOR,
					oldPrimaryEnergyFactor, primaryEnergyFactor));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ENERGY_CARRIER__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getCost() {
		return cost;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setCost(double newCost) {
		double oldCost = cost;
		cost = newCost;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ENERGY_CARRIER__COST, oldCost, cost));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.ENERGY_CARRIER__CO2_EMISSIONS_FACTOR:
			return getCo2EmissionsFactor();
		case EnCompPackage.ENERGY_CARRIER__PRIMARY_ENERGY_FACTOR:
			return getPrimaryEnergyFactor();
		case EnCompPackage.ENERGY_CARRIER__NAME:
			return getName();
		case EnCompPackage.ENERGY_CARRIER__COST:
			return getCost();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.ENERGY_CARRIER__CO2_EMISSIONS_FACTOR:
			setCo2EmissionsFactor((NullableQuantity) newValue);
			return;
		case EnCompPackage.ENERGY_CARRIER__PRIMARY_ENERGY_FACTOR:
			setPrimaryEnergyFactor((Double) newValue);
			return;
		case EnCompPackage.ENERGY_CARRIER__NAME:
			setName((String) newValue);
			return;
		case EnCompPackage.ENERGY_CARRIER__COST:
			setCost((Double) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.ENERGY_CARRIER__CO2_EMISSIONS_FACTOR:
			setCo2EmissionsFactor(CO2_EMISSIONS_FACTOR_EDEFAULT);
			return;
		case EnCompPackage.ENERGY_CARRIER__PRIMARY_ENERGY_FACTOR:
			setPrimaryEnergyFactor(PRIMARY_ENERGY_FACTOR_EDEFAULT);
			return;
		case EnCompPackage.ENERGY_CARRIER__NAME:
			setName(NAME_EDEFAULT);
			return;
		case EnCompPackage.ENERGY_CARRIER__COST:
			setCost(COST_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.ENERGY_CARRIER__CO2_EMISSIONS_FACTOR:
			return CO2_EMISSIONS_FACTOR_EDEFAULT == null ? co2EmissionsFactor != null
					: !CO2_EMISSIONS_FACTOR_EDEFAULT.equals(co2EmissionsFactor);
		case EnCompPackage.ENERGY_CARRIER__PRIMARY_ENERGY_FACTOR:
			return primaryEnergyFactor != PRIMARY_ENERGY_FACTOR_EDEFAULT;
		case EnCompPackage.ENERGY_CARRIER__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case EnCompPackage.ENERGY_CARRIER__COST:
			return cost != COST_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (co2EmissionsFactor: ");
		result.append(co2EmissionsFactor);
		result.append(", primaryEnergyFactor: ");
		result.append(primaryEnergyFactor);
		result.append(", name: ");
		result.append(name);
		result.append(", cost: ");
		result.append(cost);
		result.append(')');
		return result.toString();
	}

} //EnergyCarrierImpl
