/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.BioFuel;
import de.hftstuttgart.energycomponents.Boiler;
import de.hftstuttgart.energycomponents.CombinedHeatPower;
import de.hftstuttgart.energycomponents.ElectricalStorage;
import de.hftstuttgart.energycomponents.Electrolyzer;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.EnergyCarrier;
import de.hftstuttgart.energycomponents.EnergyComponentsCatalog;
import de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog;
import de.hftstuttgart.energycomponents.FossilFuel;
import de.hftstuttgart.energycomponents.FuelCell;
import de.hftstuttgart.energycomponents.GeothermalHeatExchanger;
import de.hftstuttgart.energycomponents.HeatExchanger;
import de.hftstuttgart.energycomponents.HeatPump;
import de.hftstuttgart.energycomponents.HydrogenCompressor;
import de.hftstuttgart.energycomponents.HydrogenStorage;
import de.hftstuttgart.energycomponents.Inverter;
import de.hftstuttgart.energycomponents.Manufacturer;
import de.hftstuttgart.energycomponents.Material;
import de.hftstuttgart.energycomponents.Medium;
import de.hftstuttgart.energycomponents.PhotovoltaicModule;
import de.hftstuttgart.energycomponents.SolarThermalCollector;
import de.hftstuttgart.energycomponents.ThermalStorage;
import de.hftstuttgart.energycomponents.WindTurbine;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Energy Components Catalog</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getAuthor <em>Author</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getBioFuels <em>Bio Fuels</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getMedia <em>Media</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getCombinedHeatPowerUtilities <em>Combined Heat Power Utilities</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getBoilers <em>Boilers</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getPhotovoltaicModules <em>Photovoltaic Modules</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getSolarThermalCollectors <em>Solar Thermal Collectors</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getWindTurbines <em>Wind Turbines</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getGeothermalHeatExchangers <em>Geothermal Heat Exchangers</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getHeatPumps <em>Heat Pumps</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getInverters <em>Inverters</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getHeatExchangers <em>Heat Exchangers</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getElectrolyzers <em>Electrolyzers</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getHydrogenCompressors <em>Hydrogen Compressors</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getFuelCells <em>Fuel Cells</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getThermalStorages <em>Thermal Storages</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getPowerStorages <em>Power Storages</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getHydrogenStorages <em>Hydrogen Storages</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getFossilFuels <em>Fossil Fuels</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getManufacturers <em>Manufacturers</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getMaterials <em>Materials</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getEnergycomponentscostcatalog <em>Energycomponentscostcatalog</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl#getEnergycarriers <em>Energycarriers</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EnergyComponentsCatalogImpl extends MinimalEObjectImpl.Container implements EnergyComponentsCatalog {
	/**
	 * The default value of the '{@link #getAuthor() <em>Author</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAuthor()
	 * @generated
	 * @ordered
	 */
	protected static final String AUTHOR_EDEFAULT = "HFT_Stuttgart";

	/**
	 * The cached value of the '{@link #getAuthor() <em>Author</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAuthor()
	 * @generated
	 * @ordered
	 */
	protected String author = AUTHOR_EDEFAULT;

	/**
	 * The cached value of the '{@link #getBioFuels() <em>Bio Fuels</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBioFuels()
	 * @generated
	 * @ordered
	 */
	protected EList<BioFuel> bioFuels;

	/**
	 * The cached value of the '{@link #getMedia() <em>Media</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMedia()
	 * @generated
	 * @ordered
	 */
	protected EList<Medium> media;

	/**
	 * The cached value of the '{@link #getCombinedHeatPowerUtilities() <em>Combined Heat Power Utilities</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCombinedHeatPowerUtilities()
	 * @generated
	 * @ordered
	 */
	protected EList<CombinedHeatPower> combinedHeatPowerUtilities;

	/**
	 * The cached value of the '{@link #getBoilers() <em>Boilers</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBoilers()
	 * @generated
	 * @ordered
	 */
	protected EList<Boiler> boilers;

	/**
	 * The cached value of the '{@link #getPhotovoltaicModules() <em>Photovoltaic Modules</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPhotovoltaicModules()
	 * @generated
	 * @ordered
	 */
	protected EList<PhotovoltaicModule> photovoltaicModules;

	/**
	 * The cached value of the '{@link #getSolarThermalCollectors() <em>Solar Thermal Collectors</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSolarThermalCollectors()
	 * @generated
	 * @ordered
	 */
	protected EList<SolarThermalCollector> solarThermalCollectors;

	/**
	 * The cached value of the '{@link #getWindTurbines() <em>Wind Turbines</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWindTurbines()
	 * @generated
	 * @ordered
	 */
	protected EList<WindTurbine> windTurbines;

	/**
	 * The cached value of the '{@link #getGeothermalHeatExchangers() <em>Geothermal Heat Exchangers</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGeothermalHeatExchangers()
	 * @generated
	 * @ordered
	 */
	protected EList<GeothermalHeatExchanger> geothermalHeatExchangers;

	/**
	 * The cached value of the '{@link #getHeatPumps() <em>Heat Pumps</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeatPumps()
	 * @generated
	 * @ordered
	 */
	protected EList<HeatPump> heatPumps;

	/**
	 * The cached value of the '{@link #getInverters() <em>Inverters</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInverters()
	 * @generated
	 * @ordered
	 */
	protected EList<Inverter> inverters;

	/**
	 * The cached value of the '{@link #getHeatExchangers() <em>Heat Exchangers</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeatExchangers()
	 * @generated
	 * @ordered
	 */
	protected EList<HeatExchanger> heatExchangers;

	/**
	 * The cached value of the '{@link #getElectrolyzers() <em>Electrolyzers</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getElectrolyzers()
	 * @generated
	 * @ordered
	 */
	protected EList<Electrolyzer> electrolyzers;

	/**
	 * The cached value of the '{@link #getHydrogenCompressors() <em>Hydrogen Compressors</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHydrogenCompressors()
	 * @generated
	 * @ordered
	 */
	protected EList<HydrogenCompressor> hydrogenCompressors;

	/**
	 * The cached value of the '{@link #getFuelCells() <em>Fuel Cells</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFuelCells()
	 * @generated
	 * @ordered
	 */
	protected EList<FuelCell> fuelCells;

	/**
	 * The cached value of the '{@link #getThermalStorages() <em>Thermal Storages</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getThermalStorages()
	 * @generated
	 * @ordered
	 */
	protected EList<ThermalStorage> thermalStorages;

	/**
	 * The cached value of the '{@link #getPowerStorages() <em>Power Storages</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPowerStorages()
	 * @generated
	 * @ordered
	 */
	protected EList<ElectricalStorage> powerStorages;

	/**
	 * The cached value of the '{@link #getHydrogenStorages() <em>Hydrogen Storages</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHydrogenStorages()
	 * @generated
	 * @ordered
	 */
	protected EList<HydrogenStorage> hydrogenStorages;

	/**
	 * The cached value of the '{@link #getFossilFuels() <em>Fossil Fuels</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFossilFuels()
	 * @generated
	 * @ordered
	 */
	protected EList<FossilFuel> fossilFuels;

	/**
	 * The cached value of the '{@link #getManufacturers() <em>Manufacturers</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getManufacturers()
	 * @generated
	 * @ordered
	 */
	protected EList<Manufacturer> manufacturers;

	/**
	 * The cached value of the '{@link #getMaterials() <em>Materials</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaterials()
	 * @generated
	 * @ordered
	 */
	protected EList<Material> materials;

	/**
	 * The cached value of the '{@link #getEnergycomponentscostcatalog() <em>Energycomponentscostcatalog</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEnergycomponentscostcatalog()
	 * @generated
	 * @ordered
	 */
	protected EnergyComponentsCostCatalog energycomponentscostcatalog;

	/**
	 * The cached value of the '{@link #getEnergycarriers() <em>Energycarriers</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEnergycarriers()
	 * @generated
	 * @ordered
	 */
	protected EList<EnergyCarrier> energycarriers;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnergyComponentsCatalogImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.ENERGY_COMPONENTS_CATALOG;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getAuthor() {
		return author;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setAuthor(String newAuthor) {
		String oldAuthor = author;
		author = newAuthor;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.ENERGY_COMPONENTS_CATALOG__AUTHOR,
					oldAuthor, author));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<BioFuel> getBioFuels() {
		if (bioFuels == null) {
			bioFuels = new EObjectContainmentEList<BioFuel>(BioFuel.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__BIO_FUELS);
		}
		return bioFuels;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Medium> getMedia() {
		if (media == null) {
			media = new EObjectContainmentEList<Medium>(Medium.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__MEDIA);
		}
		return media;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<CombinedHeatPower> getCombinedHeatPowerUtilities() {
		if (combinedHeatPowerUtilities == null) {
			combinedHeatPowerUtilities = new EObjectContainmentEList<CombinedHeatPower>(CombinedHeatPower.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__COMBINED_HEAT_POWER_UTILITIES);
		}
		return combinedHeatPowerUtilities;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Boiler> getBoilers() {
		if (boilers == null) {
			boilers = new EObjectContainmentEList<Boiler>(Boiler.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__BOILERS);
		}
		return boilers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<PhotovoltaicModule> getPhotovoltaicModules() {
		if (photovoltaicModules == null) {
			photovoltaicModules = new EObjectContainmentEList<PhotovoltaicModule>(PhotovoltaicModule.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__PHOTOVOLTAIC_MODULES);
		}
		return photovoltaicModules;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<SolarThermalCollector> getSolarThermalCollectors() {
		if (solarThermalCollectors == null) {
			solarThermalCollectors = new EObjectContainmentEList<SolarThermalCollector>(SolarThermalCollector.class,
					this, EnCompPackage.ENERGY_COMPONENTS_CATALOG__SOLAR_THERMAL_COLLECTORS);
		}
		return solarThermalCollectors;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<WindTurbine> getWindTurbines() {
		if (windTurbines == null) {
			windTurbines = new EObjectContainmentEList<WindTurbine>(WindTurbine.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__WIND_TURBINES);
		}
		return windTurbines;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<GeothermalHeatExchanger> getGeothermalHeatExchangers() {
		if (geothermalHeatExchangers == null) {
			geothermalHeatExchangers = new EObjectContainmentEList<GeothermalHeatExchanger>(
					GeothermalHeatExchanger.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__GEOTHERMAL_HEAT_EXCHANGERS);
		}
		return geothermalHeatExchangers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<HeatPump> getHeatPumps() {
		if (heatPumps == null) {
			heatPumps = new EObjectContainmentEList<HeatPump>(HeatPump.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_PUMPS);
		}
		return heatPumps;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Inverter> getInverters() {
		if (inverters == null) {
			inverters = new EObjectContainmentEList<Inverter>(Inverter.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__INVERTERS);
		}
		return inverters;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<HeatExchanger> getHeatExchangers() {
		if (heatExchangers == null) {
			heatExchangers = new EObjectContainmentEList<HeatExchanger>(HeatExchanger.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_EXCHANGERS);
		}
		return heatExchangers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Electrolyzer> getElectrolyzers() {
		if (electrolyzers == null) {
			electrolyzers = new EObjectContainmentEList<Electrolyzer>(Electrolyzer.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__ELECTROLYZERS);
		}
		return electrolyzers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<HydrogenCompressor> getHydrogenCompressors() {
		if (hydrogenCompressors == null) {
			hydrogenCompressors = new EObjectContainmentEList<HydrogenCompressor>(HydrogenCompressor.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_COMPRESSORS);
		}
		return hydrogenCompressors;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<FuelCell> getFuelCells() {
		if (fuelCells == null) {
			fuelCells = new EObjectContainmentEList<FuelCell>(FuelCell.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__FUEL_CELLS);
		}
		return fuelCells;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ThermalStorage> getThermalStorages() {
		if (thermalStorages == null) {
			thermalStorages = new EObjectContainmentEList<ThermalStorage>(ThermalStorage.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__THERMAL_STORAGES);
		}
		return thermalStorages;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ElectricalStorage> getPowerStorages() {
		if (powerStorages == null) {
			powerStorages = new EObjectContainmentEList<ElectricalStorage>(ElectricalStorage.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__POWER_STORAGES);
		}
		return powerStorages;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<HydrogenStorage> getHydrogenStorages() {
		if (hydrogenStorages == null) {
			hydrogenStorages = new EObjectContainmentEList<HydrogenStorage>(HydrogenStorage.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_STORAGES);
		}
		return hydrogenStorages;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<FossilFuel> getFossilFuels() {
		if (fossilFuels == null) {
			fossilFuels = new EObjectContainmentEList<FossilFuel>(FossilFuel.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__FOSSIL_FUELS);
		}
		return fossilFuels;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Manufacturer> getManufacturers() {
		if (manufacturers == null) {
			manufacturers = new EObjectContainmentEList<Manufacturer>(Manufacturer.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__MANUFACTURERS);
		}
		return manufacturers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Material> getMaterials() {
		if (materials == null) {
			materials = new EObjectContainmentEList<Material>(Material.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__MATERIALS);
		}
		return materials;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EnergyComponentsCostCatalog getEnergycomponentscostcatalog() {
		return energycomponentscostcatalog;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEnergycomponentscostcatalog(
			EnergyComponentsCostCatalog newEnergycomponentscostcatalog, NotificationChain msgs) {
		EnergyComponentsCostCatalog oldEnergycomponentscostcatalog = energycomponentscostcatalog;
		energycomponentscostcatalog = newEnergycomponentscostcatalog;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG,
					oldEnergycomponentscostcatalog, newEnergycomponentscostcatalog);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setEnergycomponentscostcatalog(EnergyComponentsCostCatalog newEnergycomponentscostcatalog) {
		if (newEnergycomponentscostcatalog != energycomponentscostcatalog) {
			NotificationChain msgs = null;
			if (energycomponentscostcatalog != null)
				msgs = ((InternalEObject) energycomponentscostcatalog).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG,
						null, msgs);
			if (newEnergycomponentscostcatalog != null)
				msgs = ((InternalEObject) newEnergycomponentscostcatalog).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG,
						null, msgs);
			msgs = basicSetEnergycomponentscostcatalog(newEnergycomponentscostcatalog, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG,
					newEnergycomponentscostcatalog, newEnergycomponentscostcatalog));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<EnergyCarrier> getEnergycarriers() {
		if (energycarriers == null) {
			energycarriers = new EObjectContainmentEList<EnergyCarrier>(EnergyCarrier.class, this,
					EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS);
		}
		return energycarriers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__BIO_FUELS:
			return ((InternalEList<?>) getBioFuels()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MEDIA:
			return ((InternalEList<?>) getMedia()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__COMBINED_HEAT_POWER_UTILITIES:
			return ((InternalEList<?>) getCombinedHeatPowerUtilities()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__BOILERS:
			return ((InternalEList<?>) getBoilers()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__PHOTOVOLTAIC_MODULES:
			return ((InternalEList<?>) getPhotovoltaicModules()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__SOLAR_THERMAL_COLLECTORS:
			return ((InternalEList<?>) getSolarThermalCollectors()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__WIND_TURBINES:
			return ((InternalEList<?>) getWindTurbines()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__GEOTHERMAL_HEAT_EXCHANGERS:
			return ((InternalEList<?>) getGeothermalHeatExchangers()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_PUMPS:
			return ((InternalEList<?>) getHeatPumps()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__INVERTERS:
			return ((InternalEList<?>) getInverters()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_EXCHANGERS:
			return ((InternalEList<?>) getHeatExchangers()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ELECTROLYZERS:
			return ((InternalEList<?>) getElectrolyzers()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_COMPRESSORS:
			return ((InternalEList<?>) getHydrogenCompressors()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__FUEL_CELLS:
			return ((InternalEList<?>) getFuelCells()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__THERMAL_STORAGES:
			return ((InternalEList<?>) getThermalStorages()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__POWER_STORAGES:
			return ((InternalEList<?>) getPowerStorages()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_STORAGES:
			return ((InternalEList<?>) getHydrogenStorages()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__FOSSIL_FUELS:
			return ((InternalEList<?>) getFossilFuels()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MANUFACTURERS:
			return ((InternalEList<?>) getManufacturers()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MATERIALS:
			return ((InternalEList<?>) getMaterials()).basicRemove(otherEnd, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG:
			return basicSetEnergycomponentscostcatalog(null, msgs);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS:
			return ((InternalEList<?>) getEnergycarriers()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__AUTHOR:
			return getAuthor();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__BIO_FUELS:
			return getBioFuels();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MEDIA:
			return getMedia();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__COMBINED_HEAT_POWER_UTILITIES:
			return getCombinedHeatPowerUtilities();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__BOILERS:
			return getBoilers();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__PHOTOVOLTAIC_MODULES:
			return getPhotovoltaicModules();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__SOLAR_THERMAL_COLLECTORS:
			return getSolarThermalCollectors();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__WIND_TURBINES:
			return getWindTurbines();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__GEOTHERMAL_HEAT_EXCHANGERS:
			return getGeothermalHeatExchangers();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_PUMPS:
			return getHeatPumps();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__INVERTERS:
			return getInverters();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_EXCHANGERS:
			return getHeatExchangers();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ELECTROLYZERS:
			return getElectrolyzers();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_COMPRESSORS:
			return getHydrogenCompressors();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__FUEL_CELLS:
			return getFuelCells();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__THERMAL_STORAGES:
			return getThermalStorages();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__POWER_STORAGES:
			return getPowerStorages();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_STORAGES:
			return getHydrogenStorages();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__FOSSIL_FUELS:
			return getFossilFuels();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MANUFACTURERS:
			return getManufacturers();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MATERIALS:
			return getMaterials();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG:
			return getEnergycomponentscostcatalog();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS:
			return getEnergycarriers();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__AUTHOR:
			setAuthor((String) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__BIO_FUELS:
			getBioFuels().clear();
			getBioFuels().addAll((Collection<? extends BioFuel>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MEDIA:
			getMedia().clear();
			getMedia().addAll((Collection<? extends Medium>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__COMBINED_HEAT_POWER_UTILITIES:
			getCombinedHeatPowerUtilities().clear();
			getCombinedHeatPowerUtilities().addAll((Collection<? extends CombinedHeatPower>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__BOILERS:
			getBoilers().clear();
			getBoilers().addAll((Collection<? extends Boiler>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__PHOTOVOLTAIC_MODULES:
			getPhotovoltaicModules().clear();
			getPhotovoltaicModules().addAll((Collection<? extends PhotovoltaicModule>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__SOLAR_THERMAL_COLLECTORS:
			getSolarThermalCollectors().clear();
			getSolarThermalCollectors().addAll((Collection<? extends SolarThermalCollector>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__WIND_TURBINES:
			getWindTurbines().clear();
			getWindTurbines().addAll((Collection<? extends WindTurbine>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__GEOTHERMAL_HEAT_EXCHANGERS:
			getGeothermalHeatExchangers().clear();
			getGeothermalHeatExchangers().addAll((Collection<? extends GeothermalHeatExchanger>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_PUMPS:
			getHeatPumps().clear();
			getHeatPumps().addAll((Collection<? extends HeatPump>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__INVERTERS:
			getInverters().clear();
			getInverters().addAll((Collection<? extends Inverter>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_EXCHANGERS:
			getHeatExchangers().clear();
			getHeatExchangers().addAll((Collection<? extends HeatExchanger>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ELECTROLYZERS:
			getElectrolyzers().clear();
			getElectrolyzers().addAll((Collection<? extends Electrolyzer>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_COMPRESSORS:
			getHydrogenCompressors().clear();
			getHydrogenCompressors().addAll((Collection<? extends HydrogenCompressor>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__FUEL_CELLS:
			getFuelCells().clear();
			getFuelCells().addAll((Collection<? extends FuelCell>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__THERMAL_STORAGES:
			getThermalStorages().clear();
			getThermalStorages().addAll((Collection<? extends ThermalStorage>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__POWER_STORAGES:
			getPowerStorages().clear();
			getPowerStorages().addAll((Collection<? extends ElectricalStorage>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_STORAGES:
			getHydrogenStorages().clear();
			getHydrogenStorages().addAll((Collection<? extends HydrogenStorage>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__FOSSIL_FUELS:
			getFossilFuels().clear();
			getFossilFuels().addAll((Collection<? extends FossilFuel>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MANUFACTURERS:
			getManufacturers().clear();
			getManufacturers().addAll((Collection<? extends Manufacturer>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MATERIALS:
			getMaterials().clear();
			getMaterials().addAll((Collection<? extends Material>) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG:
			setEnergycomponentscostcatalog((EnergyComponentsCostCatalog) newValue);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS:
			getEnergycarriers().clear();
			getEnergycarriers().addAll((Collection<? extends EnergyCarrier>) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__AUTHOR:
			setAuthor(AUTHOR_EDEFAULT);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__BIO_FUELS:
			getBioFuels().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MEDIA:
			getMedia().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__COMBINED_HEAT_POWER_UTILITIES:
			getCombinedHeatPowerUtilities().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__BOILERS:
			getBoilers().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__PHOTOVOLTAIC_MODULES:
			getPhotovoltaicModules().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__SOLAR_THERMAL_COLLECTORS:
			getSolarThermalCollectors().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__WIND_TURBINES:
			getWindTurbines().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__GEOTHERMAL_HEAT_EXCHANGERS:
			getGeothermalHeatExchangers().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_PUMPS:
			getHeatPumps().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__INVERTERS:
			getInverters().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_EXCHANGERS:
			getHeatExchangers().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ELECTROLYZERS:
			getElectrolyzers().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_COMPRESSORS:
			getHydrogenCompressors().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__FUEL_CELLS:
			getFuelCells().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__THERMAL_STORAGES:
			getThermalStorages().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__POWER_STORAGES:
			getPowerStorages().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_STORAGES:
			getHydrogenStorages().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__FOSSIL_FUELS:
			getFossilFuels().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MANUFACTURERS:
			getManufacturers().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MATERIALS:
			getMaterials().clear();
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG:
			setEnergycomponentscostcatalog((EnergyComponentsCostCatalog) null);
			return;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS:
			getEnergycarriers().clear();
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__AUTHOR:
			return AUTHOR_EDEFAULT == null ? author != null : !AUTHOR_EDEFAULT.equals(author);
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__BIO_FUELS:
			return bioFuels != null && !bioFuels.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MEDIA:
			return media != null && !media.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__COMBINED_HEAT_POWER_UTILITIES:
			return combinedHeatPowerUtilities != null && !combinedHeatPowerUtilities.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__BOILERS:
			return boilers != null && !boilers.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__PHOTOVOLTAIC_MODULES:
			return photovoltaicModules != null && !photovoltaicModules.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__SOLAR_THERMAL_COLLECTORS:
			return solarThermalCollectors != null && !solarThermalCollectors.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__WIND_TURBINES:
			return windTurbines != null && !windTurbines.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__GEOTHERMAL_HEAT_EXCHANGERS:
			return geothermalHeatExchangers != null && !geothermalHeatExchangers.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_PUMPS:
			return heatPumps != null && !heatPumps.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__INVERTERS:
			return inverters != null && !inverters.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HEAT_EXCHANGERS:
			return heatExchangers != null && !heatExchangers.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ELECTROLYZERS:
			return electrolyzers != null && !electrolyzers.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_COMPRESSORS:
			return hydrogenCompressors != null && !hydrogenCompressors.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__FUEL_CELLS:
			return fuelCells != null && !fuelCells.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__THERMAL_STORAGES:
			return thermalStorages != null && !thermalStorages.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__POWER_STORAGES:
			return powerStorages != null && !powerStorages.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__HYDROGEN_STORAGES:
			return hydrogenStorages != null && !hydrogenStorages.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__FOSSIL_FUELS:
			return fossilFuels != null && !fossilFuels.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MANUFACTURERS:
			return manufacturers != null && !manufacturers.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__MATERIALS:
			return materials != null && !materials.isEmpty();
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG:
			return energycomponentscostcatalog != null;
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS:
			return energycarriers != null && !energycarriers.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (author: ");
		result.append(author);
		result.append(')');
		return result.toString();
	}

} //EnergyComponentsCatalogImpl
