/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.Fuel;

import de.hftstuttgart.energycomponents.FuelTypes;
import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Fuel</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.FuelImpl#getNetCalorificValue <em>Net Calorific Value</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.FuelImpl#getGrossCalorificValue <em>Gross Calorific Value</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.FuelImpl#getDensity <em>Density</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.FuelImpl#getFuelType <em>Fuel Type</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class FuelImpl extends EnergyCarrierImpl implements Fuel {
	/**
	 * The default value of the '{@link #getNetCalorificValue() <em>Net Calorific Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNetCalorificValue()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity NET_CALORIFIC_VALUE_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "(kW*h)/m\u00b3");

	/**
	 * The cached value of the '{@link #getNetCalorificValue() <em>Net Calorific Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNetCalorificValue()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity netCalorificValue = NET_CALORIFIC_VALUE_EDEFAULT;

	/**
	 * The default value of the '{@link #getGrossCalorificValue() <em>Gross Calorific Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGrossCalorificValue()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity GROSS_CALORIFIC_VALUE_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "(kW*h)/m\u00b3");

	/**
	 * The cached value of the '{@link #getGrossCalorificValue() <em>Gross Calorific Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGrossCalorificValue()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity grossCalorificValue = GROSS_CALORIFIC_VALUE_EDEFAULT;

	/**
	 * The default value of the '{@link #getDensity() <em>Density</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDensity()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity DENSITY_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "kg/m\u00b3");

	/**
	 * The cached value of the '{@link #getDensity() <em>Density</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDensity()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity density = DENSITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getFuelType() <em>Fuel Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFuelType()
	 * @generated
	 * @ordered
	 */
	protected static final FuelTypes FUEL_TYPE_EDEFAULT = FuelTypes.NATURAL_GAS;

	/**
	 * The cached value of the '{@link #getFuelType() <em>Fuel Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFuelType()
	 * @generated
	 * @ordered
	 */
	protected FuelTypes fuelType = FUEL_TYPE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FuelImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.FUEL;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getNetCalorificValue() {
		return netCalorificValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setNetCalorificValue(NullableQuantity newNetCalorificValue) {
		NullableQuantity oldNetCalorificValue = netCalorificValue;
		netCalorificValue = newNetCalorificValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.FUEL__NET_CALORIFIC_VALUE,
					oldNetCalorificValue, netCalorificValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getGrossCalorificValue() {
		return grossCalorificValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setGrossCalorificValue(NullableQuantity newGrossCalorificValue) {
		NullableQuantity oldGrossCalorificValue = grossCalorificValue;
		grossCalorificValue = newGrossCalorificValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.FUEL__GROSS_CALORIFIC_VALUE,
					oldGrossCalorificValue, grossCalorificValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getDensity() {
		return density;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDensity(NullableQuantity newDensity) {
		NullableQuantity oldDensity = density;
		density = newDensity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.FUEL__DENSITY, oldDensity, density));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public FuelTypes getFuelType() {
		return fuelType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setFuelType(FuelTypes newFuelType) {
		FuelTypes oldFuelType = fuelType;
		fuelType = newFuelType == null ? FUEL_TYPE_EDEFAULT : newFuelType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.FUEL__FUEL_TYPE, oldFuelType,
					fuelType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.FUEL__NET_CALORIFIC_VALUE:
			return getNetCalorificValue();
		case EnCompPackage.FUEL__GROSS_CALORIFIC_VALUE:
			return getGrossCalorificValue();
		case EnCompPackage.FUEL__DENSITY:
			return getDensity();
		case EnCompPackage.FUEL__FUEL_TYPE:
			return getFuelType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.FUEL__NET_CALORIFIC_VALUE:
			setNetCalorificValue((NullableQuantity) newValue);
			return;
		case EnCompPackage.FUEL__GROSS_CALORIFIC_VALUE:
			setGrossCalorificValue((NullableQuantity) newValue);
			return;
		case EnCompPackage.FUEL__DENSITY:
			setDensity((NullableQuantity) newValue);
			return;
		case EnCompPackage.FUEL__FUEL_TYPE:
			setFuelType((FuelTypes) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.FUEL__NET_CALORIFIC_VALUE:
			setNetCalorificValue(NET_CALORIFIC_VALUE_EDEFAULT);
			return;
		case EnCompPackage.FUEL__GROSS_CALORIFIC_VALUE:
			setGrossCalorificValue(GROSS_CALORIFIC_VALUE_EDEFAULT);
			return;
		case EnCompPackage.FUEL__DENSITY:
			setDensity(DENSITY_EDEFAULT);
			return;
		case EnCompPackage.FUEL__FUEL_TYPE:
			setFuelType(FUEL_TYPE_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.FUEL__NET_CALORIFIC_VALUE:
			return NET_CALORIFIC_VALUE_EDEFAULT == null ? netCalorificValue != null
					: !NET_CALORIFIC_VALUE_EDEFAULT.equals(netCalorificValue);
		case EnCompPackage.FUEL__GROSS_CALORIFIC_VALUE:
			return GROSS_CALORIFIC_VALUE_EDEFAULT == null ? grossCalorificValue != null
					: !GROSS_CALORIFIC_VALUE_EDEFAULT.equals(grossCalorificValue);
		case EnCompPackage.FUEL__DENSITY:
			return DENSITY_EDEFAULT == null ? density != null : !DENSITY_EDEFAULT.equals(density);
		case EnCompPackage.FUEL__FUEL_TYPE:
			return fuelType != FUEL_TYPE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (netCalorificValue: ");
		result.append(netCalorificValue);
		result.append(", grossCalorificValue: ");
		result.append(grossCalorificValue);
		result.append(", density: ");
		result.append(density);
		result.append(", fuelType: ");
		result.append(fuelType);
		result.append(')');
		return result.toString();
	}

} //FuelImpl
