/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.GeothermalHeatExchanger;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Geothermal Heat Exchanger</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.GeothermalHeatExchangerImpl#getPipeDiameter <em>Pipe Diameter</em>}</li>
 * </ul>
 *
 * @generated
 */
public class GeothermalHeatExchangerImpl extends EnergyComponentImpl implements GeothermalHeatExchanger {
	/**
	 * The default value of the '{@link #getPipeDiameter() <em>Pipe Diameter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPipeDiameter()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity PIPE_DIAMETER_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "1 cm");

	/**
	 * The cached value of the '{@link #getPipeDiameter() <em>Pipe Diameter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPipeDiameter()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity pipeDiameter = PIPE_DIAMETER_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GeothermalHeatExchangerImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.GEOTHERMAL_HEAT_EXCHANGER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getPipeDiameter() {
		return pipeDiameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setPipeDiameter(NullableQuantity newPipeDiameter) {
		NullableQuantity oldPipeDiameter = pipeDiameter;
		pipeDiameter = newPipeDiameter;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.GEOTHERMAL_HEAT_EXCHANGER__PIPE_DIAMETER, oldPipeDiameter, pipeDiameter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.GEOTHERMAL_HEAT_EXCHANGER__PIPE_DIAMETER:
			return getPipeDiameter();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.GEOTHERMAL_HEAT_EXCHANGER__PIPE_DIAMETER:
			setPipeDiameter((NullableQuantity) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.GEOTHERMAL_HEAT_EXCHANGER__PIPE_DIAMETER:
			setPipeDiameter(PIPE_DIAMETER_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.GEOTHERMAL_HEAT_EXCHANGER__PIPE_DIAMETER:
			return PIPE_DIAMETER_EDEFAULT == null ? pipeDiameter != null : !PIPE_DIAMETER_EDEFAULT.equals(pipeDiameter);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (pipeDiameter: ");
		result.append(pipeDiameter);
		result.append(')');
		return result.toString();
	}

} //GeothermalHeatExchangerImpl
