/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.HeatExchanger;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Heat Exchanger</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HeatExchangerImpl#getHeatRecoveryEfficiency <em>Heat Recovery Efficiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HeatExchangerImpl#getNominalElectricityConsumption <em>Nominal Electricity Consumption</em>}</li>
 * </ul>
 *
 * @generated
 */
public class HeatExchangerImpl extends EnergyComponentImpl implements HeatExchanger {
	/**
	 * The default value of the '{@link #getHeatRecoveryEfficiency() <em>Heat Recovery Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeatRecoveryEfficiency()
	 * @generated
	 * @ordered
	 */
	protected static final double HEAT_RECOVERY_EFFICIENCY_EDEFAULT = 0.8;

	/**
	 * The cached value of the '{@link #getHeatRecoveryEfficiency() <em>Heat Recovery Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeatRecoveryEfficiency()
	 * @generated
	 * @ordered
	 */
	protected double heatRecoveryEfficiency = HEAT_RECOVERY_EFFICIENCY_EDEFAULT;

	/**
	 * The default value of the '{@link #getNominalElectricityConsumption() <em>Nominal Electricity Consumption</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNominalElectricityConsumption()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity NOMINAL_ELECTRICITY_CONSUMPTION_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "W");

	/**
	 * The cached value of the '{@link #getNominalElectricityConsumption() <em>Nominal Electricity Consumption</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNominalElectricityConsumption()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity nominalElectricityConsumption = NOMINAL_ELECTRICITY_CONSUMPTION_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HeatExchangerImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.HEAT_EXCHANGER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getHeatRecoveryEfficiency() {
		return heatRecoveryEfficiency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setHeatRecoveryEfficiency(double newHeatRecoveryEfficiency) {
		double oldHeatRecoveryEfficiency = heatRecoveryEfficiency;
		heatRecoveryEfficiency = newHeatRecoveryEfficiency;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.HEAT_EXCHANGER__HEAT_RECOVERY_EFFICIENCY, oldHeatRecoveryEfficiency,
					heatRecoveryEfficiency));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getNominalElectricityConsumption() {
		return nominalElectricityConsumption;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setNominalElectricityConsumption(NullableQuantity newNominalElectricityConsumption) {
		NullableQuantity oldNominalElectricityConsumption = nominalElectricityConsumption;
		nominalElectricityConsumption = newNominalElectricityConsumption;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.HEAT_EXCHANGER__NOMINAL_ELECTRICITY_CONSUMPTION, oldNominalElectricityConsumption,
					nominalElectricityConsumption));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.HEAT_EXCHANGER__HEAT_RECOVERY_EFFICIENCY:
			return getHeatRecoveryEfficiency();
		case EnCompPackage.HEAT_EXCHANGER__NOMINAL_ELECTRICITY_CONSUMPTION:
			return getNominalElectricityConsumption();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.HEAT_EXCHANGER__HEAT_RECOVERY_EFFICIENCY:
			setHeatRecoveryEfficiency((Double) newValue);
			return;
		case EnCompPackage.HEAT_EXCHANGER__NOMINAL_ELECTRICITY_CONSUMPTION:
			setNominalElectricityConsumption((NullableQuantity) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.HEAT_EXCHANGER__HEAT_RECOVERY_EFFICIENCY:
			setHeatRecoveryEfficiency(HEAT_RECOVERY_EFFICIENCY_EDEFAULT);
			return;
		case EnCompPackage.HEAT_EXCHANGER__NOMINAL_ELECTRICITY_CONSUMPTION:
			setNominalElectricityConsumption(NOMINAL_ELECTRICITY_CONSUMPTION_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.HEAT_EXCHANGER__HEAT_RECOVERY_EFFICIENCY:
			return heatRecoveryEfficiency != HEAT_RECOVERY_EFFICIENCY_EDEFAULT;
		case EnCompPackage.HEAT_EXCHANGER__NOMINAL_ELECTRICITY_CONSUMPTION:
			return NOMINAL_ELECTRICITY_CONSUMPTION_EDEFAULT == null ? nominalElectricityConsumption != null
					: !NOMINAL_ELECTRICITY_CONSUMPTION_EDEFAULT.equals(nominalElectricityConsumption);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (heatRecoveryEfficiency: ");
		result.append(heatRecoveryEfficiency);
		result.append(", nominalElectricityConsumption: ");
		result.append(nominalElectricityConsumption);
		result.append(')');
		return result.toString();
	}

} //HeatExchangerImpl
