/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.HydrogenCompressor;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hydrogen Compressor</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HydrogenCompressorImpl#getEfficiency <em>Efficiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HydrogenCompressorImpl#getThermodynamicMode <em>Thermodynamic Mode</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HydrogenCompressorImpl#getMaxPressure <em>Max Pressure</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HydrogenCompressorImpl#getMaxDeliveryRate <em>Max Delivery Rate</em>}</li>
 * </ul>
 *
 * @generated
 */
public class HydrogenCompressorImpl extends EnergyComponentImpl implements HydrogenCompressor {
	/**
	 * The default value of the '{@link #getEfficiency() <em>Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEfficiency()
	 * @generated
	 * @ordered
	 */
	protected static final double EFFICIENCY_EDEFAULT = 0.68;

	/**
	 * The cached value of the '{@link #getEfficiency() <em>Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEfficiency()
	 * @generated
	 * @ordered
	 */
	protected double efficiency = EFFICIENCY_EDEFAULT;

	/**
	 * The default value of the '{@link #getThermodynamicMode() <em>Thermodynamic Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getThermodynamicMode()
	 * @generated
	 * @ordered
	 */
	protected static final int THERMODYNAMIC_MODE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getThermodynamicMode() <em>Thermodynamic Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getThermodynamicMode()
	 * @generated
	 * @ordered
	 */
	protected int thermodynamicMode = THERMODYNAMIC_MODE_EDEFAULT;

	/**
	 * The default value of the '{@link #getMaxPressure() <em>Max Pressure</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxPressure()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity MAX_PRESSURE_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "50 MPa");

	/**
	 * The cached value of the '{@link #getMaxPressure() <em>Max Pressure</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxPressure()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity maxPressure = MAX_PRESSURE_EDEFAULT;

	/**
	 * The default value of the '{@link #getMaxDeliveryRate() <em>Max Delivery Rate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxDeliveryRate()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity MAX_DELIVERY_RATE_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "9 kg/h");

	/**
	 * The cached value of the '{@link #getMaxDeliveryRate() <em>Max Delivery Rate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxDeliveryRate()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity maxDeliveryRate = MAX_DELIVERY_RATE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HydrogenCompressorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.HYDROGEN_COMPRESSOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getEfficiency() {
		return efficiency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setEfficiency(double newEfficiency) {
		double oldEfficiency = efficiency;
		efficiency = newEfficiency;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HYDROGEN_COMPRESSOR__EFFICIENCY,
					oldEfficiency, efficiency));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int getThermodynamicMode() {
		return thermodynamicMode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setThermodynamicMode(int newThermodynamicMode) {
		int oldThermodynamicMode = thermodynamicMode;
		thermodynamicMode = newThermodynamicMode;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HYDROGEN_COMPRESSOR__THERMODYNAMIC_MODE,
					oldThermodynamicMode, thermodynamicMode));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getMaxPressure() {
		return maxPressure;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMaxPressure(NullableQuantity newMaxPressure) {
		NullableQuantity oldMaxPressure = maxPressure;
		maxPressure = newMaxPressure;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HYDROGEN_COMPRESSOR__MAX_PRESSURE,
					oldMaxPressure, maxPressure));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getMaxDeliveryRate() {
		return maxDeliveryRate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMaxDeliveryRate(NullableQuantity newMaxDeliveryRate) {
		NullableQuantity oldMaxDeliveryRate = maxDeliveryRate;
		maxDeliveryRate = newMaxDeliveryRate;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HYDROGEN_COMPRESSOR__MAX_DELIVERY_RATE,
					oldMaxDeliveryRate, maxDeliveryRate));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.HYDROGEN_COMPRESSOR__EFFICIENCY:
			return getEfficiency();
		case EnCompPackage.HYDROGEN_COMPRESSOR__THERMODYNAMIC_MODE:
			return getThermodynamicMode();
		case EnCompPackage.HYDROGEN_COMPRESSOR__MAX_PRESSURE:
			return getMaxPressure();
		case EnCompPackage.HYDROGEN_COMPRESSOR__MAX_DELIVERY_RATE:
			return getMaxDeliveryRate();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.HYDROGEN_COMPRESSOR__EFFICIENCY:
			setEfficiency((Double) newValue);
			return;
		case EnCompPackage.HYDROGEN_COMPRESSOR__THERMODYNAMIC_MODE:
			setThermodynamicMode((Integer) newValue);
			return;
		case EnCompPackage.HYDROGEN_COMPRESSOR__MAX_PRESSURE:
			setMaxPressure((NullableQuantity) newValue);
			return;
		case EnCompPackage.HYDROGEN_COMPRESSOR__MAX_DELIVERY_RATE:
			setMaxDeliveryRate((NullableQuantity) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.HYDROGEN_COMPRESSOR__EFFICIENCY:
			setEfficiency(EFFICIENCY_EDEFAULT);
			return;
		case EnCompPackage.HYDROGEN_COMPRESSOR__THERMODYNAMIC_MODE:
			setThermodynamicMode(THERMODYNAMIC_MODE_EDEFAULT);
			return;
		case EnCompPackage.HYDROGEN_COMPRESSOR__MAX_PRESSURE:
			setMaxPressure(MAX_PRESSURE_EDEFAULT);
			return;
		case EnCompPackage.HYDROGEN_COMPRESSOR__MAX_DELIVERY_RATE:
			setMaxDeliveryRate(MAX_DELIVERY_RATE_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.HYDROGEN_COMPRESSOR__EFFICIENCY:
			return efficiency != EFFICIENCY_EDEFAULT;
		case EnCompPackage.HYDROGEN_COMPRESSOR__THERMODYNAMIC_MODE:
			return thermodynamicMode != THERMODYNAMIC_MODE_EDEFAULT;
		case EnCompPackage.HYDROGEN_COMPRESSOR__MAX_PRESSURE:
			return MAX_PRESSURE_EDEFAULT == null ? maxPressure != null : !MAX_PRESSURE_EDEFAULT.equals(maxPressure);
		case EnCompPackage.HYDROGEN_COMPRESSOR__MAX_DELIVERY_RATE:
			return MAX_DELIVERY_RATE_EDEFAULT == null ? maxDeliveryRate != null
					: !MAX_DELIVERY_RATE_EDEFAULT.equals(maxDeliveryRate);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (efficiency: ");
		result.append(efficiency);
		result.append(", thermodynamicMode: ");
		result.append(thermodynamicMode);
		result.append(", maxPressure: ");
		result.append(maxPressure);
		result.append(", maxDeliveryRate: ");
		result.append(maxDeliveryRate);
		result.append(')');
		return result.toString();
	}

} //HydrogenCompressorImpl
