/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.HydrogenStorage;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hydrogen Storage</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HydrogenStorageImpl#getNumberOfCylinders <em>Number Of Cylinders</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HydrogenStorageImpl#getCylinderVolume <em>Cylinder Volume</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HydrogenStorageImpl#getNominalPressure <em>Nominal Pressure</em>}</li>
 * </ul>
 *
 * @generated
 */
public class HydrogenStorageImpl extends EnergyComponentImpl implements HydrogenStorage {
	/**
	 * The default value of the '{@link #getNumberOfCylinders() <em>Number Of Cylinders</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumberOfCylinders()
	 * @generated
	 * @ordered
	 */
	protected static final int NUMBER_OF_CYLINDERS_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getNumberOfCylinders() <em>Number Of Cylinders</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumberOfCylinders()
	 * @generated
	 * @ordered
	 */
	protected int numberOfCylinders = NUMBER_OF_CYLINDERS_EDEFAULT;

	/**
	 * The default value of the '{@link #getCylinderVolume() <em>Cylinder Volume</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCylinderVolume()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity CYLINDER_VOLUME_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "1.5 m\u00b3");

	/**
	 * The cached value of the '{@link #getCylinderVolume() <em>Cylinder Volume</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCylinderVolume()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity cylinderVolume = CYLINDER_VOLUME_EDEFAULT;

	/**
	 * The default value of the '{@link #getNominalPressure() <em>Nominal Pressure</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNominalPressure()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity NOMINAL_PRESSURE_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "25 MPa");

	/**
	 * The cached value of the '{@link #getNominalPressure() <em>Nominal Pressure</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNominalPressure()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity nominalPressure = NOMINAL_PRESSURE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HydrogenStorageImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.HYDROGEN_STORAGE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int getNumberOfCylinders() {
		return numberOfCylinders;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setNumberOfCylinders(int newNumberOfCylinders) {
		int oldNumberOfCylinders = numberOfCylinders;
		numberOfCylinders = newNumberOfCylinders;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HYDROGEN_STORAGE__NUMBER_OF_CYLINDERS,
					oldNumberOfCylinders, numberOfCylinders));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getCylinderVolume() {
		return cylinderVolume;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setCylinderVolume(NullableQuantity newCylinderVolume) {
		NullableQuantity oldCylinderVolume = cylinderVolume;
		cylinderVolume = newCylinderVolume;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HYDROGEN_STORAGE__CYLINDER_VOLUME,
					oldCylinderVolume, cylinderVolume));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getNominalPressure() {
		return nominalPressure;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setNominalPressure(NullableQuantity newNominalPressure) {
		NullableQuantity oldNominalPressure = nominalPressure;
		nominalPressure = newNominalPressure;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HYDROGEN_STORAGE__NOMINAL_PRESSURE,
					oldNominalPressure, nominalPressure));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.HYDROGEN_STORAGE__NUMBER_OF_CYLINDERS:
			return getNumberOfCylinders();
		case EnCompPackage.HYDROGEN_STORAGE__CYLINDER_VOLUME:
			return getCylinderVolume();
		case EnCompPackage.HYDROGEN_STORAGE__NOMINAL_PRESSURE:
			return getNominalPressure();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.HYDROGEN_STORAGE__NUMBER_OF_CYLINDERS:
			setNumberOfCylinders((Integer) newValue);
			return;
		case EnCompPackage.HYDROGEN_STORAGE__CYLINDER_VOLUME:
			setCylinderVolume((NullableQuantity) newValue);
			return;
		case EnCompPackage.HYDROGEN_STORAGE__NOMINAL_PRESSURE:
			setNominalPressure((NullableQuantity) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.HYDROGEN_STORAGE__NUMBER_OF_CYLINDERS:
			setNumberOfCylinders(NUMBER_OF_CYLINDERS_EDEFAULT);
			return;
		case EnCompPackage.HYDROGEN_STORAGE__CYLINDER_VOLUME:
			setCylinderVolume(CYLINDER_VOLUME_EDEFAULT);
			return;
		case EnCompPackage.HYDROGEN_STORAGE__NOMINAL_PRESSURE:
			setNominalPressure(NOMINAL_PRESSURE_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.HYDROGEN_STORAGE__NUMBER_OF_CYLINDERS:
			return numberOfCylinders != NUMBER_OF_CYLINDERS_EDEFAULT;
		case EnCompPackage.HYDROGEN_STORAGE__CYLINDER_VOLUME:
			return CYLINDER_VOLUME_EDEFAULT == null ? cylinderVolume != null
					: !CYLINDER_VOLUME_EDEFAULT.equals(cylinderVolume);
		case EnCompPackage.HYDROGEN_STORAGE__NOMINAL_PRESSURE:
			return NOMINAL_PRESSURE_EDEFAULT == null ? nominalPressure != null
					: !NOMINAL_PRESSURE_EDEFAULT.equals(nominalPressure);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (numberOfCylinders: ");
		result.append(numberOfCylinders);
		result.append(", cylinderVolume: ");
		result.append(cylinderVolume);
		result.append(", nominalPressure: ");
		result.append(nominalPressure);
		result.append(')');
		return result.toString();
	}

} //HydrogenStorageImpl
