/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.Medium;
import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Medium</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.MediumImpl#getDensity <em>Density</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.MediumImpl#getHeatCapacity <em>Heat Capacity</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.MediumImpl#getEvaporationTemperature <em>Evaporation Temperature</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.MediumImpl#getMeltingTemperature <em>Melting Temperature</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.MediumImpl#getName <em>Name</em>}</li>
 * </ul>
 *
 * @generated
 */
public class MediumImpl extends MinimalEObjectImpl.Container implements Medium {
	/**
	 * The default value of the '{@link #getDensity() <em>Density</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDensity()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity DENSITY_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "g/cm\u00b3");

	/**
	 * The cached value of the '{@link #getDensity() <em>Density</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDensity()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity density = DENSITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getHeatCapacity() <em>Heat Capacity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeatCapacity()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity HEAT_CAPACITY_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "kJ/(kg*K)");

	/**
	 * The cached value of the '{@link #getHeatCapacity() <em>Heat Capacity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeatCapacity()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity heatCapacity = HEAT_CAPACITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getEvaporationTemperature() <em>Evaporation Temperature</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEvaporationTemperature()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity EVAPORATION_TEMPERATURE_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "\u00b0C");

	/**
	 * The cached value of the '{@link #getEvaporationTemperature() <em>Evaporation Temperature</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEvaporationTemperature()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity evaporationTemperature = EVAPORATION_TEMPERATURE_EDEFAULT;

	/**
	 * The default value of the '{@link #getMeltingTemperature() <em>Melting Temperature</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMeltingTemperature()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity MELTING_TEMPERATURE_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "\u00b0C");

	/**
	 * The cached value of the '{@link #getMeltingTemperature() <em>Melting Temperature</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMeltingTemperature()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity meltingTemperature = MELTING_TEMPERATURE_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MediumImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.MEDIUM;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getDensity() {
		return density;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDensity(NullableQuantity newDensity) {
		NullableQuantity oldDensity = density;
		density = newDensity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.MEDIUM__DENSITY, oldDensity, density));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getHeatCapacity() {
		return heatCapacity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setHeatCapacity(NullableQuantity newHeatCapacity) {
		NullableQuantity oldHeatCapacity = heatCapacity;
		heatCapacity = newHeatCapacity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.MEDIUM__HEAT_CAPACITY, oldHeatCapacity,
					heatCapacity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getEvaporationTemperature() {
		return evaporationTemperature;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setEvaporationTemperature(NullableQuantity newEvaporationTemperature) {
		NullableQuantity oldEvaporationTemperature = evaporationTemperature;
		evaporationTemperature = newEvaporationTemperature;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.MEDIUM__EVAPORATION_TEMPERATURE,
					oldEvaporationTemperature, evaporationTemperature));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getMeltingTemperature() {
		return meltingTemperature;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMeltingTemperature(NullableQuantity newMeltingTemperature) {
		NullableQuantity oldMeltingTemperature = meltingTemperature;
		meltingTemperature = newMeltingTemperature;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.MEDIUM__MELTING_TEMPERATURE,
					oldMeltingTemperature, meltingTemperature));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.MEDIUM__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.MEDIUM__DENSITY:
			return getDensity();
		case EnCompPackage.MEDIUM__HEAT_CAPACITY:
			return getHeatCapacity();
		case EnCompPackage.MEDIUM__EVAPORATION_TEMPERATURE:
			return getEvaporationTemperature();
		case EnCompPackage.MEDIUM__MELTING_TEMPERATURE:
			return getMeltingTemperature();
		case EnCompPackage.MEDIUM__NAME:
			return getName();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.MEDIUM__DENSITY:
			setDensity((NullableQuantity) newValue);
			return;
		case EnCompPackage.MEDIUM__HEAT_CAPACITY:
			setHeatCapacity((NullableQuantity) newValue);
			return;
		case EnCompPackage.MEDIUM__EVAPORATION_TEMPERATURE:
			setEvaporationTemperature((NullableQuantity) newValue);
			return;
		case EnCompPackage.MEDIUM__MELTING_TEMPERATURE:
			setMeltingTemperature((NullableQuantity) newValue);
			return;
		case EnCompPackage.MEDIUM__NAME:
			setName((String) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.MEDIUM__DENSITY:
			setDensity(DENSITY_EDEFAULT);
			return;
		case EnCompPackage.MEDIUM__HEAT_CAPACITY:
			setHeatCapacity(HEAT_CAPACITY_EDEFAULT);
			return;
		case EnCompPackage.MEDIUM__EVAPORATION_TEMPERATURE:
			setEvaporationTemperature(EVAPORATION_TEMPERATURE_EDEFAULT);
			return;
		case EnCompPackage.MEDIUM__MELTING_TEMPERATURE:
			setMeltingTemperature(MELTING_TEMPERATURE_EDEFAULT);
			return;
		case EnCompPackage.MEDIUM__NAME:
			setName(NAME_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.MEDIUM__DENSITY:
			return DENSITY_EDEFAULT == null ? density != null : !DENSITY_EDEFAULT.equals(density);
		case EnCompPackage.MEDIUM__HEAT_CAPACITY:
			return HEAT_CAPACITY_EDEFAULT == null ? heatCapacity != null : !HEAT_CAPACITY_EDEFAULT.equals(heatCapacity);
		case EnCompPackage.MEDIUM__EVAPORATION_TEMPERATURE:
			return EVAPORATION_TEMPERATURE_EDEFAULT == null ? evaporationTemperature != null
					: !EVAPORATION_TEMPERATURE_EDEFAULT.equals(evaporationTemperature);
		case EnCompPackage.MEDIUM__MELTING_TEMPERATURE:
			return MELTING_TEMPERATURE_EDEFAULT == null ? meltingTemperature != null
					: !MELTING_TEMPERATURE_EDEFAULT.equals(meltingTemperature);
		case EnCompPackage.MEDIUM__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (density: ");
		result.append(density);
		result.append(", heatCapacity: ");
		result.append(heatCapacity);
		result.append(", evaporationTemperature: ");
		result.append(evaporationTemperature);
		result.append(", meltingTemperature: ");
		result.append(meltingTemperature);
		result.append(", name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //MediumImpl
