/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.PhotovoltaicModule;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.Enumerator;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Photovoltaic Module</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.PhotovoltaicModuleImpl#getCellType <em>Cell Type</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.PhotovoltaicModuleImpl#getNominalPower <em>Nominal Power</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.PhotovoltaicModuleImpl#getMppVoltage <em>Mpp Voltage</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.PhotovoltaicModuleImpl#getMppCurrent <em>Mpp Current</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.PhotovoltaicModuleImpl#getNominalEfficiency <em>Nominal Efficiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.PhotovoltaicModuleImpl#getModuleArea <em>Module Area</em>}</li>
 * </ul>
 *
 * @generated
 */
public class PhotovoltaicModuleImpl extends EnergyComponentImpl implements PhotovoltaicModule {
	/**
	 * The default value of the '{@link #getCellType() <em>Cell Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCellType()
	 * @generated
	 * @ordered
	 */
	protected static final Enumerator CELL_TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getCellType() <em>Cell Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCellType()
	 * @generated
	 * @ordered
	 */
	protected Enumerator cellType = CELL_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getNominalPower() <em>Nominal Power</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNominalPower()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity NOMINAL_POWER_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "W");

	/**
	 * The cached value of the '{@link #getNominalPower() <em>Nominal Power</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNominalPower()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity nominalPower = NOMINAL_POWER_EDEFAULT;

	/**
	 * The default value of the '{@link #getMppVoltage() <em>Mpp Voltage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMppVoltage()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity MPP_VOLTAGE_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "V");

	/**
	 * The cached value of the '{@link #getMppVoltage() <em>Mpp Voltage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMppVoltage()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity mppVoltage = MPP_VOLTAGE_EDEFAULT;

	/**
	 * The default value of the '{@link #getMppCurrent() <em>Mpp Current</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMppCurrent()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity MPP_CURRENT_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "A");

	/**
	 * The cached value of the '{@link #getMppCurrent() <em>Mpp Current</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMppCurrent()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity mppCurrent = MPP_CURRENT_EDEFAULT;

	/**
	 * The default value of the '{@link #getNominalEfficiency() <em>Nominal Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNominalEfficiency()
	 * @generated
	 * @ordered
	 */
	protected static final double NOMINAL_EFFICIENCY_EDEFAULT = 0.18;

	/**
	 * The cached value of the '{@link #getNominalEfficiency() <em>Nominal Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNominalEfficiency()
	 * @generated
	 * @ordered
	 */
	protected double nominalEfficiency = NOMINAL_EFFICIENCY_EDEFAULT;

	/**
	 * The default value of the '{@link #getModuleArea() <em>Module Area</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModuleArea()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity MODULE_AREA_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "m\u00b2");

	/**
	 * The cached value of the '{@link #getModuleArea() <em>Module Area</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModuleArea()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity moduleArea = MODULE_AREA_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PhotovoltaicModuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.PHOTOVOLTAIC_MODULE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Enumerator getCellType() {
		return cellType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setCellType(Enumerator newCellType) {
		Enumerator oldCellType = cellType;
		cellType = newCellType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.PHOTOVOLTAIC_MODULE__CELL_TYPE,
					oldCellType, cellType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getNominalPower() {
		return nominalPower;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setNominalPower(NullableQuantity newNominalPower) {
		NullableQuantity oldNominalPower = nominalPower;
		nominalPower = newNominalPower;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.PHOTOVOLTAIC_MODULE__NOMINAL_POWER,
					oldNominalPower, nominalPower));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getMppVoltage() {
		return mppVoltage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMppVoltage(NullableQuantity newMppVoltage) {
		NullableQuantity oldMppVoltage = mppVoltage;
		mppVoltage = newMppVoltage;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.PHOTOVOLTAIC_MODULE__MPP_VOLTAGE,
					oldMppVoltage, mppVoltage));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getMppCurrent() {
		return mppCurrent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMppCurrent(NullableQuantity newMppCurrent) {
		NullableQuantity oldMppCurrent = mppCurrent;
		mppCurrent = newMppCurrent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.PHOTOVOLTAIC_MODULE__MPP_CURRENT,
					oldMppCurrent, mppCurrent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getNominalEfficiency() {
		return nominalEfficiency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setNominalEfficiency(double newNominalEfficiency) {
		double oldNominalEfficiency = nominalEfficiency;
		nominalEfficiency = newNominalEfficiency;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.PHOTOVOLTAIC_MODULE__NOMINAL_EFFICIENCY,
					oldNominalEfficiency, nominalEfficiency));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getModuleArea() {
		return moduleArea;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setModuleArea(NullableQuantity newModuleArea) {
		NullableQuantity oldModuleArea = moduleArea;
		moduleArea = newModuleArea;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.PHOTOVOLTAIC_MODULE__MODULE_AREA,
					oldModuleArea, moduleArea));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.PHOTOVOLTAIC_MODULE__CELL_TYPE:
			return getCellType();
		case EnCompPackage.PHOTOVOLTAIC_MODULE__NOMINAL_POWER:
			return getNominalPower();
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MPP_VOLTAGE:
			return getMppVoltage();
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MPP_CURRENT:
			return getMppCurrent();
		case EnCompPackage.PHOTOVOLTAIC_MODULE__NOMINAL_EFFICIENCY:
			return getNominalEfficiency();
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MODULE_AREA:
			return getModuleArea();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.PHOTOVOLTAIC_MODULE__CELL_TYPE:
			setCellType((Enumerator) newValue);
			return;
		case EnCompPackage.PHOTOVOLTAIC_MODULE__NOMINAL_POWER:
			setNominalPower((NullableQuantity) newValue);
			return;
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MPP_VOLTAGE:
			setMppVoltage((NullableQuantity) newValue);
			return;
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MPP_CURRENT:
			setMppCurrent((NullableQuantity) newValue);
			return;
		case EnCompPackage.PHOTOVOLTAIC_MODULE__NOMINAL_EFFICIENCY:
			setNominalEfficiency((Double) newValue);
			return;
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MODULE_AREA:
			setModuleArea((NullableQuantity) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.PHOTOVOLTAIC_MODULE__CELL_TYPE:
			setCellType(CELL_TYPE_EDEFAULT);
			return;
		case EnCompPackage.PHOTOVOLTAIC_MODULE__NOMINAL_POWER:
			setNominalPower(NOMINAL_POWER_EDEFAULT);
			return;
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MPP_VOLTAGE:
			setMppVoltage(MPP_VOLTAGE_EDEFAULT);
			return;
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MPP_CURRENT:
			setMppCurrent(MPP_CURRENT_EDEFAULT);
			return;
		case EnCompPackage.PHOTOVOLTAIC_MODULE__NOMINAL_EFFICIENCY:
			setNominalEfficiency(NOMINAL_EFFICIENCY_EDEFAULT);
			return;
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MODULE_AREA:
			setModuleArea(MODULE_AREA_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.PHOTOVOLTAIC_MODULE__CELL_TYPE:
			return CELL_TYPE_EDEFAULT == null ? cellType != null : !CELL_TYPE_EDEFAULT.equals(cellType);
		case EnCompPackage.PHOTOVOLTAIC_MODULE__NOMINAL_POWER:
			return NOMINAL_POWER_EDEFAULT == null ? nominalPower != null : !NOMINAL_POWER_EDEFAULT.equals(nominalPower);
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MPP_VOLTAGE:
			return MPP_VOLTAGE_EDEFAULT == null ? mppVoltage != null : !MPP_VOLTAGE_EDEFAULT.equals(mppVoltage);
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MPP_CURRENT:
			return MPP_CURRENT_EDEFAULT == null ? mppCurrent != null : !MPP_CURRENT_EDEFAULT.equals(mppCurrent);
		case EnCompPackage.PHOTOVOLTAIC_MODULE__NOMINAL_EFFICIENCY:
			return nominalEfficiency != NOMINAL_EFFICIENCY_EDEFAULT;
		case EnCompPackage.PHOTOVOLTAIC_MODULE__MODULE_AREA:
			return MODULE_AREA_EDEFAULT == null ? moduleArea != null : !MODULE_AREA_EDEFAULT.equals(moduleArea);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (cellType: ");
		result.append(cellType);
		result.append(", nominalPower: ");
		result.append(nominalPower);
		result.append(", mppVoltage: ");
		result.append(mppVoltage);
		result.append(", mppCurrent: ");
		result.append(mppCurrent);
		result.append(", nominalEfficiency: ");
		result.append(nominalEfficiency);
		result.append(", moduleArea: ");
		result.append(moduleArea);
		result.append(')');
		return result.toString();
	}

} //PhotovoltaicModuleImpl
