/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.CollectorTypes;
import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.SolarThermalCollector;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Solar Thermal Collector</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.SolarThermalCollectorImpl#getCollectorType <em>Collector Type</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.SolarThermalCollectorImpl#getApertureArea <em>Aperture Area</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.SolarThermalCollectorImpl#getOpticalEfficiency <em>Optical Efficiency</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.SolarThermalCollectorImpl#getLinearHeatLossCoefficient <em>Linear Heat Loss Coefficient</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.SolarThermalCollectorImpl#getQuadraticalHeatLossCoefficient <em>Quadratical Heat Loss Coefficient</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SolarThermalCollectorImpl extends EnergyComponentImpl implements SolarThermalCollector {
	/**
	 * The default value of the '{@link #getCollectorType() <em>Collector Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCollectorType()
	 * @generated
	 * @ordered
	 */
	protected static final CollectorTypes COLLECTOR_TYPE_EDEFAULT = CollectorTypes.FLAT_PLANE_COLLECTOR;

	/**
	 * The cached value of the '{@link #getCollectorType() <em>Collector Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCollectorType()
	 * @generated
	 * @ordered
	 */
	protected CollectorTypes collectorType = COLLECTOR_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getApertureArea() <em>Aperture Area</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getApertureArea()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity APERTURE_AREA_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "m\u00b2");

	/**
	 * The cached value of the '{@link #getApertureArea() <em>Aperture Area</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getApertureArea()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity apertureArea = APERTURE_AREA_EDEFAULT;

	/**
	 * The default value of the '{@link #getOpticalEfficiency() <em>Optical Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOpticalEfficiency()
	 * @generated
	 * @ordered
	 */
	protected static final double OPTICAL_EFFICIENCY_EDEFAULT = 0.77;

	/**
	 * The cached value of the '{@link #getOpticalEfficiency() <em>Optical Efficiency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOpticalEfficiency()
	 * @generated
	 * @ordered
	 */
	protected double opticalEfficiency = OPTICAL_EFFICIENCY_EDEFAULT;

	/**
	 * The default value of the '{@link #getLinearHeatLossCoefficient() <em>Linear Heat Loss Coefficient</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinearHeatLossCoefficient()
	 * @generated
	 * @ordered
	 */
	protected static final double LINEAR_HEAT_LOSS_COEFFICIENT_EDEFAULT = 3.2;

	/**
	 * The cached value of the '{@link #getLinearHeatLossCoefficient() <em>Linear Heat Loss Coefficient</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinearHeatLossCoefficient()
	 * @generated
	 * @ordered
	 */
	protected double linearHeatLossCoefficient = LINEAR_HEAT_LOSS_COEFFICIENT_EDEFAULT;

	/**
	 * The default value of the '{@link #getQuadraticalHeatLossCoefficient() <em>Quadratical Heat Loss Coefficient</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getQuadraticalHeatLossCoefficient()
	 * @generated
	 * @ordered
	 */
	protected static final double QUADRATICAL_HEAT_LOSS_COEFFICIENT_EDEFAULT = 0.01;

	/**
	 * The cached value of the '{@link #getQuadraticalHeatLossCoefficient() <em>Quadratical Heat Loss Coefficient</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getQuadraticalHeatLossCoefficient()
	 * @generated
	 * @ordered
	 */
	protected double quadraticalHeatLossCoefficient = QUADRATICAL_HEAT_LOSS_COEFFICIENT_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SolarThermalCollectorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.SOLAR_THERMAL_COLLECTOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public CollectorTypes getCollectorType() {
		return collectorType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setCollectorType(CollectorTypes newCollectorType) {
		CollectorTypes oldCollectorType = collectorType;
		collectorType = newCollectorType == null ? COLLECTOR_TYPE_EDEFAULT : newCollectorType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.SOLAR_THERMAL_COLLECTOR__COLLECTOR_TYPE,
					oldCollectorType, collectorType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getApertureArea() {
		return apertureArea;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setApertureArea(NullableQuantity newApertureArea) {
		NullableQuantity oldApertureArea = apertureArea;
		apertureArea = newApertureArea;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.SOLAR_THERMAL_COLLECTOR__APERTURE_AREA,
					oldApertureArea, apertureArea));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getOpticalEfficiency() {
		return opticalEfficiency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setOpticalEfficiency(double newOpticalEfficiency) {
		double oldOpticalEfficiency = opticalEfficiency;
		opticalEfficiency = newOpticalEfficiency;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.SOLAR_THERMAL_COLLECTOR__OPTICAL_EFFICIENCY, oldOpticalEfficiency,
					opticalEfficiency));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getLinearHeatLossCoefficient() {
		return linearHeatLossCoefficient;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setLinearHeatLossCoefficient(double newLinearHeatLossCoefficient) {
		double oldLinearHeatLossCoefficient = linearHeatLossCoefficient;
		linearHeatLossCoefficient = newLinearHeatLossCoefficient;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.SOLAR_THERMAL_COLLECTOR__LINEAR_HEAT_LOSS_COEFFICIENT, oldLinearHeatLossCoefficient,
					linearHeatLossCoefficient));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getQuadraticalHeatLossCoefficient() {
		return quadraticalHeatLossCoefficient;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setQuadraticalHeatLossCoefficient(double newQuadraticalHeatLossCoefficient) {
		double oldQuadraticalHeatLossCoefficient = quadraticalHeatLossCoefficient;
		quadraticalHeatLossCoefficient = newQuadraticalHeatLossCoefficient;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.SOLAR_THERMAL_COLLECTOR__QUADRATICAL_HEAT_LOSS_COEFFICIENT,
					oldQuadraticalHeatLossCoefficient, quadraticalHeatLossCoefficient));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__COLLECTOR_TYPE:
			return getCollectorType();
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__APERTURE_AREA:
			return getApertureArea();
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__OPTICAL_EFFICIENCY:
			return getOpticalEfficiency();
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__LINEAR_HEAT_LOSS_COEFFICIENT:
			return getLinearHeatLossCoefficient();
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__QUADRATICAL_HEAT_LOSS_COEFFICIENT:
			return getQuadraticalHeatLossCoefficient();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__COLLECTOR_TYPE:
			setCollectorType((CollectorTypes) newValue);
			return;
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__APERTURE_AREA:
			setApertureArea((NullableQuantity) newValue);
			return;
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__OPTICAL_EFFICIENCY:
			setOpticalEfficiency((Double) newValue);
			return;
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__LINEAR_HEAT_LOSS_COEFFICIENT:
			setLinearHeatLossCoefficient((Double) newValue);
			return;
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__QUADRATICAL_HEAT_LOSS_COEFFICIENT:
			setQuadraticalHeatLossCoefficient((Double) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__COLLECTOR_TYPE:
			setCollectorType(COLLECTOR_TYPE_EDEFAULT);
			return;
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__APERTURE_AREA:
			setApertureArea(APERTURE_AREA_EDEFAULT);
			return;
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__OPTICAL_EFFICIENCY:
			setOpticalEfficiency(OPTICAL_EFFICIENCY_EDEFAULT);
			return;
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__LINEAR_HEAT_LOSS_COEFFICIENT:
			setLinearHeatLossCoefficient(LINEAR_HEAT_LOSS_COEFFICIENT_EDEFAULT);
			return;
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__QUADRATICAL_HEAT_LOSS_COEFFICIENT:
			setQuadraticalHeatLossCoefficient(QUADRATICAL_HEAT_LOSS_COEFFICIENT_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__COLLECTOR_TYPE:
			return collectorType != COLLECTOR_TYPE_EDEFAULT;
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__APERTURE_AREA:
			return APERTURE_AREA_EDEFAULT == null ? apertureArea != null : !APERTURE_AREA_EDEFAULT.equals(apertureArea);
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__OPTICAL_EFFICIENCY:
			return opticalEfficiency != OPTICAL_EFFICIENCY_EDEFAULT;
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__LINEAR_HEAT_LOSS_COEFFICIENT:
			return linearHeatLossCoefficient != LINEAR_HEAT_LOSS_COEFFICIENT_EDEFAULT;
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR__QUADRATICAL_HEAT_LOSS_COEFFICIENT:
			return quadraticalHeatLossCoefficient != QUADRATICAL_HEAT_LOSS_COEFFICIENT_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (collectorType: ");
		result.append(collectorType);
		result.append(", apertureArea: ");
		result.append(apertureArea);
		result.append(", opticalEfficiency: ");
		result.append(opticalEfficiency);
		result.append(", linearHeatLossCoefficient: ");
		result.append(linearHeatLossCoefficient);
		result.append(", quadraticalHeatLossCoefficient: ");
		result.append(quadraticalHeatLossCoefficient);
		result.append(')');
		return result.toString();
	}

} //SolarThermalCollectorImpl
