/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.FuelTypes;
import de.hftstuttgart.energycomponents.ThermalEnergyDevice;

import de.hftstuttgart.units.NullableQuantity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Thermal Energy Device</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ThermalEnergyDeviceImpl#getInstalledThermalPower <em>Installed Thermal Power</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ThermalEnergyDeviceImpl#getModulationRange <em>Modulation Range</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ThermalEnergyDeviceImpl#getFuel <em>Fuel</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class ThermalEnergyDeviceImpl extends EnergyComponentImpl implements ThermalEnergyDevice {
	/**
	 * The default value of the '{@link #getInstalledThermalPower() <em>Installed Thermal Power</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInstalledThermalPower()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity INSTALLED_THERMAL_POWER_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "kW");

	/**
	 * The cached value of the '{@link #getInstalledThermalPower() <em>Installed Thermal Power</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInstalledThermalPower()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity installedThermalPower = INSTALLED_THERMAL_POWER_EDEFAULT;

	/**
	 * The default value of the '{@link #getModulationRange() <em>Modulation Range</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModulationRange()
	 * @generated
	 * @ordered
	 */
	protected static final double MODULATION_RANGE_EDEFAULT = 0.5;

	/**
	 * The cached value of the '{@link #getModulationRange() <em>Modulation Range</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModulationRange()
	 * @generated
	 * @ordered
	 */
	protected double modulationRange = MODULATION_RANGE_EDEFAULT;

	/**
	 * The default value of the '{@link #getFuel() <em>Fuel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFuel()
	 * @generated
	 * @ordered
	 */
	protected static final FuelTypes FUEL_EDEFAULT = FuelTypes.NATURAL_GAS;

	/**
	 * The cached value of the '{@link #getFuel() <em>Fuel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFuel()
	 * @generated
	 * @ordered
	 */
	protected FuelTypes fuel = FUEL_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ThermalEnergyDeviceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.THERMAL_ENERGY_DEVICE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getInstalledThermalPower() {
		return installedThermalPower;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setInstalledThermalPower(NullableQuantity newInstalledThermalPower) {
		NullableQuantity oldInstalledThermalPower = installedThermalPower;
		installedThermalPower = newInstalledThermalPower;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					EnCompPackage.THERMAL_ENERGY_DEVICE__INSTALLED_THERMAL_POWER, oldInstalledThermalPower,
					installedThermalPower));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getModulationRange() {
		return modulationRange;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setModulationRange(double newModulationRange) {
		double oldModulationRange = modulationRange;
		modulationRange = newModulationRange;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.THERMAL_ENERGY_DEVICE__MODULATION_RANGE,
					oldModulationRange, modulationRange));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public FuelTypes getFuel() {
		return fuel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setFuel(FuelTypes newFuel) {
		FuelTypes oldFuel = fuel;
		fuel = newFuel == null ? FUEL_EDEFAULT : newFuel;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.THERMAL_ENERGY_DEVICE__FUEL, oldFuel,
					fuel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.THERMAL_ENERGY_DEVICE__INSTALLED_THERMAL_POWER:
			return getInstalledThermalPower();
		case EnCompPackage.THERMAL_ENERGY_DEVICE__MODULATION_RANGE:
			return getModulationRange();
		case EnCompPackage.THERMAL_ENERGY_DEVICE__FUEL:
			return getFuel();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.THERMAL_ENERGY_DEVICE__INSTALLED_THERMAL_POWER:
			setInstalledThermalPower((NullableQuantity) newValue);
			return;
		case EnCompPackage.THERMAL_ENERGY_DEVICE__MODULATION_RANGE:
			setModulationRange((Double) newValue);
			return;
		case EnCompPackage.THERMAL_ENERGY_DEVICE__FUEL:
			setFuel((FuelTypes) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.THERMAL_ENERGY_DEVICE__INSTALLED_THERMAL_POWER:
			setInstalledThermalPower(INSTALLED_THERMAL_POWER_EDEFAULT);
			return;
		case EnCompPackage.THERMAL_ENERGY_DEVICE__MODULATION_RANGE:
			setModulationRange(MODULATION_RANGE_EDEFAULT);
			return;
		case EnCompPackage.THERMAL_ENERGY_DEVICE__FUEL:
			setFuel(FUEL_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.THERMAL_ENERGY_DEVICE__INSTALLED_THERMAL_POWER:
			return INSTALLED_THERMAL_POWER_EDEFAULT == null ? installedThermalPower != null
					: !INSTALLED_THERMAL_POWER_EDEFAULT.equals(installedThermalPower);
		case EnCompPackage.THERMAL_ENERGY_DEVICE__MODULATION_RANGE:
			return modulationRange != MODULATION_RANGE_EDEFAULT;
		case EnCompPackage.THERMAL_ENERGY_DEVICE__FUEL:
			return fuel != FUEL_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (installedThermalPower: ");
		result.append(installedThermalPower);
		result.append(", modulationRange: ");
		result.append(modulationRange);
		result.append(", fuel: ");
		result.append(fuel);
		result.append(')');
		return result.toString();
	}

} //ThermalEnergyDeviceImpl
