/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.Material;
import de.hftstuttgart.energycomponents.Medium;
import de.hftstuttgart.energycomponents.ThermalStorage;
import de.hftstuttgart.energycomponents.ThermalStorageTypes;

import de.hftstuttgart.units.NullableQuantity;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Thermal Storage</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ThermalStorageImpl#getVolume <em>Volume</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ThermalStorageImpl#getThermalStorageType <em>Thermal Storage Type</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ThermalStorageImpl#getMaxTemp <em>Max Temp</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ThermalStorageImpl#getTankThickness <em>Tank Thickness</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ThermalStorageImpl#getInsulationThickness <em>Insulation Thickness</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ThermalStorageImpl#getUsesMedium <em>Uses Medium</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ThermalStorageImpl#getInsulationMaterial <em>Insulation Material</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ThermalStorageImpl#getHeight <em>Height</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.ThermalStorageImpl#getTankMaterial <em>Tank Material</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ThermalStorageImpl extends EnergyComponentImpl implements ThermalStorage {
	/**
	 * The default value of the '{@link #getVolume() <em>Volume</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVolume()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity VOLUME_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "5 m\u00b3");

	/**
	 * The cached value of the '{@link #getVolume() <em>Volume</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVolume()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity volume = VOLUME_EDEFAULT;

	/**
	 * The default value of the '{@link #getThermalStorageType() <em>Thermal Storage Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getThermalStorageType()
	 * @generated
	 * @ordered
	 */
	protected static final ThermalStorageTypes THERMAL_STORAGE_TYPE_EDEFAULT = ThermalStorageTypes.SENSIBLE;

	/**
	 * The cached value of the '{@link #getThermalStorageType() <em>Thermal Storage Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getThermalStorageType()
	 * @generated
	 * @ordered
	 */
	protected ThermalStorageTypes thermalStorageType = THERMAL_STORAGE_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getMaxTemp() <em>Max Temp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxTemp()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity MAX_TEMP_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "80 \u00b0C");

	/**
	 * The cached value of the '{@link #getMaxTemp() <em>Max Temp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxTemp()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity maxTemp = MAX_TEMP_EDEFAULT;

	/**
	 * The default value of the '{@link #getTankThickness() <em>Tank Thickness</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTankThickness()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity TANK_THICKNESS_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "10 mm ");

	/**
	 * The cached value of the '{@link #getTankThickness() <em>Tank Thickness</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTankThickness()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity tankThickness = TANK_THICKNESS_EDEFAULT;

	/**
	 * The default value of the '{@link #getInsulationThickness() <em>Insulation Thickness</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInsulationThickness()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity INSULATION_THICKNESS_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "100 mm");

	/**
	 * The cached value of the '{@link #getInsulationThickness() <em>Insulation Thickness</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInsulationThickness()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity insulationThickness = INSULATION_THICKNESS_EDEFAULT;

	/**
	 * The cached value of the '{@link #getUsesMedium() <em>Uses Medium</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUsesMedium()
	 * @generated
	 * @ordered
	 */
	protected Medium usesMedium;

	/**
	 * The cached value of the '{@link #getInsulationMaterial() <em>Insulation Material</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInsulationMaterial()
	 * @generated
	 * @ordered
	 */
	protected Material insulationMaterial;

	/**
	 * The default value of the '{@link #getHeight() <em>Height</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeight()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity HEIGHT_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "2 m");

	/**
	 * The cached value of the '{@link #getHeight() <em>Height</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeight()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity height = HEIGHT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getTankMaterial() <em>Tank Material</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTankMaterial()
	 * @generated
	 * @ordered
	 */
	protected Material tankMaterial;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ThermalStorageImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.THERMAL_STORAGE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getVolume() {
		return volume;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setVolume(NullableQuantity newVolume) {
		NullableQuantity oldVolume = volume;
		volume = newVolume;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.THERMAL_STORAGE__VOLUME, oldVolume,
					volume));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ThermalStorageTypes getThermalStorageType() {
		return thermalStorageType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setThermalStorageType(ThermalStorageTypes newThermalStorageType) {
		ThermalStorageTypes oldThermalStorageType = thermalStorageType;
		thermalStorageType = newThermalStorageType == null ? THERMAL_STORAGE_TYPE_EDEFAULT : newThermalStorageType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.THERMAL_STORAGE__THERMAL_STORAGE_TYPE,
					oldThermalStorageType, thermalStorageType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getMaxTemp() {
		return maxTemp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMaxTemp(NullableQuantity newMaxTemp) {
		NullableQuantity oldMaxTemp = maxTemp;
		maxTemp = newMaxTemp;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.THERMAL_STORAGE__MAX_TEMP, oldMaxTemp,
					maxTemp));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getTankThickness() {
		return tankThickness;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setTankThickness(NullableQuantity newTankThickness) {
		NullableQuantity oldTankThickness = tankThickness;
		tankThickness = newTankThickness;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.THERMAL_STORAGE__TANK_THICKNESS,
					oldTankThickness, tankThickness));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getInsulationThickness() {
		return insulationThickness;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setInsulationThickness(NullableQuantity newInsulationThickness) {
		NullableQuantity oldInsulationThickness = insulationThickness;
		insulationThickness = newInsulationThickness;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.THERMAL_STORAGE__INSULATION_THICKNESS,
					oldInsulationThickness, insulationThickness));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Medium getUsesMedium() {
		if (usesMedium != null && usesMedium.eIsProxy()) {
			InternalEObject oldUsesMedium = (InternalEObject) usesMedium;
			usesMedium = (Medium) eResolveProxy(oldUsesMedium);
			if (usesMedium != oldUsesMedium) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE,
							EnCompPackage.THERMAL_STORAGE__USES_MEDIUM, oldUsesMedium, usesMedium));
			}
		}
		return usesMedium;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Medium basicGetUsesMedium() {
		return usesMedium;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setUsesMedium(Medium newUsesMedium) {
		Medium oldUsesMedium = usesMedium;
		usesMedium = newUsesMedium;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.THERMAL_STORAGE__USES_MEDIUM,
					oldUsesMedium, usesMedium));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Material getInsulationMaterial() {
		if (insulationMaterial != null && insulationMaterial.eIsProxy()) {
			InternalEObject oldInsulationMaterial = (InternalEObject) insulationMaterial;
			insulationMaterial = (Material) eResolveProxy(oldInsulationMaterial);
			if (insulationMaterial != oldInsulationMaterial) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE,
							EnCompPackage.THERMAL_STORAGE__INSULATION_MATERIAL, oldInsulationMaterial,
							insulationMaterial));
			}
		}
		return insulationMaterial;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Material basicGetInsulationMaterial() {
		return insulationMaterial;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setInsulationMaterial(Material newInsulationMaterial) {
		Material oldInsulationMaterial = insulationMaterial;
		insulationMaterial = newInsulationMaterial;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.THERMAL_STORAGE__INSULATION_MATERIAL,
					oldInsulationMaterial, insulationMaterial));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getHeight() {
		return height;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setHeight(NullableQuantity newHeight) {
		NullableQuantity oldHeight = height;
		height = newHeight;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.THERMAL_STORAGE__HEIGHT, oldHeight,
					height));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Material getTankMaterial() {
		if (tankMaterial != null && tankMaterial.eIsProxy()) {
			InternalEObject oldTankMaterial = (InternalEObject) tankMaterial;
			tankMaterial = (Material) eResolveProxy(oldTankMaterial);
			if (tankMaterial != oldTankMaterial) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE,
							EnCompPackage.THERMAL_STORAGE__TANK_MATERIAL, oldTankMaterial, tankMaterial));
			}
		}
		return tankMaterial;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Material basicGetTankMaterial() {
		return tankMaterial;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setTankMaterial(Material newTankMaterial) {
		Material oldTankMaterial = tankMaterial;
		tankMaterial = newTankMaterial;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.THERMAL_STORAGE__TANK_MATERIAL,
					oldTankMaterial, tankMaterial));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.THERMAL_STORAGE__VOLUME:
			return getVolume();
		case EnCompPackage.THERMAL_STORAGE__THERMAL_STORAGE_TYPE:
			return getThermalStorageType();
		case EnCompPackage.THERMAL_STORAGE__MAX_TEMP:
			return getMaxTemp();
		case EnCompPackage.THERMAL_STORAGE__TANK_THICKNESS:
			return getTankThickness();
		case EnCompPackage.THERMAL_STORAGE__INSULATION_THICKNESS:
			return getInsulationThickness();
		case EnCompPackage.THERMAL_STORAGE__USES_MEDIUM:
			if (resolve)
				return getUsesMedium();
			return basicGetUsesMedium();
		case EnCompPackage.THERMAL_STORAGE__INSULATION_MATERIAL:
			if (resolve)
				return getInsulationMaterial();
			return basicGetInsulationMaterial();
		case EnCompPackage.THERMAL_STORAGE__HEIGHT:
			return getHeight();
		case EnCompPackage.THERMAL_STORAGE__TANK_MATERIAL:
			if (resolve)
				return getTankMaterial();
			return basicGetTankMaterial();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.THERMAL_STORAGE__VOLUME:
			setVolume((NullableQuantity) newValue);
			return;
		case EnCompPackage.THERMAL_STORAGE__THERMAL_STORAGE_TYPE:
			setThermalStorageType((ThermalStorageTypes) newValue);
			return;
		case EnCompPackage.THERMAL_STORAGE__MAX_TEMP:
			setMaxTemp((NullableQuantity) newValue);
			return;
		case EnCompPackage.THERMAL_STORAGE__TANK_THICKNESS:
			setTankThickness((NullableQuantity) newValue);
			return;
		case EnCompPackage.THERMAL_STORAGE__INSULATION_THICKNESS:
			setInsulationThickness((NullableQuantity) newValue);
			return;
		case EnCompPackage.THERMAL_STORAGE__USES_MEDIUM:
			setUsesMedium((Medium) newValue);
			return;
		case EnCompPackage.THERMAL_STORAGE__INSULATION_MATERIAL:
			setInsulationMaterial((Material) newValue);
			return;
		case EnCompPackage.THERMAL_STORAGE__HEIGHT:
			setHeight((NullableQuantity) newValue);
			return;
		case EnCompPackage.THERMAL_STORAGE__TANK_MATERIAL:
			setTankMaterial((Material) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.THERMAL_STORAGE__VOLUME:
			setVolume(VOLUME_EDEFAULT);
			return;
		case EnCompPackage.THERMAL_STORAGE__THERMAL_STORAGE_TYPE:
			setThermalStorageType(THERMAL_STORAGE_TYPE_EDEFAULT);
			return;
		case EnCompPackage.THERMAL_STORAGE__MAX_TEMP:
			setMaxTemp(MAX_TEMP_EDEFAULT);
			return;
		case EnCompPackage.THERMAL_STORAGE__TANK_THICKNESS:
			setTankThickness(TANK_THICKNESS_EDEFAULT);
			return;
		case EnCompPackage.THERMAL_STORAGE__INSULATION_THICKNESS:
			setInsulationThickness(INSULATION_THICKNESS_EDEFAULT);
			return;
		case EnCompPackage.THERMAL_STORAGE__USES_MEDIUM:
			setUsesMedium((Medium) null);
			return;
		case EnCompPackage.THERMAL_STORAGE__INSULATION_MATERIAL:
			setInsulationMaterial((Material) null);
			return;
		case EnCompPackage.THERMAL_STORAGE__HEIGHT:
			setHeight(HEIGHT_EDEFAULT);
			return;
		case EnCompPackage.THERMAL_STORAGE__TANK_MATERIAL:
			setTankMaterial((Material) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.THERMAL_STORAGE__VOLUME:
			return VOLUME_EDEFAULT == null ? volume != null : !VOLUME_EDEFAULT.equals(volume);
		case EnCompPackage.THERMAL_STORAGE__THERMAL_STORAGE_TYPE:
			return thermalStorageType != THERMAL_STORAGE_TYPE_EDEFAULT;
		case EnCompPackage.THERMAL_STORAGE__MAX_TEMP:
			return MAX_TEMP_EDEFAULT == null ? maxTemp != null : !MAX_TEMP_EDEFAULT.equals(maxTemp);
		case EnCompPackage.THERMAL_STORAGE__TANK_THICKNESS:
			return TANK_THICKNESS_EDEFAULT == null ? tankThickness != null
					: !TANK_THICKNESS_EDEFAULT.equals(tankThickness);
		case EnCompPackage.THERMAL_STORAGE__INSULATION_THICKNESS:
			return INSULATION_THICKNESS_EDEFAULT == null ? insulationThickness != null
					: !INSULATION_THICKNESS_EDEFAULT.equals(insulationThickness);
		case EnCompPackage.THERMAL_STORAGE__USES_MEDIUM:
			return usesMedium != null;
		case EnCompPackage.THERMAL_STORAGE__INSULATION_MATERIAL:
			return insulationMaterial != null;
		case EnCompPackage.THERMAL_STORAGE__HEIGHT:
			return HEIGHT_EDEFAULT == null ? height != null : !HEIGHT_EDEFAULT.equals(height);
		case EnCompPackage.THERMAL_STORAGE__TANK_MATERIAL:
			return tankMaterial != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (volume: ");
		result.append(volume);
		result.append(", thermalStorageType: ");
		result.append(thermalStorageType);
		result.append(", maxTemp: ");
		result.append(maxTemp);
		result.append(", tankThickness: ");
		result.append(tankThickness);
		result.append(", insulationThickness: ");
		result.append(insulationThickness);
		result.append(", height: ");
		result.append(height);
		result.append(')');
		return result.toString();
	}

} //ThermalStorageImpl
