/**
 */
package de.hftstuttgart.energycomponents.util;

import de.hftstuttgart.energycomponents.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see de.hftstuttgart.energycomponents.EnCompPackage
 * @generated
 */
public class EnCompAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static EnCompPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EnCompAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = EnCompPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject) object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnCompSwitch<Adapter> modelSwitch = new EnCompSwitch<Adapter>() {
		@Override
		public Adapter caseEnergyComponent(EnergyComponent object) {
			return createEnergyComponentAdapter();
		}

		@Override
		public Adapter caseEnergyComponentsCatalog(EnergyComponentsCatalog object) {
			return createEnergyComponentsCatalogAdapter();
		}

		@Override
		public Adapter caseThermalStorage(ThermalStorage object) {
			return createThermalStorageAdapter();
		}

		@Override
		public Adapter caseElectricalStorage(ElectricalStorage object) {
			return createElectricalStorageAdapter();
		}

		@Override
		public Adapter caseCombinedHeatPower(CombinedHeatPower object) {
			return createCombinedHeatPowerAdapter();
		}

		@Override
		public Adapter caseHeatPump(HeatPump object) {
			return createHeatPumpAdapter();
		}

		@Override
		public Adapter caseBoiler(Boiler object) {
			return createBoilerAdapter();
		}

		@Override
		public Adapter caseSolarThermalCollector(SolarThermalCollector object) {
			return createSolarThermalCollectorAdapter();
		}

		@Override
		public Adapter caseElectrolyzer(Electrolyzer object) {
			return createElectrolyzerAdapter();
		}

		@Override
		public Adapter caseThermalEnergyDevice(ThermalEnergyDevice object) {
			return createThermalEnergyDeviceAdapter();
		}

		@Override
		public Adapter caseHydrogenCompressor(HydrogenCompressor object) {
			return createHydrogenCompressorAdapter();
		}

		@Override
		public Adapter caseHydrogenStorage(HydrogenStorage object) {
			return createHydrogenStorageAdapter();
		}

		@Override
		public Adapter caseFuelCell(FuelCell object) {
			return createFuelCellAdapter();
		}

		@Override
		public Adapter caseEnergyCarrier(EnergyCarrier object) {
			return createEnergyCarrierAdapter();
		}

		@Override
		public Adapter caseFossilFuel(FossilFuel object) {
			return createFossilFuelAdapter();
		}

		@Override
		public Adapter caseHydrogen(Hydrogen object) {
			return createHydrogenAdapter();
		}

		@Override
		public Adapter caseElectricity(Electricity object) {
			return createElectricityAdapter();
		}

		@Override
		public Adapter caseBioFuel(BioFuel object) {
			return createBioFuelAdapter();
		}

		@Override
		public Adapter caseFuel(Fuel object) {
			return createFuelAdapter();
		}

		@Override
		public Adapter caseWindTurbine(WindTurbine object) {
			return createWindTurbineAdapter();
		}

		@Override
		public Adapter casePhotovoltaicModule(PhotovoltaicModule object) {
			return createPhotovoltaicModuleAdapter();
		}

		@Override
		public Adapter caseInverter(Inverter object) {
			return createInverterAdapter();
		}

		@Override
		public Adapter caseHeatExchanger(HeatExchanger object) {
			return createHeatExchangerAdapter();
		}

		@Override
		public Adapter caseGeothermalHeatExchanger(GeothermalHeatExchanger object) {
			return createGeothermalHeatExchangerAdapter();
		}

		@Override
		public Adapter caseMedium(Medium object) {
			return createMediumAdapter();
		}

		@Override
		public Adapter caseLinearFunction(LinearFunction object) {
			return createLinearFunctionAdapter();
		}

		@Override
		public Adapter caseDataPoint(DataPoint object) {
			return createDataPointAdapter();
		}

		@Override
		public Adapter caseTableFunction(TableFunction object) {
			return createTableFunctionAdapter();
		}

		@Override
		public Adapter caseExponentialFunction(ExponentialFunction object) {
			return createExponentialFunctionAdapter();
		}

		@Override
		public Adapter caseCharacteristic(Characteristic object) {
			return createCharacteristicAdapter();
		}

		@Override
		public Adapter caseTableCharacteristic(TableCharacteristic object) {
			return createTableCharacteristicAdapter();
		}

		@Override
		public Adapter caseLinearCharacteristic(LinearCharacteristic object) {
			return createLinearCharacteristicAdapter();
		}

		@Override
		public Adapter caseExponentionalCharacteristic(ExponentionalCharacteristic object) {
			return createExponentionalCharacteristicAdapter();
		}

		@Override
		public Adapter caseManufacturer(Manufacturer object) {
			return createManufacturerAdapter();
		}

		@Override
		public Adapter casePolynomialCharacteristic(PolynomialCharacteristic object) {
			return createPolynomialCharacteristicAdapter();
		}

		@Override
		public Adapter casePolynomialFunction(PolynomialFunction object) {
			return createPolynomialFunctionAdapter();
		}

		@Override
		public Adapter caseMaterial(Material object) {
			return createMaterialAdapter();
		}

		@Override
		public Adapter caseEnergyComponentsCostCatalog(EnergyComponentsCostCatalog object) {
			return createEnergyComponentsCostCatalogAdapter();
		}

		@Override
		public Adapter caseCost(Cost object) {
			return createCostAdapter();
		}

		@Override
		public Adapter casePowerCharacteristic(PowerCharacteristic object) {
			return createPowerCharacteristicAdapter();
		}

		@Override
		public Adapter casePowerFunction(PowerFunction object) {
			return createPowerFunctionAdapter();
		}

		@Override
		public Adapter defaultCase(EObject object) {
			return createEObjectAdapter();
		}
	};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject) target);
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.EnergyComponent <em>Energy Component</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.EnergyComponent
	 * @generated
	 */
	public Adapter createEnergyComponentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog <em>Energy Components Catalog</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog
	 * @generated
	 */
	public Adapter createEnergyComponentsCatalogAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.ThermalStorage <em>Thermal Storage</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.ThermalStorage
	 * @generated
	 */
	public Adapter createThermalStorageAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.ElectricalStorage <em>Electrical Storage</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.ElectricalStorage
	 * @generated
	 */
	public Adapter createElectricalStorageAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.CombinedHeatPower <em>Combined Heat Power</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.CombinedHeatPower
	 * @generated
	 */
	public Adapter createCombinedHeatPowerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.HeatPump <em>Heat Pump</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.HeatPump
	 * @generated
	 */
	public Adapter createHeatPumpAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.Boiler <em>Boiler</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.Boiler
	 * @generated
	 */
	public Adapter createBoilerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.SolarThermalCollector <em>Solar Thermal Collector</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.SolarThermalCollector
	 * @generated
	 */
	public Adapter createSolarThermalCollectorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.Electrolyzer <em>Electrolyzer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.Electrolyzer
	 * @generated
	 */
	public Adapter createElectrolyzerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.ThermalEnergyDevice <em>Thermal Energy Device</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.ThermalEnergyDevice
	 * @generated
	 */
	public Adapter createThermalEnergyDeviceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.HydrogenCompressor <em>Hydrogen Compressor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.HydrogenCompressor
	 * @generated
	 */
	public Adapter createHydrogenCompressorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.HydrogenStorage <em>Hydrogen Storage</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.HydrogenStorage
	 * @generated
	 */
	public Adapter createHydrogenStorageAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.FuelCell <em>Fuel Cell</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.FuelCell
	 * @generated
	 */
	public Adapter createFuelCellAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.EnergyCarrier <em>Energy Carrier</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.EnergyCarrier
	 * @generated
	 */
	public Adapter createEnergyCarrierAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.FossilFuel <em>Fossil Fuel</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.FossilFuel
	 * @generated
	 */
	public Adapter createFossilFuelAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.Hydrogen <em>Hydrogen</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.Hydrogen
	 * @generated
	 */
	public Adapter createHydrogenAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.Electricity <em>Electricity</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.Electricity
	 * @generated
	 */
	public Adapter createElectricityAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.BioFuel <em>Bio Fuel</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.BioFuel
	 * @generated
	 */
	public Adapter createBioFuelAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.Fuel <em>Fuel</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.Fuel
	 * @generated
	 */
	public Adapter createFuelAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.WindTurbine <em>Wind Turbine</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.WindTurbine
	 * @generated
	 */
	public Adapter createWindTurbineAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule <em>Photovoltaic Module</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.PhotovoltaicModule
	 * @generated
	 */
	public Adapter createPhotovoltaicModuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.Inverter <em>Inverter</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.Inverter
	 * @generated
	 */
	public Adapter createInverterAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.HeatExchanger <em>Heat Exchanger</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.HeatExchanger
	 * @generated
	 */
	public Adapter createHeatExchangerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.GeothermalHeatExchanger <em>Geothermal Heat Exchanger</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.GeothermalHeatExchanger
	 * @generated
	 */
	public Adapter createGeothermalHeatExchangerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.Medium <em>Medium</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.Medium
	 * @generated
	 */
	public Adapter createMediumAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.LinearFunction <em>Linear Function</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.LinearFunction
	 * @generated
	 */
	public Adapter createLinearFunctionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.DataPoint <em>Data Point</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.DataPoint
	 * @generated
	 */
	public Adapter createDataPointAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.TableFunction <em>Table Function</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.TableFunction
	 * @generated
	 */
	public Adapter createTableFunctionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.ExponentialFunction <em>Exponential Function</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.ExponentialFunction
	 * @generated
	 */
	public Adapter createExponentialFunctionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.Characteristic <em>Characteristic</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.Characteristic
	 * @generated
	 */
	public Adapter createCharacteristicAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.TableCharacteristic <em>Table Characteristic</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.TableCharacteristic
	 * @generated
	 */
	public Adapter createTableCharacteristicAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.LinearCharacteristic <em>Linear Characteristic</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.LinearCharacteristic
	 * @generated
	 */
	public Adapter createLinearCharacteristicAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.ExponentionalCharacteristic <em>Exponentional Characteristic</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.ExponentionalCharacteristic
	 * @generated
	 */
	public Adapter createExponentionalCharacteristicAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.Manufacturer <em>Manufacturer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.Manufacturer
	 * @generated
	 */
	public Adapter createManufacturerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.PolynomialCharacteristic <em>Polynomial Characteristic</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.PolynomialCharacteristic
	 * @generated
	 */
	public Adapter createPolynomialCharacteristicAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.PolynomialFunction <em>Polynomial Function</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.PolynomialFunction
	 * @generated
	 */
	public Adapter createPolynomialFunctionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.Material <em>Material</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.Material
	 * @generated
	 */
	public Adapter createMaterialAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog <em>Energy Components Cost Catalog</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog
	 * @generated
	 */
	public Adapter createEnergyComponentsCostCatalogAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.Cost <em>Cost</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.Cost
	 * @generated
	 */
	public Adapter createCostAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.PowerCharacteristic <em>Power Characteristic</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.PowerCharacteristic
	 * @generated
	 */
	public Adapter createPowerCharacteristicAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.hftstuttgart.energycomponents.PowerFunction <em>Power Function</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.hftstuttgart.energycomponents.PowerFunction
	 * @generated
	 */
	public Adapter createPowerFunctionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //EnCompAdapterFactory
