/**
 */
package de.hftstuttgart.energycomponents.util;

import de.hftstuttgart.energycomponents.*;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see de.hftstuttgart.energycomponents.EnCompPackage
 * @generated
 */
public class EnCompSwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static EnCompPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EnCompSwitch() {
		if (modelPackage == null) {
			modelPackage = EnCompPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
		case EnCompPackage.ENERGY_COMPONENT: {
			EnergyComponent energyComponent = (EnergyComponent) theEObject;
			T result = caseEnergyComponent(energyComponent);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.ENERGY_COMPONENTS_CATALOG: {
			EnergyComponentsCatalog energyComponentsCatalog = (EnergyComponentsCatalog) theEObject;
			T result = caseEnergyComponentsCatalog(energyComponentsCatalog);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.THERMAL_STORAGE: {
			ThermalStorage thermalStorage = (ThermalStorage) theEObject;
			T result = caseThermalStorage(thermalStorage);
			if (result == null)
				result = caseEnergyComponent(thermalStorage);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.ELECTRICAL_STORAGE: {
			ElectricalStorage electricalStorage = (ElectricalStorage) theEObject;
			T result = caseElectricalStorage(electricalStorage);
			if (result == null)
				result = caseEnergyComponent(electricalStorage);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.COMBINED_HEAT_POWER: {
			CombinedHeatPower combinedHeatPower = (CombinedHeatPower) theEObject;
			T result = caseCombinedHeatPower(combinedHeatPower);
			if (result == null)
				result = caseThermalEnergyDevice(combinedHeatPower);
			if (result == null)
				result = caseEnergyComponent(combinedHeatPower);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.HEAT_PUMP: {
			HeatPump heatPump = (HeatPump) theEObject;
			T result = caseHeatPump(heatPump);
			if (result == null)
				result = caseThermalEnergyDevice(heatPump);
			if (result == null)
				result = caseEnergyComponent(heatPump);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.BOILER: {
			Boiler boiler = (Boiler) theEObject;
			T result = caseBoiler(boiler);
			if (result == null)
				result = caseThermalEnergyDevice(boiler);
			if (result == null)
				result = caseEnergyComponent(boiler);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.SOLAR_THERMAL_COLLECTOR: {
			SolarThermalCollector solarThermalCollector = (SolarThermalCollector) theEObject;
			T result = caseSolarThermalCollector(solarThermalCollector);
			if (result == null)
				result = caseEnergyComponent(solarThermalCollector);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.ELECTROLYZER: {
			Electrolyzer electrolyzer = (Electrolyzer) theEObject;
			T result = caseElectrolyzer(electrolyzer);
			if (result == null)
				result = caseEnergyComponent(electrolyzer);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.THERMAL_ENERGY_DEVICE: {
			ThermalEnergyDevice thermalEnergyDevice = (ThermalEnergyDevice) theEObject;
			T result = caseThermalEnergyDevice(thermalEnergyDevice);
			if (result == null)
				result = caseEnergyComponent(thermalEnergyDevice);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.HYDROGEN_COMPRESSOR: {
			HydrogenCompressor hydrogenCompressor = (HydrogenCompressor) theEObject;
			T result = caseHydrogenCompressor(hydrogenCompressor);
			if (result == null)
				result = caseEnergyComponent(hydrogenCompressor);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.HYDROGEN_STORAGE: {
			HydrogenStorage hydrogenStorage = (HydrogenStorage) theEObject;
			T result = caseHydrogenStorage(hydrogenStorage);
			if (result == null)
				result = caseEnergyComponent(hydrogenStorage);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.FUEL_CELL: {
			FuelCell fuelCell = (FuelCell) theEObject;
			T result = caseFuelCell(fuelCell);
			if (result == null)
				result = caseEnergyComponent(fuelCell);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.ENERGY_CARRIER: {
			EnergyCarrier energyCarrier = (EnergyCarrier) theEObject;
			T result = caseEnergyCarrier(energyCarrier);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.FOSSIL_FUEL: {
			FossilFuel fossilFuel = (FossilFuel) theEObject;
			T result = caseFossilFuel(fossilFuel);
			if (result == null)
				result = caseFuel(fossilFuel);
			if (result == null)
				result = caseEnergyCarrier(fossilFuel);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.HYDROGEN: {
			Hydrogen hydrogen = (Hydrogen) theEObject;
			T result = caseHydrogen(hydrogen);
			if (result == null)
				result = caseFuel(hydrogen);
			if (result == null)
				result = caseEnergyCarrier(hydrogen);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.ELECTRICITY: {
			Electricity electricity = (Electricity) theEObject;
			T result = caseElectricity(electricity);
			if (result == null)
				result = caseEnergyCarrier(electricity);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.BIO_FUEL: {
			BioFuel bioFuel = (BioFuel) theEObject;
			T result = caseBioFuel(bioFuel);
			if (result == null)
				result = caseFuel(bioFuel);
			if (result == null)
				result = caseEnergyCarrier(bioFuel);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.FUEL: {
			Fuel fuel = (Fuel) theEObject;
			T result = caseFuel(fuel);
			if (result == null)
				result = caseEnergyCarrier(fuel);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.WIND_TURBINE: {
			WindTurbine windTurbine = (WindTurbine) theEObject;
			T result = caseWindTurbine(windTurbine);
			if (result == null)
				result = caseEnergyComponent(windTurbine);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.PHOTOVOLTAIC_MODULE: {
			PhotovoltaicModule photovoltaicModule = (PhotovoltaicModule) theEObject;
			T result = casePhotovoltaicModule(photovoltaicModule);
			if (result == null)
				result = caseEnergyComponent(photovoltaicModule);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.INVERTER: {
			Inverter inverter = (Inverter) theEObject;
			T result = caseInverter(inverter);
			if (result == null)
				result = caseEnergyComponent(inverter);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.HEAT_EXCHANGER: {
			HeatExchanger heatExchanger = (HeatExchanger) theEObject;
			T result = caseHeatExchanger(heatExchanger);
			if (result == null)
				result = caseEnergyComponent(heatExchanger);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.GEOTHERMAL_HEAT_EXCHANGER: {
			GeothermalHeatExchanger geothermalHeatExchanger = (GeothermalHeatExchanger) theEObject;
			T result = caseGeothermalHeatExchanger(geothermalHeatExchanger);
			if (result == null)
				result = caseEnergyComponent(geothermalHeatExchanger);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.MEDIUM: {
			Medium medium = (Medium) theEObject;
			T result = caseMedium(medium);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.LINEAR_FUNCTION: {
			LinearFunction linearFunction = (LinearFunction) theEObject;
			T result = caseLinearFunction(linearFunction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.DATA_POINT: {
			DataPoint dataPoint = (DataPoint) theEObject;
			T result = caseDataPoint(dataPoint);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.TABLE_FUNCTION: {
			TableFunction tableFunction = (TableFunction) theEObject;
			T result = caseTableFunction(tableFunction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.EXPONENTIAL_FUNCTION: {
			ExponentialFunction exponentialFunction = (ExponentialFunction) theEObject;
			T result = caseExponentialFunction(exponentialFunction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.CHARACTERISTIC: {
			Characteristic characteristic = (Characteristic) theEObject;
			T result = caseCharacteristic(characteristic);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.TABLE_CHARACTERISTIC: {
			TableCharacteristic tableCharacteristic = (TableCharacteristic) theEObject;
			T result = caseTableCharacteristic(tableCharacteristic);
			if (result == null)
				result = caseCharacteristic(tableCharacteristic);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.LINEAR_CHARACTERISTIC: {
			LinearCharacteristic linearCharacteristic = (LinearCharacteristic) theEObject;
			T result = caseLinearCharacteristic(linearCharacteristic);
			if (result == null)
				result = caseCharacteristic(linearCharacteristic);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.EXPONENTIONAL_CHARACTERISTIC: {
			ExponentionalCharacteristic exponentionalCharacteristic = (ExponentionalCharacteristic) theEObject;
			T result = caseExponentionalCharacteristic(exponentionalCharacteristic);
			if (result == null)
				result = caseCharacteristic(exponentionalCharacteristic);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.MANUFACTURER: {
			Manufacturer manufacturer = (Manufacturer) theEObject;
			T result = caseManufacturer(manufacturer);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.POLYNOMIAL_CHARACTERISTIC: {
			PolynomialCharacteristic polynomialCharacteristic = (PolynomialCharacteristic) theEObject;
			T result = casePolynomialCharacteristic(polynomialCharacteristic);
			if (result == null)
				result = caseCharacteristic(polynomialCharacteristic);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.POLYNOMIAL_FUNCTION: {
			PolynomialFunction polynomialFunction = (PolynomialFunction) theEObject;
			T result = casePolynomialFunction(polynomialFunction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.MATERIAL: {
			Material material = (Material) theEObject;
			T result = caseMaterial(material);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.ENERGY_COMPONENTS_COST_CATALOG: {
			EnergyComponentsCostCatalog energyComponentsCostCatalog = (EnergyComponentsCostCatalog) theEObject;
			T result = caseEnergyComponentsCostCatalog(energyComponentsCostCatalog);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.COST: {
			Cost cost = (Cost) theEObject;
			T result = caseCost(cost);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.POWER_CHARACTERISTIC: {
			PowerCharacteristic powerCharacteristic = (PowerCharacteristic) theEObject;
			T result = casePowerCharacteristic(powerCharacteristic);
			if (result == null)
				result = caseCharacteristic(powerCharacteristic);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case EnCompPackage.POWER_FUNCTION: {
			PowerFunction powerFunction = (PowerFunction) theEObject;
			T result = casePowerFunction(powerFunction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		default:
			return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Energy Component</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Energy Component</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEnergyComponent(EnergyComponent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Energy Components Catalog</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Energy Components Catalog</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEnergyComponentsCatalog(EnergyComponentsCatalog object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Thermal Storage</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Thermal Storage</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseThermalStorage(ThermalStorage object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Electrical Storage</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Electrical Storage</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseElectricalStorage(ElectricalStorage object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Combined Heat Power</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Combined Heat Power</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCombinedHeatPower(CombinedHeatPower object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Heat Pump</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Heat Pump</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseHeatPump(HeatPump object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Boiler</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Boiler</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBoiler(Boiler object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Solar Thermal Collector</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Solar Thermal Collector</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSolarThermalCollector(SolarThermalCollector object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Electrolyzer</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Electrolyzer</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseElectrolyzer(Electrolyzer object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Thermal Energy Device</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Thermal Energy Device</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseThermalEnergyDevice(ThermalEnergyDevice object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Hydrogen Compressor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Hydrogen Compressor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseHydrogenCompressor(HydrogenCompressor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Hydrogen Storage</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Hydrogen Storage</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseHydrogenStorage(HydrogenStorage object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Fuel Cell</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Fuel Cell</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFuelCell(FuelCell object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Energy Carrier</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Energy Carrier</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEnergyCarrier(EnergyCarrier object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Fossil Fuel</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Fossil Fuel</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFossilFuel(FossilFuel object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Hydrogen</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Hydrogen</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseHydrogen(Hydrogen object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Electricity</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Electricity</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseElectricity(Electricity object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Bio Fuel</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Bio Fuel</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBioFuel(BioFuel object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Fuel</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Fuel</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFuel(Fuel object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Wind Turbine</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Wind Turbine</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseWindTurbine(WindTurbine object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Photovoltaic Module</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Photovoltaic Module</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePhotovoltaicModule(PhotovoltaicModule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Inverter</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Inverter</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseInverter(Inverter object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Heat Exchanger</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Heat Exchanger</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseHeatExchanger(HeatExchanger object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Geothermal Heat Exchanger</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Geothermal Heat Exchanger</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGeothermalHeatExchanger(GeothermalHeatExchanger object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Medium</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Medium</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMedium(Medium object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Linear Function</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Linear Function</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLinearFunction(LinearFunction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Data Point</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Data Point</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDataPoint(DataPoint object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Table Function</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Table Function</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTableFunction(TableFunction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Exponential Function</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Exponential Function</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseExponentialFunction(ExponentialFunction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Characteristic</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Characteristic</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCharacteristic(Characteristic object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Table Characteristic</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Table Characteristic</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTableCharacteristic(TableCharacteristic object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Linear Characteristic</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Linear Characteristic</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLinearCharacteristic(LinearCharacteristic object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Exponentional Characteristic</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Exponentional Characteristic</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseExponentionalCharacteristic(ExponentionalCharacteristic object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Manufacturer</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Manufacturer</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseManufacturer(Manufacturer object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Polynomial Characteristic</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Polynomial Characteristic</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePolynomialCharacteristic(PolynomialCharacteristic object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Polynomial Function</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Polynomial Function</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePolynomialFunction(PolynomialFunction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Material</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Material</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMaterial(Material object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Energy Components Cost Catalog</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Energy Components Cost Catalog</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEnergyComponentsCostCatalog(EnergyComponentsCostCatalog object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Cost</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Cost</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCost(Cost object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Power Characteristic</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Power Characteristic</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePowerCharacteristic(PowerCharacteristic object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Power Function</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Power Function</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePowerFunction(PowerFunction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} //EnCompSwitch
