/**
 */
package de.hftstuttgart.energycomponents;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see de.hftstuttgart.energycomponents.EnCompFactory
 * @model kind="package"
 * @generated
 */
public interface EnCompPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "energycomponents";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "https://www.hft-stuttgart.de/energycomponents";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "encomp";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	EnCompPackage eINSTANCE = de.hftstuttgart.energycomponents.impl.EnCompPackageImpl.init();

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.EnergyComponentImpl <em>Energy Component</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.EnergyComponentImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getEnergyComponent()
	 * @generated
	 */
	int ENERGY_COMPONENT = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENT__DESCRIPTION = 0;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENT__MODEL_NAME = 1;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENT__REVISION_YEAR = 2;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENT__TECHNICAL_LIFETIME = 3;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENT__MANUFACTURER = 4;

	/**
	 * The number of structural features of the '<em>Energy Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENT_FEATURE_COUNT = 5;

	/**
	 * The number of operations of the '<em>Energy Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl <em>Energy Components Catalog</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getEnergyComponentsCatalog()
	 * @generated
	 */
	int ENERGY_COMPONENTS_CATALOG = 1;

	/**
	 * The feature id for the '<em><b>Author</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__AUTHOR = 0;

	/**
	 * The feature id for the '<em><b>Bio Fuels</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__BIO_FUELS = 1;

	/**
	 * The feature id for the '<em><b>Media</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__MEDIA = 2;

	/**
	 * The feature id for the '<em><b>Combined Heat Power Utilities</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__COMBINED_HEAT_POWER_UTILITIES = 3;

	/**
	 * The feature id for the '<em><b>Boilers</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__BOILERS = 4;

	/**
	 * The feature id for the '<em><b>Photovoltaic Modules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__PHOTOVOLTAIC_MODULES = 5;

	/**
	 * The feature id for the '<em><b>Solar Thermal Collectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__SOLAR_THERMAL_COLLECTORS = 6;

	/**
	 * The feature id for the '<em><b>Wind Turbines</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__WIND_TURBINES = 7;

	/**
	 * The feature id for the '<em><b>Geothermal Heat Exchangers</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__GEOTHERMAL_HEAT_EXCHANGERS = 8;

	/**
	 * The feature id for the '<em><b>Heat Pumps</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__HEAT_PUMPS = 9;

	/**
	 * The feature id for the '<em><b>Inverters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__INVERTERS = 10;

	/**
	 * The feature id for the '<em><b>Heat Exchangers</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__HEAT_EXCHANGERS = 11;

	/**
	 * The feature id for the '<em><b>Electrolyzers</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__ELECTROLYZERS = 12;

	/**
	 * The feature id for the '<em><b>Hydrogen Compressors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__HYDROGEN_COMPRESSORS = 13;

	/**
	 * The feature id for the '<em><b>Fuel Cells</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__FUEL_CELLS = 14;

	/**
	 * The feature id for the '<em><b>Thermal Storages</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__THERMAL_STORAGES = 15;

	/**
	 * The feature id for the '<em><b>Power Storages</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__POWER_STORAGES = 16;

	/**
	 * The feature id for the '<em><b>Hydrogen Storages</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__HYDROGEN_STORAGES = 17;

	/**
	 * The feature id for the '<em><b>Fossil Fuels</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__FOSSIL_FUELS = 18;

	/**
	 * The feature id for the '<em><b>Manufacturers</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__MANUFACTURERS = 19;

	/**
	 * The feature id for the '<em><b>Materials</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__MATERIALS = 20;

	/**
	 * The feature id for the '<em><b>Energycomponentscostcatalog</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG = 21;

	/**
	 * The feature id for the '<em><b>Energycarriers</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS = 22;

	/**
	 * The number of structural features of the '<em>Energy Components Catalog</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG_FEATURE_COUNT = 23;

	/**
	 * The number of operations of the '<em>Energy Components Catalog</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_CATALOG_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.ThermalStorageImpl <em>Thermal Storage</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.ThermalStorageImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getThermalStorage()
	 * @generated
	 */
	int THERMAL_STORAGE = 2;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__DESCRIPTION = ENERGY_COMPONENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__MODEL_NAME = ENERGY_COMPONENT__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__REVISION_YEAR = ENERGY_COMPONENT__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__TECHNICAL_LIFETIME = ENERGY_COMPONENT__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__MANUFACTURER = ENERGY_COMPONENT__MANUFACTURER;

	/**
	 * The feature id for the '<em><b>Volume</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__VOLUME = ENERGY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Thermal Storage Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__THERMAL_STORAGE_TYPE = ENERGY_COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Max Temp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__MAX_TEMP = ENERGY_COMPONENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Tank Thickness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__TANK_THICKNESS = ENERGY_COMPONENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Insulation Thickness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__INSULATION_THICKNESS = ENERGY_COMPONENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Uses Medium</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__USES_MEDIUM = ENERGY_COMPONENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Insulation Material</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__INSULATION_MATERIAL = ENERGY_COMPONENT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Height</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__HEIGHT = ENERGY_COMPONENT_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Tank Material</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE__TANK_MATERIAL = ENERGY_COMPONENT_FEATURE_COUNT + 8;

	/**
	 * The number of structural features of the '<em>Thermal Storage</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE_FEATURE_COUNT = ENERGY_COMPONENT_FEATURE_COUNT + 9;

	/**
	 * The number of operations of the '<em>Thermal Storage</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_STORAGE_OPERATION_COUNT = ENERGY_COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.ElectricalStorageImpl <em>Electrical Storage</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.ElectricalStorageImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getElectricalStorage()
	 * @generated
	 */
	int ELECTRICAL_STORAGE = 3;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE__DESCRIPTION = ENERGY_COMPONENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE__MODEL_NAME = ENERGY_COMPONENT__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE__REVISION_YEAR = ENERGY_COMPONENT__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE__TECHNICAL_LIFETIME = ENERGY_COMPONENT__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE__MANUFACTURER = ENERGY_COMPONENT__MANUFACTURER;

	/**
	 * The feature id for the '<em><b>Electrical Storage Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE__ELECTRICAL_STORAGE_TYPE = ENERGY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Battery Capacity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE__BATTERY_CAPACITY = ENERGY_COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Battery Voltage</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE__BATTERY_VOLTAGE = ENERGY_COMPONENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Battery Life Cycle</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE__BATTERY_LIFE_CYCLE = ENERGY_COMPONENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Self Discharge</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE__SELF_DISCHARGE = ENERGY_COMPONENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Inverter Included</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE__INVERTER_INCLUDED = ENERGY_COMPONENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Battery Effiency</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE__BATTERY_EFFIENCY = ENERGY_COMPONENT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Energy Content</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE__ENERGY_CONTENT = ENERGY_COMPONENT_FEATURE_COUNT + 7;

	/**
	 * The number of structural features of the '<em>Electrical Storage</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE_FEATURE_COUNT = ENERGY_COMPONENT_FEATURE_COUNT + 8;

	/**
	 * The number of operations of the '<em>Electrical Storage</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICAL_STORAGE_OPERATION_COUNT = ENERGY_COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.ThermalEnergyDeviceImpl <em>Thermal Energy Device</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.ThermalEnergyDeviceImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getThermalEnergyDevice()
	 * @generated
	 */
	int THERMAL_ENERGY_DEVICE = 9;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_ENERGY_DEVICE__DESCRIPTION = ENERGY_COMPONENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_ENERGY_DEVICE__MODEL_NAME = ENERGY_COMPONENT__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_ENERGY_DEVICE__REVISION_YEAR = ENERGY_COMPONENT__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_ENERGY_DEVICE__TECHNICAL_LIFETIME = ENERGY_COMPONENT__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_ENERGY_DEVICE__MANUFACTURER = ENERGY_COMPONENT__MANUFACTURER;

	/**
	 * The feature id for the '<em><b>Installed Thermal Power</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_ENERGY_DEVICE__INSTALLED_THERMAL_POWER = ENERGY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Modulation Range</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_ENERGY_DEVICE__MODULATION_RANGE = ENERGY_COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Fuel</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_ENERGY_DEVICE__FUEL = ENERGY_COMPONENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Thermal Energy Device</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_ENERGY_DEVICE_FEATURE_COUNT = ENERGY_COMPONENT_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Thermal Energy Device</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THERMAL_ENERGY_DEVICE_OPERATION_COUNT = ENERGY_COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.CombinedHeatPowerImpl <em>Combined Heat Power</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.CombinedHeatPowerImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getCombinedHeatPower()
	 * @generated
	 */
	int COMBINED_HEAT_POWER = 4;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER__DESCRIPTION = THERMAL_ENERGY_DEVICE__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER__MODEL_NAME = THERMAL_ENERGY_DEVICE__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER__REVISION_YEAR = THERMAL_ENERGY_DEVICE__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER__TECHNICAL_LIFETIME = THERMAL_ENERGY_DEVICE__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER__MANUFACTURER = THERMAL_ENERGY_DEVICE__MANUFACTURER;

	/**
	 * The feature id for the '<em><b>Installed Thermal Power</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER__INSTALLED_THERMAL_POWER = THERMAL_ENERGY_DEVICE__INSTALLED_THERMAL_POWER;

	/**
	 * The feature id for the '<em><b>Modulation Range</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER__MODULATION_RANGE = THERMAL_ENERGY_DEVICE__MODULATION_RANGE;

	/**
	 * The feature id for the '<em><b>Fuel</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER__FUEL = THERMAL_ENERGY_DEVICE__FUEL;

	/**
	 * The feature id for the '<em><b>Thermal Efficiency</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER__THERMAL_EFFICIENCY = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Electrical Efficiency</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Installed Electrical Power</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER__INSTALLED_ELECTRICAL_POWER = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Electrical Efficiency Part Load</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Thermal Efficiency Part Load</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Combined Heat Power</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER_FEATURE_COUNT = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Combined Heat Power</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMBINED_HEAT_POWER_OPERATION_COUNT = THERMAL_ENERGY_DEVICE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.HeatPumpImpl <em>Heat Pump</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.HeatPumpImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getHeatPump()
	 * @generated
	 */
	int HEAT_PUMP = 5;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP__DESCRIPTION = THERMAL_ENERGY_DEVICE__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP__MODEL_NAME = THERMAL_ENERGY_DEVICE__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP__REVISION_YEAR = THERMAL_ENERGY_DEVICE__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP__TECHNICAL_LIFETIME = THERMAL_ENERGY_DEVICE__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP__MANUFACTURER = THERMAL_ENERGY_DEVICE__MANUFACTURER;

	/**
	 * The feature id for the '<em><b>Installed Thermal Power</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP__INSTALLED_THERMAL_POWER = THERMAL_ENERGY_DEVICE__INSTALLED_THERMAL_POWER;

	/**
	 * The feature id for the '<em><b>Modulation Range</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP__MODULATION_RANGE = THERMAL_ENERGY_DEVICE__MODULATION_RANGE;

	/**
	 * The feature id for the '<em><b>Fuel</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP__FUEL = THERMAL_ENERGY_DEVICE__FUEL;

	/**
	 * The feature id for the '<em><b>Heat Source</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP__HEAT_SOURCE = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Coefficient Of Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Power Input</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP__POWER_INPUT = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Heat Output</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP__HEAT_OUTPUT = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Heat Pump</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP_FEATURE_COUNT = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Heat Pump</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_PUMP_OPERATION_COUNT = THERMAL_ENERGY_DEVICE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.BoilerImpl <em>Boiler</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.BoilerImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getBoiler()
	 * @generated
	 */
	int BOILER = 6;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOILER__DESCRIPTION = THERMAL_ENERGY_DEVICE__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOILER__MODEL_NAME = THERMAL_ENERGY_DEVICE__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOILER__REVISION_YEAR = THERMAL_ENERGY_DEVICE__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOILER__TECHNICAL_LIFETIME = THERMAL_ENERGY_DEVICE__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOILER__MANUFACTURER = THERMAL_ENERGY_DEVICE__MANUFACTURER;

	/**
	 * The feature id for the '<em><b>Installed Thermal Power</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOILER__INSTALLED_THERMAL_POWER = THERMAL_ENERGY_DEVICE__INSTALLED_THERMAL_POWER;

	/**
	 * The feature id for the '<em><b>Modulation Range</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOILER__MODULATION_RANGE = THERMAL_ENERGY_DEVICE__MODULATION_RANGE;

	/**
	 * The feature id for the '<em><b>Fuel</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOILER__FUEL = THERMAL_ENERGY_DEVICE__FUEL;

	/**
	 * The feature id for the '<em><b>Nominal Efficiency</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOILER__NOMINAL_EFFICIENCY = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Boiler Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOILER__BOILER_TYPE = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Boiler</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOILER_FEATURE_COUNT = THERMAL_ENERGY_DEVICE_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Boiler</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOILER_OPERATION_COUNT = THERMAL_ENERGY_DEVICE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.SolarThermalCollectorImpl <em>Solar Thermal Collector</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.SolarThermalCollectorImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getSolarThermalCollector()
	 * @generated
	 */
	int SOLAR_THERMAL_COLLECTOR = 7;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLAR_THERMAL_COLLECTOR__DESCRIPTION = ENERGY_COMPONENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLAR_THERMAL_COLLECTOR__MODEL_NAME = ENERGY_COMPONENT__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLAR_THERMAL_COLLECTOR__REVISION_YEAR = ENERGY_COMPONENT__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLAR_THERMAL_COLLECTOR__TECHNICAL_LIFETIME = ENERGY_COMPONENT__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLAR_THERMAL_COLLECTOR__MANUFACTURER = ENERGY_COMPONENT__MANUFACTURER;

	/**
	 * The feature id for the '<em><b>Collector Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLAR_THERMAL_COLLECTOR__COLLECTOR_TYPE = ENERGY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Aperture Area</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLAR_THERMAL_COLLECTOR__APERTURE_AREA = ENERGY_COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Optical Efficiency</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLAR_THERMAL_COLLECTOR__OPTICAL_EFFICIENCY = ENERGY_COMPONENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Linear Heat Loss Coefficient</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLAR_THERMAL_COLLECTOR__LINEAR_HEAT_LOSS_COEFFICIENT = ENERGY_COMPONENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Quadratical Heat Loss Coefficient</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLAR_THERMAL_COLLECTOR__QUADRATICAL_HEAT_LOSS_COEFFICIENT = ENERGY_COMPONENT_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Solar Thermal Collector</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLAR_THERMAL_COLLECTOR_FEATURE_COUNT = ENERGY_COMPONENT_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Solar Thermal Collector</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOLAR_THERMAL_COLLECTOR_OPERATION_COUNT = ENERGY_COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.ElectrolyzerImpl <em>Electrolyzer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.ElectrolyzerImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getElectrolyzer()
	 * @generated
	 */
	int ELECTROLYZER = 8;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER__DESCRIPTION = ENERGY_COMPONENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER__MODEL_NAME = ENERGY_COMPONENT__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER__REVISION_YEAR = ENERGY_COMPONENT__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER__TECHNICAL_LIFETIME = ENERGY_COMPONENT__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER__MANUFACTURER = ENERGY_COMPONENT__MANUFACTURER;

	/**
	 * The feature id for the '<em><b>Cell Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER__CELL_TYPE = ENERGY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Cell Area</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER__CELL_AREA = ENERGY_COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Number Of Cells</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER__NUMBER_OF_CELLS = ENERGY_COMPONENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Max Operating Current Density</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER__MAX_OPERATING_CURRENT_DENSITY = ENERGY_COMPONENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Min Operating Current Density</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER__MIN_OPERATING_CURRENT_DENSITY = ENERGY_COMPONENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Overload Capacity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER__OVERLOAD_CAPACITY = ENERGY_COMPONENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Nominal Cell Voltage</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER__NOMINAL_CELL_VOLTAGE = ENERGY_COMPONENT_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Electrolyzer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER_FEATURE_COUNT = ENERGY_COMPONENT_FEATURE_COUNT + 7;

	/**
	 * The number of operations of the '<em>Electrolyzer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTROLYZER_OPERATION_COUNT = ENERGY_COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.HydrogenCompressorImpl <em>Hydrogen Compressor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.HydrogenCompressorImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getHydrogenCompressor()
	 * @generated
	 */
	int HYDROGEN_COMPRESSOR = 10;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_COMPRESSOR__DESCRIPTION = ENERGY_COMPONENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_COMPRESSOR__MODEL_NAME = ENERGY_COMPONENT__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_COMPRESSOR__REVISION_YEAR = ENERGY_COMPONENT__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_COMPRESSOR__TECHNICAL_LIFETIME = ENERGY_COMPONENT__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_COMPRESSOR__MANUFACTURER = ENERGY_COMPONENT__MANUFACTURER;

	/**
	 * The feature id for the '<em><b>Efficiency</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_COMPRESSOR__EFFICIENCY = ENERGY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Thermodynamic Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_COMPRESSOR__THERMODYNAMIC_MODE = ENERGY_COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Max Pressure</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_COMPRESSOR__MAX_PRESSURE = ENERGY_COMPONENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Max Delivery Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_COMPRESSOR__MAX_DELIVERY_RATE = ENERGY_COMPONENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Hydrogen Compressor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_COMPRESSOR_FEATURE_COUNT = ENERGY_COMPONENT_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Hydrogen Compressor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_COMPRESSOR_OPERATION_COUNT = ENERGY_COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.HydrogenStorageImpl <em>Hydrogen Storage</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.HydrogenStorageImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getHydrogenStorage()
	 * @generated
	 */
	int HYDROGEN_STORAGE = 11;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_STORAGE__DESCRIPTION = ENERGY_COMPONENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_STORAGE__MODEL_NAME = ENERGY_COMPONENT__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_STORAGE__REVISION_YEAR = ENERGY_COMPONENT__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_STORAGE__TECHNICAL_LIFETIME = ENERGY_COMPONENT__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_STORAGE__MANUFACTURER = ENERGY_COMPONENT__MANUFACTURER;

	/**
	 * The feature id for the '<em><b>Number Of Cylinders</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_STORAGE__NUMBER_OF_CYLINDERS = ENERGY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Cylinder Volume</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_STORAGE__CYLINDER_VOLUME = ENERGY_COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Nominal Pressure</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_STORAGE__NOMINAL_PRESSURE = ENERGY_COMPONENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Hydrogen Storage</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_STORAGE_FEATURE_COUNT = ENERGY_COMPONENT_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Hydrogen Storage</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_STORAGE_OPERATION_COUNT = ENERGY_COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.FuelCellImpl <em>Fuel Cell</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.FuelCellImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getFuelCell()
	 * @generated
	 */
	int FUEL_CELL = 12;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL_CELL__DESCRIPTION = ENERGY_COMPONENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL_CELL__MODEL_NAME = ENERGY_COMPONENT__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL_CELL__REVISION_YEAR = ENERGY_COMPONENT__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL_CELL__TECHNICAL_LIFETIME = ENERGY_COMPONENT__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL_CELL__MANUFACTURER = ENERGY_COMPONENT__MANUFACTURER;

	/**
	 * The number of structural features of the '<em>Fuel Cell</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL_CELL_FEATURE_COUNT = ENERGY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Fuel Cell</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL_CELL_OPERATION_COUNT = ENERGY_COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.EnergyCarrierImpl <em>Energy Carrier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.EnergyCarrierImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getEnergyCarrier()
	 * @generated
	 */
	int ENERGY_CARRIER = 13;

	/**
	 * The feature id for the '<em><b>Co2 Emissions Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_CARRIER__CO2_EMISSIONS_FACTOR = 0;

	/**
	 * The feature id for the '<em><b>Primary Energy Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_CARRIER__PRIMARY_ENERGY_FACTOR = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_CARRIER__NAME = 2;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_CARRIER__COST = 3;

	/**
	 * The number of structural features of the '<em>Energy Carrier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_CARRIER_FEATURE_COUNT = 4;

	/**
	 * The number of operations of the '<em>Energy Carrier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_CARRIER_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.FuelImpl <em>Fuel</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.FuelImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getFuel()
	 * @generated
	 */
	int FUEL = 18;

	/**
	 * The feature id for the '<em><b>Co2 Emissions Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL__CO2_EMISSIONS_FACTOR = ENERGY_CARRIER__CO2_EMISSIONS_FACTOR;

	/**
	 * The feature id for the '<em><b>Primary Energy Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL__PRIMARY_ENERGY_FACTOR = ENERGY_CARRIER__PRIMARY_ENERGY_FACTOR;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL__NAME = ENERGY_CARRIER__NAME;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL__COST = ENERGY_CARRIER__COST;

	/**
	 * The feature id for the '<em><b>Net Calorific Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL__NET_CALORIFIC_VALUE = ENERGY_CARRIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Gross Calorific Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL__GROSS_CALORIFIC_VALUE = ENERGY_CARRIER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Density</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL__DENSITY = ENERGY_CARRIER_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Fuel Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL__FUEL_TYPE = ENERGY_CARRIER_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Fuel</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL_FEATURE_COUNT = ENERGY_CARRIER_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Fuel</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUEL_OPERATION_COUNT = ENERGY_CARRIER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.FossilFuelImpl <em>Fossil Fuel</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.FossilFuelImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getFossilFuel()
	 * @generated
	 */
	int FOSSIL_FUEL = 14;

	/**
	 * The feature id for the '<em><b>Co2 Emissions Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOSSIL_FUEL__CO2_EMISSIONS_FACTOR = FUEL__CO2_EMISSIONS_FACTOR;

	/**
	 * The feature id for the '<em><b>Primary Energy Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOSSIL_FUEL__PRIMARY_ENERGY_FACTOR = FUEL__PRIMARY_ENERGY_FACTOR;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOSSIL_FUEL__NAME = FUEL__NAME;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOSSIL_FUEL__COST = FUEL__COST;

	/**
	 * The feature id for the '<em><b>Net Calorific Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOSSIL_FUEL__NET_CALORIFIC_VALUE = FUEL__NET_CALORIFIC_VALUE;

	/**
	 * The feature id for the '<em><b>Gross Calorific Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOSSIL_FUEL__GROSS_CALORIFIC_VALUE = FUEL__GROSS_CALORIFIC_VALUE;

	/**
	 * The feature id for the '<em><b>Density</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOSSIL_FUEL__DENSITY = FUEL__DENSITY;

	/**
	 * The feature id for the '<em><b>Fuel Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOSSIL_FUEL__FUEL_TYPE = FUEL__FUEL_TYPE;

	/**
	 * The feature id for the '<em><b>Methane Content</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOSSIL_FUEL__METHANE_CONTENT = FUEL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Fossil Fuel</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOSSIL_FUEL_FEATURE_COUNT = FUEL_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Fossil Fuel</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOSSIL_FUEL_OPERATION_COUNT = FUEL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.HydrogenImpl <em>Hydrogen</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.HydrogenImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getHydrogen()
	 * @generated
	 */
	int HYDROGEN = 15;

	/**
	 * The feature id for the '<em><b>Co2 Emissions Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN__CO2_EMISSIONS_FACTOR = FUEL__CO2_EMISSIONS_FACTOR;

	/**
	 * The feature id for the '<em><b>Primary Energy Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN__PRIMARY_ENERGY_FACTOR = FUEL__PRIMARY_ENERGY_FACTOR;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN__NAME = FUEL__NAME;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN__COST = FUEL__COST;

	/**
	 * The feature id for the '<em><b>Net Calorific Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN__NET_CALORIFIC_VALUE = FUEL__NET_CALORIFIC_VALUE;

	/**
	 * The feature id for the '<em><b>Gross Calorific Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN__GROSS_CALORIFIC_VALUE = FUEL__GROSS_CALORIFIC_VALUE;

	/**
	 * The feature id for the '<em><b>Density</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN__DENSITY = FUEL__DENSITY;

	/**
	 * The feature id for the '<em><b>Fuel Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN__FUEL_TYPE = FUEL__FUEL_TYPE;

	/**
	 * The feature id for the '<em><b>Chemical Purity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN__CHEMICAL_PURITY = FUEL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Hydrogen For Hydrogen Storage</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN__HYDROGEN_FOR_HYDROGEN_STORAGE = FUEL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Hydrogen</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_FEATURE_COUNT = FUEL_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Hydrogen</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYDROGEN_OPERATION_COUNT = FUEL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.ElectricityImpl <em>Electricity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.ElectricityImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getElectricity()
	 * @generated
	 */
	int ELECTRICITY = 16;

	/**
	 * The feature id for the '<em><b>Co2 Emissions Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICITY__CO2_EMISSIONS_FACTOR = ENERGY_CARRIER__CO2_EMISSIONS_FACTOR;

	/**
	 * The feature id for the '<em><b>Primary Energy Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICITY__PRIMARY_ENERGY_FACTOR = ENERGY_CARRIER__PRIMARY_ENERGY_FACTOR;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICITY__NAME = ENERGY_CARRIER__NAME;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICITY__COST = ENERGY_CARRIER__COST;

	/**
	 * The feature id for the '<em><b>Renewable Share</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICITY__RENEWABLE_SHARE = ENERGY_CARRIER_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Electricity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICITY_FEATURE_COUNT = ENERGY_CARRIER_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Electricity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELECTRICITY_OPERATION_COUNT = ENERGY_CARRIER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.BioFuelImpl <em>Bio Fuel</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.BioFuelImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getBioFuel()
	 * @generated
	 */
	int BIO_FUEL = 17;

	/**
	 * The feature id for the '<em><b>Co2 Emissions Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIO_FUEL__CO2_EMISSIONS_FACTOR = FUEL__CO2_EMISSIONS_FACTOR;

	/**
	 * The feature id for the '<em><b>Primary Energy Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIO_FUEL__PRIMARY_ENERGY_FACTOR = FUEL__PRIMARY_ENERGY_FACTOR;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIO_FUEL__NAME = FUEL__NAME;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIO_FUEL__COST = FUEL__COST;

	/**
	 * The feature id for the '<em><b>Net Calorific Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIO_FUEL__NET_CALORIFIC_VALUE = FUEL__NET_CALORIFIC_VALUE;

	/**
	 * The feature id for the '<em><b>Gross Calorific Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIO_FUEL__GROSS_CALORIFIC_VALUE = FUEL__GROSS_CALORIFIC_VALUE;

	/**
	 * The feature id for the '<em><b>Density</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIO_FUEL__DENSITY = FUEL__DENSITY;

	/**
	 * The feature id for the '<em><b>Fuel Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIO_FUEL__FUEL_TYPE = FUEL__FUEL_TYPE;

	/**
	 * The feature id for the '<em><b>Water Content</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIO_FUEL__WATER_CONTENT = FUEL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Ash Content</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIO_FUEL__ASH_CONTENT = FUEL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Bio Fuel</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIO_FUEL_FEATURE_COUNT = FUEL_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Bio Fuel</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIO_FUEL_OPERATION_COUNT = FUEL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.WindTurbineImpl <em>Wind Turbine</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.WindTurbineImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getWindTurbine()
	 * @generated
	 */
	int WIND_TURBINE = 19;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WIND_TURBINE__DESCRIPTION = ENERGY_COMPONENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WIND_TURBINE__MODEL_NAME = ENERGY_COMPONENT__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WIND_TURBINE__REVISION_YEAR = ENERGY_COMPONENT__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WIND_TURBINE__TECHNICAL_LIFETIME = ENERGY_COMPONENT__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WIND_TURBINE__MANUFACTURER = ENERGY_COMPONENT__MANUFACTURER;

	/**
	 * The number of structural features of the '<em>Wind Turbine</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WIND_TURBINE_FEATURE_COUNT = ENERGY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Wind Turbine</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WIND_TURBINE_OPERATION_COUNT = ENERGY_COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.PhotovoltaicModuleImpl <em>Photovoltaic Module</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.PhotovoltaicModuleImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getPhotovoltaicModule()
	 * @generated
	 */
	int PHOTOVOLTAIC_MODULE = 20;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHOTOVOLTAIC_MODULE__DESCRIPTION = ENERGY_COMPONENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHOTOVOLTAIC_MODULE__MODEL_NAME = ENERGY_COMPONENT__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHOTOVOLTAIC_MODULE__REVISION_YEAR = ENERGY_COMPONENT__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHOTOVOLTAIC_MODULE__TECHNICAL_LIFETIME = ENERGY_COMPONENT__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHOTOVOLTAIC_MODULE__MANUFACTURER = ENERGY_COMPONENT__MANUFACTURER;

	/**
	 * The feature id for the '<em><b>Cell Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHOTOVOLTAIC_MODULE__CELL_TYPE = ENERGY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Nominal Power</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHOTOVOLTAIC_MODULE__NOMINAL_POWER = ENERGY_COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Mpp Voltage</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHOTOVOLTAIC_MODULE__MPP_VOLTAGE = ENERGY_COMPONENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Mpp Current</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHOTOVOLTAIC_MODULE__MPP_CURRENT = ENERGY_COMPONENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Nominal Efficiency</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHOTOVOLTAIC_MODULE__NOMINAL_EFFICIENCY = ENERGY_COMPONENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Module Area</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHOTOVOLTAIC_MODULE__MODULE_AREA = ENERGY_COMPONENT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Photovoltaic Module</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHOTOVOLTAIC_MODULE_FEATURE_COUNT = ENERGY_COMPONENT_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Photovoltaic Module</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHOTOVOLTAIC_MODULE_OPERATION_COUNT = ENERGY_COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.InverterImpl <em>Inverter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.InverterImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getInverter()
	 * @generated
	 */
	int INVERTER = 21;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVERTER__DESCRIPTION = ENERGY_COMPONENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVERTER__MODEL_NAME = ENERGY_COMPONENT__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVERTER__REVISION_YEAR = ENERGY_COMPONENT__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVERTER__TECHNICAL_LIFETIME = ENERGY_COMPONENT__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVERTER__MANUFACTURER = ENERGY_COMPONENT__MANUFACTURER;

	/**
	 * The number of structural features of the '<em>Inverter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVERTER_FEATURE_COUNT = ENERGY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Inverter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVERTER_OPERATION_COUNT = ENERGY_COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.HeatExchangerImpl <em>Heat Exchanger</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.HeatExchangerImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getHeatExchanger()
	 * @generated
	 */
	int HEAT_EXCHANGER = 22;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_EXCHANGER__DESCRIPTION = ENERGY_COMPONENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_EXCHANGER__MODEL_NAME = ENERGY_COMPONENT__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_EXCHANGER__REVISION_YEAR = ENERGY_COMPONENT__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_EXCHANGER__TECHNICAL_LIFETIME = ENERGY_COMPONENT__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_EXCHANGER__MANUFACTURER = ENERGY_COMPONENT__MANUFACTURER;

	/**
	 * The feature id for the '<em><b>Heat Recovery Efficiency</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_EXCHANGER__HEAT_RECOVERY_EFFICIENCY = ENERGY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Nominal Electricity Consumption</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_EXCHANGER__NOMINAL_ELECTRICITY_CONSUMPTION = ENERGY_COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Heat Exchanger</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_EXCHANGER_FEATURE_COUNT = ENERGY_COMPONENT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Heat Exchanger</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEAT_EXCHANGER_OPERATION_COUNT = ENERGY_COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.GeothermalHeatExchangerImpl <em>Geothermal Heat Exchanger</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.GeothermalHeatExchangerImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getGeothermalHeatExchanger()
	 * @generated
	 */
	int GEOTHERMAL_HEAT_EXCHANGER = 23;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GEOTHERMAL_HEAT_EXCHANGER__DESCRIPTION = ENERGY_COMPONENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GEOTHERMAL_HEAT_EXCHANGER__MODEL_NAME = ENERGY_COMPONENT__MODEL_NAME;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GEOTHERMAL_HEAT_EXCHANGER__REVISION_YEAR = ENERGY_COMPONENT__REVISION_YEAR;

	/**
	 * The feature id for the '<em><b>Technical Lifetime</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GEOTHERMAL_HEAT_EXCHANGER__TECHNICAL_LIFETIME = ENERGY_COMPONENT__TECHNICAL_LIFETIME;

	/**
	 * The feature id for the '<em><b>Manufacturer</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GEOTHERMAL_HEAT_EXCHANGER__MANUFACTURER = ENERGY_COMPONENT__MANUFACTURER;

	/**
	 * The feature id for the '<em><b>Pipe Diameter</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GEOTHERMAL_HEAT_EXCHANGER__PIPE_DIAMETER = ENERGY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Geothermal Heat Exchanger</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GEOTHERMAL_HEAT_EXCHANGER_FEATURE_COUNT = ENERGY_COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Geothermal Heat Exchanger</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GEOTHERMAL_HEAT_EXCHANGER_OPERATION_COUNT = ENERGY_COMPONENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.MediumImpl <em>Medium</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.MediumImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getMedium()
	 * @generated
	 */
	int MEDIUM = 24;

	/**
	 * The feature id for the '<em><b>Density</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIUM__DENSITY = 0;

	/**
	 * The feature id for the '<em><b>Heat Capacity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIUM__HEAT_CAPACITY = 1;

	/**
	 * The feature id for the '<em><b>Evaporation Temperature</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIUM__EVAPORATION_TEMPERATURE = 2;

	/**
	 * The feature id for the '<em><b>Melting Temperature</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIUM__MELTING_TEMPERATURE = 3;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIUM__NAME = 4;

	/**
	 * The number of structural features of the '<em>Medium</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIUM_FEATURE_COUNT = 5;

	/**
	 * The number of operations of the '<em>Medium</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIUM_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.LinearFunctionImpl <em>Linear Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.LinearFunctionImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getLinearFunction()
	 * @generated
	 */
	int LINEAR_FUNCTION = 25;

	/**
	 * The feature id for the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINEAR_FUNCTION__KEY = 0;

	/**
	 * The feature id for the '<em><b>Parameter M</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINEAR_FUNCTION__PARAMETER_M = 1;

	/**
	 * The feature id for the '<em><b>Parameter C</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINEAR_FUNCTION__PARAMETER_C = 2;

	/**
	 * The number of structural features of the '<em>Linear Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINEAR_FUNCTION_FEATURE_COUNT = 3;

	/**
	 * The operation id for the '<em>Linearfunction</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINEAR_FUNCTION___LINEARFUNCTION__DOUBLE = 0;

	/**
	 * The number of operations of the '<em>Linear Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINEAR_FUNCTION_OPERATION_COUNT = 1;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.DataPointImpl <em>Data Point</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.DataPointImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getDataPoint()
	 * @generated
	 */
	int DATA_POINT = 26;

	/**
	 * The feature id for the '<em><b>X</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_POINT__X = 0;

	/**
	 * The feature id for the '<em><b>Y</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_POINT__Y = 1;

	/**
	 * The number of structural features of the '<em>Data Point</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_POINT_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Data Point</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_POINT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.TableFunctionImpl <em>Table Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.TableFunctionImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getTableFunction()
	 * @generated
	 */
	int TABLE_FUNCTION = 27;

	/**
	 * The feature id for the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TABLE_FUNCTION__KEY = 0;

	/**
	 * The feature id for the '<em><b>Datapoints</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TABLE_FUNCTION__DATAPOINTS = 1;

	/**
	 * The number of structural features of the '<em>Table Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TABLE_FUNCTION_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Table Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TABLE_FUNCTION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.ExponentialFunctionImpl <em>Exponential Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.ExponentialFunctionImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getExponentialFunction()
	 * @generated
	 */
	int EXPONENTIAL_FUNCTION = 28;

	/**
	 * The feature id for the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIAL_FUNCTION__KEY = 0;

	/**
	 * The feature id for the '<em><b>Parameter A</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIAL_FUNCTION__PARAMETER_A = 1;

	/**
	 * The feature id for the '<em><b>Parameter B</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIAL_FUNCTION__PARAMETER_B = 2;

	/**
	 * The number of structural features of the '<em>Exponential Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIAL_FUNCTION_FEATURE_COUNT = 3;

	/**
	 * The operation id for the '<em>Exponentialfunction</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIAL_FUNCTION___EXPONENTIALFUNCTION__DOUBLE = 0;

	/**
	 * The number of operations of the '<em>Exponential Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIAL_FUNCTION_OPERATION_COUNT = 1;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.CharacteristicImpl <em>Characteristic</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.CharacteristicImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getCharacteristic()
	 * @generated
	 */
	int CHARACTERISTIC = 29;

	/**
	 * The number of structural features of the '<em>Characteristic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHARACTERISTIC_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Characteristic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHARACTERISTIC_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.TableCharacteristicImpl <em>Table Characteristic</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.TableCharacteristicImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getTableCharacteristic()
	 * @generated
	 */
	int TABLE_CHARACTERISTIC = 30;

	/**
	 * The feature id for the '<em><b>Functions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TABLE_CHARACTERISTIC__FUNCTIONS = CHARACTERISTIC_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Table Characteristic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TABLE_CHARACTERISTIC_FEATURE_COUNT = CHARACTERISTIC_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Table Characteristic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TABLE_CHARACTERISTIC_OPERATION_COUNT = CHARACTERISTIC_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.LinearCharacteristicImpl <em>Linear Characteristic</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.LinearCharacteristicImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getLinearCharacteristic()
	 * @generated
	 */
	int LINEAR_CHARACTERISTIC = 31;

	/**
	 * The feature id for the '<em><b>Functions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINEAR_CHARACTERISTIC__FUNCTIONS = CHARACTERISTIC_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Linear Characteristic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINEAR_CHARACTERISTIC_FEATURE_COUNT = CHARACTERISTIC_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Linear Characteristic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINEAR_CHARACTERISTIC_OPERATION_COUNT = CHARACTERISTIC_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.ExponentionalCharacteristicImpl <em>Exponentional Characteristic</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.ExponentionalCharacteristicImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getExponentionalCharacteristic()
	 * @generated
	 */
	int EXPONENTIONAL_CHARACTERISTIC = 32;

	/**
	 * The feature id for the '<em><b>Functions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIONAL_CHARACTERISTIC__FUNCTIONS = CHARACTERISTIC_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Exponentional Characteristic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIONAL_CHARACTERISTIC_FEATURE_COUNT = CHARACTERISTIC_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Exponentional Characteristic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIONAL_CHARACTERISTIC_OPERATION_COUNT = CHARACTERISTIC_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.ManufacturerImpl <em>Manufacturer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.ManufacturerImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getManufacturer()
	 * @generated
	 */
	int MANUFACTURER = 33;

	/**
	 * The feature id for the '<em><b>Manufacturer Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MANUFACTURER__MANUFACTURER_NAME = 0;

	/**
	 * The feature id for the '<em><b>Country</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MANUFACTURER__COUNTRY = 1;

	/**
	 * The feature id for the '<em><b>Out Of Business Since</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MANUFACTURER__OUT_OF_BUSINESS_SINCE = 2;

	/**
	 * The number of structural features of the '<em>Manufacturer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MANUFACTURER_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Manufacturer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MANUFACTURER_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.PolynomialCharacteristicImpl <em>Polynomial Characteristic</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.PolynomialCharacteristicImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getPolynomialCharacteristic()
	 * @generated
	 */
	int POLYNOMIAL_CHARACTERISTIC = 34;

	/**
	 * The feature id for the '<em><b>Functions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POLYNOMIAL_CHARACTERISTIC__FUNCTIONS = CHARACTERISTIC_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Polynomial Characteristic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POLYNOMIAL_CHARACTERISTIC_FEATURE_COUNT = CHARACTERISTIC_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Polynomial Characteristic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POLYNOMIAL_CHARACTERISTIC_OPERATION_COUNT = CHARACTERISTIC_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.PolynomialFunctionImpl <em>Polynomial Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.PolynomialFunctionImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getPolynomialFunction()
	 * @generated
	 */
	int POLYNOMIAL_FUNCTION = 35;

	/**
	 * The feature id for the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POLYNOMIAL_FUNCTION__KEY = 0;

	/**
	 * The feature id for the '<em><b>Parameter A</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POLYNOMIAL_FUNCTION__PARAMETER_A = 1;

	/**
	 * The feature id for the '<em><b>Parameter B</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POLYNOMIAL_FUNCTION__PARAMETER_B = 2;

	/**
	 * The feature id for the '<em><b>Parameter C</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POLYNOMIAL_FUNCTION__PARAMETER_C = 3;

	/**
	 * The number of structural features of the '<em>Polynomial Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POLYNOMIAL_FUNCTION_FEATURE_COUNT = 4;

	/**
	 * The operation id for the '<em>Polynomialfunction</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POLYNOMIAL_FUNCTION___POLYNOMIALFUNCTION__DOUBLE = 0;

	/**
	 * The number of operations of the '<em>Polynomial Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POLYNOMIAL_FUNCTION_OPERATION_COUNT = 1;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.MaterialImpl <em>Material</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.MaterialImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getMaterial()
	 * @generated
	 */
	int MATERIAL = 36;

	/**
	 * The feature id for the '<em><b>Thermal Conductivity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL__THERMAL_CONDUCTIVITY = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL__NAME = 1;

	/**
	 * The number of structural features of the '<em>Material</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Material</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MATERIAL_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCostCatalogImpl <em>Energy Components Cost Catalog</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.EnergyComponentsCostCatalogImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getEnergyComponentsCostCatalog()
	 * @generated
	 */
	int ENERGY_COMPONENTS_COST_CATALOG = 37;

	/**
	 * The feature id for the '<em><b>Author</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_COST_CATALOG__AUTHOR = 0;

	/**
	 * The feature id for the '<em><b>Revision Year</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_COST_CATALOG__REVISION_YEAR = 1;

	/**
	 * The feature id for the '<em><b>Cost Categories</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_COST_CATALOG__COST_CATEGORIES = 2;

	/**
	 * The feature id for the '<em><b>Personnel Cost</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_COST_CATALOG__PERSONNEL_COST = 3;

	/**
	 * The number of structural features of the '<em>Energy Components Cost Catalog</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_COST_CATALOG_FEATURE_COUNT = 4;

	/**
	 * The number of operations of the '<em>Energy Components Cost Catalog</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENERGY_COMPONENTS_COST_CATALOG_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.CostImpl <em>Cost</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.CostImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getCost()
	 * @generated
	 */
	int COST = 38;

	/**
	 * The feature id for the '<em><b>Component Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST__COMPONENT_NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Heat Source</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST__HEAT_SOURCE = 2;

	/**
	 * The feature id for the '<em><b>Datasource</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST__DATASOURCE = 3;

	/**
	 * The feature id for the '<em><b>Investment Cost</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST__INVESTMENT_COST = 4;

	/**
	 * The feature id for the '<em><b>Other Investment Cost</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST__OTHER_INVESTMENT_COST = 5;

	/**
	 * The feature id for the '<em><b>Personnel Hours</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST__PERSONNEL_HOURS = 6;

	/**
	 * The feature id for the '<em><b>Personnel Cost Share</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST__PERSONNEL_COST_SHARE = 7;

	/**
	 * The feature id for the '<em><b>Administration And Other Cost Share</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST__ADMINISTRATION_AND_OTHER_COST_SHARE = 8;

	/**
	 * The feature id for the '<em><b>Maintenance Cost Share</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST__MAINTENANCE_COST_SHARE = 9;

	/**
	 * The number of structural features of the '<em>Cost</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST_FEATURE_COUNT = 10;

	/**
	 * The number of operations of the '<em>Cost</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.PowerCharacteristicImpl <em>Power Characteristic</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.PowerCharacteristicImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getPowerCharacteristic()
	 * @generated
	 */
	int POWER_CHARACTERISTIC = 39;

	/**
	 * The feature id for the '<em><b>Functions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_CHARACTERISTIC__FUNCTIONS = CHARACTERISTIC_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Power Characteristic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_CHARACTERISTIC_FEATURE_COUNT = CHARACTERISTIC_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Power Characteristic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_CHARACTERISTIC_OPERATION_COUNT = CHARACTERISTIC_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.impl.PowerFunctionImpl <em>Power Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.impl.PowerFunctionImpl
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getPowerFunction()
	 * @generated
	 */
	int POWER_FUNCTION = 40;

	/**
	 * The feature id for the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_FUNCTION__KEY = 0;

	/**
	 * The feature id for the '<em><b>Parameter A</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_FUNCTION__PARAMETER_A = 1;

	/**
	 * The feature id for the '<em><b>Parameter B</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_FUNCTION__PARAMETER_B = 2;

	/**
	 * The number of structural features of the '<em>Power Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_FUNCTION_FEATURE_COUNT = 3;

	/**
	 * The operation id for the '<em>Powerfunction</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_FUNCTION___POWERFUNCTION__DOUBLE = 0;

	/**
	 * The number of operations of the '<em>Power Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_FUNCTION_OPERATION_COUNT = 1;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.HeatSources <em>Heat Sources</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.HeatSources
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getHeatSources()
	 * @generated
	 */
	int HEAT_SOURCES = 41;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.CollectorTypes <em>Collector Types</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.CollectorTypes
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getCollectorTypes()
	 * @generated
	 */
	int COLLECTOR_TYPES = 42;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.ElectricalStorageTypes <em>Electrical Storage Types</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.ElectricalStorageTypes
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getElectricalStorageTypes()
	 * @generated
	 */
	int ELECTRICAL_STORAGE_TYPES = 43;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.BoilerTypes <em>Boiler Types</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.BoilerTypes
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getBoilerTypes()
	 * @generated
	 */
	int BOILER_TYPES = 44;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.ThermalStorageTypes <em>Thermal Storage Types</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.ThermalStorageTypes
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getThermalStorageTypes()
	 * @generated
	 */
	int THERMAL_STORAGE_TYPES = 45;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.FuelTypes <em>Fuel Types</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.FuelTypes
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getFuelTypes()
	 * @generated
	 */
	int FUEL_TYPES = 47;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.TypeOfHeatSource <em>Type Of Heat Source</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.TypeOfHeatSource
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getTypeOfHeatSource()
	 * @generated
	 */
	int TYPE_OF_HEAT_SOURCE = 48;

	/**
	 * The meta object id for the '{@link de.hftstuttgart.energycomponents.cellTypesElectrolyzer <em>cell Types Electrolyzer</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.energycomponents.cellTypesElectrolyzer
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getcellTypesElectrolyzer()
	 * @generated
	 */
	int CELL_TYPES_ELECTROLYZER = 46;

	/**
	 * The meta object id for the '<em>Quantity Double</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.units.NullableQuantity
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getQuantityDouble()
	 * @generated
	 */
	int QUANTITY_DOUBLE = 49;

	/**
	 * The meta object id for the '<em>Quantity Long</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.units.NullableQuantity
	 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getQuantityLong()
	 * @generated
	 */
	int QUANTITY_LONG = 50;

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.EnergyComponent <em>Energy Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Energy Component</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponent
	 * @generated
	 */
	EClass getEnergyComponent();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.EnergyComponent#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponent#getDescription()
	 * @see #getEnergyComponent()
	 * @generated
	 */
	EAttribute getEnergyComponent_Description();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.EnergyComponent#getModelName <em>Model Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Model Name</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponent#getModelName()
	 * @see #getEnergyComponent()
	 * @generated
	 */
	EAttribute getEnergyComponent_ModelName();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.EnergyComponent#getRevisionYear <em>Revision Year</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Revision Year</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponent#getRevisionYear()
	 * @see #getEnergyComponent()
	 * @generated
	 */
	EAttribute getEnergyComponent_RevisionYear();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.EnergyComponent#getTechnicalLifetime <em>Technical Lifetime</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Technical Lifetime</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponent#getTechnicalLifetime()
	 * @see #getEnergyComponent()
	 * @generated
	 */
	EAttribute getEnergyComponent_TechnicalLifetime();

	/**
	 * Returns the meta object for the reference '{@link de.hftstuttgart.energycomponents.EnergyComponent#getManufacturer <em>Manufacturer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Manufacturer</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponent#getManufacturer()
	 * @see #getEnergyComponent()
	 * @generated
	 */
	EReference getEnergyComponent_Manufacturer();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog <em>Energy Components Catalog</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Energy Components Catalog</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog
	 * @generated
	 */
	EClass getEnergyComponentsCatalog();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getAuthor <em>Author</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Author</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getAuthor()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EAttribute getEnergyComponentsCatalog_Author();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getBioFuels <em>Bio Fuels</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Bio Fuels</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getBioFuels()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_BioFuels();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getMedia <em>Media</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Media</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getMedia()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_Media();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getCombinedHeatPowerUtilities <em>Combined Heat Power Utilities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Combined Heat Power Utilities</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getCombinedHeatPowerUtilities()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_CombinedHeatPowerUtilities();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getBoilers <em>Boilers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Boilers</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getBoilers()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_Boilers();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getPhotovoltaicModules <em>Photovoltaic Modules</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Photovoltaic Modules</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getPhotovoltaicModules()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_PhotovoltaicModules();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getSolarThermalCollectors <em>Solar Thermal Collectors</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Solar Thermal Collectors</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getSolarThermalCollectors()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_SolarThermalCollectors();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getWindTurbines <em>Wind Turbines</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Wind Turbines</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getWindTurbines()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_WindTurbines();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getGeothermalHeatExchangers <em>Geothermal Heat Exchangers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Geothermal Heat Exchangers</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getGeothermalHeatExchangers()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_GeothermalHeatExchangers();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getHeatPumps <em>Heat Pumps</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Heat Pumps</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getHeatPumps()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_HeatPumps();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getInverters <em>Inverters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Inverters</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getInverters()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_Inverters();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getHeatExchangers <em>Heat Exchangers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Heat Exchangers</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getHeatExchangers()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_HeatExchangers();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getElectrolyzers <em>Electrolyzers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Electrolyzers</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getElectrolyzers()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_Electrolyzers();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getHydrogenCompressors <em>Hydrogen Compressors</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Hydrogen Compressors</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getHydrogenCompressors()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_HydrogenCompressors();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getFuelCells <em>Fuel Cells</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Fuel Cells</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getFuelCells()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_FuelCells();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getThermalStorages <em>Thermal Storages</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Thermal Storages</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getThermalStorages()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_ThermalStorages();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getPowerStorages <em>Power Storages</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Power Storages</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getPowerStorages()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_PowerStorages();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getHydrogenStorages <em>Hydrogen Storages</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Hydrogen Storages</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getHydrogenStorages()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_HydrogenStorages();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getFossilFuels <em>Fossil Fuels</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Fossil Fuels</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getFossilFuels()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_FossilFuels();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getManufacturers <em>Manufacturers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Manufacturers</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getManufacturers()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_Manufacturers();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getMaterials <em>Materials</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Materials</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getMaterials()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_Materials();

	/**
	 * Returns the meta object for the containment reference '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getEnergycomponentscostcatalog <em>Energycomponentscostcatalog</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Energycomponentscostcatalog</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getEnergycomponentscostcatalog()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_Energycomponentscostcatalog();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getEnergycarriers <em>Energycarriers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Energycarriers</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCatalog#getEnergycarriers()
	 * @see #getEnergyComponentsCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCatalog_Energycarriers();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.ThermalStorage <em>Thermal Storage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thermal Storage</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalStorage
	 * @generated
	 */
	EClass getThermalStorage();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ThermalStorage#getVolume <em>Volume</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Volume</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalStorage#getVolume()
	 * @see #getThermalStorage()
	 * @generated
	 */
	EAttribute getThermalStorage_Volume();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ThermalStorage#getThermalStorageType <em>Thermal Storage Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Thermal Storage Type</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalStorage#getThermalStorageType()
	 * @see #getThermalStorage()
	 * @generated
	 */
	EAttribute getThermalStorage_ThermalStorageType();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ThermalStorage#getMaxTemp <em>Max Temp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Temp</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalStorage#getMaxTemp()
	 * @see #getThermalStorage()
	 * @generated
	 */
	EAttribute getThermalStorage_MaxTemp();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ThermalStorage#getTankThickness <em>Tank Thickness</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tank Thickness</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalStorage#getTankThickness()
	 * @see #getThermalStorage()
	 * @generated
	 */
	EAttribute getThermalStorage_TankThickness();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ThermalStorage#getInsulationThickness <em>Insulation Thickness</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Insulation Thickness</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalStorage#getInsulationThickness()
	 * @see #getThermalStorage()
	 * @generated
	 */
	EAttribute getThermalStorage_InsulationThickness();

	/**
	 * Returns the meta object for the reference '{@link de.hftstuttgart.energycomponents.ThermalStorage#getUsesMedium <em>Uses Medium</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Uses Medium</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalStorage#getUsesMedium()
	 * @see #getThermalStorage()
	 * @generated
	 */
	EReference getThermalStorage_UsesMedium();

	/**
	 * Returns the meta object for the reference '{@link de.hftstuttgart.energycomponents.ThermalStorage#getInsulationMaterial <em>Insulation Material</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Insulation Material</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalStorage#getInsulationMaterial()
	 * @see #getThermalStorage()
	 * @generated
	 */
	EReference getThermalStorage_InsulationMaterial();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ThermalStorage#getHeight <em>Height</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Height</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalStorage#getHeight()
	 * @see #getThermalStorage()
	 * @generated
	 */
	EAttribute getThermalStorage_Height();

	/**
	 * Returns the meta object for the reference '{@link de.hftstuttgart.energycomponents.ThermalStorage#getTankMaterial <em>Tank Material</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Tank Material</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalStorage#getTankMaterial()
	 * @see #getThermalStorage()
	 * @generated
	 */
	EReference getThermalStorage_TankMaterial();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.ElectricalStorage <em>Electrical Storage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Electrical Storage</em>'.
	 * @see de.hftstuttgart.energycomponents.ElectricalStorage
	 * @generated
	 */
	EClass getElectricalStorage();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getElectricalStorageType <em>Electrical Storage Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Electrical Storage Type</em>'.
	 * @see de.hftstuttgart.energycomponents.ElectricalStorage#getElectricalStorageType()
	 * @see #getElectricalStorage()
	 * @generated
	 */
	EAttribute getElectricalStorage_ElectricalStorageType();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryCapacity <em>Battery Capacity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Battery Capacity</em>'.
	 * @see de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryCapacity()
	 * @see #getElectricalStorage()
	 * @generated
	 */
	EAttribute getElectricalStorage_BatteryCapacity();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryVoltage <em>Battery Voltage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Battery Voltage</em>'.
	 * @see de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryVoltage()
	 * @see #getElectricalStorage()
	 * @generated
	 */
	EAttribute getElectricalStorage_BatteryVoltage();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryLifeCycle <em>Battery Life Cycle</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Battery Life Cycle</em>'.
	 * @see de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryLifeCycle()
	 * @see #getElectricalStorage()
	 * @generated
	 */
	EAttribute getElectricalStorage_BatteryLifeCycle();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getSelfDischarge <em>Self Discharge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Self Discharge</em>'.
	 * @see de.hftstuttgart.energycomponents.ElectricalStorage#getSelfDischarge()
	 * @see #getElectricalStorage()
	 * @generated
	 */
	EAttribute getElectricalStorage_SelfDischarge();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getInverterIncluded <em>Inverter Included</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Inverter Included</em>'.
	 * @see de.hftstuttgart.energycomponents.ElectricalStorage#getInverterIncluded()
	 * @see #getElectricalStorage()
	 * @generated
	 */
	EAttribute getElectricalStorage_InverterIncluded();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryEffiency <em>Battery Effiency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Battery Effiency</em>'.
	 * @see de.hftstuttgart.energycomponents.ElectricalStorage#getBatteryEffiency()
	 * @see #getElectricalStorage()
	 * @generated
	 */
	EAttribute getElectricalStorage_BatteryEffiency();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ElectricalStorage#getEnergyContent <em>Energy Content</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Energy Content</em>'.
	 * @see de.hftstuttgart.energycomponents.ElectricalStorage#getEnergyContent()
	 * @see #getElectricalStorage()
	 * @generated
	 */
	EAttribute getElectricalStorage_EnergyContent();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.CombinedHeatPower <em>Combined Heat Power</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Combined Heat Power</em>'.
	 * @see de.hftstuttgart.energycomponents.CombinedHeatPower
	 * @generated
	 */
	EClass getCombinedHeatPower();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getThermalEfficiency <em>Thermal Efficiency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Thermal Efficiency</em>'.
	 * @see de.hftstuttgart.energycomponents.CombinedHeatPower#getThermalEfficiency()
	 * @see #getCombinedHeatPower()
	 * @generated
	 */
	EAttribute getCombinedHeatPower_ThermalEfficiency();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getElectricalEfficiency <em>Electrical Efficiency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Electrical Efficiency</em>'.
	 * @see de.hftstuttgart.energycomponents.CombinedHeatPower#getElectricalEfficiency()
	 * @see #getCombinedHeatPower()
	 * @generated
	 */
	EAttribute getCombinedHeatPower_ElectricalEfficiency();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getInstalledElectricalPower <em>Installed Electrical Power</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Installed Electrical Power</em>'.
	 * @see de.hftstuttgart.energycomponents.CombinedHeatPower#getInstalledElectricalPower()
	 * @see #getCombinedHeatPower()
	 * @generated
	 */
	EAttribute getCombinedHeatPower_InstalledElectricalPower();

	/**
	 * Returns the meta object for the containment reference '{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getElectricalEfficiencyPartLoad <em>Electrical Efficiency Part Load</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Electrical Efficiency Part Load</em>'.
	 * @see de.hftstuttgart.energycomponents.CombinedHeatPower#getElectricalEfficiencyPartLoad()
	 * @see #getCombinedHeatPower()
	 * @generated
	 */
	EReference getCombinedHeatPower_ElectricalEfficiencyPartLoad();

	/**
	 * Returns the meta object for the containment reference '{@link de.hftstuttgart.energycomponents.CombinedHeatPower#getThermalEfficiencyPartLoad <em>Thermal Efficiency Part Load</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Thermal Efficiency Part Load</em>'.
	 * @see de.hftstuttgart.energycomponents.CombinedHeatPower#getThermalEfficiencyPartLoad()
	 * @see #getCombinedHeatPower()
	 * @generated
	 */
	EReference getCombinedHeatPower_ThermalEfficiencyPartLoad();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.HeatPump <em>Heat Pump</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Heat Pump</em>'.
	 * @see de.hftstuttgart.energycomponents.HeatPump
	 * @generated
	 */
	EClass getHeatPump();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.HeatPump#getHeatSource <em>Heat Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Heat Source</em>'.
	 * @see de.hftstuttgart.energycomponents.HeatPump#getHeatSource()
	 * @see #getHeatPump()
	 * @generated
	 */
	EAttribute getHeatPump_HeatSource();

	/**
	 * Returns the meta object for the containment reference '{@link de.hftstuttgart.energycomponents.HeatPump#getPowerInput <em>Power Input</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Power Input</em>'.
	 * @see de.hftstuttgart.energycomponents.HeatPump#getPowerInput()
	 * @see #getHeatPump()
	 * @generated
	 */
	EReference getHeatPump_PowerInput();

	/**
	 * Returns the meta object for the containment reference '{@link de.hftstuttgart.energycomponents.HeatPump#getHeatOutput <em>Heat Output</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Heat Output</em>'.
	 * @see de.hftstuttgart.energycomponents.HeatPump#getHeatOutput()
	 * @see #getHeatPump()
	 * @generated
	 */
	EReference getHeatPump_HeatOutput();

	/**
	 * Returns the meta object for the containment reference '{@link de.hftstuttgart.energycomponents.HeatPump#getCoefficientOfPerformance <em>Coefficient Of Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Coefficient Of Performance</em>'.
	 * @see de.hftstuttgart.energycomponents.HeatPump#getCoefficientOfPerformance()
	 * @see #getHeatPump()
	 * @generated
	 */
	EReference getHeatPump_CoefficientOfPerformance();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.Boiler <em>Boiler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Boiler</em>'.
	 * @see de.hftstuttgart.energycomponents.Boiler
	 * @generated
	 */
	EClass getBoiler();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Boiler#getNominalEfficiency <em>Nominal Efficiency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Nominal Efficiency</em>'.
	 * @see de.hftstuttgart.energycomponents.Boiler#getNominalEfficiency()
	 * @see #getBoiler()
	 * @generated
	 */
	EAttribute getBoiler_NominalEfficiency();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Boiler#getBoilerType <em>Boiler Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Boiler Type</em>'.
	 * @see de.hftstuttgart.energycomponents.Boiler#getBoilerType()
	 * @see #getBoiler()
	 * @generated
	 */
	EAttribute getBoiler_BoilerType();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.SolarThermalCollector <em>Solar Thermal Collector</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Solar Thermal Collector</em>'.
	 * @see de.hftstuttgart.energycomponents.SolarThermalCollector
	 * @generated
	 */
	EClass getSolarThermalCollector();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getCollectorType <em>Collector Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Collector Type</em>'.
	 * @see de.hftstuttgart.energycomponents.SolarThermalCollector#getCollectorType()
	 * @see #getSolarThermalCollector()
	 * @generated
	 */
	EAttribute getSolarThermalCollector_CollectorType();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getApertureArea <em>Aperture Area</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Aperture Area</em>'.
	 * @see de.hftstuttgart.energycomponents.SolarThermalCollector#getApertureArea()
	 * @see #getSolarThermalCollector()
	 * @generated
	 */
	EAttribute getSolarThermalCollector_ApertureArea();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getOpticalEfficiency <em>Optical Efficiency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Optical Efficiency</em>'.
	 * @see de.hftstuttgart.energycomponents.SolarThermalCollector#getOpticalEfficiency()
	 * @see #getSolarThermalCollector()
	 * @generated
	 */
	EAttribute getSolarThermalCollector_OpticalEfficiency();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getLinearHeatLossCoefficient <em>Linear Heat Loss Coefficient</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Linear Heat Loss Coefficient</em>'.
	 * @see de.hftstuttgart.energycomponents.SolarThermalCollector#getLinearHeatLossCoefficient()
	 * @see #getSolarThermalCollector()
	 * @generated
	 */
	EAttribute getSolarThermalCollector_LinearHeatLossCoefficient();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.SolarThermalCollector#getQuadraticalHeatLossCoefficient <em>Quadratical Heat Loss Coefficient</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Quadratical Heat Loss Coefficient</em>'.
	 * @see de.hftstuttgart.energycomponents.SolarThermalCollector#getQuadraticalHeatLossCoefficient()
	 * @see #getSolarThermalCollector()
	 * @generated
	 */
	EAttribute getSolarThermalCollector_QuadraticalHeatLossCoefficient();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.Electrolyzer <em>Electrolyzer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Electrolyzer</em>'.
	 * @see de.hftstuttgart.energycomponents.Electrolyzer
	 * @generated
	 */
	EClass getElectrolyzer();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Electrolyzer#getCellType <em>Cell Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cell Type</em>'.
	 * @see de.hftstuttgart.energycomponents.Electrolyzer#getCellType()
	 * @see #getElectrolyzer()
	 * @generated
	 */
	EAttribute getElectrolyzer_CellType();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Electrolyzer#getCellArea <em>Cell Area</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cell Area</em>'.
	 * @see de.hftstuttgart.energycomponents.Electrolyzer#getCellArea()
	 * @see #getElectrolyzer()
	 * @generated
	 */
	EAttribute getElectrolyzer_CellArea();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Electrolyzer#getNumberOfCells <em>Number Of Cells</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Number Of Cells</em>'.
	 * @see de.hftstuttgart.energycomponents.Electrolyzer#getNumberOfCells()
	 * @see #getElectrolyzer()
	 * @generated
	 */
	EAttribute getElectrolyzer_NumberOfCells();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Electrolyzer#getMaxOperatingCurrentDensity <em>Max Operating Current Density</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Operating Current Density</em>'.
	 * @see de.hftstuttgart.energycomponents.Electrolyzer#getMaxOperatingCurrentDensity()
	 * @see #getElectrolyzer()
	 * @generated
	 */
	EAttribute getElectrolyzer_MaxOperatingCurrentDensity();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Electrolyzer#getMinOperatingCurrentDensity <em>Min Operating Current Density</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Min Operating Current Density</em>'.
	 * @see de.hftstuttgart.energycomponents.Electrolyzer#getMinOperatingCurrentDensity()
	 * @see #getElectrolyzer()
	 * @generated
	 */
	EAttribute getElectrolyzer_MinOperatingCurrentDensity();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Electrolyzer#getOverloadCapacity <em>Overload Capacity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Overload Capacity</em>'.
	 * @see de.hftstuttgart.energycomponents.Electrolyzer#getOverloadCapacity()
	 * @see #getElectrolyzer()
	 * @generated
	 */
	EAttribute getElectrolyzer_OverloadCapacity();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Electrolyzer#getNominalCellVoltage <em>Nominal Cell Voltage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Nominal Cell Voltage</em>'.
	 * @see de.hftstuttgart.energycomponents.Electrolyzer#getNominalCellVoltage()
	 * @see #getElectrolyzer()
	 * @generated
	 */
	EAttribute getElectrolyzer_NominalCellVoltage();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.ThermalEnergyDevice <em>Thermal Energy Device</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thermal Energy Device</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalEnergyDevice
	 * @generated
	 */
	EClass getThermalEnergyDevice();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ThermalEnergyDevice#getInstalledThermalPower <em>Installed Thermal Power</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Installed Thermal Power</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalEnergyDevice#getInstalledThermalPower()
	 * @see #getThermalEnergyDevice()
	 * @generated
	 */
	EAttribute getThermalEnergyDevice_InstalledThermalPower();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ThermalEnergyDevice#getModulationRange <em>Modulation Range</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Modulation Range</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalEnergyDevice#getModulationRange()
	 * @see #getThermalEnergyDevice()
	 * @generated
	 */
	EAttribute getThermalEnergyDevice_ModulationRange();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ThermalEnergyDevice#getFuel <em>Fuel</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Fuel</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalEnergyDevice#getFuel()
	 * @see #getThermalEnergyDevice()
	 * @generated
	 */
	EAttribute getThermalEnergyDevice_Fuel();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.HydrogenCompressor <em>Hydrogen Compressor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hydrogen Compressor</em>'.
	 * @see de.hftstuttgart.energycomponents.HydrogenCompressor
	 * @generated
	 */
	EClass getHydrogenCompressor();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.HydrogenCompressor#getEfficiency <em>Efficiency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Efficiency</em>'.
	 * @see de.hftstuttgart.energycomponents.HydrogenCompressor#getEfficiency()
	 * @see #getHydrogenCompressor()
	 * @generated
	 */
	EAttribute getHydrogenCompressor_Efficiency();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.HydrogenCompressor#getThermodynamicMode <em>Thermodynamic Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Thermodynamic Mode</em>'.
	 * @see de.hftstuttgart.energycomponents.HydrogenCompressor#getThermodynamicMode()
	 * @see #getHydrogenCompressor()
	 * @generated
	 */
	EAttribute getHydrogenCompressor_ThermodynamicMode();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.HydrogenCompressor#getMaxPressure <em>Max Pressure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Pressure</em>'.
	 * @see de.hftstuttgart.energycomponents.HydrogenCompressor#getMaxPressure()
	 * @see #getHydrogenCompressor()
	 * @generated
	 */
	EAttribute getHydrogenCompressor_MaxPressure();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.HydrogenCompressor#getMaxDeliveryRate <em>Max Delivery Rate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Delivery Rate</em>'.
	 * @see de.hftstuttgart.energycomponents.HydrogenCompressor#getMaxDeliveryRate()
	 * @see #getHydrogenCompressor()
	 * @generated
	 */
	EAttribute getHydrogenCompressor_MaxDeliveryRate();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.HydrogenStorage <em>Hydrogen Storage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hydrogen Storage</em>'.
	 * @see de.hftstuttgart.energycomponents.HydrogenStorage
	 * @generated
	 */
	EClass getHydrogenStorage();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.HydrogenStorage#getNumberOfCylinders <em>Number Of Cylinders</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Number Of Cylinders</em>'.
	 * @see de.hftstuttgart.energycomponents.HydrogenStorage#getNumberOfCylinders()
	 * @see #getHydrogenStorage()
	 * @generated
	 */
	EAttribute getHydrogenStorage_NumberOfCylinders();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.HydrogenStorage#getCylinderVolume <em>Cylinder Volume</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cylinder Volume</em>'.
	 * @see de.hftstuttgart.energycomponents.HydrogenStorage#getCylinderVolume()
	 * @see #getHydrogenStorage()
	 * @generated
	 */
	EAttribute getHydrogenStorage_CylinderVolume();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.HydrogenStorage#getNominalPressure <em>Nominal Pressure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Nominal Pressure</em>'.
	 * @see de.hftstuttgart.energycomponents.HydrogenStorage#getNominalPressure()
	 * @see #getHydrogenStorage()
	 * @generated
	 */
	EAttribute getHydrogenStorage_NominalPressure();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.FuelCell <em>Fuel Cell</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Fuel Cell</em>'.
	 * @see de.hftstuttgart.energycomponents.FuelCell
	 * @generated
	 */
	EClass getFuelCell();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.EnergyCarrier <em>Energy Carrier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Energy Carrier</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyCarrier
	 * @generated
	 */
	EClass getEnergyCarrier();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.EnergyCarrier#getCo2EmissionsFactor <em>Co2 Emissions Factor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Co2 Emissions Factor</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyCarrier#getCo2EmissionsFactor()
	 * @see #getEnergyCarrier()
	 * @generated
	 */
	EAttribute getEnergyCarrier_Co2EmissionsFactor();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.EnergyCarrier#getPrimaryEnergyFactor <em>Primary Energy Factor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Primary Energy Factor</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyCarrier#getPrimaryEnergyFactor()
	 * @see #getEnergyCarrier()
	 * @generated
	 */
	EAttribute getEnergyCarrier_PrimaryEnergyFactor();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.EnergyCarrier#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyCarrier#getName()
	 * @see #getEnergyCarrier()
	 * @generated
	 */
	EAttribute getEnergyCarrier_Name();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.EnergyCarrier#getCost <em>Cost</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cost</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyCarrier#getCost()
	 * @see #getEnergyCarrier()
	 * @generated
	 */
	EAttribute getEnergyCarrier_Cost();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.FossilFuel <em>Fossil Fuel</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Fossil Fuel</em>'.
	 * @see de.hftstuttgart.energycomponents.FossilFuel
	 * @generated
	 */
	EClass getFossilFuel();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.FossilFuel#getMethaneContent <em>Methane Content</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Methane Content</em>'.
	 * @see de.hftstuttgart.energycomponents.FossilFuel#getMethaneContent()
	 * @see #getFossilFuel()
	 * @generated
	 */
	EAttribute getFossilFuel_MethaneContent();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.Hydrogen <em>Hydrogen</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hydrogen</em>'.
	 * @see de.hftstuttgart.energycomponents.Hydrogen
	 * @generated
	 */
	EClass getHydrogen();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Hydrogen#getChemicalPurity <em>Chemical Purity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Chemical Purity</em>'.
	 * @see de.hftstuttgart.energycomponents.Hydrogen#getChemicalPurity()
	 * @see #getHydrogen()
	 * @generated
	 */
	EAttribute getHydrogen_ChemicalPurity();

	/**
	 * Returns the meta object for the reference '{@link de.hftstuttgart.energycomponents.Hydrogen#getHydrogenForHydrogenStorage <em>Hydrogen For Hydrogen Storage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Hydrogen For Hydrogen Storage</em>'.
	 * @see de.hftstuttgart.energycomponents.Hydrogen#getHydrogenForHydrogenStorage()
	 * @see #getHydrogen()
	 * @generated
	 */
	EReference getHydrogen_HydrogenForHydrogenStorage();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.Electricity <em>Electricity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Electricity</em>'.
	 * @see de.hftstuttgart.energycomponents.Electricity
	 * @generated
	 */
	EClass getElectricity();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Electricity#getRenewableShare <em>Renewable Share</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Renewable Share</em>'.
	 * @see de.hftstuttgart.energycomponents.Electricity#getRenewableShare()
	 * @see #getElectricity()
	 * @generated
	 */
	EAttribute getElectricity_RenewableShare();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.BioFuel <em>Bio Fuel</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bio Fuel</em>'.
	 * @see de.hftstuttgart.energycomponents.BioFuel
	 * @generated
	 */
	EClass getBioFuel();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.BioFuel#getWaterContent <em>Water Content</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Water Content</em>'.
	 * @see de.hftstuttgart.energycomponents.BioFuel#getWaterContent()
	 * @see #getBioFuel()
	 * @generated
	 */
	EAttribute getBioFuel_WaterContent();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.BioFuel#getAshContent <em>Ash Content</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ash Content</em>'.
	 * @see de.hftstuttgart.energycomponents.BioFuel#getAshContent()
	 * @see #getBioFuel()
	 * @generated
	 */
	EAttribute getBioFuel_AshContent();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.Fuel <em>Fuel</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Fuel</em>'.
	 * @see de.hftstuttgart.energycomponents.Fuel
	 * @generated
	 */
	EClass getFuel();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Fuel#getNetCalorificValue <em>Net Calorific Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Net Calorific Value</em>'.
	 * @see de.hftstuttgart.energycomponents.Fuel#getNetCalorificValue()
	 * @see #getFuel()
	 * @generated
	 */
	EAttribute getFuel_NetCalorificValue();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Fuel#getGrossCalorificValue <em>Gross Calorific Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Gross Calorific Value</em>'.
	 * @see de.hftstuttgart.energycomponents.Fuel#getGrossCalorificValue()
	 * @see #getFuel()
	 * @generated
	 */
	EAttribute getFuel_GrossCalorificValue();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Fuel#getDensity <em>Density</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Density</em>'.
	 * @see de.hftstuttgart.energycomponents.Fuel#getDensity()
	 * @see #getFuel()
	 * @generated
	 */
	EAttribute getFuel_Density();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Fuel#getFuelType <em>Fuel Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Fuel Type</em>'.
	 * @see de.hftstuttgart.energycomponents.Fuel#getFuelType()
	 * @see #getFuel()
	 * @generated
	 */
	EAttribute getFuel_FuelType();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.WindTurbine <em>Wind Turbine</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Wind Turbine</em>'.
	 * @see de.hftstuttgart.energycomponents.WindTurbine
	 * @generated
	 */
	EClass getWindTurbine();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule <em>Photovoltaic Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Photovoltaic Module</em>'.
	 * @see de.hftstuttgart.energycomponents.PhotovoltaicModule
	 * @generated
	 */
	EClass getPhotovoltaicModule();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getCellType <em>Cell Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cell Type</em>'.
	 * @see de.hftstuttgart.energycomponents.PhotovoltaicModule#getCellType()
	 * @see #getPhotovoltaicModule()
	 * @generated
	 */
	EAttribute getPhotovoltaicModule_CellType();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getNominalPower <em>Nominal Power</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Nominal Power</em>'.
	 * @see de.hftstuttgart.energycomponents.PhotovoltaicModule#getNominalPower()
	 * @see #getPhotovoltaicModule()
	 * @generated
	 */
	EAttribute getPhotovoltaicModule_NominalPower();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getMppVoltage <em>Mpp Voltage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mpp Voltage</em>'.
	 * @see de.hftstuttgart.energycomponents.PhotovoltaicModule#getMppVoltage()
	 * @see #getPhotovoltaicModule()
	 * @generated
	 */
	EAttribute getPhotovoltaicModule_MppVoltage();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getMppCurrent <em>Mpp Current</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mpp Current</em>'.
	 * @see de.hftstuttgart.energycomponents.PhotovoltaicModule#getMppCurrent()
	 * @see #getPhotovoltaicModule()
	 * @generated
	 */
	EAttribute getPhotovoltaicModule_MppCurrent();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getNominalEfficiency <em>Nominal Efficiency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Nominal Efficiency</em>'.
	 * @see de.hftstuttgart.energycomponents.PhotovoltaicModule#getNominalEfficiency()
	 * @see #getPhotovoltaicModule()
	 * @generated
	 */
	EAttribute getPhotovoltaicModule_NominalEfficiency();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.PhotovoltaicModule#getModuleArea <em>Module Area</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Module Area</em>'.
	 * @see de.hftstuttgart.energycomponents.PhotovoltaicModule#getModuleArea()
	 * @see #getPhotovoltaicModule()
	 * @generated
	 */
	EAttribute getPhotovoltaicModule_ModuleArea();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.Inverter <em>Inverter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Inverter</em>'.
	 * @see de.hftstuttgart.energycomponents.Inverter
	 * @generated
	 */
	EClass getInverter();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.HeatExchanger <em>Heat Exchanger</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Heat Exchanger</em>'.
	 * @see de.hftstuttgart.energycomponents.HeatExchanger
	 * @generated
	 */
	EClass getHeatExchanger();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.HeatExchanger#getHeatRecoveryEfficiency <em>Heat Recovery Efficiency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Heat Recovery Efficiency</em>'.
	 * @see de.hftstuttgart.energycomponents.HeatExchanger#getHeatRecoveryEfficiency()
	 * @see #getHeatExchanger()
	 * @generated
	 */
	EAttribute getHeatExchanger_HeatRecoveryEfficiency();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.HeatExchanger#getNominalElectricityConsumption <em>Nominal Electricity Consumption</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Nominal Electricity Consumption</em>'.
	 * @see de.hftstuttgart.energycomponents.HeatExchanger#getNominalElectricityConsumption()
	 * @see #getHeatExchanger()
	 * @generated
	 */
	EAttribute getHeatExchanger_NominalElectricityConsumption();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.GeothermalHeatExchanger <em>Geothermal Heat Exchanger</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Geothermal Heat Exchanger</em>'.
	 * @see de.hftstuttgart.energycomponents.GeothermalHeatExchanger
	 * @generated
	 */
	EClass getGeothermalHeatExchanger();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.GeothermalHeatExchanger#getPipeDiameter <em>Pipe Diameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Pipe Diameter</em>'.
	 * @see de.hftstuttgart.energycomponents.GeothermalHeatExchanger#getPipeDiameter()
	 * @see #getGeothermalHeatExchanger()
	 * @generated
	 */
	EAttribute getGeothermalHeatExchanger_PipeDiameter();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.Medium <em>Medium</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Medium</em>'.
	 * @see de.hftstuttgart.energycomponents.Medium
	 * @generated
	 */
	EClass getMedium();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Medium#getDensity <em>Density</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Density</em>'.
	 * @see de.hftstuttgart.energycomponents.Medium#getDensity()
	 * @see #getMedium()
	 * @generated
	 */
	EAttribute getMedium_Density();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Medium#getHeatCapacity <em>Heat Capacity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Heat Capacity</em>'.
	 * @see de.hftstuttgart.energycomponents.Medium#getHeatCapacity()
	 * @see #getMedium()
	 * @generated
	 */
	EAttribute getMedium_HeatCapacity();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Medium#getEvaporationTemperature <em>Evaporation Temperature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Evaporation Temperature</em>'.
	 * @see de.hftstuttgart.energycomponents.Medium#getEvaporationTemperature()
	 * @see #getMedium()
	 * @generated
	 */
	EAttribute getMedium_EvaporationTemperature();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Medium#getMeltingTemperature <em>Melting Temperature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Melting Temperature</em>'.
	 * @see de.hftstuttgart.energycomponents.Medium#getMeltingTemperature()
	 * @see #getMedium()
	 * @generated
	 */
	EAttribute getMedium_MeltingTemperature();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Medium#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.hftstuttgart.energycomponents.Medium#getName()
	 * @see #getMedium()
	 * @generated
	 */
	EAttribute getMedium_Name();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.LinearFunction <em>Linear Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Linear Function</em>'.
	 * @see de.hftstuttgart.energycomponents.LinearFunction
	 * @generated
	 */
	EClass getLinearFunction();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.LinearFunction#getKey <em>Key</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Key</em>'.
	 * @see de.hftstuttgart.energycomponents.LinearFunction#getKey()
	 * @see #getLinearFunction()
	 * @generated
	 */
	EAttribute getLinearFunction_Key();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.LinearFunction#getParameterM <em>Parameter M</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parameter M</em>'.
	 * @see de.hftstuttgart.energycomponents.LinearFunction#getParameterM()
	 * @see #getLinearFunction()
	 * @generated
	 */
	EAttribute getLinearFunction_ParameterM();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.LinearFunction#getParameterC <em>Parameter C</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parameter C</em>'.
	 * @see de.hftstuttgart.energycomponents.LinearFunction#getParameterC()
	 * @see #getLinearFunction()
	 * @generated
	 */
	EAttribute getLinearFunction_ParameterC();

	/**
	 * Returns the meta object for the '{@link de.hftstuttgart.energycomponents.LinearFunction#linearfunction(double) <em>Linearfunction</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Linearfunction</em>' operation.
	 * @see de.hftstuttgart.energycomponents.LinearFunction#linearfunction(double)
	 * @generated
	 */
	EOperation getLinearFunction__Linearfunction__double();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.DataPoint <em>Data Point</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Point</em>'.
	 * @see de.hftstuttgart.energycomponents.DataPoint
	 * @generated
	 */
	EClass getDataPoint();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.DataPoint#getX <em>X</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>X</em>'.
	 * @see de.hftstuttgart.energycomponents.DataPoint#getX()
	 * @see #getDataPoint()
	 * @generated
	 */
	EAttribute getDataPoint_X();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.DataPoint#getY <em>Y</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Y</em>'.
	 * @see de.hftstuttgart.energycomponents.DataPoint#getY()
	 * @see #getDataPoint()
	 * @generated
	 */
	EAttribute getDataPoint_Y();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.TableFunction <em>Table Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Table Function</em>'.
	 * @see de.hftstuttgart.energycomponents.TableFunction
	 * @generated
	 */
	EClass getTableFunction();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.TableFunction#getKey <em>Key</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Key</em>'.
	 * @see de.hftstuttgart.energycomponents.TableFunction#getKey()
	 * @see #getTableFunction()
	 * @generated
	 */
	EAttribute getTableFunction_Key();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.TableFunction#getDatapoints <em>Datapoints</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Datapoints</em>'.
	 * @see de.hftstuttgart.energycomponents.TableFunction#getDatapoints()
	 * @see #getTableFunction()
	 * @generated
	 */
	EReference getTableFunction_Datapoints();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.ExponentialFunction <em>Exponential Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exponential Function</em>'.
	 * @see de.hftstuttgart.energycomponents.ExponentialFunction
	 * @generated
	 */
	EClass getExponentialFunction();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ExponentialFunction#getKey <em>Key</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Key</em>'.
	 * @see de.hftstuttgart.energycomponents.ExponentialFunction#getKey()
	 * @see #getExponentialFunction()
	 * @generated
	 */
	EAttribute getExponentialFunction_Key();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ExponentialFunction#getParameterA <em>Parameter A</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parameter A</em>'.
	 * @see de.hftstuttgart.energycomponents.ExponentialFunction#getParameterA()
	 * @see #getExponentialFunction()
	 * @generated
	 */
	EAttribute getExponentialFunction_ParameterA();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.ExponentialFunction#getParameterB <em>Parameter B</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parameter B</em>'.
	 * @see de.hftstuttgart.energycomponents.ExponentialFunction#getParameterB()
	 * @see #getExponentialFunction()
	 * @generated
	 */
	EAttribute getExponentialFunction_ParameterB();

	/**
	 * Returns the meta object for the '{@link de.hftstuttgart.energycomponents.ExponentialFunction#exponentialfunction(double) <em>Exponentialfunction</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Exponentialfunction</em>' operation.
	 * @see de.hftstuttgart.energycomponents.ExponentialFunction#exponentialfunction(double)
	 * @generated
	 */
	EOperation getExponentialFunction__Exponentialfunction__double();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.Characteristic <em>Characteristic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Characteristic</em>'.
	 * @see de.hftstuttgart.energycomponents.Characteristic
	 * @generated
	 */
	EClass getCharacteristic();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.TableCharacteristic <em>Table Characteristic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Table Characteristic</em>'.
	 * @see de.hftstuttgart.energycomponents.TableCharacteristic
	 * @generated
	 */
	EClass getTableCharacteristic();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.TableCharacteristic#getFunctions <em>Functions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Functions</em>'.
	 * @see de.hftstuttgart.energycomponents.TableCharacteristic#getFunctions()
	 * @see #getTableCharacteristic()
	 * @generated
	 */
	EReference getTableCharacteristic_Functions();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.LinearCharacteristic <em>Linear Characteristic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Linear Characteristic</em>'.
	 * @see de.hftstuttgart.energycomponents.LinearCharacteristic
	 * @generated
	 */
	EClass getLinearCharacteristic();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.LinearCharacteristic#getFunctions <em>Functions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Functions</em>'.
	 * @see de.hftstuttgart.energycomponents.LinearCharacteristic#getFunctions()
	 * @see #getLinearCharacteristic()
	 * @generated
	 */
	EReference getLinearCharacteristic_Functions();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.ExponentionalCharacteristic <em>Exponentional Characteristic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exponentional Characteristic</em>'.
	 * @see de.hftstuttgart.energycomponents.ExponentionalCharacteristic
	 * @generated
	 */
	EClass getExponentionalCharacteristic();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.ExponentionalCharacteristic#getFunctions <em>Functions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Functions</em>'.
	 * @see de.hftstuttgart.energycomponents.ExponentionalCharacteristic#getFunctions()
	 * @see #getExponentionalCharacteristic()
	 * @generated
	 */
	EReference getExponentionalCharacteristic_Functions();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.Manufacturer <em>Manufacturer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Manufacturer</em>'.
	 * @see de.hftstuttgart.energycomponents.Manufacturer
	 * @generated
	 */
	EClass getManufacturer();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Manufacturer#getManufacturerName <em>Manufacturer Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Manufacturer Name</em>'.
	 * @see de.hftstuttgart.energycomponents.Manufacturer#getManufacturerName()
	 * @see #getManufacturer()
	 * @generated
	 */
	EAttribute getManufacturer_ManufacturerName();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Manufacturer#getCountry <em>Country</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Country</em>'.
	 * @see de.hftstuttgart.energycomponents.Manufacturer#getCountry()
	 * @see #getManufacturer()
	 * @generated
	 */
	EAttribute getManufacturer_Country();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Manufacturer#getOutOfBusinessSince <em>Out Of Business Since</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Out Of Business Since</em>'.
	 * @see de.hftstuttgart.energycomponents.Manufacturer#getOutOfBusinessSince()
	 * @see #getManufacturer()
	 * @generated
	 */
	EAttribute getManufacturer_OutOfBusinessSince();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.PolynomialCharacteristic <em>Polynomial Characteristic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Polynomial Characteristic</em>'.
	 * @see de.hftstuttgart.energycomponents.PolynomialCharacteristic
	 * @generated
	 */
	EClass getPolynomialCharacteristic();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.PolynomialCharacteristic#getFunctions <em>Functions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Functions</em>'.
	 * @see de.hftstuttgart.energycomponents.PolynomialCharacteristic#getFunctions()
	 * @see #getPolynomialCharacteristic()
	 * @generated
	 */
	EReference getPolynomialCharacteristic_Functions();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.PolynomialFunction <em>Polynomial Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Polynomial Function</em>'.
	 * @see de.hftstuttgart.energycomponents.PolynomialFunction
	 * @generated
	 */
	EClass getPolynomialFunction();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.PolynomialFunction#getKey <em>Key</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Key</em>'.
	 * @see de.hftstuttgart.energycomponents.PolynomialFunction#getKey()
	 * @see #getPolynomialFunction()
	 * @generated
	 */
	EAttribute getPolynomialFunction_Key();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.PolynomialFunction#getParameterA <em>Parameter A</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parameter A</em>'.
	 * @see de.hftstuttgart.energycomponents.PolynomialFunction#getParameterA()
	 * @see #getPolynomialFunction()
	 * @generated
	 */
	EAttribute getPolynomialFunction_ParameterA();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.PolynomialFunction#getParameterB <em>Parameter B</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parameter B</em>'.
	 * @see de.hftstuttgart.energycomponents.PolynomialFunction#getParameterB()
	 * @see #getPolynomialFunction()
	 * @generated
	 */
	EAttribute getPolynomialFunction_ParameterB();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.PolynomialFunction#getParameterC <em>Parameter C</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parameter C</em>'.
	 * @see de.hftstuttgart.energycomponents.PolynomialFunction#getParameterC()
	 * @see #getPolynomialFunction()
	 * @generated
	 */
	EAttribute getPolynomialFunction_ParameterC();

	/**
	 * Returns the meta object for the '{@link de.hftstuttgart.energycomponents.PolynomialFunction#polynomialfunction(double) <em>Polynomialfunction</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Polynomialfunction</em>' operation.
	 * @see de.hftstuttgart.energycomponents.PolynomialFunction#polynomialfunction(double)
	 * @generated
	 */
	EOperation getPolynomialFunction__Polynomialfunction__double();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.Material <em>Material</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Material</em>'.
	 * @see de.hftstuttgart.energycomponents.Material
	 * @generated
	 */
	EClass getMaterial();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Material#getThermalConductivity <em>Thermal Conductivity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Thermal Conductivity</em>'.
	 * @see de.hftstuttgart.energycomponents.Material#getThermalConductivity()
	 * @see #getMaterial()
	 * @generated
	 */
	EAttribute getMaterial_ThermalConductivity();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Material#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.hftstuttgart.energycomponents.Material#getName()
	 * @see #getMaterial()
	 * @generated
	 */
	EAttribute getMaterial_Name();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog <em>Energy Components Cost Catalog</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Energy Components Cost Catalog</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog
	 * @generated
	 */
	EClass getEnergyComponentsCostCatalog();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog#getAuthor <em>Author</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Author</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog#getAuthor()
	 * @see #getEnergyComponentsCostCatalog()
	 * @generated
	 */
	EAttribute getEnergyComponentsCostCatalog_Author();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog#getRevisionYear <em>Revision Year</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Revision Year</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog#getRevisionYear()
	 * @see #getEnergyComponentsCostCatalog()
	 * @generated
	 */
	EAttribute getEnergyComponentsCostCatalog_RevisionYear();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog#getCostCategories <em>Cost Categories</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Cost Categories</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog#getCostCategories()
	 * @see #getEnergyComponentsCostCatalog()
	 * @generated
	 */
	EReference getEnergyComponentsCostCatalog_CostCategories();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog#getPersonnelCost <em>Personnel Cost</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Personnel Cost</em>'.
	 * @see de.hftstuttgart.energycomponents.EnergyComponentsCostCatalog#getPersonnelCost()
	 * @see #getEnergyComponentsCostCatalog()
	 * @generated
	 */
	EAttribute getEnergyComponentsCostCatalog_PersonnelCost();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.Cost <em>Cost</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cost</em>'.
	 * @see de.hftstuttgart.energycomponents.Cost
	 * @generated
	 */
	EClass getCost();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Cost#getDatasource <em>Datasource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Datasource</em>'.
	 * @see de.hftstuttgart.energycomponents.Cost#getDatasource()
	 * @see #getCost()
	 * @generated
	 */
	EAttribute getCost_Datasource();

	/**
	 * Returns the meta object for the containment reference '{@link de.hftstuttgart.energycomponents.Cost#getInvestmentCost <em>Investment Cost</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Investment Cost</em>'.
	 * @see de.hftstuttgart.energycomponents.Cost#getInvestmentCost()
	 * @see #getCost()
	 * @generated
	 */
	EReference getCost_InvestmentCost();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Cost#getOtherInvestmentCost <em>Other Investment Cost</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Other Investment Cost</em>'.
	 * @see de.hftstuttgart.energycomponents.Cost#getOtherInvestmentCost()
	 * @see #getCost()
	 * @generated
	 */
	EAttribute getCost_OtherInvestmentCost();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Cost#getPersonnelHours <em>Personnel Hours</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Personnel Hours</em>'.
	 * @see de.hftstuttgart.energycomponents.Cost#getPersonnelHours()
	 * @see #getCost()
	 * @generated
	 */
	EAttribute getCost_PersonnelHours();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Cost#getPersonnelCostShare <em>Personnel Cost Share</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Personnel Cost Share</em>'.
	 * @see de.hftstuttgart.energycomponents.Cost#getPersonnelCostShare()
	 * @see #getCost()
	 * @generated
	 */
	EAttribute getCost_PersonnelCostShare();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Cost#getAdministrationAndOtherCostShare <em>Administration And Other Cost Share</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Administration And Other Cost Share</em>'.
	 * @see de.hftstuttgart.energycomponents.Cost#getAdministrationAndOtherCostShare()
	 * @see #getCost()
	 * @generated
	 */
	EAttribute getCost_AdministrationAndOtherCostShare();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Cost#getMaintenanceCostShare <em>Maintenance Cost Share</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Maintenance Cost Share</em>'.
	 * @see de.hftstuttgart.energycomponents.Cost#getMaintenanceCostShare()
	 * @see #getCost()
	 * @generated
	 */
	EAttribute getCost_MaintenanceCostShare();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.PowerCharacteristic <em>Power Characteristic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Power Characteristic</em>'.
	 * @see de.hftstuttgart.energycomponents.PowerCharacteristic
	 * @generated
	 */
	EClass getPowerCharacteristic();

	/**
	 * Returns the meta object for the containment reference list '{@link de.hftstuttgart.energycomponents.PowerCharacteristic#getFunctions <em>Functions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Functions</em>'.
	 * @see de.hftstuttgart.energycomponents.PowerCharacteristic#getFunctions()
	 * @see #getPowerCharacteristic()
	 * @generated
	 */
	EReference getPowerCharacteristic_Functions();

	/**
	 * Returns the meta object for class '{@link de.hftstuttgart.energycomponents.PowerFunction <em>Power Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Power Function</em>'.
	 * @see de.hftstuttgart.energycomponents.PowerFunction
	 * @generated
	 */
	EClass getPowerFunction();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.PowerFunction#getKey <em>Key</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Key</em>'.
	 * @see de.hftstuttgart.energycomponents.PowerFunction#getKey()
	 * @see #getPowerFunction()
	 * @generated
	 */
	EAttribute getPowerFunction_Key();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.PowerFunction#getParameterA <em>Parameter A</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parameter A</em>'.
	 * @see de.hftstuttgart.energycomponents.PowerFunction#getParameterA()
	 * @see #getPowerFunction()
	 * @generated
	 */
	EAttribute getPowerFunction_ParameterA();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.PowerFunction#getParameterB <em>Parameter B</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parameter B</em>'.
	 * @see de.hftstuttgart.energycomponents.PowerFunction#getParameterB()
	 * @see #getPowerFunction()
	 * @generated
	 */
	EAttribute getPowerFunction_ParameterB();

	/**
	 * Returns the meta object for the '{@link de.hftstuttgart.energycomponents.PowerFunction#powerfunction(double) <em>Powerfunction</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Powerfunction</em>' operation.
	 * @see de.hftstuttgart.energycomponents.PowerFunction#powerfunction(double)
	 * @generated
	 */
	EOperation getPowerFunction__Powerfunction__double();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Cost#getComponentName <em>Component Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Component Name</em>'.
	 * @see de.hftstuttgart.energycomponents.Cost#getComponentName()
	 * @see #getCost()
	 * @generated
	 */
	EAttribute getCost_ComponentName();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Cost#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see de.hftstuttgart.energycomponents.Cost#getDescription()
	 * @see #getCost()
	 * @generated
	 */
	EAttribute getCost_Description();

	/**
	 * Returns the meta object for the attribute '{@link de.hftstuttgart.energycomponents.Cost#getHeatSource <em>Heat Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Heat Source</em>'.
	 * @see de.hftstuttgart.energycomponents.Cost#getHeatSource()
	 * @see #getCost()
	 * @generated
	 */
	EAttribute getCost_HeatSource();

	/**
	 * Returns the meta object for enum '{@link de.hftstuttgart.energycomponents.HeatSources <em>Heat Sources</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Heat Sources</em>'.
	 * @see de.hftstuttgart.energycomponents.HeatSources
	 * @generated
	 */
	EEnum getHeatSources();

	/**
	 * Returns the meta object for enum '{@link de.hftstuttgart.energycomponents.CollectorTypes <em>Collector Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Collector Types</em>'.
	 * @see de.hftstuttgart.energycomponents.CollectorTypes
	 * @generated
	 */
	EEnum getCollectorTypes();

	/**
	 * Returns the meta object for enum '{@link de.hftstuttgart.energycomponents.ElectricalStorageTypes <em>Electrical Storage Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Electrical Storage Types</em>'.
	 * @see de.hftstuttgart.energycomponents.ElectricalStorageTypes
	 * @generated
	 */
	EEnum getElectricalStorageTypes();

	/**
	 * Returns the meta object for enum '{@link de.hftstuttgart.energycomponents.BoilerTypes <em>Boiler Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Boiler Types</em>'.
	 * @see de.hftstuttgart.energycomponents.BoilerTypes
	 * @generated
	 */
	EEnum getBoilerTypes();

	/**
	 * Returns the meta object for enum '{@link de.hftstuttgart.energycomponents.ThermalStorageTypes <em>Thermal Storage Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Thermal Storage Types</em>'.
	 * @see de.hftstuttgart.energycomponents.ThermalStorageTypes
	 * @generated
	 */
	EEnum getThermalStorageTypes();

	/**
	 * Returns the meta object for enum '{@link de.hftstuttgart.energycomponents.FuelTypes <em>Fuel Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Fuel Types</em>'.
	 * @see de.hftstuttgart.energycomponents.FuelTypes
	 * @generated
	 */
	EEnum getFuelTypes();

	/**
	 * Returns the meta object for enum '{@link de.hftstuttgart.energycomponents.TypeOfHeatSource <em>Type Of Heat Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Type Of Heat Source</em>'.
	 * @see de.hftstuttgart.energycomponents.TypeOfHeatSource
	 * @generated
	 */
	EEnum getTypeOfHeatSource();

	/**
	 * Returns the meta object for enum '{@link de.hftstuttgart.energycomponents.cellTypesElectrolyzer <em>cell Types Electrolyzer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>cell Types Electrolyzer</em>'.
	 * @see de.hftstuttgart.energycomponents.cellTypesElectrolyzer
	 * @generated
	 */
	EEnum getcellTypesElectrolyzer();

	/**
	 * Returns the meta object for data type '{@link de.hftstuttgart.units.NullableQuantity <em>Quantity Double</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Quantity Double</em>'.
	 * @see de.hftstuttgart.units.NullableQuantity
	 * @model instanceClass="de.hftstuttgart.units.NullableQuantity"
	 * @generated
	 */
	EDataType getQuantityDouble();

	/**
	 * Returns the meta object for data type '{@link de.hftstuttgart.units.NullableQuantity <em>Quantity Long</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Quantity Long</em>'.
	 * @see de.hftstuttgart.units.NullableQuantity
	 * @model instanceClass="de.hftstuttgart.units.NullableQuantity"
	 * @generated
	 */
	EDataType getQuantityLong();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	EnCompFactory getEnCompFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.EnergyComponentImpl <em>Energy Component</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.EnergyComponentImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getEnergyComponent()
		 * @generated
		 */
		EClass ENERGY_COMPONENT = eINSTANCE.getEnergyComponent();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENERGY_COMPONENT__DESCRIPTION = eINSTANCE.getEnergyComponent_Description();

		/**
		 * The meta object literal for the '<em><b>Model Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENERGY_COMPONENT__MODEL_NAME = eINSTANCE.getEnergyComponent_ModelName();

		/**
		 * The meta object literal for the '<em><b>Revision Year</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENERGY_COMPONENT__REVISION_YEAR = eINSTANCE.getEnergyComponent_RevisionYear();

		/**
		 * The meta object literal for the '<em><b>Technical Lifetime</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENERGY_COMPONENT__TECHNICAL_LIFETIME = eINSTANCE.getEnergyComponent_TechnicalLifetime();

		/**
		 * The meta object literal for the '<em><b>Manufacturer</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENT__MANUFACTURER = eINSTANCE.getEnergyComponent_Manufacturer();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl <em>Energy Components Catalog</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.EnergyComponentsCatalogImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getEnergyComponentsCatalog()
		 * @generated
		 */
		EClass ENERGY_COMPONENTS_CATALOG = eINSTANCE.getEnergyComponentsCatalog();

		/**
		 * The meta object literal for the '<em><b>Author</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENERGY_COMPONENTS_CATALOG__AUTHOR = eINSTANCE.getEnergyComponentsCatalog_Author();

		/**
		 * The meta object literal for the '<em><b>Bio Fuels</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__BIO_FUELS = eINSTANCE.getEnergyComponentsCatalog_BioFuels();

		/**
		 * The meta object literal for the '<em><b>Media</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__MEDIA = eINSTANCE.getEnergyComponentsCatalog_Media();

		/**
		 * The meta object literal for the '<em><b>Combined Heat Power Utilities</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__COMBINED_HEAT_POWER_UTILITIES = eINSTANCE
				.getEnergyComponentsCatalog_CombinedHeatPowerUtilities();

		/**
		 * The meta object literal for the '<em><b>Boilers</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__BOILERS = eINSTANCE.getEnergyComponentsCatalog_Boilers();

		/**
		 * The meta object literal for the '<em><b>Photovoltaic Modules</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__PHOTOVOLTAIC_MODULES = eINSTANCE
				.getEnergyComponentsCatalog_PhotovoltaicModules();

		/**
		 * The meta object literal for the '<em><b>Solar Thermal Collectors</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__SOLAR_THERMAL_COLLECTORS = eINSTANCE
				.getEnergyComponentsCatalog_SolarThermalCollectors();

		/**
		 * The meta object literal for the '<em><b>Wind Turbines</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__WIND_TURBINES = eINSTANCE.getEnergyComponentsCatalog_WindTurbines();

		/**
		 * The meta object literal for the '<em><b>Geothermal Heat Exchangers</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__GEOTHERMAL_HEAT_EXCHANGERS = eINSTANCE
				.getEnergyComponentsCatalog_GeothermalHeatExchangers();

		/**
		 * The meta object literal for the '<em><b>Heat Pumps</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__HEAT_PUMPS = eINSTANCE.getEnergyComponentsCatalog_HeatPumps();

		/**
		 * The meta object literal for the '<em><b>Inverters</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__INVERTERS = eINSTANCE.getEnergyComponentsCatalog_Inverters();

		/**
		 * The meta object literal for the '<em><b>Heat Exchangers</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__HEAT_EXCHANGERS = eINSTANCE.getEnergyComponentsCatalog_HeatExchangers();

		/**
		 * The meta object literal for the '<em><b>Electrolyzers</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__ELECTROLYZERS = eINSTANCE.getEnergyComponentsCatalog_Electrolyzers();

		/**
		 * The meta object literal for the '<em><b>Hydrogen Compressors</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__HYDROGEN_COMPRESSORS = eINSTANCE
				.getEnergyComponentsCatalog_HydrogenCompressors();

		/**
		 * The meta object literal for the '<em><b>Fuel Cells</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__FUEL_CELLS = eINSTANCE.getEnergyComponentsCatalog_FuelCells();

		/**
		 * The meta object literal for the '<em><b>Thermal Storages</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__THERMAL_STORAGES = eINSTANCE.getEnergyComponentsCatalog_ThermalStorages();

		/**
		 * The meta object literal for the '<em><b>Power Storages</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__POWER_STORAGES = eINSTANCE.getEnergyComponentsCatalog_PowerStorages();

		/**
		 * The meta object literal for the '<em><b>Hydrogen Storages</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__HYDROGEN_STORAGES = eINSTANCE
				.getEnergyComponentsCatalog_HydrogenStorages();

		/**
		 * The meta object literal for the '<em><b>Fossil Fuels</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__FOSSIL_FUELS = eINSTANCE.getEnergyComponentsCatalog_FossilFuels();

		/**
		 * The meta object literal for the '<em><b>Manufacturers</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__MANUFACTURERS = eINSTANCE.getEnergyComponentsCatalog_Manufacturers();

		/**
		 * The meta object literal for the '<em><b>Materials</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__MATERIALS = eINSTANCE.getEnergyComponentsCatalog_Materials();

		/**
		 * The meta object literal for the '<em><b>Energycomponentscostcatalog</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__ENERGYCOMPONENTSCOSTCATALOG = eINSTANCE
				.getEnergyComponentsCatalog_Energycomponentscostcatalog();

		/**
		 * The meta object literal for the '<em><b>Energycarriers</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_CATALOG__ENERGYCARRIERS = eINSTANCE.getEnergyComponentsCatalog_Energycarriers();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.ThermalStorageImpl <em>Thermal Storage</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.ThermalStorageImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getThermalStorage()
		 * @generated
		 */
		EClass THERMAL_STORAGE = eINSTANCE.getThermalStorage();

		/**
		 * The meta object literal for the '<em><b>Volume</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute THERMAL_STORAGE__VOLUME = eINSTANCE.getThermalStorage_Volume();

		/**
		 * The meta object literal for the '<em><b>Thermal Storage Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute THERMAL_STORAGE__THERMAL_STORAGE_TYPE = eINSTANCE.getThermalStorage_ThermalStorageType();

		/**
		 * The meta object literal for the '<em><b>Max Temp</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute THERMAL_STORAGE__MAX_TEMP = eINSTANCE.getThermalStorage_MaxTemp();

		/**
		 * The meta object literal for the '<em><b>Tank Thickness</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute THERMAL_STORAGE__TANK_THICKNESS = eINSTANCE.getThermalStorage_TankThickness();

		/**
		 * The meta object literal for the '<em><b>Insulation Thickness</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute THERMAL_STORAGE__INSULATION_THICKNESS = eINSTANCE.getThermalStorage_InsulationThickness();

		/**
		 * The meta object literal for the '<em><b>Uses Medium</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference THERMAL_STORAGE__USES_MEDIUM = eINSTANCE.getThermalStorage_UsesMedium();

		/**
		 * The meta object literal for the '<em><b>Insulation Material</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference THERMAL_STORAGE__INSULATION_MATERIAL = eINSTANCE.getThermalStorage_InsulationMaterial();

		/**
		 * The meta object literal for the '<em><b>Height</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute THERMAL_STORAGE__HEIGHT = eINSTANCE.getThermalStorage_Height();

		/**
		 * The meta object literal for the '<em><b>Tank Material</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference THERMAL_STORAGE__TANK_MATERIAL = eINSTANCE.getThermalStorage_TankMaterial();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.ElectricalStorageImpl <em>Electrical Storage</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.ElectricalStorageImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getElectricalStorage()
		 * @generated
		 */
		EClass ELECTRICAL_STORAGE = eINSTANCE.getElectricalStorage();

		/**
		 * The meta object literal for the '<em><b>Electrical Storage Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTRICAL_STORAGE__ELECTRICAL_STORAGE_TYPE = eINSTANCE.getElectricalStorage_ElectricalStorageType();

		/**
		 * The meta object literal for the '<em><b>Battery Capacity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTRICAL_STORAGE__BATTERY_CAPACITY = eINSTANCE.getElectricalStorage_BatteryCapacity();

		/**
		 * The meta object literal for the '<em><b>Battery Voltage</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTRICAL_STORAGE__BATTERY_VOLTAGE = eINSTANCE.getElectricalStorage_BatteryVoltage();

		/**
		 * The meta object literal for the '<em><b>Battery Life Cycle</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTRICAL_STORAGE__BATTERY_LIFE_CYCLE = eINSTANCE.getElectricalStorage_BatteryLifeCycle();

		/**
		 * The meta object literal for the '<em><b>Self Discharge</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTRICAL_STORAGE__SELF_DISCHARGE = eINSTANCE.getElectricalStorage_SelfDischarge();

		/**
		 * The meta object literal for the '<em><b>Inverter Included</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTRICAL_STORAGE__INVERTER_INCLUDED = eINSTANCE.getElectricalStorage_InverterIncluded();

		/**
		 * The meta object literal for the '<em><b>Battery Effiency</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTRICAL_STORAGE__BATTERY_EFFIENCY = eINSTANCE.getElectricalStorage_BatteryEffiency();

		/**
		 * The meta object literal for the '<em><b>Energy Content</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTRICAL_STORAGE__ENERGY_CONTENT = eINSTANCE.getElectricalStorage_EnergyContent();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.CombinedHeatPowerImpl <em>Combined Heat Power</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.CombinedHeatPowerImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getCombinedHeatPower()
		 * @generated
		 */
		EClass COMBINED_HEAT_POWER = eINSTANCE.getCombinedHeatPower();

		/**
		 * The meta object literal for the '<em><b>Thermal Efficiency</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMBINED_HEAT_POWER__THERMAL_EFFICIENCY = eINSTANCE.getCombinedHeatPower_ThermalEfficiency();

		/**
		 * The meta object literal for the '<em><b>Electrical Efficiency</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY = eINSTANCE.getCombinedHeatPower_ElectricalEfficiency();

		/**
		 * The meta object literal for the '<em><b>Installed Electrical Power</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMBINED_HEAT_POWER__INSTALLED_ELECTRICAL_POWER = eINSTANCE
				.getCombinedHeatPower_InstalledElectricalPower();

		/**
		 * The meta object literal for the '<em><b>Electrical Efficiency Part Load</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMBINED_HEAT_POWER__ELECTRICAL_EFFICIENCY_PART_LOAD = eINSTANCE
				.getCombinedHeatPower_ElectricalEfficiencyPartLoad();

		/**
		 * The meta object literal for the '<em><b>Thermal Efficiency Part Load</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMBINED_HEAT_POWER__THERMAL_EFFICIENCY_PART_LOAD = eINSTANCE
				.getCombinedHeatPower_ThermalEfficiencyPartLoad();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.HeatPumpImpl <em>Heat Pump</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.HeatPumpImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getHeatPump()
		 * @generated
		 */
		EClass HEAT_PUMP = eINSTANCE.getHeatPump();

		/**
		 * The meta object literal for the '<em><b>Heat Source</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HEAT_PUMP__HEAT_SOURCE = eINSTANCE.getHeatPump_HeatSource();

		/**
		 * The meta object literal for the '<em><b>Power Input</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HEAT_PUMP__POWER_INPUT = eINSTANCE.getHeatPump_PowerInput();

		/**
		 * The meta object literal for the '<em><b>Heat Output</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HEAT_PUMP__HEAT_OUTPUT = eINSTANCE.getHeatPump_HeatOutput();

		/**
		 * The meta object literal for the '<em><b>Coefficient Of Performance</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE = eINSTANCE.getHeatPump_CoefficientOfPerformance();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.BoilerImpl <em>Boiler</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.BoilerImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getBoiler()
		 * @generated
		 */
		EClass BOILER = eINSTANCE.getBoiler();

		/**
		 * The meta object literal for the '<em><b>Nominal Efficiency</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BOILER__NOMINAL_EFFICIENCY = eINSTANCE.getBoiler_NominalEfficiency();

		/**
		 * The meta object literal for the '<em><b>Boiler Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BOILER__BOILER_TYPE = eINSTANCE.getBoiler_BoilerType();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.SolarThermalCollectorImpl <em>Solar Thermal Collector</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.SolarThermalCollectorImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getSolarThermalCollector()
		 * @generated
		 */
		EClass SOLAR_THERMAL_COLLECTOR = eINSTANCE.getSolarThermalCollector();

		/**
		 * The meta object literal for the '<em><b>Collector Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SOLAR_THERMAL_COLLECTOR__COLLECTOR_TYPE = eINSTANCE.getSolarThermalCollector_CollectorType();

		/**
		 * The meta object literal for the '<em><b>Aperture Area</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SOLAR_THERMAL_COLLECTOR__APERTURE_AREA = eINSTANCE.getSolarThermalCollector_ApertureArea();

		/**
		 * The meta object literal for the '<em><b>Optical Efficiency</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SOLAR_THERMAL_COLLECTOR__OPTICAL_EFFICIENCY = eINSTANCE.getSolarThermalCollector_OpticalEfficiency();

		/**
		 * The meta object literal for the '<em><b>Linear Heat Loss Coefficient</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SOLAR_THERMAL_COLLECTOR__LINEAR_HEAT_LOSS_COEFFICIENT = eINSTANCE
				.getSolarThermalCollector_LinearHeatLossCoefficient();

		/**
		 * The meta object literal for the '<em><b>Quadratical Heat Loss Coefficient</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SOLAR_THERMAL_COLLECTOR__QUADRATICAL_HEAT_LOSS_COEFFICIENT = eINSTANCE
				.getSolarThermalCollector_QuadraticalHeatLossCoefficient();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.ElectrolyzerImpl <em>Electrolyzer</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.ElectrolyzerImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getElectrolyzer()
		 * @generated
		 */
		EClass ELECTROLYZER = eINSTANCE.getElectrolyzer();

		/**
		 * The meta object literal for the '<em><b>Cell Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTROLYZER__CELL_TYPE = eINSTANCE.getElectrolyzer_CellType();

		/**
		 * The meta object literal for the '<em><b>Cell Area</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTROLYZER__CELL_AREA = eINSTANCE.getElectrolyzer_CellArea();

		/**
		 * The meta object literal for the '<em><b>Number Of Cells</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTROLYZER__NUMBER_OF_CELLS = eINSTANCE.getElectrolyzer_NumberOfCells();

		/**
		 * The meta object literal for the '<em><b>Max Operating Current Density</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTROLYZER__MAX_OPERATING_CURRENT_DENSITY = eINSTANCE.getElectrolyzer_MaxOperatingCurrentDensity();

		/**
		 * The meta object literal for the '<em><b>Min Operating Current Density</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTROLYZER__MIN_OPERATING_CURRENT_DENSITY = eINSTANCE.getElectrolyzer_MinOperatingCurrentDensity();

		/**
		 * The meta object literal for the '<em><b>Overload Capacity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTROLYZER__OVERLOAD_CAPACITY = eINSTANCE.getElectrolyzer_OverloadCapacity();

		/**
		 * The meta object literal for the '<em><b>Nominal Cell Voltage</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTROLYZER__NOMINAL_CELL_VOLTAGE = eINSTANCE.getElectrolyzer_NominalCellVoltage();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.ThermalEnergyDeviceImpl <em>Thermal Energy Device</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.ThermalEnergyDeviceImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getThermalEnergyDevice()
		 * @generated
		 */
		EClass THERMAL_ENERGY_DEVICE = eINSTANCE.getThermalEnergyDevice();

		/**
		 * The meta object literal for the '<em><b>Installed Thermal Power</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute THERMAL_ENERGY_DEVICE__INSTALLED_THERMAL_POWER = eINSTANCE
				.getThermalEnergyDevice_InstalledThermalPower();

		/**
		 * The meta object literal for the '<em><b>Modulation Range</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute THERMAL_ENERGY_DEVICE__MODULATION_RANGE = eINSTANCE.getThermalEnergyDevice_ModulationRange();

		/**
		 * The meta object literal for the '<em><b>Fuel</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute THERMAL_ENERGY_DEVICE__FUEL = eINSTANCE.getThermalEnergyDevice_Fuel();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.HydrogenCompressorImpl <em>Hydrogen Compressor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.HydrogenCompressorImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getHydrogenCompressor()
		 * @generated
		 */
		EClass HYDROGEN_COMPRESSOR = eINSTANCE.getHydrogenCompressor();

		/**
		 * The meta object literal for the '<em><b>Efficiency</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYDROGEN_COMPRESSOR__EFFICIENCY = eINSTANCE.getHydrogenCompressor_Efficiency();

		/**
		 * The meta object literal for the '<em><b>Thermodynamic Mode</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYDROGEN_COMPRESSOR__THERMODYNAMIC_MODE = eINSTANCE.getHydrogenCompressor_ThermodynamicMode();

		/**
		 * The meta object literal for the '<em><b>Max Pressure</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYDROGEN_COMPRESSOR__MAX_PRESSURE = eINSTANCE.getHydrogenCompressor_MaxPressure();

		/**
		 * The meta object literal for the '<em><b>Max Delivery Rate</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYDROGEN_COMPRESSOR__MAX_DELIVERY_RATE = eINSTANCE.getHydrogenCompressor_MaxDeliveryRate();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.HydrogenStorageImpl <em>Hydrogen Storage</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.HydrogenStorageImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getHydrogenStorage()
		 * @generated
		 */
		EClass HYDROGEN_STORAGE = eINSTANCE.getHydrogenStorage();

		/**
		 * The meta object literal for the '<em><b>Number Of Cylinders</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYDROGEN_STORAGE__NUMBER_OF_CYLINDERS = eINSTANCE.getHydrogenStorage_NumberOfCylinders();

		/**
		 * The meta object literal for the '<em><b>Cylinder Volume</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYDROGEN_STORAGE__CYLINDER_VOLUME = eINSTANCE.getHydrogenStorage_CylinderVolume();

		/**
		 * The meta object literal for the '<em><b>Nominal Pressure</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYDROGEN_STORAGE__NOMINAL_PRESSURE = eINSTANCE.getHydrogenStorage_NominalPressure();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.FuelCellImpl <em>Fuel Cell</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.FuelCellImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getFuelCell()
		 * @generated
		 */
		EClass FUEL_CELL = eINSTANCE.getFuelCell();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.EnergyCarrierImpl <em>Energy Carrier</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.EnergyCarrierImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getEnergyCarrier()
		 * @generated
		 */
		EClass ENERGY_CARRIER = eINSTANCE.getEnergyCarrier();

		/**
		 * The meta object literal for the '<em><b>Co2 Emissions Factor</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENERGY_CARRIER__CO2_EMISSIONS_FACTOR = eINSTANCE.getEnergyCarrier_Co2EmissionsFactor();

		/**
		 * The meta object literal for the '<em><b>Primary Energy Factor</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENERGY_CARRIER__PRIMARY_ENERGY_FACTOR = eINSTANCE.getEnergyCarrier_PrimaryEnergyFactor();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENERGY_CARRIER__NAME = eINSTANCE.getEnergyCarrier_Name();

		/**
		 * The meta object literal for the '<em><b>Cost</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENERGY_CARRIER__COST = eINSTANCE.getEnergyCarrier_Cost();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.FossilFuelImpl <em>Fossil Fuel</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.FossilFuelImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getFossilFuel()
		 * @generated
		 */
		EClass FOSSIL_FUEL = eINSTANCE.getFossilFuel();

		/**
		 * The meta object literal for the '<em><b>Methane Content</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FOSSIL_FUEL__METHANE_CONTENT = eINSTANCE.getFossilFuel_MethaneContent();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.HydrogenImpl <em>Hydrogen</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.HydrogenImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getHydrogen()
		 * @generated
		 */
		EClass HYDROGEN = eINSTANCE.getHydrogen();

		/**
		 * The meta object literal for the '<em><b>Chemical Purity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYDROGEN__CHEMICAL_PURITY = eINSTANCE.getHydrogen_ChemicalPurity();

		/**
		 * The meta object literal for the '<em><b>Hydrogen For Hydrogen Storage</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HYDROGEN__HYDROGEN_FOR_HYDROGEN_STORAGE = eINSTANCE.getHydrogen_HydrogenForHydrogenStorage();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.ElectricityImpl <em>Electricity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.ElectricityImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getElectricity()
		 * @generated
		 */
		EClass ELECTRICITY = eINSTANCE.getElectricity();

		/**
		 * The meta object literal for the '<em><b>Renewable Share</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELECTRICITY__RENEWABLE_SHARE = eINSTANCE.getElectricity_RenewableShare();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.BioFuelImpl <em>Bio Fuel</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.BioFuelImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getBioFuel()
		 * @generated
		 */
		EClass BIO_FUEL = eINSTANCE.getBioFuel();

		/**
		 * The meta object literal for the '<em><b>Water Content</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BIO_FUEL__WATER_CONTENT = eINSTANCE.getBioFuel_WaterContent();

		/**
		 * The meta object literal for the '<em><b>Ash Content</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BIO_FUEL__ASH_CONTENT = eINSTANCE.getBioFuel_AshContent();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.FuelImpl <em>Fuel</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.FuelImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getFuel()
		 * @generated
		 */
		EClass FUEL = eINSTANCE.getFuel();

		/**
		 * The meta object literal for the '<em><b>Net Calorific Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FUEL__NET_CALORIFIC_VALUE = eINSTANCE.getFuel_NetCalorificValue();

		/**
		 * The meta object literal for the '<em><b>Gross Calorific Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FUEL__GROSS_CALORIFIC_VALUE = eINSTANCE.getFuel_GrossCalorificValue();

		/**
		 * The meta object literal for the '<em><b>Density</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FUEL__DENSITY = eINSTANCE.getFuel_Density();

		/**
		 * The meta object literal for the '<em><b>Fuel Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FUEL__FUEL_TYPE = eINSTANCE.getFuel_FuelType();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.WindTurbineImpl <em>Wind Turbine</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.WindTurbineImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getWindTurbine()
		 * @generated
		 */
		EClass WIND_TURBINE = eINSTANCE.getWindTurbine();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.PhotovoltaicModuleImpl <em>Photovoltaic Module</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.PhotovoltaicModuleImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getPhotovoltaicModule()
		 * @generated
		 */
		EClass PHOTOVOLTAIC_MODULE = eINSTANCE.getPhotovoltaicModule();

		/**
		 * The meta object literal for the '<em><b>Cell Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PHOTOVOLTAIC_MODULE__CELL_TYPE = eINSTANCE.getPhotovoltaicModule_CellType();

		/**
		 * The meta object literal for the '<em><b>Nominal Power</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PHOTOVOLTAIC_MODULE__NOMINAL_POWER = eINSTANCE.getPhotovoltaicModule_NominalPower();

		/**
		 * The meta object literal for the '<em><b>Mpp Voltage</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PHOTOVOLTAIC_MODULE__MPP_VOLTAGE = eINSTANCE.getPhotovoltaicModule_MppVoltage();

		/**
		 * The meta object literal for the '<em><b>Mpp Current</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PHOTOVOLTAIC_MODULE__MPP_CURRENT = eINSTANCE.getPhotovoltaicModule_MppCurrent();

		/**
		 * The meta object literal for the '<em><b>Nominal Efficiency</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PHOTOVOLTAIC_MODULE__NOMINAL_EFFICIENCY = eINSTANCE.getPhotovoltaicModule_NominalEfficiency();

		/**
		 * The meta object literal for the '<em><b>Module Area</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PHOTOVOLTAIC_MODULE__MODULE_AREA = eINSTANCE.getPhotovoltaicModule_ModuleArea();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.InverterImpl <em>Inverter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.InverterImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getInverter()
		 * @generated
		 */
		EClass INVERTER = eINSTANCE.getInverter();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.HeatExchangerImpl <em>Heat Exchanger</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.HeatExchangerImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getHeatExchanger()
		 * @generated
		 */
		EClass HEAT_EXCHANGER = eINSTANCE.getHeatExchanger();

		/**
		 * The meta object literal for the '<em><b>Heat Recovery Efficiency</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HEAT_EXCHANGER__HEAT_RECOVERY_EFFICIENCY = eINSTANCE.getHeatExchanger_HeatRecoveryEfficiency();

		/**
		 * The meta object literal for the '<em><b>Nominal Electricity Consumption</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HEAT_EXCHANGER__NOMINAL_ELECTRICITY_CONSUMPTION = eINSTANCE
				.getHeatExchanger_NominalElectricityConsumption();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.GeothermalHeatExchangerImpl <em>Geothermal Heat Exchanger</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.GeothermalHeatExchangerImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getGeothermalHeatExchanger()
		 * @generated
		 */
		EClass GEOTHERMAL_HEAT_EXCHANGER = eINSTANCE.getGeothermalHeatExchanger();

		/**
		 * The meta object literal for the '<em><b>Pipe Diameter</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GEOTHERMAL_HEAT_EXCHANGER__PIPE_DIAMETER = eINSTANCE.getGeothermalHeatExchanger_PipeDiameter();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.MediumImpl <em>Medium</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.MediumImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getMedium()
		 * @generated
		 */
		EClass MEDIUM = eINSTANCE.getMedium();

		/**
		 * The meta object literal for the '<em><b>Density</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MEDIUM__DENSITY = eINSTANCE.getMedium_Density();

		/**
		 * The meta object literal for the '<em><b>Heat Capacity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MEDIUM__HEAT_CAPACITY = eINSTANCE.getMedium_HeatCapacity();

		/**
		 * The meta object literal for the '<em><b>Evaporation Temperature</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MEDIUM__EVAPORATION_TEMPERATURE = eINSTANCE.getMedium_EvaporationTemperature();

		/**
		 * The meta object literal for the '<em><b>Melting Temperature</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MEDIUM__MELTING_TEMPERATURE = eINSTANCE.getMedium_MeltingTemperature();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MEDIUM__NAME = eINSTANCE.getMedium_Name();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.LinearFunctionImpl <em>Linear Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.LinearFunctionImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getLinearFunction()
		 * @generated
		 */
		EClass LINEAR_FUNCTION = eINSTANCE.getLinearFunction();

		/**
		 * The meta object literal for the '<em><b>Key</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LINEAR_FUNCTION__KEY = eINSTANCE.getLinearFunction_Key();

		/**
		 * The meta object literal for the '<em><b>Parameter M</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LINEAR_FUNCTION__PARAMETER_M = eINSTANCE.getLinearFunction_ParameterM();

		/**
		 * The meta object literal for the '<em><b>Parameter C</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LINEAR_FUNCTION__PARAMETER_C = eINSTANCE.getLinearFunction_ParameterC();

		/**
		 * The meta object literal for the '<em><b>Linearfunction</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation LINEAR_FUNCTION___LINEARFUNCTION__DOUBLE = eINSTANCE.getLinearFunction__Linearfunction__double();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.DataPointImpl <em>Data Point</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.DataPointImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getDataPoint()
		 * @generated
		 */
		EClass DATA_POINT = eINSTANCE.getDataPoint();

		/**
		 * The meta object literal for the '<em><b>X</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_POINT__X = eINSTANCE.getDataPoint_X();

		/**
		 * The meta object literal for the '<em><b>Y</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_POINT__Y = eINSTANCE.getDataPoint_Y();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.TableFunctionImpl <em>Table Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.TableFunctionImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getTableFunction()
		 * @generated
		 */
		EClass TABLE_FUNCTION = eINSTANCE.getTableFunction();

		/**
		 * The meta object literal for the '<em><b>Key</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TABLE_FUNCTION__KEY = eINSTANCE.getTableFunction_Key();

		/**
		 * The meta object literal for the '<em><b>Datapoints</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TABLE_FUNCTION__DATAPOINTS = eINSTANCE.getTableFunction_Datapoints();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.ExponentialFunctionImpl <em>Exponential Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.ExponentialFunctionImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getExponentialFunction()
		 * @generated
		 */
		EClass EXPONENTIAL_FUNCTION = eINSTANCE.getExponentialFunction();

		/**
		 * The meta object literal for the '<em><b>Key</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EXPONENTIAL_FUNCTION__KEY = eINSTANCE.getExponentialFunction_Key();

		/**
		 * The meta object literal for the '<em><b>Parameter A</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EXPONENTIAL_FUNCTION__PARAMETER_A = eINSTANCE.getExponentialFunction_ParameterA();

		/**
		 * The meta object literal for the '<em><b>Parameter B</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EXPONENTIAL_FUNCTION__PARAMETER_B = eINSTANCE.getExponentialFunction_ParameterB();

		/**
		 * The meta object literal for the '<em><b>Exponentialfunction</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation EXPONENTIAL_FUNCTION___EXPONENTIALFUNCTION__DOUBLE = eINSTANCE
				.getExponentialFunction__Exponentialfunction__double();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.CharacteristicImpl <em>Characteristic</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.CharacteristicImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getCharacteristic()
		 * @generated
		 */
		EClass CHARACTERISTIC = eINSTANCE.getCharacteristic();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.TableCharacteristicImpl <em>Table Characteristic</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.TableCharacteristicImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getTableCharacteristic()
		 * @generated
		 */
		EClass TABLE_CHARACTERISTIC = eINSTANCE.getTableCharacteristic();

		/**
		 * The meta object literal for the '<em><b>Functions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TABLE_CHARACTERISTIC__FUNCTIONS = eINSTANCE.getTableCharacteristic_Functions();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.LinearCharacteristicImpl <em>Linear Characteristic</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.LinearCharacteristicImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getLinearCharacteristic()
		 * @generated
		 */
		EClass LINEAR_CHARACTERISTIC = eINSTANCE.getLinearCharacteristic();

		/**
		 * The meta object literal for the '<em><b>Functions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINEAR_CHARACTERISTIC__FUNCTIONS = eINSTANCE.getLinearCharacteristic_Functions();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.ExponentionalCharacteristicImpl <em>Exponentional Characteristic</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.ExponentionalCharacteristicImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getExponentionalCharacteristic()
		 * @generated
		 */
		EClass EXPONENTIONAL_CHARACTERISTIC = eINSTANCE.getExponentionalCharacteristic();

		/**
		 * The meta object literal for the '<em><b>Functions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXPONENTIONAL_CHARACTERISTIC__FUNCTIONS = eINSTANCE.getExponentionalCharacteristic_Functions();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.ManufacturerImpl <em>Manufacturer</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.ManufacturerImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getManufacturer()
		 * @generated
		 */
		EClass MANUFACTURER = eINSTANCE.getManufacturer();

		/**
		 * The meta object literal for the '<em><b>Manufacturer Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MANUFACTURER__MANUFACTURER_NAME = eINSTANCE.getManufacturer_ManufacturerName();

		/**
		 * The meta object literal for the '<em><b>Country</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MANUFACTURER__COUNTRY = eINSTANCE.getManufacturer_Country();

		/**
		 * The meta object literal for the '<em><b>Out Of Business Since</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MANUFACTURER__OUT_OF_BUSINESS_SINCE = eINSTANCE.getManufacturer_OutOfBusinessSince();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.PolynomialCharacteristicImpl <em>Polynomial Characteristic</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.PolynomialCharacteristicImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getPolynomialCharacteristic()
		 * @generated
		 */
		EClass POLYNOMIAL_CHARACTERISTIC = eINSTANCE.getPolynomialCharacteristic();

		/**
		 * The meta object literal for the '<em><b>Functions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference POLYNOMIAL_CHARACTERISTIC__FUNCTIONS = eINSTANCE.getPolynomialCharacteristic_Functions();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.PolynomialFunctionImpl <em>Polynomial Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.PolynomialFunctionImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getPolynomialFunction()
		 * @generated
		 */
		EClass POLYNOMIAL_FUNCTION = eINSTANCE.getPolynomialFunction();

		/**
		 * The meta object literal for the '<em><b>Key</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute POLYNOMIAL_FUNCTION__KEY = eINSTANCE.getPolynomialFunction_Key();

		/**
		 * The meta object literal for the '<em><b>Parameter A</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute POLYNOMIAL_FUNCTION__PARAMETER_A = eINSTANCE.getPolynomialFunction_ParameterA();

		/**
		 * The meta object literal for the '<em><b>Parameter B</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute POLYNOMIAL_FUNCTION__PARAMETER_B = eINSTANCE.getPolynomialFunction_ParameterB();

		/**
		 * The meta object literal for the '<em><b>Parameter C</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute POLYNOMIAL_FUNCTION__PARAMETER_C = eINSTANCE.getPolynomialFunction_ParameterC();

		/**
		 * The meta object literal for the '<em><b>Polynomialfunction</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation POLYNOMIAL_FUNCTION___POLYNOMIALFUNCTION__DOUBLE = eINSTANCE
				.getPolynomialFunction__Polynomialfunction__double();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.MaterialImpl <em>Material</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.MaterialImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getMaterial()
		 * @generated
		 */
		EClass MATERIAL = eINSTANCE.getMaterial();

		/**
		 * The meta object literal for the '<em><b>Thermal Conductivity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MATERIAL__THERMAL_CONDUCTIVITY = eINSTANCE.getMaterial_ThermalConductivity();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MATERIAL__NAME = eINSTANCE.getMaterial_Name();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.EnergyComponentsCostCatalogImpl <em>Energy Components Cost Catalog</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.EnergyComponentsCostCatalogImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getEnergyComponentsCostCatalog()
		 * @generated
		 */
		EClass ENERGY_COMPONENTS_COST_CATALOG = eINSTANCE.getEnergyComponentsCostCatalog();

		/**
		 * The meta object literal for the '<em><b>Author</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENERGY_COMPONENTS_COST_CATALOG__AUTHOR = eINSTANCE.getEnergyComponentsCostCatalog_Author();

		/**
		 * The meta object literal for the '<em><b>Revision Year</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENERGY_COMPONENTS_COST_CATALOG__REVISION_YEAR = eINSTANCE
				.getEnergyComponentsCostCatalog_RevisionYear();

		/**
		 * The meta object literal for the '<em><b>Cost Categories</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENERGY_COMPONENTS_COST_CATALOG__COST_CATEGORIES = eINSTANCE
				.getEnergyComponentsCostCatalog_CostCategories();

		/**
		 * The meta object literal for the '<em><b>Personnel Cost</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENERGY_COMPONENTS_COST_CATALOG__PERSONNEL_COST = eINSTANCE
				.getEnergyComponentsCostCatalog_PersonnelCost();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.CostImpl <em>Cost</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.CostImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getCost()
		 * @generated
		 */
		EClass COST = eINSTANCE.getCost();

		/**
		 * The meta object literal for the '<em><b>Datasource</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COST__DATASOURCE = eINSTANCE.getCost_Datasource();

		/**
		 * The meta object literal for the '<em><b>Investment Cost</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COST__INVESTMENT_COST = eINSTANCE.getCost_InvestmentCost();

		/**
		 * The meta object literal for the '<em><b>Other Investment Cost</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COST__OTHER_INVESTMENT_COST = eINSTANCE.getCost_OtherInvestmentCost();

		/**
		 * The meta object literal for the '<em><b>Personnel Hours</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COST__PERSONNEL_HOURS = eINSTANCE.getCost_PersonnelHours();

		/**
		 * The meta object literal for the '<em><b>Personnel Cost Share</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COST__PERSONNEL_COST_SHARE = eINSTANCE.getCost_PersonnelCostShare();

		/**
		 * The meta object literal for the '<em><b>Administration And Other Cost Share</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COST__ADMINISTRATION_AND_OTHER_COST_SHARE = eINSTANCE.getCost_AdministrationAndOtherCostShare();

		/**
		 * The meta object literal for the '<em><b>Maintenance Cost Share</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COST__MAINTENANCE_COST_SHARE = eINSTANCE.getCost_MaintenanceCostShare();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.PowerCharacteristicImpl <em>Power Characteristic</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.PowerCharacteristicImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getPowerCharacteristic()
		 * @generated
		 */
		EClass POWER_CHARACTERISTIC = eINSTANCE.getPowerCharacteristic();

		/**
		 * The meta object literal for the '<em><b>Functions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference POWER_CHARACTERISTIC__FUNCTIONS = eINSTANCE.getPowerCharacteristic_Functions();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.impl.PowerFunctionImpl <em>Power Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.impl.PowerFunctionImpl
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getPowerFunction()
		 * @generated
		 */
		EClass POWER_FUNCTION = eINSTANCE.getPowerFunction();

		/**
		 * The meta object literal for the '<em><b>Key</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute POWER_FUNCTION__KEY = eINSTANCE.getPowerFunction_Key();

		/**
		 * The meta object literal for the '<em><b>Parameter A</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute POWER_FUNCTION__PARAMETER_A = eINSTANCE.getPowerFunction_ParameterA();

		/**
		 * The meta object literal for the '<em><b>Parameter B</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute POWER_FUNCTION__PARAMETER_B = eINSTANCE.getPowerFunction_ParameterB();

		/**
		 * The meta object literal for the '<em><b>Powerfunction</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation POWER_FUNCTION___POWERFUNCTION__DOUBLE = eINSTANCE.getPowerFunction__Powerfunction__double();

		/**
		 * The meta object literal for the '<em><b>Component Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COST__COMPONENT_NAME = eINSTANCE.getCost_ComponentName();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COST__DESCRIPTION = eINSTANCE.getCost_Description();

		/**
		 * The meta object literal for the '<em><b>Heat Source</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COST__HEAT_SOURCE = eINSTANCE.getCost_HeatSource();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.HeatSources <em>Heat Sources</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.HeatSources
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getHeatSources()
		 * @generated
		 */
		EEnum HEAT_SOURCES = eINSTANCE.getHeatSources();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.CollectorTypes <em>Collector Types</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.CollectorTypes
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getCollectorTypes()
		 * @generated
		 */
		EEnum COLLECTOR_TYPES = eINSTANCE.getCollectorTypes();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.ElectricalStorageTypes <em>Electrical Storage Types</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.ElectricalStorageTypes
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getElectricalStorageTypes()
		 * @generated
		 */
		EEnum ELECTRICAL_STORAGE_TYPES = eINSTANCE.getElectricalStorageTypes();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.BoilerTypes <em>Boiler Types</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.BoilerTypes
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getBoilerTypes()
		 * @generated
		 */
		EEnum BOILER_TYPES = eINSTANCE.getBoilerTypes();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.ThermalStorageTypes <em>Thermal Storage Types</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.ThermalStorageTypes
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getThermalStorageTypes()
		 * @generated
		 */
		EEnum THERMAL_STORAGE_TYPES = eINSTANCE.getThermalStorageTypes();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.FuelTypes <em>Fuel Types</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.FuelTypes
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getFuelTypes()
		 * @generated
		 */
		EEnum FUEL_TYPES = eINSTANCE.getFuelTypes();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.TypeOfHeatSource <em>Type Of Heat Source</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.TypeOfHeatSource
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getTypeOfHeatSource()
		 * @generated
		 */
		EEnum TYPE_OF_HEAT_SOURCE = eINSTANCE.getTypeOfHeatSource();

		/**
		 * The meta object literal for the '{@link de.hftstuttgart.energycomponents.cellTypesElectrolyzer <em>cell Types Electrolyzer</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.energycomponents.cellTypesElectrolyzer
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getcellTypesElectrolyzer()
		 * @generated
		 */
		EEnum CELL_TYPES_ELECTROLYZER = eINSTANCE.getcellTypesElectrolyzer();

		/**
		 * The meta object literal for the '<em>Quantity Double</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.units.NullableQuantity
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getQuantityDouble()
		 * @generated
		 */
		EDataType QUANTITY_DOUBLE = eINSTANCE.getQuantityDouble();

		/**
		 * The meta object literal for the '<em>Quantity Long</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.units.NullableQuantity
		 * @see de.hftstuttgart.energycomponents.impl.EnCompPackageImpl#getQuantityLong()
		 * @generated
		 */
		EDataType QUANTITY_LONG = eINSTANCE.getQuantityLong();

	}

} //EnCompPackage
